
C---------------------------------------------------------------------------
C                     PROGRAM   E S C A L C
C---------------------------------------------------------------------------

C ESCALC is updated from ESCALC, April 1993, to allow for tagging of
C charges (from the chr file/s) for switching in FDCALC.

C updated October.90 to take atom VdW radius and charge information from
C the "atoms_es.dat" file, used also by FDCALC and POLH_GEN.

C This program calculates electrostatic interactions in proteins
C using a variety of methods - all of which are based on spherical,
C planar or no protein geometry, to allow analytic calculation
C of the interaction values.
C The overall grid set up is from PEPR, but is only for the (optional)
C electrostatic potential map output.  The actual calculations are
C performed on the (x,y,z) coordinates of the charges, read fom the
C Protein Data Bank file.  This program is thus capable of predicting
C pK changes, and electrostatic energy contributions, that PEPR, based
C on the numerical methods, is not.

C ESCALC is an assemblage of empirical methods.
C That should be remebered.

C Input the iteration control data from the ESCALC.CTR control file.

C The grid for the optional electrostatic potential map output is
C stored in a variable dimension array.
C This is the variable dimension array.
C 58**3 = 195112

	REAL POT(195112)

C These 4 Q... arrays contain the charge information that is read in with
C "READQ".

C QR contains : x, y, z, q, pK, solv. acc., radius, q_site (in delpk calc)
C in location : 1  2  3  4   5      6         7        8

C QA4 contains identifiers : RES, ATYP, PRTNER
C QL contains the flags:  IONISE, SWITCHQ
C QI contains res. no. :  NCUR, IFIL, IQPRT
C OCT.2001:
C QC contains chain id

	REAL		QR(30000,8), QCUR(30000)
	CHARACTER*4	QA4(30000,3)
	INTEGER		QI(30000,3)
	LOGICAL		QL(30000,2)
	CHARACTER*1	QC(30000), chain
	CHARACTER*4	CHEK, CALTYP (10), ATM
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	LOGICAL		CALC (10), OUTSA
	REAL	POTI (30000), WI (30000), DELPK (30000),PKCUR (30000),
     1		poti_fixed (30000), poti_pK (30000), wbufi (30000)
	INTEGER		which_VdW
	CHARACTER*4	METHA4 (20)
	REAL		LOG10E
	LOGICAL		VERGED, BULKDH, SETUP, PLOT
      REAL TOT(3),ZERO(3),MMAX(3),MMIN(3),FGSIZE(3),MAXMIN, XYZT (3),
     1     XYZ (3)
	CHARACTER*1	AXIS, ATMTYP
      INTEGER FGRDIM(3),IAX(3),XAI(3),IZER(3)
	REAL TRNFIL (5,3), ROTFIL (5,3,3)
	CHARACTER*80	DATFIL, POTFIL
	CHARACTER*80	HED (5), QFIL (5), PDBFIL (5), BITE
C ??	BYTE HED (5,80), QFIL (5,80), PDBFIL (5,80), BITE (80)
	BYTE		spacer (80)
	LOGICAL MACINC,ITRATE,WIJOUT,more_charge_info,
     1		track_split, pH_shift,move_file (5),most_charge_info,
     2		skip_ijcalc, old_coord_nres_I5
	LOGICAL*1	show_action (30000)

	COMMON /QSTAT/ WIJOUT
	COMMON /QHOLD/ QR, QCUR, QA4, QL, QI, QT, QTCUR, MACINC,
     1                 ITRATE, q_before, QC
	COMMON /FILE/ QFIL, NFIL, IFIL, TRNFIL, ROTFIL, PDBFIL, HED,
     1                BITE, move_file
	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /INTER/ POTI, WI, DELPK, SUMWIJ, ENERGY, PKCUR, NSITE,
     1                 TENER, poti_fixed, poti_pK, wbufi,show_action,
     2			sumwij_1, sumwij_2
	COMMON /DONE/	RMS, VERGED
	COMMON /METHID/ METHA4
	COMMON /OPT4/ T41,T42,T43,T44,T45
	COMMON /OPT5/ T51,T52
	COMMON /OPT6/ T61
	COMMON /OPT8/ ATK, BTK, NLEGEN
	COMMON	/charge_set/	i_qset, track_split, pH_shift

C Internal program potentials will be stored as,

C         charge (units of e)   /   distance (angstrom units)

C Internal program energies will be stored as,

C         charge (units of e)   *   { internal potential units}

C The "CONST" COMMON holds the various constants, including lumped
C constants.

	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6

	LOGICAL MAPOUT

C Set the A4 flags for the method i.d. when output data.
C Adjust so as to match the integer i.d. format; 11X,8(I2,6X),I2

	DATA METHA4 / ' UNI','NON ',' VAC','D-H ',' UNI','D-H ',
     1                ' E&M','D-H*',' WHL','D-H*',' DIS','D-H*',
     1                ' PLN','CONV',' T-K','CONV', 4 * '    ' /

	DATA	spacer	/ 80 * '-' /

1020	FORMAT (80A1)
1025	FORMAT (/,80A1)
1030	FORMAT (A80)
1040	FORMAT (20X,'ESCALC (NOV.90 VERSION) RUN INFORMATION FILE')
2010	FORMAT (/,80A1)
2020	FORMAT (' ','On iteration number ',I3,' charge total = ',
     1 F10.3,'  rms = ',F12.6)
2030	FORMAT (' ','using calculation method number ',I1,
     1 ' --- ',2A4)
2040	FORMAT (' ',' FINISHED ON CYCLE  ',I3,' charge total = ',
     1 F10.3,'  rms = ',F12.6)
2050	FORMAT (' ',20X,'-- NO -- ITERATION OF IONISABLE GROUPS')
2060	FORMAT ('0','**** skip_ij is set - NO ij GEAR calculated
     1 at all - charges ok for FDCALC ****')
2062	FORMAT ('0','charge before pH shift = ',F10.2,' and charge
     1 before iteration = ',F10.2)
2070	FORMAT ('0',' wij energy of ionisable groups only  = ',F10.2,
     1 '  kJ/mole')
2080	FORMAT ('0','interaction of ionisable with fixed   = ',F10.2,
     1 '  kJ/mole')
2090	FORMAT ('0','so that totl ij energy of ionisables  = ',F10.2,
     1 '  kJ/mole')
2100	FORMAT ('0',' buffer  energy at end of calculation = ',F10.2,
     1 '  kJ/mole')
2110	FORMAT ('0','totl wij energy at end of calculation = ',F10.2,
     1 '  kJ/mole')
2120	FORMAT ('0','total es energy at end of calculation = ',F10.2,
     1 '  kJ/mole')
2130	FORMAT ('0','iterated charge at end of calculation = ',F10.2,
     1 '  e units')
2140	FORMAT ('0','(charge before pH shift = ',F10.2,' and charge
     1 before iteration = ',F10.2,')')
2200	FORMAT (' ',10X,'INDIVIDUAL CHARGE INFORMATION AFTER
     1 CALCULATION')
2205	FORMAT (' ','index  i_prt   q_pK   potl_pK    nres resi atyp
     1  pK_curr q_curr     wi    wbufi')
2210	FORMAT (' ','                (e)     (mV)                   
     1            (e)      (kJ/mole)  ')
2220	FORMAT (' ',I5,2X,I5,2X,F5.2,1X,F10.1,2X,I5,1X,A4,1X,A4,
     1 3X,F6.2,2X,F5.2,1X,F7.2,1X,F7.2)
2240	FORMAT (' ',I5,2X,5X,2X,5X,1X,10X,2X,I5,1X,A4,1X,A4,
     1 3X,6X,2X,F5.2,1X,F7.2,1X,7X)

C Constant setting -----------------------------------------------

	BOLT = 1.38062 E -23
	TEMP = 300.
	EPSZER = 8.85419 E -12
	AVAGAD = 6.02217 E 23
	ELEC = 1.60219 E -19
	ENAT = 2.718282
	PI = 3.14159
	LOG10E = 0.4342945

	CON1 = BOLT * TEMP

	CON2 = CON1 / ELEC
	
C      Volts = CON3 * { charge (units of e) / Rij (angstroms) }.
C ie.  Volts = CON3 * { internal potential units }

	CON3 = ELEC / ( 4. * PI * EPSZER * 1. E -10 )

	CON6 = 1. / ( 4. * PI * EPSZER * 1. E -10 )

C      Joules = ELEC * CON3 * { internal energy units }

C kJ/mol = CON4 * { Joules }

	CON4 = AVAGAD / 1. E 3

C kcal/mol = CON5 * { kJ/mol }

C######### IS 4.184 RIGHT ?? - MORE ACCURATE REQUIRED ############

	CON5 = 1. / 4.184

C Constant setting end -------------------------------------------

      OPEN (UNIT=9, NAME='escalc.ctr', TYPE='OLD')
      READ(9,11) CHEK
11     FORMAT(A4)
      IF(CHEK.NE.'ESCC') STOP 'ESCC'

C First we'll see if we want to forget charge i/p and e.s. calcn., in
C favour of just plotting the effective dielectric as a function of sepn.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'PLOT' ) STOP 'PLOT'
	READ (9,*) PLOT

C We will o/p a file with all charge information,
C and delpK, energy information, that can be used for 2 things :

C    (ii)  input to a finite difference program - FDCALC
C   (iii)  input to a plot routine for the delpK s

C If WIJOUT is set, then the SCRATCH:WIJ.SCR file is not deleted at
C the end of the ESCALC run.
C more_charge_info controls a long (T) or short (F) charge summary.
C most_charge_info will also give info o/p for non-ionisable charges.
C If skip_ijcalc is set, then we just output the charges and dummy ij values.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'QHOW') STOP 'QHOW'
	READ (9,*) WIJOUT, more_charge_info, most_charge_info,
     1		   skip_ijcalc

C We have the option of processing more than one data file.
C The coordinate data in each file will be transformed by a
C translation vector, and a rotation matrix, to put the
C coordinates into 'calculation space'.
C April.90 - add in the coord_nres_i5 flag to read nres over the ch id field
C	     too, to deal with large molecules (see FDCALC too).
C OCT.2001: disallow coord_nres_i5, since we are jow carrying chain id thro.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'NFIL' ) STOP 'NFIL'
	READ (9,*) NFIL, old_coord_nres_i5
	IF (old_coord_nres_i5) STOP 'no coord_nres_i5: chainid now'

C If the Plot flag is set, then skip some ctr reads for dummy reads.

	IF ( PLOT .AND. ( NFIL .NE. 1 ) ) STOP 'Nfil .ne. 1 / Plot'
	IF ( PLOT ) IDUMRD = 14
	IF ( PLOT ) CALL DUMRD ( IDUMRD )
	IF ( PLOT ) GOTO 133

C We have a maximimum number of 5 coordinate/charge file sets, at present.

	IF ( NFIL .GT. 5 ) STOP 'NFIL > 5'
	IF ( NFIL .LT. 1 ) STOP 'NFIL < 1'

	DO 101 IFIL = 1, NFIL

C ??	DO 1017 ich = 1, 80
C ??	  PDBFIL (IFIL,ich) = ' '
C ??	  QFIL (IFIL,ich) = ' '
C ??1017	CONTINUE

	READ(9,11) CHEK
	IF(CHEK.NE.'DATA') STOP 'DATA'

	READ (9,1030) BITE
	CALL	get_filename (BITE, PDBFIL (IFIL))
	READ (9,1030) BITE
	CALL	get_filename (BITE, QFIL (IFIL))

C ??	READ(9,103,ERR=8200) NCH,(PDBFIL(IFIL,ICH),ICH=1,NCH)
C ??103	FORMAT(Q,80A1)
C ??	READ(9,103,ERR=8200) NCH,(QFIL(IFIL,ICH),ICH=1,NCH)
C ??	CALL PUTBYT ( BITE, PDBFIL, IFIL )

	BITE	= PDBFIL (IFIL)
	OPEN(UNIT=1,NAME=BITE,TYPE='OLD')
	READ (1,1030) HED (IFIL)

C ??	READ(1,102) BITE
C ??102	FORMAT(80A1)
C ??	CALL BYTPUT ( HED, IFIL, BITE )
	CLOSE ( UNIT = 1 )

C Get the transformations for this file (none applied if move_file is False).

	READ (9,11) CHEK
	IF ( CHEK .NE. 'TRAN' ) STOP 'TRAN'
	READ (9,*) move_file (ifil), ( TRNFIL (IFIL,NAX), NAX = 1, 3 )

	READ (9,11) CHEK
	IF ( CHEK .NE. 'ROTN' ) STOP 'ROTN'
	READ (9,*) ( ( ROTFIL (IFIL,NROW,NCOL), NCOL=1,3), NROW =1,3 )

101	CONTINUE

C Sep 2001 - use POTFIL to specify the qop file now.

109	READ(9,11) CHEK
	IF(CHEK.NE.'FILE') STOP 'FILE'
	READ (9,1030) BITE
	CALL	get_filename (BITE, DATFIL)
	READ (9,1030) BITE
	CALL	get_filename (BITE, POTFIL)

	OPEN(UNIT=11,NAME=DATFIL,TYPE='NEW')

	WRITE (11,1020) spacer
	WRITE (11,1040)
	WRITE (11,1020) spacer

C Output a map, using the normally input calculation methid, if required.

	READ(9,11) CHEK
	IF(CHEK.NE.'GRID') STOP 'GRID'
	READ(9,*) MAPOUT, STEPF, EXTEND, IAX(1)

	STEPF2=STEPF/2.

C We want a pH for our ionisable groups, (which may or may not be
C iterated - see the QFIL input).

	READ (9,11) CHEK
	IF ( CHEK .NE. 'PH  ' ) STOP 'PH  '
	READ (9,*) PH

C If the BULKDH flag is set, then diel = 78.4 will be used for the
C D-H parameter calculation in the 'COOL' calculation methods.
C If it is not set, then diel (Rij) will be used.

133	READ (9,11) CHEK
	IF ( CHEK .NE. 'DIDH' ) STOP 'DIDH'
	READ (9,*) BULKDH

C We shall be dictatorial (wrt BULKDH) for present;

	IF ( BULKDH ) STOP 'Read the Guide Matey'

C If the Plot flag is set, then skip some ctr reads for dummy reads.

	IDUMRD = 6
	IF ( PLOT ) CALL DUMRD ( IDUMRD )
	IF ( PLOT ) GOTO 143

C Set an rms pK shift per iteration, below which, the individual
C method iterations will cease.
C RMSFIN will be checked against rms.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'DONE' ) STOP 'DONE'
	READ (9,*) RMSFIN

C ###### At present, all pK increments are multiplied by this PKSMOO
C ###### factor.
C The iteration will drop out after NITMAX iterations, if
C it has not already reached convergence on all calculation methods.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'SMOO' ) STOP 'SMOO'
	READ (9,*) PKSMOO, NITMAX

143	CONTINUE

C Go through the various interaction calculation options.
C These options can be split into those with dielectric
C boundaries (and ion exclusion regions), and those without.
C Those without can be easily worked together, just with
C separate calls for the dielectric and counter-ion factors.

C i.e. the general form of the i-j interaction for uniform
C medium calculations is :

C   { Qi*Qj / ( 4*pi*eps*eps0*Rij ) }  *  { exp (-K*Rij) }

C The inhomogeneous region calculations require more diverse
C analyses.

C Individual lines in the control file will give the parameters
C for a single type of calculation, starting with the CALC (n)
C flag, which signals inclusion of this method.  As many methods
C as desired, may be specified in a single program run.

C The various options are, (at present);

C  CALC (n)			Type of calculation

C        1      Uniform dielectric,    No counter-ions
C        2      Vacuum dielectric,     D-H counter-ions
C        3      Uniform dielectric,    D-H counter-ions
C        4   Eichele & Mehler diel.,   D-H counter-ions
C        5      Warshel dielectric,    D-H counter-ions
C        6   Dist. dep. dielectric,    D-H counter-ions

C        7  ###### Planar interface method (GET TO iT  JW ) ########
C        8   ###### Tanford - Kirkwood ( S.A. modified ?? ) ########

C Set up the method arrays which control level of calculation.
C In the CALTYP array ;
C		        "EASY" means straight look up on eps and c-i
C		        "COOL" means calc of eps reqd, (lookup c-i)
C		        "BIND" means convoluted int., (inhomogeneous)

	CALTYP (1) = 'EASY'
	CALTYP (2) = 'EASY'
	CALTYP (3) = 'EASY'
	CALTYP (4) = 'COOL'
	CALTYP (5) = 'COOL'
	CALTYP (6) = 'COOL'
	CALTYP (7) = 'BIND'
	CALTYP (8) = 'BIND'

C Initialise the CALC array flags.
Clnx - we (lnx) found an age-old error here - we had N for I in CALC (.)

	    DO 303 I = 1, 10
	    CALC (I) = .FALSE.
303	    CONTINUE

C If the Plot flag is set, then skip some of the reads for dummy reads.

	IDUMRD = 2
	IF ( PLOT ) CALL DUMRD ( IDUMRD )
	IF ( PLOT ) GOTO 367

C If the OUTSA flag is set then specific S.A. information for each atom
C is output to the data file, using VdW radii set with index which_VdW.
C RPROBE is the probe radius.
C PLNDIV is the division between planes for the S.A. calculation.
C NANG is the number of sample points takne on each plane circle.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'SACC' ) STOP 'SACC'
	READ (9,*) OUTSA, RPROBE, PLNDIV, NANG, which_VdW

	IF ( RPROBE .GT. 5. ) STOP 'RPROBE > 5.'
	IF ( PLNDIV .LT. 0.1 ) STOP 'PLNDIV < 0.1'
	IF ( PLNDIV .GT. 1.0 ) STOP 'PLNDIF > 1.0'
	IF ( NANG .LT. 10 ) STOP 'NANG < 10'
	IF ( NANG .GT. 720 ) STOP 'NANG > 720'

C VALEN (ICAL) stores the valency (z) for the { z+,z- } ion pair.

C CONCI (ICAL) is the ion species molarity.

367	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT1' ) STOP 'OPT1'
	READ (9,*) CALC (1), DIEL (1,1)			! Uniform e, no c-i
	CONCI (1) = 0.
	VALEN (1) = 0.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT2' ) STOP 'OPT2'
	READ (9,*) CALC (2), CONCI (2), VALEN (2)	! Vac e, c-i
	DIEL (2,1) = 1.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT3' ) STOP 'OPT3'
	READ (9,*) CALC (3), DIEL (3,1), CONCI (3), VALEN (3) ! Uni e, c-i

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT4' ) STOP 'OPT4'
	READ (9,*) CALC (4), CONCI (4), VALEN (4)	! E & M e, c-i

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT5' ) STOP 'OPT5'
	READ (9,*) CALC (5), CONCI (5), VALEN (5)	! Wshel e, c-i

C T61 is the multiplication constant that gives the dielectric value
C from the angstrom Rij value, for option 6 ONLY.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT6' ) STOP 'OPT6'
	READ (9,*) CALC (6), CONCI (6), VALEN (6), T61	! Dist. dep. e, c-i

C This (7) is the planar interface option.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT7' ) STOP 'OPT7'
	READ (9,*) CALC (7), DIEL (7,1), DIEL (7,2), CONCI (7),
     1             VALEN (7)

C @@@@@@  not letting this go, until sort out the c-i deal.
C @@@@@@  and program what I have in my notebook !

	IF ( CALC (7) ) STOP 'No planar Option please'

C This (8) is the Tanford - Kirkwood option.

	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT8' ) STOP 'OPT8'
	READ (9,*) CALC (8), DIEL (8,1), DIEL (8,2), CONCI (8),
     1             VALEN (8)
	READ (9,11) CHEK
	IF ( CHEK .NE. 'OPT8' ) STOP 'OPT8'
	READ (9,*) ATK, BTK, NLEGEN

C NLEGEN is the number of Legendre polynomials that will be included.
C ATK is the ion exclusion radius.  BTK is the protein radius.

	IF ( ATK .LT. BTK ) STOP 'ATK < BTK'

C Close the control file.

	CLOSE ( UNIT = 9 )

C In the post - Oct.90 ESCALC we allow only one calculation at a time (nset=1)

	nset		= 0
	DO 407 ical	= 1, 8
	  IF (calc (ical)) THEN
	    nset	= nset + 1
	    ncal	= ical
	  END IF
407	CONTINUE						! End ical
	IF (nset .NE. 1) STOP 'must be ONE method set'
	n1	= 2*ncal - 1
	n2	= 2*ncal
	WRITE (11,2010) spacer
	WRITE (11,2030) ncal, metha4 (n1), metha4 (n2)
	WRITE (11,1020) spacer

C Work out the Debye-Huckel parameters for all these methods.

	CALL DHCAL

C Set the constants in the Tanford-Kirkwood routine, if required.

	SETUP = .TRUE.
	IF (ncal .EQ. 8) THEN
	  CALL TANKIRK ( SETUP, RIJ, COSTIJ, ESIJ )
	END IF

C If we just want to see a Wij versus Rij plot for the chosen calculation
C in the normal opt records.  We will drop out in WIJPLT.

	IF ( PLOT ) CALL WIJPLT

C Use the "atoms_dat.for" module subroutines to read in the "atoms_es.dat"
C file of charges, atom types and VdW radii, and residues.

	CALL	read_atoms_es

C Lets get hold of them charges then.  NQ as the total number of charges.
C nq_ionise charges are ionisable.

	CALL READQ ( NQ, nq_ionise, PH, POTFIL )

C Work out Solvent Accessibility values for charges if required.  These are
C used for information - not for any modification of interaction values,
C unlike options in the old (pre-Oct90) ESCALC.

	IF (OUTSA) THEN
	  CALL	SACALC (NQ)
	END IF

C QT is the sum of all charges before reduced by any pH effects.
C QTCUR is the sum all charges modified by pH effects.

	QT	= 0.
	QTCUR	= 0.

	DO 1070 IQ = 1, NQ
	    Q = QR (IQ,4)
	    TQCUR = Q
	    PK = QR (IQ,5)
	    IF (pH_shift) THEN
	      IF ( QL (IQ,1) ) CALL QSHIFT ( Q, PH, PK, TQCUR )
	    END IF						! pH_shift
	    QCUR (IQ)	= TQCUR
	    QTCUR	= QTCUR + QCUR (IQ)
	    QT = QT + Q
1070	CONTINUE						! End IQ
	q_before	= qtcur

C If skip_ijcalc is set then write out dummy values for the second set of
C charge output - other than for the current pk = standard pk.

	IF (skip_ijcalc) THEN
	  WRITE (3) 0., 0., 0., 0., 0., 0.
	  DO 1065 iq	= 1, nq
	    pkcur_skip	= qr (iq,5)
	    WRITE (3) 0., 0., 0.,
     1		      0., 0., pkcur_skip,
     2		      0., 0., 0.
1065	  CONTINUE						! End iq
	  CLOSE (UNIT=3)
	  WRITE (11,1025) spacer
	  WRITE (11,2060)
	  WRITE (11,2062) qt, q_before
	  WRITE (11,1025) spacer
	  CLOSE (UNIT=11)
	  CALL	EXIT
	END IF							! skip_ijcalc

	VERGED	= .FALSE.

C Calculate 'ambient' potentials at each site for the current charge set.

	NIT = 0
	CALL CALIJ ( NQ, nq_ionise, NIT )

C Iterate the pK values of ionisable groups, if required.

	IF (itrate) THEN

	  DO 1080 iq	= 1, nq
	    pkcur (iq)	= qr (iq,5)
1080	  CONTINUE						! End iq

	  WRITE (11,2010) spacer
	  DO 1700 nit	= 1, 100
	    IF (NIT .NE. 1) CALL CALIJ (NQ, nq_ionise, NIT)
	    nsite	= 0
	    rms		= 0.
	    qtcur	= 0.
	    DO 1203 iq	= 1, nq
	      IF (ql (iq,1)) THEN
		nsite	= nsite + 1
		QOLD	= QCUR (IQ)
		PKOLD	= PKCUR (IQ)
		PKNEW	= QR (IQ,5) + DELPK (IQ)
		PKINC	= PKNEW - PKOLD
		PKNEW	= PKOLD + PKSMOO * PKINC
		PK	= PKNEW
		Q	= QR (IQ,4)
		CALL QSHIFT ( Q, PH, PK, TQCUR )
		QCUR (IQ) = TQCUR
		RMS	= RMS + ( PK - PKOLD ) ** 2
		PKCUR (IQ) = PK
	      END IF						! ql (iq,1)
	      QTCUR	= QTCUR + QCUR (IQ)
1203	    CONTINUE						! End iq
	    IF ((nsite.EQ.0) .OR. (nsite.NE.nq_ionise)) STOP 'nsite'
	    RMS		= SQRT (RMS) / FLOAT (NSITE)
	    IF ( RMS .LT. RMSFIN ) THEN
	      verged	= .TRUE.
	    END IF
	    WRITE (11,2020) nit, qtcur, rms
	    IF ((verged) .OR. (nit .GT. nitmax)) GOTO 1900
1700	  CONTINUE						! End nit
	  STOP 'CANNOT POSSIBLY BE'

1900	  WRITE (11,1025) spacer
	  WRITE (11,2040) nit, qtcur, rms

	ELSE

	  WRITE (11,1025) spacer
	  WRITE (11,2050)

	END IF							! itrate

C Calculate the"buffer" energy for each ionisable group, if iterating pKs.
C I will keep this as was (Oct90), so that units are ok.  Still contentious?

	IF (itrate) THEN
	  wbufer	= 0.
	  DO 1905 iq	= 1, nq
	    show_action (iq) = .FALSE.
1905	  CONTINUE						! End iq
	  DO 1910 iq	= 1, nq
	    IF (ql (iq,1) .AND. (.NOT.show_action (iq))) THEN
	      PKINT	= QR (IQ,5)
	      QFULL	= QR (IQ,4)
	      FF	= 1.
	      IF ( QFULL .GT. 0. ) FF = -1.
	      ptot	= (poti_pK (iq)*qr (iq,8)*con3*elec) / con1
	      CALL FCALC ( FPROT, PTOT, PH, PKINT, FF )
	      CALL FCALC ( FBULK,   0., PH, PKINT, FF )
	      wbufi (iq) = - FF * 2.30258 * (PH-PKINT) * (FPROT-FBULK)
	      wbufer	= wbufer + wbufi (iq)
	      IF ((qi (iq,3).NE.-1) .AND. (qi (iq,3).NE.-2)) THEN
		ip			= qi (iq,3)
		IF (show_action (ip)) STOP '?? make a 900 write'
		wbufi (ip)		= wbufi (iq)
		show_action (ip)	= .TRUE.
		show_action (iq)	= .TRUE.
	      END IF
	    END IF						! ql (iq,1)
1910	  CONTINUE						! End iq
	END IF							! itrate

C Convert the Buffer and Wij energies to kJ/mole, and sum them to give
C the total energy.

	sumwij_1	= sumwij_1 * (con4*elec*con3)
	sumwij_1	= sumwij_1 / 2.
	sumwij_2	= sumwij_2 * (con4*elec*con3)
	sumwij_3	= sumwij_1 + sumwij_2
	WBUFER	= CON4 * CON1 * WBUFER
	TENER	= CON4 * ELEC * CON3 * ENERGY
	WTOT	= WBUFER + TENER

	WRITE (11,2070) sumwij_1
	WRITE (11,2080) sumwij_2
	WRITE (11,2090) sumwij_3
	WRITE (11,2100) wbufer
	WRITE (11,2110) tener
	WRITE (11,2120) wtot
	WRITE (11,2130) qtcur
	WRITE (11,2140) qt, q_before
	WRITE (11,1020) spacer

C Write charge information to the (potfil) data file, and close it.
C Units conversion of the arrays happens now - so that ALL subsequent
C use of these arrays must account for the new units.
C charges	will be	in	e units
C energies	will be in	kJ/mole
C potentials	will be in	mV

	WRITE (3) wbufer, tener, wtot, qtcur, qt, q_before
	convert_1	= con4 * con1
	convert_2	= con4 * elec * con3
	convert_3	= con3 * 1000.
	DO 1960 iq	= 1, nq
	  wi (iq)	= convert_2 * wi (iq)
	  wbufi (iq)	= convert_1 * wbufi (iq)
	  poti (iq)	= convert_3 * poti (iq)
	  poti_pK (iq)	= convert_3 * poti_pK (iq)
	  poti_fixed (iq) = convert_3 * poti_fixed (iq)
	  WRITE (3) poti (iq), poti_fixed (iq), poti_pK (iq),
     1		    qcur (iq), qr (iq,8), pKcur (iq),
     2		    delpK (iq), wi (iq), wbufi (iq)
1960	CONTINUE						! End iq
	CLOSE (UNIT=3)

C Write out individual charge information if required, (units already
C converted in the unit 3 output loop).

	IF (more_charge_info) THEN
	  WRITE (11,1025) spacer
	  WRITE (11,2200)
	  WRITE (11,1020) spacer
	  WRITE (11,2205)
	  WRITE (11,2210)
	  WRITE (11,1020) spacer
	  DO 1940 iq	= 1, nq
	    IF (ql (iq,1)) THEN
	      WRITE (11,2220) iq, qi (iq,3), qr (iq,8), poti_pK (iq),
     1			      qi (iq,1), (qa4 (iq,m), m=1,2),
     2			      pKcur (iq), qcur (iq), wi (iq),
     3			     wbufi (iq)
	    ELSE
	      IF (most_charge_info) THEN
		WRITE (11,2240) iq, qi (iq,1), (qa4 (iq,m), m=1,2),
     1				qcur (iq), wi (iq)
	      END IF
	    END IF
1940	  CONTINUE						! End iq
	  WRITE (11,1020) spacer
	END IF							! charge info

	IF (.NOT.MAPOUT) GOTO 3000    ! Set up the map grid, if required

      MMAX(1)=-1000.
      MMAX(2)=-1000.
      MMAX(3)=-1000.
      MMIN(1)=1000.
      MMIN(2)=1000.
      MMIN(3)=1000.

C Loop over all the coordinate files.

	DO 2600 IFIL = 1, NFIL

C ??	    CALL PUTBYT ( BITE, PDBFIL, IFIL )
	    BITE	= PDBFIL (IFIL)
	    OPEN ( UNIT=1, NAME=BITE, TYPE='OLD')
	    READ(1,2305) BITE
2305	    FORMAT(A80)

2320	    CONTINUE
	    READ(1,2330,END=2400) ATM,ATMTYP,RES,chain,NCUR,XYZT
2330	    FORMAT(A4,9X,A1,3X,A4,A1,I4,4X,3F8.3)

	    CALL TRNCRD ( XYZT, XYZ )

	    X = XYZ (1)
	    Y = XYZ (2)
	    Z = XYZ (3)

	    IF(X.GT.MMAX(1)) MMAX(1)=X
	    IF(X.LT.MMIN(1)) MMIN(1)=X
	    IF(Y.GT.MMAX(2)) MMAX(2)=Y
	    IF(Y.LT.MMIN(2)) MMIN(2)=Y
	    IF(Z.GT.MMAX(3)) MMAX(3)=Z
	    IF(Z.LT.MMIN(3)) MMIN(3)=Z

	    GOTO 2320

C Vacate the unit, ready for the next file.

2400	    CLOSE ( UNIT = 1 )

2600	CONTINUE

      TOT(1)=MMAX(1)-MMIN(1)
      TOT(2)=MMAX(2)-MMIN(2)
      TOT(3)=MMAX(3)-MMIN(3)

C IJK(GRID) = (XYZ(MOL) - ZERO(MOL))/STEP , WITH IAX ADJUSTMENT.

C SECTION AXIS IS THE PLANE STACKING AXIS FOR THE 2-D CONTOUR.
C IAX(1)=SECTION AXIS - DETERMINES OTHER AXES FOR R-H SET.

      GOTO (205,206,207) IAX(1)
205    IAX(2)=2
      IAX(3)=3
      GOTO 210
206    IAX(2)=3
      IAX(3)=1
      GOTO 210
207    IAX(2)=1
      IAX(3)=2
210    CONTINUE

C IAX INDICES ARE GRID AXES. XAI (INVERSE) INDICES ARE MOLEC AXES.

      DO 6650 IX=1,3
      DO 6650  IY=1,3
      IF(IAX(IY).NE.IX) GOTO 6650
      XAI(IX)=IY
6650   CONTINUE

C Generate the grid and o/p genaration data.

      CALL GRDGEN(TOT,MMIN,MMAX,FGSIZE,ZERO,FGRDIM,
     1  IZER,IAX,XAI,STEPF,EXTEND)

C Lets set up the variable dimension arrays.

	ID=FGRDIM(1)
	JD=FGRDIM(2)
	KD=FGRDIM(3)

	NTOTP=KD*JD*ID
	IF(NTOTP.GT.195112) STOP 'NTOT > 195112'

	WRITE(11,7481) ID,JD,KD,NTOTP
7481	FORMAT('0','ARRY',' ID, JD, KD, NTOT  =  ',4(I6,1X))

C Sep 2001 - shouldn't be here - we've hijacked POTFIL anyhow.

	i_one	= 1
	IF (i_one .EQ. 1) STOP 'POTFIL for potl?'

	CALL POTMAP ( NQ, QCUR, QR, QI, POT, KD,JD,ID, MMIN, EXTEND,
     1               STEPF, ZERO, IAX, XAI, POTFIL )

C That is it, then mate; see you again some time.

3000	CALL EXIT

8200	WRITE (11,8210)
8210	FORMAT ('0',' Error reading the coordinate/charge files')
	STOP

	END



	SUBROUTINE DUMRD ( IDUMRD )
C	********** *****

C This routine simply reads IDUMRD dummy lines from unit 9.

	DO 130 I = 1, IDUMRD
	    READ (9,*)
130	CONTINUE

	RETURN
	END



C ??	SUBROUTINE PUTBYT ( B, BA, I )
C	********** ******

C This routine simply puts the byte contents of I slot of BA array
C into the B string.

C ??	BYTE BA (5,80), B (80)

C ??	DO 120 N = 1, 80
C ??	    B (N) = BA (I,N)
C ??120	CONTINUE

C ??	RETURN
C ??	END


C ??	SUBROUTINE BYTPUT ( BA, I, B )
C	********** ******

C This routine simply puts the contents of the B byte string into the
C I slot of the BA byte array.

C ??	BYTE BA (5,80), B (80)

C ??	DO 120 N= 1,80
C ??	    BA (I,N) = B (N)
C ??120	CONTINUE

C ??	RETURN
C ??	END



	SUBROUTINE DHCAL
C	********** *****

C This routine calculates the Debye-Huckel parameter from the
C counter-ion molarity and valency.

C For CALTYP 'EASY', calculate the complete D-H parameter.
C For CALTYP 'COOL', calculate D-H parameter missing a divide
C by the square root of the relative dielectric permittivity.

C ###### Actually, at present, I will be simply using a dielectric
C ###### of bulk water for the 'COOL' calculations - since D-H param.
C ###### describes c-i attenuation, and c-i s only present in
C ###### solvent regions.

C############### IS D-H VALID AT ALL for 'COOL' ?? EMPIRICAL ??

C For CALTYP 'BIND', calculate the complete D-H parameter WITH
C the solvent dielectric value, (stored in DIEL (ncal,2)).

	CHARACTER*4	CALTYP (10)
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	INTEGER		which_VdW
	LOGICAL	CALC (10), OUTSA, more_charge_info, most_charge_info
	REAL	LOG10E
	LOGICAL	BULKDH

	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6


	    IF ( CALTYP (ncal) .EQ. 'EASY' ) D = DIEL (ncal,1)
	    IF ( CALTYP (ncal) .EQ. 'BIND' ) D = DIEL (ncal,2)

C A1 is the average number of { z+,z- } ion pairs per metre_cubed.

	    A1 = AVAGAD * 1. E 3 * CONCI (ncal)

	    A2 = EPSZER * BOLT * TEMP

	    A3 = VALEN (ncal) * ELEC

	    A4 = A3 * ( SQRT ( 2. * A1 ) / SQRT (A2) )

	    IF ( CALTYP (ncal) .NE. 'COOL' ) A4 = A4 / SQRT ( D )

C Now arrange so that DEBHUK * R (angstroms) gives the exponent,
C apart from the 'COOL' case, where still need the divide by sqrt (D).

	    DEBHUK	= A4 * 1. E -10

	RETURN
	END



	SUBROUTINE GRDGEN ( TOT,MMIN,MMAX,FGSIZE,ZERO,FGRDIM,
C	********** ******
     1                      IZER,IAX,XAI,STEPF,EXTEN )

C Subroutine to setup grid and output grid data.

      REAL TOT(3),MMIN(3),MMAX(3),FGSIZE(3),ZERO(3)

      INTEGER FGRDIM(3),IZER(3),IAX(3),XAI(3)

	CHARACTER*1	AXIS
	CHARACTER*4	RNAM
      BYTE DIVIDE (80)

	DATA DIVIDE / 80 * '+' /

C EXTEND may be used to generate b.c. distance from atoms. Therefore,
C must contain this inside of the tesian grid setup.

	EXTEND=EXTEN+STEPF

C ZEROx    records the molecular ordinate of the first FG element.
C FGRDIMi  records the total number of FG elements.
C FGSIZEx  records the unit cell dimension of the FG.
C IZERi    records the FG element corresponding to zero molecular
C          ordinate.

C M is the molecular axis; I is the grid axis.
C Make sure that ZERO is a multiple of STEPF, so that we can match up
C precisely with the coordinates in FRODO, (and this is also PEPR).

      DO 90 M=1,3

            I=XAI(M)
	    IZER(I)=0

	    ITMP = INT ( ((MMIN(M)-EXTEND)/STEPF) )
	    ZERO (M) = STEPF * FLOAT (ITMP)
	    IF ( (MMIN(M)-EXTEND) .LT. 0. ) ZERO (M) = ZERO (M) - STEPF
C	ZERO(M)=MMIN(M)-EXTEND
            FGRDIM(I)=INT((TOT(M)+2.*EXTEND)/STEPF)+2
            FGSIZE(M)=(FGRDIM(I)-1)*STEPF

90	    CONTINUE

2	FORMAT ('0',21X,'The ICAL method number is ....   ',I2)
3	FORMAT ('0',80A1)
4	FORMAT ('0',20X,'THIS ESCALC RUN IS PRODUCING A MAP FILE')
5      FORMAT(' ',' MOLECULE ON ',A1,' IS ',F8.3,' FROM ',F8.3,
     1  ' TO ',F8.3)
10     FORMAT(' ',' * ',A4,' *  X Y Z *   ',3F12.4)
12     FORMAT(' ',' * ',A4,' *  X Y Z *   ',3I6)
15     FORMAT(' ',' * ',A4,' *  I J K *   ',3I6)
17     FORMAT(' ',' * ',A4,' *  I J K *   ',3F12.4)
20     FORMAT(' ')

	WRITE (11,3) DIVIDE
	WRITE (11,4)
	WRITE (11,20)
      AXIS='X'
      WRITE(11,5) AXIS,TOT(1),MMIN(1),MMAX(1)
      AXIS='Y'
      WRITE(11,5) AXIS,TOT(2),MMIN(2),MMAX(2)
      AXIS='Z'
      WRITE(11,5) AXIS,TOT(3),MMIN(3),MMAX(3)
	WRITE (11,20)
      RNAM='FGSZ'
      WRITE(11,10) RNAM,FGSIZE
      RNAM='ZERO'
      WRITE(11,10) RNAM,ZERO
      WRITE(11,20)
      RNAM='FGRD'
      WRITE(11,15) RNAM,FGRDIM
      WRITE(11,20)
      RNAM=' IAX'
      WRITE(11,15) RNAM,IAX
      RNAM=' XAI'
      WRITE(11,12) RNAM,XAI
	WRITE (11,3) DIVIDE

      RETURN
      END


	SUBROUTINE POTMAP ( NQ, QCUR, QR, QI, POT, KD,JD,ID, MMIN,
C	********** ******
     1                      EXTEND, STEPF, ZERO, IAX, XAI, POTFIL )

C This subroutine outputs the potential map on a grid that is
C compatible with the PEPR grid - set up with EXTEND and STEPF
C and IAX(1).

	DIMENSION POT(KD,JD,ID)
	DIMENSION	POTROW(200)
	REAL 	MMIN (3), ZERO (3)
	CHARACTER*80	POTFIL
	INTEGER IAX(3),XAI(3)
	REAL 	QCUR (30000), QR (30000,8)
	INTEGER QI (30000,3)
	CHARACTER*4	CALTYP (10)
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	INTEGER		which_VdW
	LOGICAL	CALC (10), OUTSA, more_charge_info, most_charge_info
	REAL	LOG10E, XYZ (3), XYZQ (3)
	LOGICAL	BULKDH

	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6

	DATA DIBULK / 78.4 /

	IF ( ncal .EQ. 7 ) Stop 'ncal = 7'
	OPEN ( UNIT=9, NAME=POTFIL, TYPE='NEW', FORM='UNFORMATTED' )

	DO 300 I = 1, ID
	    XYZ (IAX(1)) = ZERO (IAX(1)) + STEPF * FLOAT (I-1)
	    DO 300 J = 1, JD
		XYZ (IAX(2)) = ZERO (IAX(2)) + STEPF * FLOAT (J-1)
		DO 290 K = 1, KD
		    XYZ (IAX(3)) = ZERO (IAX(3)) + STEPF * FLOAT (K-1)
		    POTROW (K) = 0.
		    DO 280 IQ = 1, NQ
			DO 220 N = 1, 3
			    XYZQ (N) = QR (IQ,N)
220			CONTINUE				! End N
			DIJ = SQRT ( ( XYZ(1) - XYZQ(1) ) ** 2 +
     1                               ( XYZ(2) - XYZQ(2) ) ** 2 +
     1                               ( XYZ(3) - XYZQ(3) ) ** 2 )

C Solvent Accessibility modified Tanford-Kirkwood is ncal = 8.
C Since the Phi field is not on the surface of sphere we will cheat, and
C take simply UNIDH fn at spec. I, with diel=80, and qcur values;
C Rather than do T-K that would give spherical boundary .. Screwy anyway.

			IF ( CALTYP (ncal) .EQ. 'COOL' )
     1                     CALL DICAL ( DIEL, ncal, DIJ )
			DILEC = DIEL (ncal,1)
			IF ( ncal .EQ. 8 ) DILEC = DIEL (ncal,2)
			ESIJ = 1. / ( DILEC * DIJ )

			DHT = DEBHUK
			IF ( CALTYP (ncal) .NE. 'COOL' ) GOTO 380
			DIDH = DIBULK
			IF ( .NOT. BULKDH ) DIDH = DIEL (ncal,1)
			DHT = DEBHUK / SQRT (DIDH)

380			ESIJ = ESIJ * ENAT ** ( - DHT * DIJ )
			POTROW (K) = POTROW (K) + ESIJ * QCUR (IQ)

280		    CONTINUE					! End IQ

C The potential output is in milli_Volts.

		    POTROW (K) = 1000. * CON3 * POTROW (K)
290		CONTINUE					! End K
		WRITE (9) ( POTROW (K), K = 1, KD )
300	    CONTINUE						! End J,I

	CLOSE ( UNIT=9 )

	RETURN
	END


	SUBROUTINE READQ ( NQ, nq_ionise, PH, POTFIL )
C	********** *****

C Input charges from coordinate files, under the control of the charge
C files, with basic charge information coming from the "atoms_es.dat" arrays.

	REAL	QR(30000,8), QCUR(30000)
	CHARACTER*4	QA4(30000,3)
	INTEGER QI(30000,3)
	LOGICAL		QL(30000,2)
	CHARACTER*1	QC(30000)
	LOGICAL IONISE, ITRAT1, switchq
	LOGICAL MACINC,ITRATE
	REAL	TRNFIL (5,3), ROTFIL (5,3,3)
	CHARACTER*80	HED (5), QFIL (5), PDBFIL (5), BITE
C ??	BYTE	HED (5,80), QFIL (5,80), PDBFIL (5,80), BITE (80)
	CHARACTER*80	POTFIL
	CHARACTER*4	CALTYP (10), check, atyp, res, prtner,
     1			atyp_over, res_over, atyp_swch, res_swch,
     2			atyp_prt
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	INTEGER		which_VdW, nres_hel (4)
	LOGICAL	CALC (10), BULKDH, OUTSA
	CHARACTER*4	over_char (200,3), swch_char (100,2),
     1			xtra_char (200,3), common_atyp (100),
     2			res_type (200), at_type (2000),
     3			at_prtner (2000), buf_atyp (100,2),
     4			buf_res (100,2), buf_atom (100,2),
     5			exclude (200,2)
	REAL		buf_xyz (100,3,2),
     2			over_real (200,2), xyz (3),
     3			xtra_real (200,5), xyz_hel (4,3),xyz_trn (3),
     4			at_VdW (100,10), at_chrg (2000,4),
     6			at_pK (2000)
	INTEGER		over_int (200),helix (200,2),xtra_int (200,2),
     1			buf_nres (100,2), n_buf (2), n_hel (4),
     2			n_res_ats (200), nat_pter (200,2),
     3			at_class (2000), common_pter (100),
     4			at_Qfiled (2000,2), swch_int (100)
	CHARACTER*1	buf_chain (100,2), chain, over_chain (200),
     1			chain_over
	LOGICAL*1	over_log (200), xtra_log (200,2),
     1			found_hel (4), at_excl (2000),
     2			at_anyq (2000), at_ionise (2000), common_at,
     3			check_override, check_swch
	LOGICAL		end_of_file, track_split, track_split_first,
     1			itrate_first, macinc_first,more_charge_info,
     2			pH_shift, move_file (5), most_charge_info,
     3			first_res, first_atom
	BYTE		spacer (80)
	CHARACTER*80	atom_record
	CHARACTER*34	at_info (100)

	COMMON /FILE/ QFIL, NFIL, IFIL, TRNFIL, ROTFIL, PDBFIL, HED,
     1                BITE, move_file
	COMMON /QHOLD/ QR, QCUR, QA4, QL, QI, QT, QTCUR, MACINC,
     1                 ITRATE, q_before, QC
	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON	/atoms_es_type/ at_info, n_at_types, at_VdW, n_VdW
	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/common_atoms/	common_atyp, common_pter, n_common
	COMMON	/charge_set/	i_qset, track_split, pH_shift
	COMMON	/helices/	n_helices, helix
	COMMON	/exclude_class/ n_exclude, exclude, at_excl
	COMMON	/override/	over_real, over_int, over_log,
     1				n_override, over_char, over_chain
	COMMON /switching/	nq_switch, swch_char, swch_int
	COMMON	/xtra/		xtra_real, xtra_int, xtra_log,n_extra,
     1				xtra_char
	COMMON	/coord_buf/	buf_atyp, buf_res, buf_xyz,
     1				buf_atom, buf_nres, first_res,
     2				atom_record, n_buf, first_atom,
     3				buf_chain
	COMMON	/first_info/	i_qset_first, itrate_first,
     1				macinc_first, track_split_first

	DATA	spacer	/ 80 * '-' /
	DATA	qhel	/ 0.5 /

C qhel is the helix dipole charge in e units.

C----------------------------------------------------------------------------
C QFIL is the file that controls which charges are to be included in
C the calculation, for each separate coordinate file, ( separate QFIL).
C It should contain:
C A header record followed by:
C specification of "atoms_es.dat" charge set to be used.
C			QSET
C			i_qset
C specification of helix dipoles to be included (if any).
C			HELX
C		        macinc, n_helices
C			n1,n2 (one helix per record)
C do we iterate ionisable group charges or not? (must remain const over ifil)
C			ITER
C			itrate
C			atyp, res (one set per record)
C exclude charged atom classes
C			EXCL
C			n_exclude
C			atyp, res (one set per record - in exclude array)
C overide individual charge assignements
C			OVER
C			n_override
C			atyp,res,chn,nres, newq, newionise, newpk, newprtner
C tag charges that can be switched through increments in FDCALC
C			SWCH
C			nq_switch
C			atyp, res, nres
C listing of extra charges
C			XTRA
C			n_extra
C			iclass,atyp,res,nres,q,ionise,pK,prtner,switchq,xyz
C end of charge file
C			END 
C----------------------------------------------------------------------------
C individual charge override arrays -
Clnx	over_real (i,1-5)	-	atyp, res, newq, newpk, newprtner
C	over_real (i,1/2)	-	           newq, newpk
C	over_char (i,1-3)	-	atyp, res,              newprtner
C	over_chain (i)		-	chain id
C	over_int (i)		-	nres
C	over_log (i)		-	newionise
C----------------------------------------------------------------------------
C individual swch charge arrays -
Clnx	swch_real (i,1-2)	-	atyp, res
C	swch_char (i,1/2)	-	atyp, res
C	swch_int (i)		-	nres
C----------------------------------------------------------------------------
C extra charge arrays -
Clnx	xtra_real (i,1-8)	-	atyp, res, newq, newpk, newprtner, xyz
C	xtra_real (i,1-5)	-	           newq, newpk,            xyz
C	xtra_char (i,1-3)	-	atyp, res,              newprtner
C	xtra_int (i,1/2)	-	nres, atomclass
C	xtra_log (i,1/2)	-	newionise, switchq
C----------------------------------------------------------------------------

1018	FORMAT (A80)
1020	FORMAT (80A1)
1025	FORMAT (/,80A1)
1030	FORMAT (A4)
1040	FORMAT (A4,2X,A4)
1050	FORMAT (A4,2X,A4,2X,A1,I4,2X,F6.3,2X,L1,2X,F5.2,2X,A4)
1055	FORMAT (A4,2X,A4,2X,I5)
1060	FORMAT (I2,2X,A4,2X,A4,2X,I5,2X,F6.3,2X,L1,2X,F5.2,2X,A4,
     1		1X,L1,2X,3F8.3)
1200	FORMAT (' ',20X,'Charge Input in READQ subroutine')
1210	FORMAT (/,' Coordinate/Charge file set number ',I1,' ---')
1215	FORMAT ('0',12X,'(x,y,z) Translation vector = ',3(2X,F7.2))
1220	FORMAT (' ',80A1)
1225	FORMAT ('0',30X,'The Rotation Matrix')
1235	FORMAT ('0',26X,3(2X,F7.2))
1230	FORMAT (' WE ARE USING CHARGE SET number -- 1 --
     1 with single site ionisable groups')
1240	FORMAT (' WE ARE USING CHARGE SET number -- 2 --
     1 with split site ionisable groups',/,
     2 ' but without partial charges')
1250	FORMAT (' WE ARE USING CHARGE SET number -- 3 --
     1 with split site ionisable groups',/,
     2 ' and with partial charges')
1260	FORMAT (' WE ARE USING CHARGE SET number -- 4 --
     1 with partial charges also on the ionisable ',/,
     2 ' groups - we cannot iterate this system',/,
     3 ' AND NOTE THAT WE WILL NOT SHIFT FOR pH - ok there?')
1270	FORMAT (/,I4,' helix dipoles input for file set ',I1,
     1 ' with charge counter at ',I5)
1280	FORMAT (/,' Exclusions for ',I3,' classes of charged
     1 atoms as follows -',/)
1290	FORMAT (' ',' res, atyp = ',A4,2X,A4,' excluded (common atom)')
1295	FORMAT (' ',' res, atyp = ',A4,2X,A4,' excluded')
1298	FORMAT (' ',' q switch charge atom ',A4,2X,A4,2X,I5,
     1 ' recorded as switchable')
1300	FORMAT (' ',' override charge atom ',A4,2X,A4,2X,A1,I4,
     1 ' not filed - charge < 0.001')
1305	FORMAT (/,' file set ',I1,' - number q switch input = ',I3,
     1 ' number q switch done = ',I3)
1310	FORMAT (/,' file set ',I1,' - number override input = ',I3,
     1 ' number override done = ',I3)
1320	FORMAT (/,' file set ',I1,' - residues read in = ',I5,
     1 ' current charge counter = ',I6,/)
1330	FORMAT (' ',' extra charge number ',I3,' for file set ',I1,
     1 ' not filed (< .001)')
1340	FORMAT (/,' file set ',I1,' - number extra input = ',I3,
     1 ' number extra charges filed = ',I3)
1350	FORMAT (/,' END of charge file input - we have a total of ',
     1 I6, ' charges filed')
1360	FORMAT (/,' WITH total helices = ',I4,' AND total extra
     1 charges = ',I4)
1365	FORMAT (' ',20X,'CHARGED ATOM CLASS INFORMATION')
1370	FORMAT (' ',' resi  atom  max-charge  ionise   pK   prtner
     1  VdW rad  no.filed  atom  resi')
1380	FORMAT (' ',1X,A4,3X,A4,4X,F6.3,6X,L1,4X,F5.2,3X,A4,2X,F5.2,
     1		    3X,I5,6X,A4,2X,A4)
1383	FORMAT (' ',20X,'SETTING SPLIT IONISABLE GROUP PAIRS')
1385	FORMAT (' ','partner not found for split atom ',A4,2X,A4,A1,I4)
1390	FORMAT (/,' number of split pairs assigned = ',
     1 I5,' and no. missing partners = ',I5)

9000	FORMAT ('0','*** ERROR * readq * A4 charge file flag wrong')
9100	FORMAT ('0','*** ERROR * readq * i_qset is out of range')
9150	FORMAT ('0','*** ERROR * readq * which_VdW out of range')
9200	FORMAT ('0','*** ERROR * readq * n_helices .gt. 200')
9250	FORMAT ('0','*** ERROR * readq * macinc consistency problem')
9300	FORMAT ('0','*** ERROR * readq * n_exclude .gt. 200')
9350	FORMAT ('0','*** ERROR * readq * cannot iterate these chrgs')
9400	FORMAT ('0','*** ERROR * readq * n_override .gt. 200')
9420	FORMAT ('0','*** ERROR * readq * nq_switch .gt. 100')
9450	FORMAT ('0','*** ERROR * readq * higher i_qset - change readq')
9500	FORMAT ('0','*** ERROR * readq * n_extra .gt. 200')
9550	FORMAT ('0','*** ERROR * readq * helix must be at least 6 aas')
9600	FORMAT ('0','*** ERROR * readq * problem with HELX section')
9650	FORMAT ('0','*** ERROR * readq * flags changed over file sets')
C ?? C-t 9700	FORMAT ('0','*** ERROR * readq * too many atms in res')
9750	FORMAT ('0','*** ERROR * readq * i_class is out of range')

C For each coordinate file and charge file set first read in the charge file
C information, (helices, atom class exclusions, indidual atom charge
C overriding, switch tagging, extra charges), and then go through the coord
C file enacting the charge file demands, and assigning charges.
C For all of these sections, in which groups are listed by residue number,
C we assume that the numberings are sequential and that they correspond to
C the coordinate file sequence.

	WRITE (11,1025) spacer
	WRITE (11,1200)

	IF ((which_VdW.LT.1) .OR. (which_VdW.GT.n_VdW)) GOTO 915
	nq			= 0
	nq_ionise		= 0
	DO 140 ia		= 1, n_all_at
	  at_Qfiled (ia,1)	= 0
	  at_Qfiled (ia,2)	= 0
140	CONTINUE						! End ia
	n_extra_total		= 0
	n_helices_total		= 0
	DO 600 ifil	= 1, nfil
	  WRITE (11,1210) ifil
C ??	  CALL	putbyt (bite, qfil, ifil)
	  bite		= qfil (ifil)
	  OPEN (UNIT=3, NAME=bite, TYPE='OLD')
	  WRITE (11,1018) bite
	  READ (3,1018) bite
C ??	  CALL	putbyt (bite, pdbfil, ifil)
	  bite		= pdbfil (ifil)
	  OPEN (UNIT=1, NAME=bite, TYPE='OLD')
	  WRITE (11,1018) bite
	  IF (move_file (ifil)) THEN
	    WRITE (11,1215) (trnfil (ifil,n), n=1,3)
	    WRITE (11,1225)
	    DO 160 m	= 1, 3
	      WRITE (11,1235) (rotfil (ifil,m,n), n=1,3)
160	    CONTINUE						! End m
	  END IF
	  READ (1,1018) bite

	  READ (3,1030) check
	  IF (check .NE. 'QSET') GOTO 900
	  READ (3,*) i_qset
	  IF ((i_qset.LT.1) .OR. (i_qset.GT.n_chrg)) GOTO 910

	  READ (3,1030) check
	  IF (check .NE. 'HELX') GOTO 900
	  READ (3,*) macinc, n_helices
	  IF (n_helices .GT. 200) GOTO 920
	  IF (n_helices .NE. 0) THEN
	    IF (.NOT. macinc) GOTO 925
	    DO 200 ih	= 1, n_helices
	      READ (3,*) helix (ih,1), helix (ih,2)
200	    CONTINUE						! End ih
	  END IF

	  READ (3,1030) check
	  IF (check .NE. 'ITER') GOTO 900
	  READ (3,*) itrate
	  READ (3,1030) check
	  IF (check .NE. 'EXCL') GOTO 900
	  READ (3,*) n_exclude
	  IF (n_exclude .GT. 200) GOTO 930
	  IF (n_exclude .NE. 0) THEN
	    DO 260 ie	= 1, n_exclude
	      READ (3,1040) exclude (ie,1), exclude (ie,2)
260	    CONTINUE						! End ie
	  END IF

	  READ (3,1030) check
	  IF (check .NE. 'OVER') GOTO 900
	  READ (3,*) n_override
	  IF (n_override .GT. 200) GOTO 940

CJan.03	IF (n_override .NE. 0) STOP 'OCT.2001 override/chainid'

	  IF (n_override .NE. 0) THEN
	    DO 280 io	= 1, n_override
	      READ (3,1050) (over_char(io,m),m=1,2),
     1			     over_chain (io),over_int(io),
     2			     over_real(io,1),over_log(io),
     3			     over_real(io,2),over_char(io,3)
280	    CONTINUE						! End io
	  END IF

	  READ (3,1030) check
	  IF (check .NE. 'SWCH') GOTO 900
	  READ (3,*) nq_switch
	  IF (nq_switch .GT. 100) GOTO 942

C OCT.2001: Yet to update switch with chain id.
	IF (nq_switch .NE. 0) STOP 'OCT.2001 switch/chainid'

	  IF (nq_switch .NE. 0) THEN
	    DO 290 is	= 1, nq_switch
	      READ (3,1055) (swch_char(is,m), m=1,2), swch_int (is)
290	    CONTINUE						! End is
	  END IF

	  READ (3,1030) check
	  IF (check .NE. 'XTRA') GOTO 900
	  READ (3,*) n_extra
	  IF (n_extra .GT. 200) GOTO 950

C OCT.2001: Yet to update extra with chain id.
	IF (n_extra .NE. 0) STOP 'OCT.2001 extra/chainid'

	  IF (n_extra .NE. 0) THEN
	    DO 300 ix	= 1, n_extra
	      READ (3,1060) xtra_int(ix,2), (xtra_char(ix,m),m=1,2),
     1			    xtra_int(ix,1), xtra_real(ix,1),
     2			    xtra_log(ix,1), xtra_real(ix,2),
     3			    xtra_char (ix,3),
     4			    xtra_log(ix,2), (xtra_real(ix,m),m=3,5)
300	    CONTINUE						! End ix
	  END IF

	  READ (3,1030) check
	  IF (check .NE. 'END ') GOTO 900
	  CLOSE (UNIT=3)

C Check that choice of charge set is compatible with other flags.
C track_split setting will depend on the charge set.  It will be false for
C single site ionisable groups and for fully partially charged ionisable
C groups.  We need it set whether or not itrate is set, since we may still
C need to calculate energies over (not more than two) equivalent sites.
C ?? Note that we will have to expand this for more charge sets.

	  IF (ifil .EQ. 1) WRITE (11,1025) spacer
	  IF	  (i_qset .EQ. 1) THEN
	    track_split		= .FALSE.
	    pH_shift		= .TRUE.
	    IF (ifil .EQ. 1) WRITE (11,1230)
	  ELSE IF (i_qset .EQ. 2) THEN
	    track_split		= .TRUE.
	    pH_shift		= .TRUE.
	    IF (ifil .EQ. 1) WRITE (11,1240)
	  ELSE IF (i_qset .EQ. 3) THEN
	    IF (macinc) GOTO 925
	    track_split		= .TRUE.
	    pH_shift		= .TRUE.
	    IF (ifil .EQ. 1) WRITE (11,1250)
	  ELSE IF (i_qset .EQ. 4) THEN
	    IF (macinc) GOTO 925
	    IF (itrate) GOTO 935
	    track_split		= .FALSE.
	    pH_shift		= .FALSE.
	    IF (ifil .EQ. 1) WRITE (11,1260)
	  ELSE
	    GOTO 945
	  END IF
	  IF (ifil .EQ. 1) WRITE (11,1020) spacer

C Check that the charge input flags are consistent if we have multiple qfils.

	  IF (ifil .EQ. 1) THEN
	    IF (nfil .GT. 1) THEN
	      i_qset_first	= i_qset
	      itrate_first	= itrate
	      macinc_first	= macinc
	      track_split_first = track_split
	    END IF
	  ELSE
	    IF (i_qset .NE. i_qset_first) GOTO 965
	    IF (itrate .NEQV. itrate_first) GOTO 965
	    IF (macinc .NEQV. macinc_first) GOTO 965
	    IF (track_split .NEQV. track_split_first) GOTO 965
	  END IF

C Set the charge switching flag to false, until set otherwise.

	  switchq	= .FALSE.

C First the helices.

	  IF (n_helices .NE. 0) THEN
	    first_res		= .TRUE.
	    first_atom		= .TRUE.
	    end_of_file		= .FALSE.
	    DO 400 ih		= 1, n_helices
	      DO 320 m		= 1, 4
		found_hel (m)	= .FALSE.
320	      CONTINUE						! End m
	      nres_hel (1)	= helix (ih,1)
	      nres_hel (2)	= helix (ih,1) + 2
	      nres_hel (3)	= helix (ih,2) - 2
	      nres_hel (4)	= helix (ih,2)
	      IF ((nres_hel (4) - nres_hel (1)) .LE. 4) GOTO 955
340	      CALL	read_residue (end_of_file)
	      DO 360 m		= 1, 4
		IF (buf_nres (1,2) .EQ. nres_hel (m)) THEN
		  DO 350 ia	= 1, n_buf (2)
		    IF (buf_atyp (ia,2) .EQ. 'CA  ') THEN
		      DO 345 n		= 1, 3
			xyz_hel (m,n)	= buf_xyz (ia,n,2)
345		      CONTINUE					! End n
		      found_hel (m)	= .TRUE.
		      IF (m .EQ. 4) THEN
			GOTO 370
		      ELSE
			IF (end_of_file) THEN
			  GOTO 960
			ELSE
			  IF (first_res) first_res = .FALSE.
			  GOTO 340
			END IF
		      END IF
		    END IF					! If CA
350		  CONTINUE					! End ia
		  GOTO 960
		END IF						! If nres
360	      CONTINUE						! End m
	      IF (end_of_file) THEN
		GOTO 960
	      ELSE
		IF (first_res) first_res = .FALSE.
		GOTO 340
	      END IF

370	      pK		= 0.
	      res		= 'HELX'
	      ionise		= .FALSE.
	      prtner		= '    '
	      rad		= 0.
	      nres		= 0
	      DO 380 m		= 1, 4
		IF (.NOT. found_hel (m)) GOTO 960
380	      CONTINUE						! End m
	      q			= qhel
	      atyp		= 'AMIN'
	      DO 385 n		= 1, 3
		xyz (n)		= (xyz_hel (1,n) + xyz_hel (2,n)) / 2.
385	      CONTINUE						! End n
	      CALL	trncrd (xyz, xyz_trn)
	      CALL	qfile (nq, nq_ionise, xyz_trn,q,pK, res,atyp,
     1			       ionise, pH, nres, ifil, rad, prtner,
     2			       switchq, chain)
	      q			= - qhel
	      atyp		= 'CRXL'
	      DO 390 n		= 1, 3
		xyz (n)		= (xyz_hel (3,n) + xyz_hel (4,n)) / 2.
390	      CONTINUE						! End n
	      CALL	trncrd (xyz, xyz_trn)
	      CALL	qfile (nq, nq_ionise, xyz_trn,q,pK, res,atyp,
     1			       ionise, pH, nres, ifil, rad, prtner,
     2			       switchq, chain)
400	    CONTINUE						! End ih
	    WRITE (11,1270) n_helices, ifil, nq
	    n_helices_total	= n_helices_total + 1
	  END IF						! If hels

C And now the class exclusions.  Mark a temporary flag array that runs
C along all at_type slots.

	  DO 410 ia		= 1, n_all_at
	    at_excl (ia)	= .FALSE.
410	  CONTINUE						! End ia
	  IF (n_exclude .NE. 0) THEN
	    WRITE (11,1280) n_exclude
	    DO 440 ie		= 1, n_exclude
	      res		= exclude (ie,2)
	      CALL	res_id (res, ir, ia_1, ia_2, na)
	      atyp		= exclude (ie,1)
	      common_at		= .FALSE.
	      DO 420 i_com	= 1, n_common
		IF (atyp .EQ. common_atyp (i_com)) THEN
		  iat		= common_pter (i_com)
		  common_at	= .TRUE.
		END IF
420	      CONTINUE						! End i_com
	      IF (.NOT. common_at) THEN
		CALL	atom_id (atyp, iat, ia_1, ia_2)
	      END IF
	      at_excl (iat)	= .TRUE.
	      IF (common_at) THEN
		WRITE (11,1290) res, atyp
	      ELSE
		WRITE (11,1295) res, atyp
	      END IF
440	    CONTINUE						! End ie
	  END IF

C Read through the coordinate file, checking for overrides AND any charges
C to be switch tagged as we go along.  We will do the switch id checking
C at the front of the 540 loop, to catch regular and overriden charges
C and get switch right for qfile-ing.

	  REWIND 1
	  READ (1,1018) bite
	  end_of_file	= .FALSE.
	  first_res	= .TRUE.
	  first_atom	= .TRUE.
	  IF (n_override .NE. 0) THEN
	    check_override	= .TRUE.
	    i_over		= 1
	    nres_over		= over_int (i_over)
	    atyp_over		= over_char (i_over,1)
	    res_over		= over_char (i_over,2)
	    chain_over		= over_chain (i_over)
	  ELSE
	    check_override	= .FALSE.
	  END IF
	  IF (nq_switch .NE. 0) THEN
	    check_swch		= .TRUE.
	    i_swch		= 1
	    nres_swch		= swch_int (i_swch)
	    atyp_swch		= swch_char (i_swch,1)
	    res_swch		= swch_char (i_swch,2)
	  ELSE
	    check_swch		= .FALSE.
	  END IF
	  ir_read	= 0
	  i_overdone	= 0
	  i_swchdone	= 0
500	  ir_read	= ir_read + 1
	  CALL	read_residue (end_of_file)
	  res		= buf_res (1,2)
	  CALL	res_id (res, ir, ia_1, ia_2, na)
C ?? C-t	  IF (n_buf (2) .GT. na) GOTO 970
	  DO 540 in	= 1, n_buf (2)
	    atyp	= buf_atyp (in,2)
	    common_at	= .FALSE.
	    DO 510 i_com	= 1, n_common
	      IF (atyp .EQ. common_atyp (i_com)) THEN
		iat		= common_pter (i_com)
		common_at	= .TRUE.
	      END IF
510	    CONTINUE						! End i_com
	    IF (.NOT. common_at) THEN
	      CALL	atom_id (atyp, iat, ia_1, ia_2)
	    END IF

	    IF (.NOT. at_excl (iat)) THEN
	      nres	= buf_nres (in,2)
	      chain	= buf_chain (in,2)
	      switchq	= .FALSE.
	      IF (check_swch) THEN
		IF ((nres.EQ.nres_swch) .AND. (atyp.EQ.atyp_swch)
     1		    .AND. (res.EQ.res_swch)) THEN
		  switchq	= .TRUE.
		  i_swchdone	= i_swchdone + 1
		  WRITE (11,1298) atyp, res, nres
		  i_swch		= i_swch + 1
		  IF (i_swch .GT. nq_switch) THEN
		    check_swch	= .FALSE.
		  ELSE
		    nres_swch	= swch_int (i_swch)
		    atyp_swch	= swch_char (i_swch,1)
		    res_swch	= swch_char (i_swch,2)
		  END IF
		END IF
	      END IF
	      IF (check_override) THEN
		IF ((nres.EQ.nres_over).AND.(atyp.EQ.atyp_over)
     1	   .AND.(res.EQ.res_over).AND.(chain.EQ.chain_over)) THEN
		  IF (ABS (over_real (i_over,1)) .GT. 0.001) THEN
		    DO 520 n	= 1, 3
		      xyz (n)	= buf_xyz (in,n,2)
520		    CONTINUE					! End n
		    q		= over_real (i_over,1)
		    pK		= over_real (i_over,2)
		    ionise	= over_log (i_over)
		    IF (outsa) THEN
		      i_class	= at_class (iat)
		      rad	= at_VdW (i_class,which_VdW)
		    ELSE
		      rad	= 0.
		    END IF
		    prtner	= over_char (i_over,3)
		    CALL	trncrd (xyz, xyz_trn)
		    CALL	qfile (nq, nq_ionise, xyz_trn,q,pK,
     1			               res, atyp, ionise, pH, nres,
     2				       ifil, rad, prtner, switchq,
     3				       chain)
		    at_Qfiled (iat,1)	= at_Qfiled (iat,1) + 1
		    i_overdone	= i_overdone + 1
		  ELSE
		    i_overdone	= i_overdone + 1
		    at_Qfiled (iat,2)	= at_Qfiled (iat,2) + 1
		    WRITE (11,1300) atyp, res, chain, nres
		  END IF
		  i_over	= i_over + 1
		  IF (i_over .GT. n_override) THEN
		    check_override	= .FALSE.
		  ELSE
		    nres_over		= over_int (i_over)
		    atyp_over		= over_char (i_over,1)
		    res_over		= over_char (i_over,2)
		    chain_over		= over_chain (i_over)
		  END IF
		  GOTO 540
		END IF
	      END IF						! chck_ovr

	      q			= at_chrg (iat,i_qset)
	      IF (ABS (q) .GT. 0.001) THEN
		DO 530 n	= 1, 3
		  xyz (n)	= buf_xyz (in,n,2)
530		CONTINUE					! End n
		pK		= at_pK (iat)
		ionise		= at_ionise (iat)
		IF (outsa) THEN
		  i_class	= at_class (iat)
		  rad		= at_VdW (i_class,which_VdW)
		ELSE
		  rad		= 0.
		END IF
		prtner		= at_prtner (iat)
		CALL	trncrd (xyz, xyz_trn)
		CALL	qfile (nq, nq_ionise, xyz_trn,q,pK, res,atyp,
     1			       ionise, pH, nres, ifil, rad, prtner,
     2			       switchq, chain)
		at_Qfiled (iat,1)	= at_Qfiled (iat,1) + 1
	      END IF
	    END IF						! at_excl
540	  CONTINUE						! End in
	  IF (.NOT. end_of_file) THEN
	    IF (first_res) first_res = .FALSE.
	    GOTO 500
	  END IF
	  WRITE (11,1305) ifil, nq_switch, i_swchdone
	  WRITE (11,1310) ifil, n_override, i_overdone
	  WRITE (11,1320) ifil, ir_read, nq

	  CLOSE (UNIT=1)

C The extra charges go after the coordinate file read for this file set.

	  IF (n_extra .NE. 0) THEN
	    n_extra_filed	= 0
	    DO 580 ix		= 1, n_extra
	      q			= xtra_real (ix,1)
	      IF (ABS (q) .GT. 0.001) THEN
		IF (outsa) THEN
		  i_class	= xtra_int (ix,2)
		  IF ((i_class.LT.1) .OR. (i_class.GT.n_at_types))
     1		    GOTO 975
		  rad		= at_VdW (i_class,which_VdW)
		ELSE
		  rad		= 0.
		END IF
		pK		= xtra_real (ix,2)
		res		= xtra_char (ix,2)
		atyp		= xtra_char (ix,1)
		ionise		= xtra_log (ix,1)
		switchq		= xtra_log (ix,2)
		nres		= xtra_int (ix,1)
		prtner		= xtra_char (ix,3)
		DO 560 n	= 1, 3
		  xyz (n)	= xtra_real (ix,n+2)
560		CONTINUE					! End n
		CALL	trncrd (xyz, xyz_trn)
		CALL	qfile (nq, nq_ionise, xyz_trn,q,pK, res,atyp,
     1			       ionise, pH, nres, ifil, rad, prtner,
     2			       switchq, chain)
		n_extra_filed		= n_extra_filed + 1
	      ELSE
		WRITE (11,1330) ix, ifil
	      END IF
580	    CONTINUE						! End ix
	    WRITE (11,1340) ifil, n_extra, n_extra_filed
	    WRITE (11,1020) spacer
	    n_extra_total	= n_extra_total + n_extra_filed
	  END IF

600	CONTINUE						! End ifil

	WRITE (11,1350) nq
	WRITE (11,1360) n_helices_total, n_extra_total
	WRITE (11,1020) spacer
	IF (more_charge_info) THEN
	  WRITE (11,1025) spacer
	  WRITE (11,1365)
	  WRITE (11,1020) spacer
	  WRITE (11,1370)
	  WRITE (11,1020) spacer
	  DO 700 ir	= 1, n_res_types
	    ia_1	= nat_pter (ir,1)
	    ia_2	= nat_pter (ir,2)
	    res		= res_type (ir)
	    DO 660 ia	= ia_1, ia_2
	      IF (at_Qfiled (ia,1) .NE. 0) THEN
		ic	= at_class (ia)
		WRITE (11,1380) res, at_type (ia),at_chrg (ia,i_qset),
     1				at_ionise (ia), at_pK (ia),
     2				at_prtner (ia), at_VdW (ic,which_VdW),
     3				at_Qfiled (ia,1), at_type (ia), res
	      END IF
660	    CONTINUE						! End ia
700	  CONTINUE						! End ir
	  WRITE (11,1020) spacer
	END IF

C Record partner charges for any that need a split analysis.
C In qi (iq,3)	-1	no split analysis required (init. from qfile)
C               iq_prt	split with iq_prt
C		-2	should be split, but partner not found

	IF (track_split) THEN
	  WRITE (11,1025) spacer
	  WRITE (11,1383)
	  n_pairs		= 0
	  n_missing		= 0
	  DO 740 iq		= 1, nq
	    IF (qi (iq,3) .EQ. -1) THEN
	      atyp_prt		= qa4 (iq,3)
	      IF (atyp_prt .NE. '    ') THEN
		nres		= qi (iq,1)
		chain		= qc (iq)
		res		= qa4 (iq,1)
		iq_1		= iq - 20
		IF (iq_1 .LT. 1) iq_1	= 1
		iq_2	= iq + 20
		IF (iq_2 .GT. nq) iq_2	= nq
		DO 720 iqp	= iq_1, iq_2
		  IF ((qa4(iqp,1).EQ.res).AND.(qi(iqp,1).EQ.nres).AND.
     1		      (qc(iqp).EQ.chain)) THEN
		    IF (atyp_prt.EQ.qa4(iqp,2)) THEN
		      qi (iq,3)  = iqp
		      qi (iqp,3) = iq
		      n_pairs	= n_pairs + 1
		      GOTO 740
		    END IF
		  END IF
720		CONTINUE					! End iqp
		qi (iq,3)	= -2
		n_missing	= n_missing + 1
		WRITE (11,1385) qa4(iq,2),qa4(iq,1),qc(iq),qi(iq,1)
	      END IF
	    END IF
740	  CONTINUE						! End iq
	  WRITE (11,1390) n_pairs, n_missing
	  WRITE (11,1020) spacer
	END IF

C Write out charge information to the output data file.
C Note that the qr (.,8) slot (the charge for delpk) is not set now.

	OPEN (UNIT=3,NAME=POTFIL,TYPE='NEW',
     1	      FORM='UNFORMATTED')
	WRITE (3) nfil
	DO 760 ifil	= 1, nfil
	  WRITE (3) pdbfil (ifil)
	  WRITE (3) qfil (ifil)
C ??	  WRITE (3) (pdbfil (ifil,nc), nc=1,80)
C ??	  WRITE (3) (qfil   (ifil,nc), nc=1,80)
760	CONTINUE						! End ifil
	WRITE (3) nq, macinc, itrate, i_qset, which_VdW, ncal
	DO 780 iq	= 1, nq
	  WRITE (3) (qr  (iq,m), m=1,7),
     1		    (qa4 (iq,m), m=1,3),
     2		    (qi  (iq,m), m=1,3),
     3		    (ql  (iq,m), m=1,2),
     4		     qc  (iq)
780	CONTINUE						! End iq

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

915	WRITE (6,9150)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

925	WRITE (6,9250)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

935	WRITE (6,9350)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

942	WRITE (6,9420)
	CALL	EXIT

945	WRITE (6,9450)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT

955	WRITE (6,9550)
	CALL	EXIT

960	WRITE (6,9600)
	CALL	EXIT

965	WRITE (6,9650)
	CALL	EXIT

C ?? C-t 970	WRITE (6,9700)
C ?? C-t	CALL	EXIT

975	WRITE (6,9750)
	CALL	EXIT
	END


	SUBROUTINE QFILE ( NQ, nq_ionise, XYZ, Q, PK, RES, ATYP,
C	********** *****
     1             IONISE, PH, NCUR, IFIL, RAD, PRTNER, switchq,
     2		   chain )

C This routine stores away the charge in the standard charge arrays,
C with the current charge value determined from the pH and pK for an
C ionisable group.

	REAL	QR(30000,8), QCUR(30000)
	CHARACTER*4	QA4(30000,3), RES, ATYP, PRTNER
	INTEGER QI(30000,3)
	LOGICAL		QL(30000,2)
	CHARACTER*1	QC(30000), chain
	REAL	XYZ(3)
	LOGICAL MACINC,ITRATE
	LOGICAL IONISE, switchq

	COMMON /QHOLD/ QR, QCUR, QA4, QL, QI, QT, QTCUR, MACINC,
     1                 ITRATE, q_before, QC

	NQ = NQ + 1
	IF (IONISE) nq_ionise	= nq_ionise + 1

C We currently have a maximum of 30000 charges.

	IF ( NQ .GT. 30000 ) STOP 'NQ > 30000'

	QR (NQ,1) = XYZ (1)
	QR (NQ,2) = XYZ (2)
	QR (NQ,3) = XYZ (3)
	QR (NQ,4) = Q
	QR (NQ,5) = PK
	QR (NQ,7) = RAD
	QR (NQ,8) = 0.
	QA4 (NQ,1) = RES
	QA4 (NQ,2) = ATYP
	QA4 (NQ,3) = PRTNER

	QL (NQ,1) = IONISE
	QL (NQ,2) = switchq

	QI (NQ,1) = NCUR
	QC (NQ)   = chain

C Store the number of the input coord/charge file set from whence we came!

	QI (NQ,2) = IFIL

C Initialise the qi (iq,3) slot (no split analysis required).

	QI (NQ,3) = -1

	RETURN
	END



	SUBROUTINE QSHIFT ( Q, PH, PK, TQCUR )
C	********** ******

C This routine calculates the current charge (TQCUR) from Q, PH, PK
C for an ionisable group.

C Fraction of charged/uncharged = 10 ** ff*(ph-pk)  where
C ff=-1 for a base, ff=+1 for an acid.

	FF = 1.0
	IF ( Q .GT. 0. ) FF = -1.0

	EXP = FF * ( PH-PK )
	IF ( EXP .GT. 35. ) EXP = 35.
	IF ( EXP .LT. -35. ) EXP = -35.

	FRAC = 10. ** EXP

	FRACQ = 1. / ( 1. + 1./FRAC )
	TQCUR = FRACQ * Q

C Ok, so I'm paranoid.  I can't help it!

	IF ( ABS (TQCUR) .GT. ABS (Q) ) STOP 'Q/CUR ABS'
	IF ( Q * TQCUR .LT. 0. ) STOP 'Q/QCUR SIGN'

50	RETURN
	END


	SUBROUTINE TRNCRD ( XT, X )
C	********** ******

C This subroutine transforms the 3 vector XT to the 3 vector X,
C using the translation and rotation operations for this file set.

	REAL XT (3), X (3)
	REAL TRNFIL (5,3), ROTFIL (5,3,3)
C ??	BYTE HED (5,80), QFIL (5,80), PDBFIL (5,80), BITE (80)
	CHARACTER*80	HED (5), QFIL (5), PDBFIL (5), BITE
	LOGICAL		move_file (5)

	COMMON /FILE/ QFIL, NFIL, IFIL, TRNFIL, ROTFIL, PDBFIL, HED,
     1                BITE, move_file

	IF (move_file (ifil)) THEN
	  DO 120 N = 1, 3
	    XT (N) = XT (N) + TRNFIL (IFIL,N)
120	  CONTINUE
	  DO 140 N = 1,3
	    X (N) = 0.
	    DO 140 M = 1,3
	      X (N) = X (N) + XT (M) * ROTFIL (IFIL,N,M)
140	  CONTINUE
	ELSE
	  DO 200 n	= 1, 3
	    x (n)	= xt (n)
200	  CONTINUE						! End n
	END IF

	RETURN
	END


	SUBROUTINE SACALC (NQ)
C	********** ******

C This routine calculates solvent accessibility (S.A.) values for ionisable
C groups in the charge arrays.  The coordinates of all atoms in all the
C coordinate files are used.
C The total number of atoms is all coord. files must not exceed 100000.

	REAL	QR(30000,8), QCUR(30000)
	CHARACTER*4	QA4(30000,3)
	INTEGER QI(30000,3)
	LOGICAL		QL(30000,2)
	CHARACTER*1	QC(30000), chain
	LOGICAL MACINC,ITRATE
	REAL	AT (100000,4),XYZT (3),XYZ (3),XYZMIN (3),XYZMAX (3),
     1		XYZC (3)
	INTEGER ATBOX (100001), BOX (35,35,35,2), IJKM (3), IJK (3),
     1          IJKC (3), IJK1 (3), IJK2 (3)
	LOGICAL FREE (720)
	CHARACTER*4	CALTYP (10), atyp, res, ATM
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	INTEGER		which_VdW
	LOGICAL	CALC (10), BULKDH, OUTSA,
     1		more_charge_info, move_file (5), most_charge_info
	REAL	TRNFIL (5,3), ROTFIL (5,3,3)
	CHARACTER*80	HED (5), QFIL (5), PDBFIL (5), BITE
C ??	BYTE	HED (5,80), QFIL (5,80), PDBFIL (5,80), BITE (80)
	BYTE		spacer (80)
	CHARACTER*4	common_atyp (100), res_type (200),
     1			at_type (2000), at_prtner (2000)
	REAL		at_VdW (100,10), at_chrg (2000,4),
     2			at_pK (2000)
	INTEGER		n_res_ats (200), nat_pter (200,2),
     1			at_class (2000), common_pter (100)
	CHARACTER*34	at_info (100)
	LOGICAL*1	at_anyq (2000), at_ionise (2000), common_at

	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /FILE/ QFIL, NFIL, IFIL, TRNFIL, ROTFIL, PDBFIL, HED,
     1                BITE, move_file
	COMMON /QHOLD/ QR, QCUR, QA4, QL, QI, QT, QTCUR, MACINC,
     1                 ITRATE, q_before, QC
	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6
	COMMON /BOXGRD/ XYZMIN, XYZMAX, STEP, IJKM
	COMMON	/atoms_es_type/ at_info, n_at_types, at_VdW, n_VdW
	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/common_atoms/	common_atyp, common_pter, n_common

	DATA	spacer	/ 80 * '-' /

1020	FORMAT (80A1)
1025	FORMAT (/,80A1)
1035	FORMAT (' ',20X,'SOLVENT ACCESSIBILITY INFORMATION')
1040	FORMAT (' ','resi atom  nres  max-chr  ionise  pK
     1  prtr  r_VdW AREA prcnt SA  nres atom resi')
1060	FORMAT (' ',A4,1X,A4,1X,I5,3X,F6.3,5X,L1,2X,F5.2,1X,A4,2X,
     1 F5.2,1X,F5.1,2X,F5.1,2X,I5,1X,A4,1X,A4)

	TWOPI = 2. * PI
	IATM = 0
	RMAX = 0.

	DANG = TWOPI / ( FLOAT (NANG) )

	DO 170 N = 1, 3
	    XYZMIN (N) =  100000.
	    XYZMAX (N) = -100000.
170	CONTINUE

C Go through all the coordinate files, reading in atoms, and assigning
C atomic radii as we read.

	DO 400 IFIL = 1, NFIL

	    BITE	= PDBFIL (IFIL)
C ??	    CALL PUTBYT ( BITE, PDBFIL, IFIL )
	    OPEN(UNIT=1,NAME=BITE,TYPE='OLD')
	    READ(1,210) BITE
210	    FORMAT(A80)

225	    CONTINUE
	    READ (1,230,END=300) ATM,ATYP,RES,chain,NCUR,XYZT
230	    FORMAT (A4,9X,A4,A4,A1,I4,4X,3F8.3)

	    IF ( ATM .NE. 'ATOM' .AND. ATM .NE. 'HETA' ) GOTO 225

	    CALL TRNCRD ( XYZT, XYZ )

	    DO 270 N = 1, 3
		IF ( XYZ (N) .LT. XYZMIN (N) ) XYZMIN (N) = XYZ (N)
		IF ( XYZ (N) .GT. XYZMAX (N) ) XYZMAX (N) = XYZ (N)
270	    CONTINUE

	    CALL	res_id (res, irt, ia_1, ia_2, na)
	    common_at		= .FALSE.
	    DO 280 i_com	= 1, n_common
	      IF (atyp .EQ. common_atyp (i_com)) THEN
		iat		= common_pter (i_com)
		common_at	= .TRUE.
	      END IF
280	    CONTINUE						! End i_com
	    IF (.NOT. common_at) THEN
	      CALL	atom_id (atyp, iat, ia_1, ia_2)
	    END IF
	    ic		= at_class (iat)
	    rad		= at_VdW (ic,which_VdW)

C All VdW radii should be greater than 1.0 A.

	    IF ( RAD .LT. 0.95 ) STOP 'RAD < 0.95 A'
	    IF ( RAD .GT. RMAX ) RMAX = RAD

	    IATM = IATM + 1
	    IF ( IATM .GT. 100000 ) STOP 'IATM > 100000'

C Store this atom away in the cumulative array.

	    AT (IATM,1) = XYZ (1)
	    AT (IATM,2) = XYZ (2)
	    AT (IATM,3) = XYZ (3)
	    AT (IATM,4) = RAD

	    GOTO 225

300	    CLOSE ( UNIT = 1 )

400	CONTINUE

	NAT = IATM

C We will box the atoms into grid cells of dimension 2(rmax+rprobe).
C This will speed the search for nearest neighbour atoms.
C Generate the box parameters from the extent of the atomic ordinates.

C The BOX array contains the starting index in the ATBOX array for atoms
C in this BOX (i,j,k..) slot, followed by the number of atoms in this
C slot.
C The ATBOX array contains the indices of atoms in the AT array, ordered

	STEP = 2. * ( RMAX + RPROBE )

	DO 470 N = 1, 3
	    XYZMIN (N) = XYZMIN (N) - 0.1
	    TMP = XYZMAX (N) - XYZMIN (N)
	    IJKM (N) = 2 + INT ( TMP / STEP )
	    IF ( IJKM (N) .GT. 35 ) STOP 'BOX IJK > 35'
470	CONTINUE

C Ok then, lets put these little ol atoms away.
C The first pass through the AT array fills BOX with the number of
C atoms in each box data, (BOX(i,j,k,2)).
C Using this data we will generate the BOX(i,j,k,1) slot, which
C contains the starting index in the ATBOX array for this i,j,k
C box.
C Then we can fill up the ATBOX array, with the BOX array, and a
C second pass through the AT array.

C Initialise the BOX array.

	DO 530 M = 1, 2
	    DO 530 K = 1, IJKM (3)
		DO 530 J = 1, IJKM (2)
		    DO 530 I = 1, IJKM (1)
			BOX ( I,J,K,M ) = 0
530		CONTINUE

	DO 550 IATM = 1, NAT

	    DO 510 N = 1, 3
		XYZ (N) = AT (IATM,N)
510	    CONTINUE

	    CALL BOXIJK ( XYZ, IJK )

	    BOX ( IJK(1), IJK(2), IJK(3), 2 ) =
     1      BOX ( IJK(1), IJK(2), IJK(3), 2 ) + 1

550	CONTINUE

C We will have k varying quickest in the BOX array.

	IATM = 0
	BOX ( 1,1,1,1 ) = 1

	DO 600 I = 1, IJKM (1)
	    DO 600 J = 1, IJKM (2)
		DO 600 K = 1, IJKM (3)

		    IATM = IATM + BOX ( I,J,K,2 )
		    IF ( I.EQ.1 .AND. J.EQ.1 .AND. K.EQ.1 ) GOTO 590
		    BOX ( I,J,K,1 ) = IATMOLD + 1

590		    IATMOLD = IATM
600	      CONTINUE

	IF ( IATM .NE. NAT ) STOP 'IATM<>NAT'

C Initialise the ATBOX array with zeroes, so that we know that any zero
C location has not 'yet' been used.

	DO 610 IATM = 1, NAT + 1
	    ATBOX ( IATM ) = 0
610	CONTINUE

	DO 700 IATM = 1, NAT

	    DO 620 N = 1, 3
		XYZ (N) = AT (IATM,N)
620	    CONTINUE

	    CALL BOXIJK ( XYZ, IJK )

	    I = IJK (1)
	    J = IJK (2)
	    K = IJK (3)

C Go through the section of ATBOX corresponding to this box ijk, and
C fill up the first zero location with the index to the AT array.

	    IF ( BOX ( I,J,K,2 ) .EQ. 0 ) STOP 'NONE HERE?'
	    LOC1 = BOX ( I,J,K,1 )
	    LOC2 = LOC1 + BOX ( I,J,K,2 ) - 1

	    DO 640 LOC = LOC1, LOC2
		IF ( ATBOX (LOC) .NE. 0 ) GOTO 640
		IF ( LOC .GT. NAT+1 ) STOP 'Have location over the top'
		ATBOX (LOC) = IATM
		GOTO 650
640	    CONTINUE
	    STOP 'No free location found'

650	    CONTINUE
700	CONTINUE						! End IATM

C Initialise the QR (..,6) slot, ready for the S.A. values.

	DO 740 IQ = 1, NQ
	    QR (IQ,6) = 0.
740	CONTINUE

C We need to know how many planes we are dividing the 2*STEP distance,
C on the z-axis, up with.

	NPLN = 1 + 2 * ( 1 + INT ( STEP / PLNDIV ) )

C Now we can set about getting the S.A. values.
C At present, we will only calculate S.A. for ionisable groups.

	WRITE (11,1025) spacer
	WRITE (11,1035)
	WRITE (11,1020) spacer
	WRITE (11,1040)
	WRITE (11,1020) spacer

	DO 860 IQ = 1, NQ

	  IF (.NOT. ql (iq,1)) GOTO 860

	    DO 760 N = 1, 3
		XYZC (N) = QR (IQ,N)
760	    CONTINUE						! End N

	    XC = XYZC (1)
	    YC = XYZC (2)
	    ZC = XYZC (3)

	    CALL BOXIJK ( XYZC, IJKC )

	    RC = QR (IQ,7) + RPROBE

C Now we take this and all neighbouring box cells for atoms that
C may overlap this charge location.

	    DO 780 N = 1, 3
		IJK1 (N) = IJKC (N) - 1
		IF ( IJK1 (N) .LT. 1 ) IJK1 (N) = 1
		IJK2 (N) = IJKC (N) + 1
		IF ( IJK2 (N) .GT. IJKM (N) ) IJK2 (N) = IJKM (N)
780	    CONTINUE						! End N

C The algorithm for the S.A. calcn. is that originated by Lee & Richards,
C and outlined in Matthew et al. BBRC 81, 410- (1978).

C The whole set of atoms is cut by planes (on z) and arcs of the central
C atom on these planes, that are not cut out by neighbouring atoms, are
C summed to give the S.A. value.

C Lets loop over those z-axis planes then.

	    ARC = 0.

	    DO 820 IPLN = 1, NPLN

C Initialise FREE to no overlap for the next plane through the central atom.

		DO 783 IANG = 1, NANG
		    FREE (IANG) = .TRUE.
783		CONTINUE					! End IANG

C @@@@@@ Check this plane division coverage out, please.

		ZPLN = XYZC (3) - STEP + FLOAT (IPLN-1) * PLNDIV

C Work out the radius of the central atom/probe sphere on this z-plane.

		RCZSQ = RC**2 - (ZC-ZPLN)**2
		IF ( RCZSQ .LE. 0. ) GOTO 820
		RCZ = SQRT ( RCZSQ )

		DO 800 I = IJK1 (1), IJK2 (1)
		    DO 800 J = IJK1 (2), IJK2 (2)
			DO 800 K = IJK1 (3), IJK2 (3)
			    IF ( BOX ( I,J,K,2 ) .EQ. 0 ) GOTO 800
			    LOC1 = BOX ( I,J,K,1 )
			    LOC2 = LOC1 + BOX ( I,J,K,2 )
			    DO 790 IPT = LOC1, LOC2
				IATM = ATBOX (IPT)
				XAT = AT (IATM,1)
				YAT = AT (IATM,2)
				ZAT = AT (IATM,3)

C @@@@@ If we are very close to the central atom, then we are probably
C @@@@@ it, (charges in the AT array too).  Lets get out of here !

				bugy = (XC-XAT)**2 +
     1				         (YC-YAT)**2 + (ZC-ZAT)**2
				IF (bugy .GT. 0.) THEN
				  DCAT = SQRT (bugy)
				ELSE
				  DCAT = 0.
				END IF
Cbug				DCAT = SQRT ( (XC-XAT)**2 +
Cbug     1			         (YC-YAT)**2 + (ZC-ZAT)**2 )
				IF ( DCAT .LT. 0.1 ) GOTO 790

				RAT = AT (IATM,4) + RPROBE

C Work out the radius of circle with which this atom/probe sphere cuts the
C z-plane.

				RATZSQ = RAT**2 - (ZPLN-ZAT)**2
				IF ( RATZSQ .LE. 0. ) GOTO 790
				RATZ = SQRT ( RATZSQ )

C Ok then; Is there any overlap between these two circles ?
C Work just in the x-y dimension now.

				DCATZ = SQRT ((XC-XAT)**2+(YC-YAT)**2)
				IF ( (RCZ+RATZ) .LT. DCATZ ) GOTO 790

C For each pair of circles within interesecting range, there are 3
C possibilities.  Two are with one circle inside the other.  The other
C is the more usual case for two point intersection of the circles.

C This tests for the central atom circle inside the neighbour atom
C circle; and if so there will be NO S.A. on this z-plane.

				IF ( (RCZ+DCATZ) .GT. RATZ ) GOTO 785
				IANG1 = 1
				IANG2 = NANG
				GOTO 788

C This tests for the neighbour atom circle inside the central atom
C circle; and if so there will be no occlusion by this neighbour.

785				IF ( (RATZ+DCATZ) .LE. RCZ ) GOTO 790

C We must be at the two point intersection case now.  Find the circular
C polar angles corresponding to the two intersection pts, seen from centre.

				COSALP=(RCZ*RCZ+DCATZ*DCATZ-RATZ*RATZ)
     1                                 / (2.*RCZ*DCATZ)
				IF (COSALP .GT. 1.0) COSALP = 1.0
				IF (COSALP .LT.-1.0) COSALP =-1.0
				ALP = ACOS ( COSALP )
				COSBET = (XAT-XC) / DCATZ
				BET = ACOS ( COSBET )
				IF ( (YAT-YC) .LT. 0. )
     1                             BET = TWOPI - BET
				THET1 = BET - ALP
				IF ( THET1 .GT. TWOPI )
     1                             THET1 = THET1 - TWOPI
				IF ( THET1 .LT. 0. )
     1                             THET1 = THET1 + TWOPI
				THET2 = THET1 + 2.*ALP
				IF ( THET2 .GT. TWOPI )
     1                             THET2 = THET2 - TWOPI
				IF ( THET2 .LT. 0. )
     1                             THET2 = THET2 + TWOPI

				IANG1 = 2 + INT ( (THET1/DANG) )
				IANG2 = 1 + INT ( (THET2/DANG) )
				IF ( IANG1 .GT. NANG ) IANG1 = NANG
				IF ( IANG2 .GT. NANG ) IANG2 = NANG

788				IF ( IANG1 .GT. IANG2 ) GOTO 7885

				DO 789 IANG = IANG1, IANG2
				    FREE (IANG) = .FALSE.
789				CONTINUE			! End IANG
				GOTO 790

7885				CONTINUE

				DO 7886 IANG = IANG1, NANG
				    FREE (IANG) = .FALSE.
7886				CONTINUE			! End IANG

				DO 7887 IANG = 1, IANG2
				    FREE (IANG) = .FALSE.
7887				CONTINUE			! End IANG

790			    CONTINUE				! End IPT

800		    CONTINUE					! End K,J,I

C The summation of the plane arc lengths is a JW thing.  I do not
C trust the previous incumbents of the es - SA mantel !
C The plane contribution is not modified by any z fn, since the dec
C in RC is cancelled by the increase in modified delz as fn z.

		    NFREE = 0
		    DO 808 IANG = 1, NANG
			IF ( FREE (IANG) ) NFREE = NFREE + 1
808		    CONTINUE					! End IANG

		    ARCZ = TWOPI * ( FLOAT (NFREE) / FLOAT (NANG) )
		    ARC = ARC + ARCZ

820	    CONTINUE						! End IPLN

C Get the S.A. value in Angstrom squared.

	    AREA = RC * PLNDIV * ARC

C Get, and store, the fractional S.A. value.

	    FSA = AREA / ( 4. * PI * RC**2 )
	    IF ( FSA .GT. 1. ) STOP 'frac S.A. > 1.'
	    IF ( FSA .LT. 0. ) STOP 'frac S.A. < 0.'

C This is the Lee & Richards definition of S.A., as used all down the
C line by Matthew et al.  It is a percentage solvent accessibility,
C NOT the absolute are value.

	    QR (IQ,6) = 100. * FSA

	  IF (iq .NE. 1) THEN
	    IF (qi (iq,1) .NE. qi (iq-1,1)) THEN
	      WRITE (11,1020) spacer
	    END IF
	  END IF

	  WRITE (11,1060)(qa4(iq,m),m=1,2),qi(iq,1),qr(iq,4),ql(iq,1),
     1			  qr(iq,5),qa4(iq,3),qr(iq,7),AREA,qr(iq,6),
     2			  qi(iq,1),qa4(iq,2),qa4(iq,1)

860	CONTINUE						! End IQ
	WRITE (11,1020) spacer

	RETURN
	END



	SUBROUTINE BOXIJK ( XYZ, IJK )
C	********** ******

C This routine simply returns the box cell index (IJK) for the
C ordinate set XYZ.

	REAL XYZ (3), XYZMIN (3), XYZMAX (3)
	INTEGER IJK (3), IJKM (3)

	COMMON /BOXGRD/ XYZMIN, XYZMAX, STEP, IJKM

	DO 120 N = 1, 3
	    DEL = XYZ (N) - XYZMIN (N)
	    IJK (N) = 1 + INT ( DEL / STEP )
	    TMP = DEL / STEP
	    IF ( ( TMP - FLOAT ( IJK(N)-1 ) ) .GT. 0.5 )
     1           IJK (N) = IJK (N) + 1
	    IF ( IJK (N) .LT. 1 ) STOP 'IJK (N) < 1'
	    IF ( IJK (N) .GT. IJKM (N) ) STOP 'IJK (N) > MAX'
120	CONTINUE

	RETURN
	END


	SUBROUTINE CALIJ ( NQ, nq_ionise, NIT )
C	********** *****

C This routine calculates the sum of interactions at each site in the
C charge array, (no self-interactions ... of course!).
C These arrays are set up : POTI, WI, DELPK, SUMWIJ, ENERGY
C DELPK is set up only for ionisable groups.
C poti_fixed (iq) for any iq is the sum of non-ionisable charge potls at iq

	REAL	QR(30000,8), QCUR(30000)
	CHARACTER*4	QA4(30000,3)
	INTEGER QI(30000,3)
	LOGICAL		QL(30000,2)
	CHARACTER*1	QC(30000)
	CHARACTER*4	CALTYP (10)
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	LOGICAL	CALC (10), OUTSA
	LOGICAL MACINC,ITRATE
	REAL	POTI (30000), WI (30000), DELPK (30000),
     1		PKCUR (30000), poti_fixed (30000), poti_pK (30000),
     2		wbufi (30000)
	INTEGER	which_VdW
	REAL	LOG10E
	LOGICAL	BULKDH, SETUP, LOOKUP, SETFIL
	LOGICAL WIJOUT, more_charge_info, wij_rec, first_time,
     1		most_charge_info
	LOGICAL*1	show_action (30000)

	COMMON /QSTAT/	WIJOUT
	COMMON /QHOLD/	QR, QCUR, QA4, QL, QI, QT, QTCUR, MACINC,
     1			ITRATE, q_before, QC
	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /OPT8/	ATK, BTK, NLEGEN
	COMMON /INTER/	POTI, WI, DELPK, SUMWIJ, ENERGY, PKCUR, NSITE,
     1			TENER, poti_fixed, poti_pK, wbufi,show_action,
     2			sumwij_1, sumwij_2
	COMMON /DONE/	RMS, VERGED
	COMMON /CONST/	BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1			LOG10E, CON1, CON2, CON3, CON4, CON5, CON6

	DATA DIBULK / 78.4 /

9000	FORMAT ('0','*** ERROR * calij * see a split non-ionisable gp')
9100	FORMAT ('0','*** ERROR * calij * we have a dij .lt. 0.98')
9200	FORMAT ('0','*** ERROR * calij * "bind" ncal is not .eq. 8')
9300	FORMAT ('0','*** ERROR * calij * wij file num recs wrong')
9400	FORMAT ('0','*** ERROR * calij * lookup should be set')
9500	FORMAT ('0','*** ERROR * calij * split charge sum .ne. 1')

C In an iterative calculation, the 'basic' Wij parameters will be
C calculated only once.  If the LOOKUP flag is set, then use the
C file of ESIJ values that has been written under the command of the
C SETFIL flag.

	IF (nit .EQ. 0) THEN
	  first_time	= .TRUE.
	ELSE
	  first_time	= .FALSE.
	END IF
	IF (itrate) THEN
	  IF (first_time) THEN
	    setfil	= .TRUE.
	    lookup	= .FALSE.
	    n_wij	= 0
	  ELSE
	    lookup	= .TRUE.
	    setfil	= .FALSE.
	  END IF
	ELSE
	  setfil	= .FALSE.
	  lookup	= .FALSE.
	END IF

C The Wij file will contain (nq*nq_ionise) records.
C If the WIJOUT flag is set, then the WIJ file will be kept.

Clnx	IF ( SETFIL .AND. (.NOT.WIJOUT) ) OPEN ( UNIT=2,
Clnx     1     NAME='wij.scr',TYPE='SCRATCH',
Clnx     2	   FORM='UNFORMATTED')
	IF ( SETFIL .AND. (.NOT.WIJOUT) ) OPEN ( UNIT=2,
     1     TYPE='SCRATCH', FORM='UNFORMATTED')

	IF ( SETFIL .AND. WIJOUT ) OPEN ( UNIT=2,
     1     NAME='wij.scr',TYPE='NEW',
     2	   FORM='UNFORMATTED')

	SETUP = .FALSE.

C Initialise various interaction parameters.

	sumwij			= 0.
	sumwij_1		= 0.
	sumwij_2		= 0.
	DO 200 iq		= 1, nq
	  poti (iq)		= 0.
	  wi (iq)		= 0.
	  IF (first_time) THEN
	    poti_fixed (iq)	= 0.
	    poti_pK (iq)	= 0.
	    wbufi (iq)		= 0.
	  END IF
200	CONTINUE			! End i

C Loop over the charges, dealing with wij file for ionisable i and j.
C On the first pass we sum up the poti_fixed values for all i.

	DO 700 i	= 1, nq
	  DO 600 j	= 1, nq

	    IF (ql (j,1)) THEN
	      wij_rec	= .TRUE.
	    ELSE
	      wij_rec	= .FALSE.
	    END IF

	    IF (j .EQ. i) THEN
	      IF (wij_rec) THEN
		IF (setfil) THEN
		  WRITE (2) wij
		  n_wij		= n_wij + 1
		END IF
		IF (lookup) READ (2) wij
	      END IF
	      GOTO 600
	    END IF
	    IF (j.EQ.qi (i,3)) THEN
	      IF (wij_rec) THEN
		IF (setfil) THEN
		  WRITE (2) wij
		  n_wij		= n_wij + 1
		END IF
		IF (lookup) READ (2) wij
	      ELSE
		GOTO 900
	      END IF
	      GOTO 600
	    END IF

	    IF (first_time) THEN				! first below
	      CALL	dijcal (qr, i, j, dij)
	      IF (dij .LT. 0.98) GOTO 910
	      IF (caltyp (ncal) .NE. 'BIND') THEN		! not bind -
		IF (caltyp (ncal) .EQ. 'COOL') THEN
		  CALL	dical (diel, ncal, dij)
		END IF
		esij	= 1. / (diel (ncal,1)*dij)
		dht	= debhuk
		IF (caltyp (ncal) .EQ. 'COOL') THEN
		  didh	= dibulk
		  IF (.NOT. bulkdh) didh = diel (ncal,1)
		  dht	= debhuk / SQRT (didh)
		END IF
		esij		= esij * enat ** (-dht*dij)
	      ELSE						! bind -
		IF (ncal .EQ. 8) THEN
		  rij		= dij
		  COSTIJ = (2.*BTK*BTK - RIJ*RIJ) / (2.*BTK*BTK)
		  IF ( RIJ .GE. (BTK+BTK) ) COSTIJ = -0.999
		  CALL TANKIRK ( SETUP, RIJ, COSTIJ, ESIJ )
		  DEFFIJ = 1. / ( RIJ * ESIJ )
		  IF ( DEFFIJ .LT. 0. ) DEFFIJ = 1000.
		  IF ( DEFFIJ .GT. 1000. ) DEFFIJ = 1000.
		  ESIJ		= 1. / ( RIJ * DEFFIJ )
		ELSE
		  GOTO 920
		END IF
	      END IF						! caltyp
	      wij		= esij
	      esij		= wij * qcur (j)
	      poti (i)		= poti (i) + esij
	      IF (.NOT. ql (j,1)) THEN
		poti_fixed (i)	= poti_fixed (i) + esij
	      END IF
	      IF (wij_rec) THEN
		n_wij		= n_wij + 1
		IF (setfil) WRITE (2) wij
	      END IF
	    ELSE						! again below
	      IF (wij_rec) THEN
		IF (lookup) THEN
		  READ (2) wij
		  esij		= wij * qcur (j)
		  poti (i)	= poti (i) + esij
		ELSE
		  GOTO 940
		END IF
	      END IF
	    END IF						! first/again
600	  CONTINUE						! End j

	  IF (.NOT. first_time) THEN
	    poti (i)	= poti (i) + poti_fixed (i)
	  END IF
	  wi (i)	= qcur (i) * poti (i)
	  sumwij	= sumwij + wi (i)
	  IF (ql (i,1)) THEN
	    sumwij_1	= sumwij_1 +
     1			  qcur (i)*(poti (i) - poti_fixed (i))
	    sumwij_2	= sumwij_2 + qcur (i)*poti_fixed (i)
	  END IF
700	CONTINUE						! End i

	IF (setfil) THEN
	  IF (n_wij .NE. (nq*nq_ionise)) GOTO 930
	END IF
	IF (setfil .OR. lookup) REWIND 2

	energy		= 0.5 * sumwij

	DO 740 i	= 1, nq
	  IF (ql (i,1)) THEN
	    IF      (qi (i,3) .EQ. -1) THEN
	      qpK	= qr (i,4)
	      ppK	= poti (i)
	    ELSE IF (qi (i,3) .EQ. -2) THEN
	      IF (qr (i,4) .GT. 0.) THEN
		qpK	=  1.
	      ELSE
		qpK	= -1.
	      END IF
	      ppK	= poti (i)
	    ELSE
	      ip	= qi (i,3)
	      ppK	= (poti (i) + poti (ip)) / 2.
	      qpK	= qr (i,4) + qr (ip,4)
	      IF ((ABS (qpK) - 1.) .GT. 0.001) GOTO 950
	    END IF
	    wijoul	= elec * con3 * qpK * ppK
	    IF (qpK .GT. 0.) THEN
	      ff	= -1.
	    ELSE
	      ff	=  1.
	    END IF
	    delpK (i)	= (log10e * wijoul) / con1
	    delpK (i)	= ff * delpK (i)
	    qr (i,8)	= qpK
	    poti_pK (i)	= ppK
C ?? - we could do ip slot at the same time, or perhaps check
	  ELSE
	    delpK (i)	= 0.
	  END IF						! ql (i,1)
740	CONTINUE						! End i

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT
	END


	SUBROUTINE WIJPLT
C	********** ******

C This routine produces a Wij vs Rij (x,y) file for plotting, for
C the specified (ncal) method.
C The (x,y) file has a 60 byte header followed by x,y records until
C the <EOF>, and is ready for conversion to a vdata file by the J.W.
C program "XYDOT", or "XYJOIN".

C Note that this routine is only called on setting the PLOT flag,
C and that it replaces the other "ESCALC" functions.

	CHARACTER*4	CALTYP (10)
	REAL	DIEL (10,2), CONCI (10), VALEN (10)
	LOGICAL	CALC (10), OUTSA
	REAL	POTI (30000), WI (30000), DELPK (30000),
     1		PKCUR (30000), poti_fixed (30000),poti_pK (30000),
     2		wbufi (30000)
	INTEGER	which_VdW
	REAL	LOG10E
	LOGICAL	BULKDH, SETUP, more_charge_info, most_charge_info
	CHARACTER*4	METHA4 (20)
	CHARACTER*1	NULL (52)
	LOGICAL*1	show_action (30000)

	COMMON /METHID/ METHA4
	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /OPT8/ ATK, BTK, NLEGEN
	COMMON /INTER/ POTI, WI, DELPK, SUMWIJ, ENERGY, PKCUR, NSITE,
     1                 TENER, poti_fixed, poti_pK, wbufi,show_action,
     2			sumwij_1, sumwij_2
	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6

	DATA DIBULK / 78.4 /


	SETUP = .FALSE.

	DO 180 ICH = 1, 52
	    NULL (ICH) = ' '
180	CONTINUE

	OPEN ( UNIT=3, NAME='pltwij.dat', TYPE='NEW',
     1         FORM = 'UNFORMATTED' )

	IA41 = ncal * 2 - 1
	IA42 = IA41 + 1

	NHED = 8
	WRITE (3) NHED, METHA4 (IA41), METHA4 (IA42), NULL

	DO 500 N = 1, 191

	    DIJ = 1.8 + 0.2 * FLOAT (N)

C If the dielectric effect is just an Rij function, (flagged
C by 'COOL'), then we can get this, and continue with the
C unconvoluted calculation process.

	    IF ( CALTYP (ncal) .EQ. 'COOL' )
     1         CALL DICAL ( DIEL, ncal, DIJ )

C Re-route for the convoluted calculation processes.

	    IF ( CALTYP (ncal) .EQ. 'BIND' ) GOTO 400

C###### DEB HUK PARAM FOR THE 'COOL' CALCNS. IS OK ??

	    DHT = DEBHUK

	    IF ( CALTYP (ncal) .NE. 'COOL' ) GOTO 380

	    DIDH = DIBULK
	    IF ( .NOT. BULKDH ) DIDH = DIEL (ncal,1)

	    DHT = DEBHUK / SQRT (DIDH)

380	    DEFFIJ = DIEL (ncal,1) / ENAT ** ( - DHT * DIJ )

	    GOTO 490

400	    CONTINUE

C The planar interface function is ical = 7.

C @@@@@	    IF ( ncal .EQ. 7 ) CALL PLANAR ( @@@@@ )

C Solvent Accessibility modified Tanford-Kirkwood is ncal = 8.

	    RIJ = DIJ

	    COSTIJ = (2.*BTK*BTK - RIJ*RIJ) / (2.*BTK*BTK)

C If rij > 2 (btk) , then we'll put tij = pi, i.e. costij = -0.999

	    IF ( RIJ .GE. (BTK+BTK) ) COSTIJ = -0.999

	    IF ( ncal .EQ. 8 )
     1        CALL TANKIRK ( SETUP, RIJ, COSTIJ, ESIJ )
	    DEFFIJ = 1. / ( DIJ * ESIJ )

C Guard against the Wij blow-downs giving -ve Deff.

	    IF ( DEFFIJ .LT. 0. ) DEFFIJ = 1000.

C Deffij at 1000 is a pretty small interaction.  Lets cut it off here.

490	    IF ( DEFFIJ .GT. 1000. ) DEFFIJ = 1000.
	    WRITE (3) DIJ, DEFFIJ

500	CONTINUE						! End N

	CLOSE ( UNIT = 3 )

	CALL EXIT
	END


	SUBROUTINE DIJCAL ( QR, I, J, DIJ )
C	********** ******

C This routine simply calculates the dustance between the charges
C of the i and j slots of QR.

	REAL QR (30000,8)

	DIJSQ = ( QR(I,1) - QR(J,1) ) ** 2
     1        + ( QR(I,2) - QR(J,2) ) ** 2
     1        + ( QR(I,3) - QR(J,3) ) ** 2

	DIJ = SQRT ( DIJSQ )

	RETURN
	END


	SUBROUTINE DICAL ( DIEL, ncal, DIJ )
C	********** *****

C This routine calculates the dielectric as fn (DIJ) for method ncal.

	REAL DIEL (10,2), LOG10E

	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6
	COMMON /OPT4/ T41,T42,T43,T44,T45
	COMMON /OPT5/ T51,T52
	COMMON /OPT6/ T61

C The T4 constants for the Eichele & Mehler function.
C Wrt paper;     T41 = A  ,  T42 = B  ,  T43 = k
C		 T44 = Lambda  ,  T45 = eps_sub_H2O
C nb   T42 = ( T45 - T41 )

	DATA T41, T42, T43, T44, T45 / -20.929, 99.329, 3.4781,
     1                                 0.001787, 78.4 /

C The T5 constants for the Warshel function, (PNAS (1984) 81, 4785).

C Wrt paper;  eps (R) = {1 + T51*( 1 - exp(T52 * R)]} * (1 +/- .5)

	DATA T51, T52 / 60., -0.1 /

C The distance multiplier for the dist. dep. dielectric, T61,
C is input from the control file.

	IF ( ncal .EQ. 4 ) GOTO 400
	IF ( ncal .EQ. 5 ) GOTO 500
	IF ( ncal .EQ. 6 ) GOTO 600

	STOP 'ncal/DICAL/4,5,6'

C This is the Eichele and Mehler function, labelled eps_sub_s in
C their Biochemistry (1984) 23, 3887-3891 paper.

400	TT1 = 1. + T43 * ENAT ** ( -T44 * T42 * DIJ )
	DIEL ( 4,1 ) = T41 + T42 / TT1

	RETURN

C This is the Warshel dielectric function.

500	DIEL ( 5,1 ) = 1. + T51 * ( 1. - ENAT ** (T52 * DIJ) )

	RETURN

C This is the distant dependent dielectric function.

600	DIEL ( 6,1 ) = T61 * DIJ

	RETURN
	END


	SUBROUTINE TANKIRK ( SETUP, RIJ, COSTIJ, ESIJ )
C	********** *******

C This routine calculates the electrostatic interaction between two
C sites, according to the Solvent Accessibility modified
C Tanford - Kirkwood algorithm; ( see ESCALC notebook for details
C method ).

	CHARACTER*4	CALTYP (10)
	REAL		DIEL (10,2), CONCI (10), VALEN (10)
	INTEGER		which_VdW
	LOGICAL	CALC (10), BULKDH, SETUP, OUTSA, more_charge_info,
     1		most_charge_info

	DOUBLE PRECISION FIPN1, DPNSUM, PNSUM, PNC, DEMDI
	DOUBLE PRECISION CSUM, FN, FN1, CT1, DHASQ, C3SQ, DHA, VP1,
     1                   VM1, CT2, DE, DI, CT3, C3, CT4, CT5, DSUM

	COMMON /METHOD/ CALC, CALTYP, DIEL, DEBHUK, CONCI, VALEN,
     1                  NCAL, NSET, BULKDH, RPROBE, PLNDIV,NANG,OUTSA,
     2			which_VdW, more_charge_info, most_charge_info
	COMMON /OPT8/ ATK, BTK, NLEGEN
	COMMON /CONST/ BOLT, TEMP, EPSZER, AVAGAD, ELEC, ENAT, PI,
     1                 LOG10E, CON1, CON2, CON3, CON4, CON5, CON6

C @@@@ Note that A, B and RIJ are all in Angstrom units, and that this is ok!

	A = ATK
	B = BTK

C We will avoid costij at +/- 1 which gives bad polynomial convergence.
C This should not affect the Wij values too much.

	IF ( COSTIJ .GT. 0.999 ) COSTIJ = 0.999
	IF ( COSTIJ .LT. -0.999 ) COSTIJ = -0.999

	IF ( .NOT. SETUP ) GOTO 200

C Set up the lumped constants for the calculation.

	A1 = B / DIEL ( 8,1 )

	DELTA = DIEL ( 8,1 ) / DIEL ( 8,2 )
	IF ( DELTA .GT. 1. ) STOP 'DELTA > 1'
	B1 = ( 1. - 2. * DELTA + 2. * DELTA ** 2 ) / DIEL ( 8,1 )
	B2 = ( DELTA - 3. * DELTA ** 2 ) / DIEL ( 8,1 )
	B3 = DELTA ** 2 / DIEL ( 8,1 )

	C1 = 1. / DIEL ( 8,2 )
	DHA = DBLE ( (A * DEBHUK) )
	C2 = DHA / ( 1. + DHA )
	DHASQ = DHA ** 2
	C3 = DBLE ( ( B / A ) )
	C3SQ = C3 ** 2
	DI = DBLE ( DIEL ( 8,1 ) )
	DE = DBLE ( DIEL ( 8,2 ) )
	DEMDI = DE - DI

	RETURN

200	CONTINUE

	AIJ = A1 / RIJ

	BT1 = SQRT ( ( 2. - 2. * COSTIJ ) )
	BT2 = ( BT1 - COSTIJ + 1. ) / ( 1. - COSTIJ )

	PNSUM = 0.
	DO 300 IPN = 0, NLEGEN
	    FIPN1 = DFLOAT ( IPN + 1 )
	    CALL PNCAL ( IPN, COSTIJ, PNC )
	    DPNSUM = PNC / FIPN1 ** 2
	    PNSUM = PNSUM + DPNSUM
	    IF ( (DABS(DPNSUM)/DABS(PNSUM)) .LT. 0.00001 ) GOTO 310
300	CONTINUE

310	BT3 = PNSUM

	BIJ = B1 / BT1 + B2 * ALOG ( BT2 ) + B3 * BT3

CBij	PNSUM = 0.
CBij	IF ( DEMDI .EQ. 0. ) GOTO 310

CBij	DO 300 N = 0, NLEGEN
CBij	    FN = DFLOAT (N)
CBij	    CALL PNCAL ( N, COSTIJ, PNC )
CBij	    DPNSUM = ( (FN+1.)*DEMDI*PNC ) / ( (FN+1.)*DE + FN*DI )
CBij	    PNSUM = PNSUM + DPNSUM
CBij	    IF ( ( DABS (DPNSUM) / DABS (PNSUM) ) .LT. 0.00001 )
CBij	     1         GOTO 310
CBij	300	CONTINUE

CBij	310	BIJ = PNSUM / DI

C If there are no counter-ions, then the Cij term is zero.

	IF ( DHA .EQ. 0. ) CIJ = 0.
	IF ( DHA .EQ. 0. ) GOTO 430

	CSUM = 0.
	DO 400 IPN = 1, NLEGEN
	    IPNP1 = IPN + 1
	    IPNM1 = IPN - 1
	    FN = DFLOAT ( IPN )
	    FN1 = DFLOAT ( IPNP1 )
	    CALL PNCAL ( IPN, COSTIJ, PNC )
	    CT1 = DHASQ * (C3SQ ** IPN) * PNC
	    CALL CALK ( IPNP1, DHA, VP1 )
	    IF ( IPNM1 .EQ. 0 ) VM1 = 1.
	    IF ( IPNM1 .NE. 0 ) CALL CALK ( IPNM1, DHA, VM1 )
	    CT2 = ( FN * (DE-DI) ) / ( (FN+1.)*DE + FN*DI )
	    CT3 = ( C3 ** (2*IPN+1) * DHASQ ) / ( 4.*FN**2 - 1. )
	    CT4 = CT1 / ( ( VP1/VM1 ) + ( CT2 * CT3 ) )
	    CT5 = ( DE / ( (FN+1.)*DE + FN*DI ) ) ** 2
	    DSUM = ( (2.*FN+1.) / (2.*FN-1.) ) * CT5 * CT4
	    CSUM = CSUM + DSUM
	    IF ( ( DABS(DSUM) / DABS(CSUM) ) .GT. 0.00001 ) GOTO 410
400	CONTINUE

410	CIJ = C1 * ( C2 + CSUM )

C Convert aij, bij, cij to S.I. so as to give S.I. units.

430	ESIJ = ( AIJ - BIJ ) / B - CIJ / A

	RETURN
	END


	SUBROUTINE PNCAL ( N, C, PN )
C	********** *****

C This routine calculates the Legendre polynomial of the first kind,
C Pn(cos{theta}), for the given n (N) and cos{theta} (C).

C The routine uses recursion relationships to generate successive
C Pn's, up to the required polynomial.

	DOUBLE PRECISION PN, COST, F1, F2, F3, PNM1, PNM2

	COST = DBLE ( C )

	IF ( N .NE. 0 ) GOTO 110
	PN = 1.
	RETURN

110	IF ( N .NE. 1 ) GOTO 120
	PN = C
	RETURN

120	PNM2 = 1.
	PNM1 = COST

	DO 140 I = 2, N
	    F1 = DFLOAT (I)
	    F2 = DFLOAT (2*I-1)
	    F3 = DFLOAT (I-1)
	    PN = ( F2 * COST * PNM1 - F3 * PNM2 ) / F1
	    PNM2 = PNM1
	    PNM1 = PN
140	CONTINUE

	RETURN
	END


	SUBROUTINE CALK ( N, X, F )
C	********** ****

C This subroutine calculates a polynomial function of (n,x), (f).

	DOUBLE PRECISION X, F, FS, FN2SP1, FNSP1, FACN2S, FACNS, FACS,
     1                   TS, XS, SUM, DSUM, FACN, FACN2

	INTEGER S

	N2 = 2*N
	CALL FACT ( N, FACN )
	CALL FACT ( N2, FACN2 )
	FACS = 1.
	TS = 1.
	XS = 1.
	FACN2S = FACN2
	FACNS = FACN

	SUM = 0.

	DO 200 S = 0, N
	    FS = DFLOAT (S)
	    FN2SP1 = DFLOAT ( 2*N - S + 1 )
	    FNSP1 = DFLOAT ( N - S + 1 )
	    IF ( S .NE. 0 ) FACN2S = FACN2S / FN2SP1
	    IF ( S .NE. 0 ) FACNS = FACNS / FNSP1
	    IF ( S .NE. 0 ) FACS = FACS * FS
	    IF ( S .NE. 0 ) TS = TS * 2.
	    IF ( S .NE. 0 ) XS = XS * X

	    DSUM = (TS * FACN * FACN2S * XS) / (FACS * FACN2 * FACNS)
	    SUM = SUM + DSUM

200	CONTINUE

	F = SUM

	RETURN
	END


	SUBROUTINE FACT ( N, FAC )
C	********** ****

C This routine returns the n factorial, (as a real).

	DOUBLE PRECISION FAC, FI

	FAC = 1.

	DO 200 I = 1, N
	    FI = DFLOAT (I)
	    FAC = FAC * FI
200	CONTINUE

	RETURN
	END


	SUBROUTINE FCALC ( FRAC, ES, PH, PKINT, FF )
C	********** *****

C This routine returns the fraction of ionisable group, (PKINTrinsic,
C QFULL .. maximum charge), that is charged (FRAC) at the given PH.
C The ES value is taken to be the es energy difference of the charged
C state between bulk and protein, in kT units.

	DATA ENAT / 2.718282 /

	IF ( ES .GT. 70. ) ES = 70.
	IF ( ES .LT. -70. ) ES = -70.
	A = ( ENAT ** (-ES) ) * ( 10. ** ( FF * (PH-PKINT) ) )

	FRAC = 1. / ( 1. + 1./A )

	RETURN
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

C Initialise the file string.

	DO 160	i	= 1, 80
	  file (i:i)	= ' '
160	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END

