
C !! - curtly - check through the whole program and clear up the .inf o/p

C modified Nov.95 to write out charge centres at same time as ctr files,
C in the temporary file 'charge_cen.dat'.
C modified Dec.95 to swap xyz_top/low if we have focus centre clash.
C modified Aug.98 to find Vfs also for ionisable gp in a background of
C          mainchain + CBs only - relates to sc relaxation ??

C Updated Jan 2000 to have variable temperature.

C ?? flags
C Program	F D _ M A N A G E R	- JW, Reading, Nov.93
C                                         updated for multiple charge sets,
C					  Apr.94

C This program manages file input and output and analysis for looping of
C FDCALC runs over individual groups of a molecule.  The looping bit will
C happen from a DCL file.  The rest will be done by fd_manager.
C An initial input file of individual groups is translated into a set of
C arrays that will be filled up with potentials/energies as the loop
C progresses.  Each new run of fd_manager will look at these arrays to see
C where to pick up from.

C There will also be an outer loop on the various charge sets representing
C various (partially) charges forms of the ionisable groups.

C For each group we will follow Gilson and have just 2 runs - protein diel
C and ind. Q and ind. diel and ind. Q, where the ind. diel will probably
C be the aa just cut away from the protein (do it with coordinates then).
C And all ind. Q - other Q intns. will be done with interpolations.  This
C may be more accurate than eg. putting partl Q's onto grid, since on maybe
C 1 A grid, may have Q cancelling, but not with potl interpolation.

	CHARACTER*8	state
	LOGICAL		extra_runs
	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	INTEGER		igps (355,4), igps_nres (355)
	CHARACTER*1	cgps (355)
	CHARACTER*80	mol_label
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			Vf (355,3)
	INTEGER		qopind (355,10,4), nq_gps (4),
     1			ind_xyz (355,10,4)
	CHARACTER*80	this_line
	CHARACTER*20	i_manager
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1300	FORMAT (A80)
2000	FORMAT (' fd_manager - done for ',I3,
     1' ionisables and ',I1,' non-fixed charge sets')

9000	FORMAT ('0','*** i_manager has wrong value')
9100	FORMAT ('0','*** loop mismatch .com / fd_manager ')
9300	FORMAT ('0','*** we still have Q_set true flags to go')
9400	FORMAT ('0','*** mix-up in getting next i_Q_here')

C Make sure that the .com file test variable is updated to n_groups, and
C that we run 4 or 8 fdcalc sets consistent with extra_runs.

C Modified Sep 2001 to get i_manager from environment variable.
C With		i_manager = '0'	set up basis files
C		i_manager = '1'	set up specfic files for all i_gp's and
C				process if i_gp greater than 1

	CALL getenv ('i_manager', i_manager)

C ??	READ (5,*) i_manager
	IF	(i_manager (1:1) .EQ. '0') THEN			! set up pass
	  CALL	ctr_setup
	  CALL	read_groups
	  CALL	setup

C These settings will flag us for no processing when we look with read_data.

	  i_Q_done		= 0
	  i_gp_here		= 0

C Find the first ionisables charge set to work on.

	  DO 240 jj		= 2, 5
	    IF (Q_set (jj)) GOTO 250
240	  CONTINUE						! End jj
	  GOTO 940

250	  i_Q_here		= jj - 1
	  curr_Q_file		= Q_file (jj)
	  curr_coords_file	= coords_file (jj)
C ??	  DO 260 m		= 1, 60
C ??	    curr_Q_file (m) 	= Q_file (jj,m)
C ??	    curr_coords_file (m) = coords_file (jj,m)
C ??260	  CONTINUE					! End m

C??C Update the coords_all.pep file eachtime we change Q set - NOT NEEDED HERE
C??
C??	  OPEN (UNIT=7, NAME=curr_coords_file, TYPE='OLD', READONLY)
C??	  OPEN (UNIT=8, NAME='coords_all.pep', TYPE='NEW')
C??270	  READ (7,1300,END=280) this_line
C??	  WRITE (8,1300) this_line
C??	  GOTO 270
C??280	  CLOSE (UNIT=7)
C??	  CLOSE (UNIT=8)

	  CALL	write_data (0)
	ELSE IF (i_manager (1:1) .EQ. '1') THEN			! regular pass
	  CALL		read_data
	  IF      (state .EQ. 'all_done') THEN
	    GOTO 910
	  ELSE IF (state .EQ. 'non_done') THEN
	    CALL	get_focus_cen
	    CALL	ctr_update
	    CALL	make_ind_files
	    CALL	write_data (1)
	  ELSE
	    CALL	process
	    DO 300 m				= 1, 2
	      DO 300 n				= 1, 3
	        done (i_gp_here,m,n,i_Q_here)	= .TRUE.
300	    CONTINUE						! End m,n
	    IF (i_gp_here .EQ. n_gps) THEN
	      i_Q_done		= i_Q_done + 1
	      IF (i_Q_done .EQ. i_Q_todo) THEN

C Just check that we didn't think there were any more ionisable charge sets
C to work on after this.

		IF (i_Q_here .LT. 4) THEN
		  DO 305 jj	= i_Q_here+2, 5
		    IF (Q_set (jj)) GOTO 930
305		  CONTINUE					! End jj
		END IF

C We are done - drop-out without setting up any more files.

		WRITE (2,*)
		WRITE (2,2000) n_gps, i_Q_done
		CALL	write_data (1)
		CLOSE (UNIT=1)
		CLOSE (UNIT=2)
		CALL	EXIT
	      ELSE

C Find the next ionisables charge set to work on.

		IF (i_Q_here .GE. 4) GOTO 940
		DO 310 jj	= i_Q_here+2,5
		  IF (Q_set (jj)) GOTO 315
310		CONTINUE					! End jj
		GOTO 940

315		i_Q_here	= jj - 1
		curr_Q_file	= Q_file (jj)
		curr_coords_file = coords_file (jj)
C ??		DO 320 m	= 1, 60
C ??		  curr_Q_file (m) = Q_file (jj,m)
C ??		  curr_coords_file (m) = coords_file (jj,m)
C ??320		CONTINUE					! End m

C Update the coords_all.pep file eachtime we change Q set.

		OPEN (UNIT=7, NAME=curr_coords_file, TYPE='OLD')
		OPEN (UNIT=8, NAME='coords_all.pep', TYPE='NEW')
330		READ (7,1300,END=340) this_line
		WRITE (8,1300) this_line
		GOTO 330
340		CLOSE (UNIT=7)
		CLOSE (UNIT=8)

		i_gp_here	= 1

	      END IF
	    ELSE
	      i_gp_here		= i_gp_here + 1
	    END IF
	    CALL	get_focus_cen
	    CALL	ctr_update
	    CALL	make_ind_files
	    CALL	write_data (1)
	    CLOSE (UNIT=2)
	  END IF						! state
	ELSE
	  GOTO 900
	END IF							! i_manager

C We'll leave the pKa processing to another program.
C?? unit 1 is fd_manager.out

	CLOSE (UNIT=1)
	CALL	EXIT

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT
	END


	SUBROUTINE	get_focus_cen
C	**********	*************

C Average xyz over the charge bits of i_gp_here - assume this is already set.

	REAL		focus_cen (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	LOGICAL		extra_runs
	CHARACTER*8	file_root, old_root, check, state
	CHARACTER*14	coords_here
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4)
	INTEGER		qopind (355,10,4), nq_gps (4)
	LOGICAL*1	done (355,2,3,4)
	REAL		focus_cent (3), gps_sum (355,4), Vf (355,3)
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	INTEGER		igps (355,4), igps_nres (355),
     1			ind_xyz (355,10,4)
	CHARACTER*80	mol_label
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1100	FORMAT (' For ionisable group ',I3,' focus grid a
     1 centre is ',3F8.1)
2000	FORMAT (I1,1X,I4)
2200	FORMAT (3F8.3)

	n_bits		= igps (i_gp_here,i_Q_here)
	OPEN (UNIT=3, NAME='charge_cen.dat', TYPE='NEW',
     1        FORM='FORMATTED')
	WRITE (3,2000) n_bits, i_gp_here
	x_tot		= 0.
	y_tot		= 0.
	z_tot		= 0.
	DO 200 m	= 1, n_bits
	  x_tot		= x_tot + xyz (i_gp_here,m,1,i_Q_here)
	  y_tot		= y_tot + xyz (i_gp_here,m,2,i_Q_here)
	  z_tot		= z_tot + xyz (i_gp_here,m,3,i_Q_here)
	  WRITE (3,2200) (xyz (i_gp_here,m,n,i_Q_here),n=1,3)
200	CONTINUE						! End m
	CLOSE (UNIT=3)
	focus_cent (1)	= x_tot / FLOAT (n_bits)
	focus_cent (2)	= y_tot / FLOAT (n_bits)
	focus_cent (3)	= z_tot / FLOAT (n_bits)
	CALL	just_3dps (focus_cent, focus_cen)

	WRITE (2,*)
	WRITE (2,1100) i_gp_here, focus_cen
	RETURN
	END


	SUBROUTINE	just_3dps (xyz_in, xyz_out)
C	**********	*********

	REAL		xyz_in (3), xyz_out (3)

	DO 200 n	= 1, 3
	  value		= AINT ( (1000.*xyz_in (n)) )
	  xyz_out (n)	= value / 1000.
200	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	read_data
C	**********	*********

C Read in the charge interaction data, and see where we are up to.

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	CHARACTER*1	fix_chain (10000), cgps (355)
	CHARACTER*4	gps_type (355), fix_res (10000),
     1			fix_atyp (10000), rgps (355)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*8	state
	CHARACTER*80	mol_label, this_line
	LOGICAL		extra_runs
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1300	FORMAT (A80)

C ?? - is this all variable record lengths?
	OPEN (UNIT=1, NAME='fd_manager.out', TYPE='OLD',
     1	      FORM='UNFORMATTED')

	READ (1) mol_label
	READ (1) i_gp_here, i_Q_here
	READ (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		  (Q_file (j), j=1,5)
	READ (1) (coords_file (j), j=1,5)
	READ (1) n_gps, (nq_gps (m), m=1,4), extra_runs
	READ (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		 (igps_nres (i), i=1,n_gps),
     2		 (cgps (i), i=1,n_gps)
	READ (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	READ (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	READ (1) (gps_type (i), i=1,n_gps)
	READ (1) ((((done (i,j,k,m), m=1,4),k=1,3), j=1,2), i=1,n_gps)
	READ (1) (((((se (i,j,k,l,m), m=1,4),l=1,10), k=1,3), j=1,2),
     1		      i=1,n_gps)
	READ (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10), i=1,n_gps)
	READ (1) ((((fix (i,j,k,m), m=1,4),k=1,3), j=1,2), i=1,n_gps)
	READ (1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		      j=1,3), i=1,n_gps)
	READ (1) (pKint (i), i=1,n_gps)
	READ (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	READ (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) nq_fix
	DO 200 i	= 1, nq_fix
	  READ (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		    fix_atyp (i), fix_nres (i), fix_chain (i)
200	CONTINUE						! End i

C Set which Q set and which i_gp we are on.  Subtract the fixed Q set off.

	IF (i_gp_here.EQ.0 .AND. i_Q_done.EQ.0) THEN
	  state = 'non_done'
	  i_gp_here	= 1
	END IF
	curr_Q_file		= Q_file (i_Q_here+1)
	curr_coords_file	= coords_file (i_Q_here+1)
C ??	DO 260 m		= 1, 60
C ??	  curr_Q_file (m)	= Q_file (i_Q_here+1,m)
C ??	  curr_coords_file (m)	= coords_file (i_Q_here+1,m)
C ??260	CONTINUE						! End m

C Update the coords_all.pep file eachtime we change Q set - and i_gp I think.

	OPEN (UNIT=7, NAME=curr_coords_file, TYPE='OLD')
	OPEN (UNIT=8, NAME='coords_all.pep', TYPE='NEW')
270	READ (7,1300,END=280) this_line
	WRITE (8,1300) this_line
	GOTO 270
280	CLOSE (UNIT=7)
	CLOSE (UNIT=8)

	IF (i_Q_done .EQ. i_Q_todo) state	= 'all_done'

C?? - keep unit 1 open for rewinding and writing from write_data
C?? - close when fd_manager exits
C??	CLOSE (UNIT=1)

	OPEN (UNIT=2, NAME='fd_manager.inf', TYPE='OLD',
     1	      ACCESS='APPEND')
	RETURN
	END


	SUBROUTINE	ctr_setup
C	**********	*********

C Set up the fdcalc ctr files.  We are assuming linear runs and quite a
C a few other things.  Those items that we can change are input here from
C the overall command file.

	REAL		focus_cen (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	LOGICAL		extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)
	CHARACTER*8	file_root, old_root, check, state
	CHARACTER*14	coords_here
	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*80	mol_label, line

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1040	FORMAT (A80)
1100	FORMAT (A8)
C??1200	FORMAT (Q,60A1)
9000	FORMAT ('0','*** error reading from com file in ctr_setup')
9100	FORMAT ('0','*** We must have a fixed charge set matey')
9200	FORMAT ('0','*** Would like a fxed Q set + one other')
9300	FORMAT ('0','*** i_VdW is out of bounds (1 to 3)')

	OPEN (UNIT=1, NAME='fd_manager.in', TYPE='OLD')

C Read the molecule/run label.

	READ (1,1040) mol_label

C We can now have a separate coordinate file for each charge set in the
C fdcalc calculations - so that we can have the varioys hydrogen config-
C urations in.  Or we could simply repeat a non-hydrogen file.
C Each change of charge set will be accompanied by a re-write of coords_all.pep
C from the appropriate coord file.  coords_all/ind.pep is used by fdcalc.

C Read through the various charge files.  The first one gives the fixed charges
C that are used for all ionisable group calculations - they remain constant -
C it is necessary.  None of the others is compulsory - but list_energy and
C pK_calc will tell us if we don't have the right material for the calculation
C we want - e.g. charged partially charge ionisable groups will want at least
C one neutral partially charged form to difference with.  The 2 neutral forms
C will allow us to put in the double forms of aspH,gluH,his, and arg?
C	Q_set 1    -    fixed		fixed dipolar charges for all runs
C	      2    -	chr_unit	unit charges from +/- (1.0 or 2*0.5)
C	      3    -	chr_prtl	unit charges from distributed prtl Q's
C	      4    -    neutral1	zero charge  from distributed prtl Q's
C             5    -	neutral2	zero charge  from distributed prtl Q's

C Initialise byte arrays for file names.

C ??	DO 1016 if		= 1, 5
C ??	  DO 1016 ic		= 1, 60
C ??	    Q_file (if,ic)	= ' '
C ??	    coords_file (if,ic)	= ' '
C ??1016	CONTINUE					! End ic,if

	n_Q_sets		= 0
	READ (1,1100) check
	IF (check .NE. 'charges ') GOTO 900
	READ (1,1100) check
	IF (check .NE. 'fixed   ') GOTO 900
	READ (1,*) Q_set (1)
	IF (Q_set (1)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (1))
C ??	  READ (1,1200) nc, (Q_file (1,ic), ic=1,nc)
	ELSE
	  GOTO 910
	END IF
	READ (1,1100) check
	IF (check .NE. 'chr_unit') GOTO 900
	READ (1,*) Q_set (2)
	IF (Q_set (2)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (2))
	  READ (1,1040) line
	  CALL	get_filename (line, coords_file (2))
C ??	  READ (1,1200) nc, (Q_file (2,ic), ic=1,nc)
C ??	  READ (1,1200) nc, (coords_file (2,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'chr_prtl') GOTO 900
	READ (1,*) Q_set (3)
	IF (Q_set (3)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (3))
	  READ (1,1040) line
	  CALL	get_filename (line, coords_file (3))
C ??	  READ (1,1200) nc, (Q_file (3,ic), ic=1,nc)
C ??	  READ (1,1200) nc, (coords_file (3,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'neutral1') GOTO 900
	READ (1,*) Q_set (4)
	IF (Q_set (4)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (4))
	  READ (1,1040) line
	  CALL	get_filename (line, coords_file (4))
C ??	  READ (1,1200) nc, (Q_file (4,ic), ic=1,nc)
C ??	  READ (1,1200) nc, (coords_file (4,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'neutral2') GOTO 900
	READ (1,*) Q_set (5)
	IF (Q_set (5)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (5))
	  READ (1,1040) line
	  CALL	get_filename (line, coords_file (5))
C ??	  READ (1,1200) nc, (Q_file (5,ic), ic=1,nc)
C ??	  READ (1,1200) nc, (coords_file (5,ic), ic=1,nc)
	END IF
	IF (n_Q_sets .LT. 2) GOTO 920
	i_Q_todo	= n_Q_sets - 1

C Choose the VdW radii set - this can change things a bit - Whoops!

	READ (1,1100) check
	IF (check .NE. 'whichVdW') GOTO 900
	READ (1,*) i_VdW
	IF (i_VdW .LT. 1 .OR. i_VdW .GT. 3) GOTO 930

C On the current scheme we have up to 8 fdcalc runs per i_gp plus
C another 2 for the mc + CBs background Vf calculation.  This will either
C be 4 or 8 plus 2, depending on whether we bring in the extra focus
C grid runs to get numerical error estimate.  The 4 will be reg and foc grids
C for protein and aa alone runs.  We only need to change the focus grid
C centres as we progress - o/p base ctr files here.
C See if we are to use the extra 4 focus grids for error checking.

	READ (1,1100) check
	IF (check .NE. 'morefocs') GOTO 900
	READ (1,*) extra_runs
	READ (1,1100) check
	IF (check .NE. 'focusgrd') GOTO 900
	READ (1,*) focus_step, focus_num
	READ (1,1100) check
	IF (check .NE. 'regulgrd') GOTO 900
	READ (1,*) step, extend
	READ (1,1100) check
	IF (check .NE. 'dielvals') GOTO 900
	READ (1,*) diel_prot, diel_solv, diel_rad, temp_K
	READ (1,1100) check
	IF (check .NE. 'pH      ') GOTO 900
	READ (1,*) pH
	READ (1,1100) check
	IF (check .NE. 'inclions') GOTO 900
	READ (1,*) incl_ion, conc_ion, rad_ion
	READ (1,1100) check
	IF (check .NE. 'sternlyr') GOTO 900
	READ (1,*) inc_ion, rad_inc

	focus_cen (1)	= 0.
	focus_cen (2)	= 0.
	focus_cen (3)	= 0.

	file_root	= 'fd93_1_r'
	old_root	= 'fd93_x_r'
	focus		= .FALSE.
	coords_here	= 'coords_all.pep'
	sor_fac		= 1.85
	CALL	ctr_write
	file_root	= 'fd93_2_r'
	old_root	= 'fd93_x_r'
	focus		= .FALSE.
	coords_here	= 'coords_ind.pep'
	sor_fac		= 1.85
	CALL	ctr_write
	file_root	= 'fd93_1_a'
	old_root	= 'fd93_1_r'
	focus		= .TRUE.
	coords_here	= 'coords_all.pep'
	sor_fac		= 1.90
	CALL	ctr_write
	file_root	= 'fd93_2_a'
	old_root	= 'fd93_2_r'
	focus		= .TRUE.
	coords_here	= 'coords_ind.pep'
	sor_fac		= 1.90
	CALL	ctr_write

C extra bit for the mc/CBs background Vf calculation.

	file_root	= 'fd93_3_r'
	old_root	= 'fd93_x_r'
	focus		= .FALSE.
	coords_here	= 'crds_indmc.pep'
	sor_fac		= 1.85
	CALL	ctr_write
	file_root	= 'fd93_3_a'
	old_root	= 'fd93_3_r'
	focus		= .TRUE.
	coords_here	= 'crds_indmc.pep'
	sor_fac		= 1.90
	CALL	ctr_write

	IF (extra_runs) THEN
	  file_root	= 'fd93_1_b'
	  old_root	= 'fd93_1_r'
	  focus		= .TRUE.
	  coords_here	= 'coords_all.pep'
	  sor_fac	= 1.90
	  CALL	ctr_write
	  file_root	= 'fd93_2_b'
	  old_root	= 'fd93_2_r'
	  focus		= .TRUE.
	  coords_here	= 'coords_ind.pep'
	  sor_fac	= 1.90
	  CALL	ctr_write
	  file_root	= 'fd93_1_c'
	  old_root	= 'fd93_1_r'
	  focus		= .TRUE.
	  coords_here	= 'coords_all.pep'
	  sor_fac	= 1.90
	  CALL	ctr_write
	  file_root	= 'fd93_2_c'
	  old_root	= 'fd93_2_r'
	  focus		= .TRUE.
	  coords_here	= 'coords_ind.pep'
	  sor_fac	= 1.90
	  CALL	ctr_write
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT
	END


	SUBROUTINE	ctr_write
C	**********	*********

C Write out and fdcalc ctr file.

	REAL		focus_cen (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	LOGICAL		t, f
	CHARACTER*8	file_root, old_root
	CHARACTER*14	coords_here

	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW

1100	FORMAT (A4)
1140	FORMAT (A14)
1200	FORMAT (A4,2X,A4)
1300	FORMAT (A8)
1500	FORMAT (A12)
1600	FORMAT (A5)
1640	FORMAT (A9)
1800	FORMAT (A14)
1900	FORMAT (1X,L1, 1X,L1, 1X,L1, 1X,I1, 1X,F9.6, 1X,3F4.1,
     1		1X,I2,1X,F4.1)

	OPEN (UNIT=4, NAME=file_root//'.ctr', TYPE='NEW')
	t	= .TRUE.
	f	= .FALSE.

	WRITE (4,1100) 'FDCL'
	WRITE (4,1100) 'FOCU'
	WRITE (4,*) focus, f, f, focus_step, focus_num, focus_cen
	WRITE (4,1100) 'SAVR'
	WRITE (4,*) f
	WRITE (4,1100) 'DATA'
	WRITE (4,1140) coords_here
	WRITE (4,1140) 'coords_ind.qop'
	WRITE (4,1100) 'MISC'
	WRITE (4,*) f, i_VdW, f
	WRITE (4,1100) 'CALP'
	WRITE (4,*) f, f, 7.1, f
	WRITE (4,1100) 'GRID'
	WRITE (4,*) step, extend, t, f, 0.0
	WRITE (4,1100) 'BCS '
	WRITE (4,1200) 'ZERO', 'ZERO'
	WRITE (4,1200) 'ZERO', 'ZERO'
	WRITE (4,1200) 'ZERO', 'ZERO'
	WRITE (4,1100) 'TMPK'
	WRITE (4,*) temp_K
	WRITE (4,1100) 'DIEL'
	WRITE (4,*) diel_prot, diel_solv, f, diel_rad, f, 0.0
	WRITE (4,1100) 'DLC2'
	WRITE (4,*) f, 5, f, 4.2, diel_solv, 1.0, 2.835
	WRITE (4,1100) 'SORP'
	WRITE (4,*) sor_fac, f, 100
	WRITE (4,1100) 'QDIS'
	WRITE (4,1300) 'NEAREST8'
	WRITE (4,1100) 'PH  '
	WRITE (4,*) 7.0
	WRITE (4,1100) 'TIME'
	WRITE (4,*) 800, f, 1400, t, 0.000001, f
	WRITE (4,1100) 'IONS'
	WRITE (4,*) incl_ion, t,t, conc_ion,f,rad_ion,inc_ion,rad_inc
	WRITE (4,1100) 'HOPE'
	WRITE (4,*) f, 3.8, 1000.
	WRITE (4,1100) 'FRAC'
	WRITE (4,*) f, f, 5
	WRITE (4,1100) 'PCS '
	WRITE (4,*) f, 100, t
	WRITE (4,1100) 'SMOO'
	WRITE (4,*) f, 0.98, f, 200, 1.00, 50
	WRITE (4,1100) 'OUTP'
	WRITE (4,1500) file_root//'.inf'
	WRITE (4,1500) file_root//'.pot'
	WRITE (4,1600) 'x.mol'
	WRITE (4,1500) file_root//'.itr'
	WRITE (4,1500) file_root//'.dlc'
	WRITE (4,1600) 'x.dfx'
	WRITE (4,1500) file_root//'.chr'
	WRITE (4,1500) file_root//'.ion'
	WRITE (4,1600) 'x.cac'
	WRITE (4,1500) file_root//'.crw'
	WRITE (4,1100) 'CONT'
	WRITE (4,1500) old_root//'.pot'
	WRITE (4,1500) old_root//'.itr'
	WRITE (4,1640) 'x_old.dlc'
	WRITE (4,1640) 'x_old.dfx'
	WRITE (4,1640) 'x_old.ion'
	WRITE (4,1640) 'x_old.cac'
	WRITE (4,1100) 'VALS'
	WRITE (4,*) 0
	WRITE (4,1100) 'SWCH'
C ??	WRITE (4,*) f, f, f, 1, 0.000001, 0.0, 0.0, 0.0, 80, 0.2
	WRITE (4,1900) f, f, f, 1, 0.000001, 0.0, 0.0, 0.0, 80, 0.2
	WRITE (4,1100) 'REGP'
	WRITE (4,1800) 'fd_X_Nreg1.pot'
	WRITE (4,1800) 'fd_X_Nreg2.pot'
	WRITE (4,1100) 'END '

	CLOSE (UNIT=4)

	RETURN
	END


	SUBROUTINE	ctr_update
C	**********	**********

C Update the fd93 ctr files as go through with different i_gp - actually
C it is only the focus centre that we will be updating.

	REAL		focus_cen (3), focus_here (3), focus_hear (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	LOGICAL		extra_runs
	CHARACTER*8	file_root, old_root, state
	CHARACTER*14	coords_here

	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW

	DO 200 n		= 1, 3
	  focus_here (n)	= focus_cen (n)
200	CONTINUE						! End n

	file_root	= 'fd93_1_r'
	focus		= .FALSE.
	CALL	ctr_fix (focus_here)
	file_root	= 'fd93_2_r'
	focus		= .FALSE.
	CALL	ctr_fix (focus_here)
	file_root	= 'fd93_1_a'
	focus		= .TRUE.
	CALL	ctr_fix (focus_here)
	file_root	= 'fd93_2_a'
	focus		= .TRUE.
	CALL	ctr_fix (focus_here)

C extra bit for the mc+CBs Vf calculation.

	file_root	= 'fd93_3_r'
	focus		= .FALSE.
	CALL	ctr_fix (focus_here)
	file_root	= 'fd93_3_a'
	focus		= .TRUE.
	CALL	ctr_fix (focus_here)

	IF (extra_runs) THEN
	  DO 300 n		= 1, 3
	    focus_hear (n)	= focus_cen (n) + focus_step/2.
300	  CONTINUE						! End n
	  CALL	just_3dps (focus_hear, focus_here)
	  file_root	= 'fd93_1_b'
	  focus		= .TRUE.
	  CALL	ctr_fix (focus_here)
	  file_root	= 'fd93_2_b'
	  focus		= .TRUE.
	  CALL	ctr_fix (focus_here)
	  DO 400 n		= 1, 3
	    focus_hear (n)	= focus_cen (n) + focus_step/3.
400	  CONTINUE						! End n
	  CALL	just_3dps (focus_hear, focus_here)
	  file_root	= 'fd93_1_c'
	  focus		= .TRUE.
	  CALL	ctr_fix (focus_here)
	  file_root	= 'fd93_2_c'
	  focus		= .TRUE.
	  CALL	ctr_fix (focus_here)
	END IF

	RETURN
	END


	SUBROUTINE	make_ind_files
C	**********	**************

C Cut the individual ionisable group coords and charges files out of the
C overall files.

	REAL		xyz_here (3), gps_sum (355,4)
	CHARACTER*4	gps_type (355), type_gp, rgps (355)
	INTEGER		igps (355,4), igps_nres (355)
	CHARACTER*1	cgps (355), qc_buf, chain_gp, chain_here
	CHARACTER*80	mol_label, header
	CHARACTER*8	state
	INTEGER		which_VdW_es
	LOGICAL		macinc, itrate, extra_runs
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			Vf (355,3)
	CHARACTER*4	atyp_here, qa4_buf (3), res_here, atm,
     1			res_gp
	INTEGER		qopind (355,10,4), nq_gps (4)
	LOGICAL*1	done (355,2,3,4)
	REAL		qr_buf (7), xyz_low(3),xyz_top(3)
	INTEGER		qi_buf (3), ind_xyz (355,10,4)
	LOGICAL		ql_buf (2), Q_set (5), write_out
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file,
     1			qfil (5), pdbfil (5)
C ??	BYTE		Q_file (5,60), qfil (5,80), pdbfil (5,80),
C ??     1		curr_Q_file (60),
C ??     2		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/xyz_lims/	xyz_low, xyz_top
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1100	FORMAT (A80)
C ?? 1200	FORMAT (A4,9X,A4,A4,1X,I4,4X,3F8.3)
1200	FORMAT (A4,9X,A4,A4,A1,I4,4X,3F8.3)

1600	FORMAT (' For nres/res = ',I4,'/',A4,' ats in
     1 iso crd file = ',I2,' + lim ats: in bg file = ',I5)
1800	FORMAT (' For nres/res = ',I4,'/',A4,' chrgs in
     1 isolated chrge file = ',I2)
9000	FORMAT ('0','*** no atoms found for ind. write-out')
9100	FORMAT ('0','*** no charges found for ind gp mismatch')
9200	FORMAT ('0','*** unidentified gps_type')

C Note that we are relaxing the res check to allow eg ARG and ARG1 to go
C through together.  We also check for N-t and C-t and first and last aa's,
C to modify the appropriate bits - see notes May.94.

	nres_gp		= igps_nres (i_gp_here)
	res_gp		= rgps (i_gp_here)
	type_gp		= gps_type (i_gp_here)
	chain_gp	= cgps (i_gp_here)
	nat_ind		= 0
	OPEN (UNIT=7, NAME='coords_all.pep', TYPE='OLD')
	OPEN (UNIT=8, NAME='coords_ind.pep', TYPE='NEW')
	OPEN (UNIT=9, NAME='crds_indmc.pep', TYPE='NEW')
	READ (7,1100) header
	WRITE (8,1100) header
	WRITE (9,1100) header
	nat_ind		= 0
	nat_indmc	= 0
	DO 160 n	= 1, 3
	  xyz_low (n)	=  999.
	  xyz_top (n)	= -999.
160	CONTINUE
200	READ (7,1200,END=300) atm, atyp_here, res_here, chain_here,
     1			nres_here, xyz_here
	DO 220 n	= 1, 3
	  IF (xyz_here(n) .LT. xyz_low(n)) xyz_low (n) = xyz_here (n)
	  IF (xyz_here(n) .GT. xyz_top(n)) xyz_top (n) = xyz_here (n)
220	CONTINUE						! End n

	write_out	= .FALSE.
	IF	(type_gp .EQ. 'side') THEN
	  IF (nres_gp   .EQ. nres_here) write_out = .TRUE.
	ELSE IF (type_gp .EQ. 'nter') THEN
	  IF (nres_gp   .EQ. nres_here) write_out = .TRUE.
	  IF (nres_gp+1 .EQ. nres_here) write_out = .TRUE.
	ELSE IF (type_gp .EQ. 'cter') THEN
	  IF (nres_gp   .EQ. nres_here) write_out = .TRUE.
	  IF (nres_gp-1 .EQ. nres_here) write_out = .TRUE.
	ELSE IF (type_gp .EQ. 'frst') THEN
	  IF (nres_gp   .EQ. nres_here) write_out = .TRUE.
	  IF (nres_gp-1 .EQ. nres_here) write_out = .TRUE.
	ELSE IF (type_gp .EQ. 'last') THEN
	  IF (nres_gp   .EQ. nres_here) write_out = .TRUE.
	  IF (nres_gp+1 .EQ. nres_here) write_out = .TRUE.
	ELSE
	  GOTO 920
	END IF

C OCT.2001 update to include a matching of chain id's.

	IF (chain_gp .NE. chain_here) write_out = .FALSE.

	IF (write_out) THEN
	  nat_ind	= nat_ind + 1
	  WRITE (8,1200) atm,atyp_here,res_here,chain_here,nres_here,
     1			 xyz_here
	  WRITE (9,1200) atm,atyp_here,res_here,chain_here,nres_here,
     1			xyz_here
	  GOTO 200
	END IF
	write_out	= .FALSE.
	IF (atyp_here .EQ. 'NT  ') write_out = .TRUE.
	IF (atyp_here .EQ. 'N   ') write_out = .TRUE.
	IF (atyp_here .EQ. 'CA  ') write_out = .TRUE.
	IF (atyp_here .EQ. 'CB  ') write_out = .TRUE.
	IF (atyp_here .EQ. 'C   ') write_out = .TRUE.
	IF (atyp_here .EQ. 'O   ') write_out = .TRUE.
	IF (atyp_here .EQ. 'CT  ') write_out = .TRUE.
	IF (atyp_here .EQ. 'OT1 ') write_out = .TRUE.
	IF (atyp_here .EQ. 'OT2 ') write_out = .TRUE.
	IF (write_out) THEN
	  nat_indmc	= nat_indmc + 1
	  WRITE (9,1200) atm,atyp_here,res_here,chain_here,nres_here,
     1			 xyz_here
	END IF
	GOTO 200

300	IF (nat_ind .EQ. 0) GOTO 900
	CLOSE (UNIT=7)
	CALL	check_lims
	nres_here	= 999
	atyp_here	= 'CB  '
	res_here	= 'LEU '
	WRITE (8,1200) 'ATOM',atyp_here,res_here,' ',nres_here,xyz_low
	WRITE (8,1200) 'ATOM',atyp_here,res_here,' ',nres_here,xyz_top
	WRITE (9,1200) 'ATOM',atyp_here,res_here,' ',nres_here,xyz_low
	WRITE (9,1200) 'ATOM',atyp_here,res_here,' ',nres_here,xyz_top
	CLOSE (UNIT=8)
	CLOSE (UNIT=9)
	WRITE (2,1600) nres_gp, res_gp, nat_ind, nat_ind+nat_indmc

C And now for the isolated charge(s) file.

	nq_ind		= 0
	OPEN (UNIT=7, NAME=curr_Q_file, TYPE='OLD',
     1	      FORM='UNFORMATTED')
	OPEN (UNIT=8, NAME='coords_ind.qop', TYPE='NEW',
     1	      FORM='UNFORMATTED')

	READ (7) nfil
	WRITE (8) nfil
	DO 400 ifil	= 1, nfil
C ??	  READ (7) (pdbfil (ifil,ich), ich=1,80)
	  READ (7) pdbfil (ifil)
	  READ (7) qfil (ifil)
C ??	  READ (7) (qfil (ifil,ich), ich=1,80)
C ??	  WRITE (8) (pdbfil (ifil,ich), ich=1,80)
	  WRITE (8) pdbfil (ifil)
	  WRITE (8) qfil (ifil)
C ??	  WRITE (8) (qfil (ifil,ich), ich=1,80)
400	CONTINUE						! ifil
        READ (7) nq_here, macinc, itrate, i_qset, which_VdW_es, ncal
	nq_tmp	= igps (i_gp_here,i_Q_here)
	WRITE (8) nq_tmp, macinc, itrate, i_qset, which_VdW_es, ncal

C For the charge bits of i_gp_here, which would have been ionisable, now
C turn ionisable off, so that fdcalc takes fixed charges.

	DO 600 iq	= 1, nq_here
	  READ (7) (qr_buf (m), m=1,7), (qa4_buf (m), m=1,3),
     1		   (qi_buf (m), m=1,3), (ql_buf (m), m=1,2),
     2		    qc_buf
	  DO 500 mm	= 1, igps (i_gp_here,i_Q_here)
	    IF (iq .EQ. qopind (i_gp_here,mm,i_Q_here)) THEN
	      ql_buf (1) = .FALSE.
	      WRITE (8) (qr_buf (m), m=1,7), (qa4_buf (m), m=1,3),
     1			(qi_buf (m), m=1,3), (ql_buf (m), m=1,2),
     2			 qc_buf
	      nq_ind	= nq_ind + 1
	    END IF
500	  CONTINUE						! End mm
600	CONTINUE						! End iq
	IF (nq_ind .NE. igps (i_gp_here,i_Q_here)) GOTO 910

	READ (7) wbufer, tener, wtot_es, qtcur, qt, q_before
	WRITE (8) wbufer, tener, wtot_es, qtcur, qt, q_before
	nq_tmp		= 0
	DO 700 iq	= 1, nq_here
	  READ (7) poti, poti_fixed, poti_pK, qcur_buf,
     1		   q_pK, pkcur_buf, delpk_buf, wi_es, wbufi
	  DO 660 m	= 1, igps (i_gp_here,i_Q_here)
	    IF (iq .EQ. qopind (i_gp_here,m,i_Q_here)) THEN
	      nq_tmp	= nq_tmp + 1
	      WRITE (8) poti, poti_fixed, poti_pK, qcur_buf,
     1		        q_pK, pkcur_buf, delpk_buf, wi_es, wbufi
	    END IF
660	  CONTINUE						! End m
700	CONTINUE						! End iq
	IF (nq_tmp .NE. nq_ind) GOTO 910

	CLOSE (UNIT=7)
	CLOSE (UNIT=8)

C !! - how many of these write-outs will we get?
	WRITE (2,1800) nres_gp, res_gp, nq_ind
	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT
	END


	SUBROUTINE	check_lims
C	**********	**********

C Make sure that the charges are some way from the arbitrary limiting atoms.

	REAL		xyz_low (3), xyz_top (3)
	REAL		focus_cen (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	CHARACTER*8	file_root, old_root
	CHARACTER*14	coords_here

	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW
	COMMON	/xyz_lims/	xyz_low, xyz_top

C?? reduce tolerance a little.
C??9000	FORMAT ('0','*** focus_cen .lt. 8 A from a limit atom ?!')
9000	FORMAT ('0','*** focus_cen .lt. 4 A from a limit atom ?!')

	dist	= SQRT ( (focus_cen (1) - xyz_low (1))**2 +
     1			 (focus_cen (2) - xyz_low (2))**2 +
     2			 (focus_cen (3) - xyz_low (3))**2 )
	IF (dist .LT. 4.0) GOTO 300
	dist	= SQRT ( (focus_cen (1) - xyz_top (1))**2 +
     1			 (focus_cen (2) - xyz_top (2))**2 +
     2			 (focus_cen (3) - xyz_top (3))**2 )
	IF (dist .LT. 4.0) GOTO 300
	RETURN

C Just try swapping the x-ordinate around.

300	temp		= xyz_low (1)
	xyz_low (1)	= xyz_top (1)
	xyz_top (1)	= temp
	dist	= SQRT ( (focus_cen (1) - xyz_low (1))**2 +
     1			 (focus_cen (2) - xyz_low (2))**2 +
     2			 (focus_cen (3) - xyz_low (3))**2 )
	IF (dist .LT. 4.0) GOTO 500
	dist	= SQRT ( (focus_cen (1) - xyz_top (1))**2 +
     1			 (focus_cen (2) - xyz_top (2))**2 +
     2			 (focus_cen (3) - xyz_top (3))**2 )
	IF (dist .LT. 4.0) GOTO 500
	RETURN

C Now also swap the y-ordinate (adding to x-ord previously swapped).

500	temp		= xyz_low (2)
	xyz_low (2)	= xyz_top (2)
	xyz_top (2)	= temp
	dist	= SQRT ( (focus_cen (1) - xyz_low (1))**2 +
     1			 (focus_cen (2) - xyz_low (2))**2 +
     2			 (focus_cen (3) - xyz_low (3))**2 )
	IF (dist .LT. 4.0) GOTO 900
	dist	= SQRT ( (focus_cen (1) - xyz_top (1))**2 +
     1			 (focus_cen (2) - xyz_top (2))**2 +
     2			 (focus_cen (3) - xyz_top (3))**2 )
	IF (dist .LT. 4.0) GOTO 900
	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	ctr_fix (focus_here)
C	**********	*******

C Overwrite just the focus grid parameter record - rest is unchanged.
C ?? Note that in curtailing the filename records we are depending on all
C ?? files specified in .ctr starting with "scr:" - NOT ON SGs THOUGH 2/99.

	REAL		focus_cen (3), focus_here (3), rel1 (3)
	INTEGER		focus_num
	LOGICAL		focus, incl_ion, inc_ion
	LOGICAL		f, log1, log2, log3
	CHARACTER*8	file_root, old_root
	CHARACTER*14	coords_here
	INTEGER		nchr (100)
	CHARACTER*78	recs (100), rec_tmp

	COMMON	/ctr_params/	file_root, focus, focus_step,
     1				focus_num, focus_cen, step, extend,
     2				diel_prot, diel_solv, diel_rad,
     3				sor_fac, incl_ion, conc_ion, rad_ion,
     4				inc_ion,rad_inc,old_root,
     5				temp_K, coords_here
	COMMON	/VdW_set/	i_VdW

1100	FORMAT (A4)
1300	FORMAT (A78)

9000	FORMAT ('0','*** ctr file wrong in ctr_fix')

	OPEN (UNIT=4, NAME=file_root//'.ctr', TYPE='OLD')

	READ (4,1300) recs (1)
	rec_tmp = recs (1)
	IF (rec_tmp (1:1).NE.'F' .OR. rec_tmp (2:2).NE.'D') GOTO 900
	READ (4,1300) recs (2)
	rec_tmp = recs (2)
	IF (rec_tmp (1:1).NE.'F' .OR. rec_tmp (2:2).NE.'O') GOTO 900
	READ (4,*) log1, log2, log3, focus_step, focus_num, rel1
	IF (log1 .NEQV. focus) GOTO 900
	IF (log2) GOTO 900
	IF (log3) GOTO 900
	f	= .FALSE.

	irec	= 3
200	irec	= irec + 1
	READ (4,1300,END=300) recs (irec)
	GOTO 200

300	nrec	= irec - 1
	rec_tmp	= recs (4)
	IF (rec_tmp (1:1).NE.'S' .OR. rec_tmp (2:2).NE.'A') GOTO 900
	REWIND 4
	DO 400 irec	= 1, nrec
	  IF (irec .EQ. 3) THEN
	    WRITE (4,*) focus, f, f, focus_step, focus_num, focus_here
	  ELSE
C??	    IF (nchr (irec) .LT. 4) THEN
C??	      DO 360 ichr		= 1+nchr(irec), 4
C??		recs (ichr,irec)	= ' '
C??360	      CONTINUE						! End ichr
C??	      nchr (irec)		= 4
C??	    END IF
	    WRITE (4,1300) recs (irec)
	  END IF
400	CONTINUE						! End irec

	CLOSE (UNIT=4)
	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	read_groups
C	**********	***********

C Read in the indidual groups to calculate on, from fd_manager.in file.

	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*8	check
	CHARACTER*80	mol_label

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps

1100	FORMAT (A8)
C ??1200	FORMAT (A4,1X,I5,1X,A4)
1200	FORMAT (A4,1X,A1,I4,1X,A4)

9000	FORMAT ('0','n_gps is oub')
9100	FORMAT ('0','*** GROUPS id not found')

C Get the number of individual groups.  And the nres, res and ionisable
C group type, which is used in making the individual charge and coord files.
C Also initialise the various charge set, charge bit counters.

	READ (1,1100) check
	IF (check .NE. 'groups  ') GOTO 910
	READ (1,*) n_gps
	IF (n_gps.LT.1 .OR. n_gps.GT.355) GOTO 900
	DO 300 i	= 1, n_gps
	  READ (1,1200)	rgps(i), cgps(i), igps_nres(i), gps_type(i)
	  DO 280 j	= 1,4
	    igps (i,j)	= 0
280	  CONTINUE						! End j
300	CONTINUE						! End i
	CLOSE (UNIT=1)
	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT
	END


	SUBROUTINE	setup
C	**********	*****

C Setup the output file, fd_manager.out.  At present we'll have this as
C a sequential file, unformatted, with complete read, and then overwriting
C must of it every time - what about D.A.??

	REAL		se (355,2,3,10,4),
     1			char (355,10,4), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			pKint (355), gps_sum (355,4), Vf (355,3)
	INTEGER		igps (355,4), igps_nres (355),
     1			qopind (355,10,4), nq_gps (4),
     2			ind_xyz (355,10,4)
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*80	mol_label
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf

1100	FORMAT(' ',30X,'FD_MANAGER.INF')
1150	FORMAT (' ',12X,'ALL SPECIFIED IONISABLE MUST HAVE UNIQUE
     1 RESIDUE NUMBERS')
1200	FORMAT (' ',A80)
1300	FORMAT (' ','Number of individual groups =  ',I3)
1310	FORMAT (/,'** MESS - n_gps lim at 200 in gp_ij/size MESS **',/)
1320	FORMAT (' ','ALL groups not individually specified, but present
     1 in .QOP file,')
1330	FORMAT (' ','WILL be treated as fixed charges and lumped
     1 into the prtl Q sum')
1340	FORMAT (' ','IT SHOULD be possible to have "add on" fd_manager
     1 runs')
1350	FORMAT (' ','IF we specify ALL individual gps from the start')

	OPEN (UNIT=2, NAME='fd_manager.inf', TYPE='NEW')
	WRITE (2,1100)
	WRITE (2,*)
	WRITE (2,1150)
	WRITE (2,*)
	WRITE (2,1200) mol_label
	WRITE (2,1300) n_gps

C ?? TIDY UP - we should make such overall size variables one point variable.
C ?? Note that arrays are passed between 'suite' progs only up to n_gps - OK.

	IF (n_gps .GT. 355) STOP 'fd_man/gpij/size'
	WRITE (2,1310)

	WRITE (2,1320)
	WRITE (2,1330)
	WRITE (2,1340)
	WRITE (2,1350)
	WRITE (2,*)

C Read in the overall ESCALC.QOP file to identify gps, and put ALL
C the rest into the fixed charges arrays.

	CALL	read_escalc

C Set the gp flags to all undone.

	DO 300 i		= 1, n_gps
	  DO 300 j		= 1, 2
	    DO 300 k		= 1, 3
	      DO 300 m		= 1, 4
		done (i,j,k,m)	= .FALSE.
300	CONTINUE						! End i

C Initialise the gpij array to zero everywhere, so that we know when we've
C been tangoed (reproducibly).

	DO 400 i			= 1, 4
	  DO 400 j			= 1, 10
	    DO 400 k			= 1, 355
	      DO 400 m			= 1, 3
		DO 400 n		= 1, 355
		  gpij (n,m,k,j,i)	= 0.
400	CONTINUE						! End 5

	CLOSE (UNIT=2)
	RETURN
	END


	SUBROUTINE	read_escalc
C	**********	***********

C This routine reads in charge files as specified in the /charges_in/
C common. Set up the gps and fixd charge arrays as we go along.  Only those
C ionisable gps specified in "fd_manager.in" are carried separate from
C the fixed charges.  Ionisable groups in the first (fixed Q) .qop are set at
C their std magnitude values ADJUSTED by the input pH (so that e.g. tyr's
C are not put in at -1.00 if neutral pH is given).

C OCT.2001 - also we are NOW putting all 'full'.qop charges whether selected
C OCT.2001 - from 'fd_manager.in' or not.  If not selected (.in) then we will
C OCT.2001 - take just the 'full' file charge (not partials) at i/p pH.

C ?? Note that we assume any matches to nres/res of i_gp that are ionisable
C ?? are part of i_gp - could be trouble with this, (atyp's not used curr.)

C qop variables --------------------------------------------------
	REAL		qr_buf (7)
	CHARACTER*4	qa4_buf (3)
	INTEGER		qi_buf (3)
	LOGICAL		ql_buf (2)
	INTEGER		which_VdW_es
	LOGICAL		macinc, itrate, pkq
C grp i/p variables ----------------------------------------------
	REAL		gps_sum (355,4)
	INTEGER		igps (355,4), igps_nres (355)
	CHARACTER*4	rgps (355)
	CHARACTER*80	mol_label

C igps_nres is nres.  igps (i,x) is counter of the Q bits found for gps i as
C we read in the escalc.qop file x.  gps_sum (i,x) is a sum check on the
C amount of charge read in - we'll check it against 0/+-1.
C grp store variables --------------------------------------------
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4)
	INTEGER		qopind (355,10,4), nq_gps (4),
     1			ind_xyz (355,10,4)
	LOGICAL*1	done (355,2,3,4)

C ind_xyz (igp,i_Q,i bit of gp) - the index for this bit in the gpij array
C done (igp/i protein or alone run/i foc cen run/i Q set)	- run done?
C fix  (igp/i protein or alone run/i foc cen run/i Q set)	- fixd Qs sum
C se   (...................................../i bit of gp/iQset)- se potl
C char (igp/i bit of gp/i Q set)				- Q of bit
C xyz  (igp/i bit of gp/1-3/i Q set)				- xyz of bit
C gpij (igp/i foc cen run/j gp/bit ind_here/iQset)-(only prt run)-ptls -jbits
C	where the "bit ind_here" index comes from ind_xyz
C pKint (igp)							- pKint
C qopind (igp/i bit of gp/i Q set)				- iq in qop

C fix store variables --------------------------------------------
	REAL		fix_xyz (3,10000), fix_q (10000)
	CHARACTER*4	fix_res (10000), fix_atyp (10000)
	INTEGER		fix_nres (10000)
	CHARACTER*1	fix_chain (10000)

C fix arrays are clear - nres/res allow match up with aa of a gp.
C ----------------------------------------------------------------
	REAL		xyz_here (3), xyz_test (3), Vf (355,3)
	INTEGER		ind_curr (355)
	CHARACTER*8	state
	CHARACTER*4	gps_type (355), res_here
	CHARACTER*1	cgps (355), chain_here, qc_buf
	LOGICAL		extra_runs
	LOGICAL		Q_set (5), chk_igps (355)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

2000	FORMAT (' ','i/p Q set ',I1,' absolute Q index ',I1,' with
     1 ',I4,' ionisable Q atoms found')
2200	FORMAT (' ','i/p fixed charge set gave ',I5,
     1 'fixed charge atoms with charge sum ',F6.1)
2205	FORMAT (/,'*** We will also fix those ionisables in "full"
     1 charges but not ".in" ***')
2210	FORMAT (' ','*** And after that we get ',I5,
     1 'fixed charge atoms with charge sum ',F6.1,' ***',/)
2400	FORMAT ('0',78('-'))
C??2600	FORMAT (' ','Group ',I3,2X,A4,2X,I5,'gpij indices used = ',I2)
2600	FORMAT (' ','Group ',I3,2X,A4,2X,A1,I4,'gpij indices = ',I2)

9100	FORMAT ('0','*** too many fixed charges in read_escalc')
9300	FORMAT ('0','*** charged bist mismatch2 in read_escalc ',
     1 A1,1X,I4,1X,A4)
9400	FORMAT ('0','*** Aha, i_Q_found .ne. n_Q_sets')
9500	FORMAT ('0','*** ind_here (for ind_xyz) is oub')

C Our check that the non-fixed charge sets are giving the same gps is firstly
C to see that each gp from .in has been hit by each set, and secondly to make
C sure that we get 0,+/-1 summed charged values over a group.

	nq_fix			= 0
	q_fix_sum		= 0.
	i_Q_found		= 0

C We just have a single counter over the (non-fixed) charge sets of bit
C indices for gpij - this is cumulative - only one gpij slot per atom.

	DO 120 m		= 1, n_gps
	  ind_curr (m)		= 0
120	CONTINUE						! End m

C The first charge set will be the fixed charges.

	DO 600 i_Q_set		= 1, 5
	  nq_gps_here		= 0
	  DO 140 m		= 1, n_gps
	    chk_igps (m)	= .FALSE.
140	  CONTINUE						! End n

	  IF (Q_set (i_Q_set)) THEN

	    i_Q_found		= i_Q_found + 1
	    curr_Q_file		= Q_file (i_Q_set)
C ??	    DO 160 m		= 1, 60
C ??	      curr_Q_file (m)	= Q_file (i_Q_set,m)
C ??160	    CONTINUE						! End m
	    OPEN (UNIT=3, NAME=curr_Q_file, TYPE='OLD',
     1	          FORM='UNFORMATTED')
	    READ (3) nfil
	    DO 200 ifil		= 1, nfil
	      READ (3)						! pdbfil
	      READ (3)						! qfil
200	    CONTINUE						! ifil
	    READ (3) nq_here, macinc, itrate, i_qset, which_VdW_es, ncal
	    DO 300 iq		= 1, nq_here

	      READ (3) (qr_buf (m), m=1,7), (qa4_buf (m), m=1,3),
     1		       (qi_buf (m), m=1,3), (ql_buf (m), m=1,2),
     2			qc_buf

	      IF (i_Q_set .EQ. 1) THEN
		nq_fix			= nq_fix + 1
		IF (nq_fix .GT. 10000) GOTO 910
		fix_xyz (1,nq_fix)	= qr_buf (1)
		fix_xyz (2,nq_fix)	= qr_buf (2)
		fix_xyz (3,nq_fix)	= qr_buf (3)
		IF (ql_buf (1)) THEN
		  qmag			= qr_buf (4)
		  pkq			= ql_buf (1)
		  pk			= qr_buf (5)
		  CALL	q_calc (qmag, pkq, pk, pH, q_here)
		  fix_q (nq_fix)	= q_here
C !! - write to .inf the ionisable fixed value - an extra check for us
		ELSE
		  fix_q (nq_fix)	= qr_buf (4)
		END IF
		q_fix_sum		= q_fix_sum + fix_q (nq_fix)
		fix_res (nq_fix)	= qa4_buf (1)
		fix_atyp (nq_fix)	= qa4_buf (2)
		fix_nres (nq_fix)	= qi_buf (1)
		fix_chain (nq_fix)	= qc_buf

	      ELSE
		IF (ql_buf (1)) THEN

		  res_here		= qa4_buf (1)
		  nres_here		= qi_buf (1)
		  chain_here		= qc_buf
		  DO 240 ig		= 1, n_gps

C !! Note that we are relaxing the res check here, to avoid eg GLU1 clashing
C !! with GLU.  We could reinstate this with some char* work, if needed.
C OCT.2001 We are introducing the chain id throughout (from escalc) and
C OCT.2001 it must match between '.in' selected gps and escalc '.qop'

		    IF ( (nres_here .EQ. igps_nres (ig)) .AND.
     1			 (chain_here .EQ. cgps (ig)) ) THEN	! gps charge

C !!		    IF ((res_here .EQ. rgps (ig)) .AND.
C !! 1			(nres_here .EQ. igps_nres (ig))) THEN	! gps charge

C This is the ind_xyz assignment - first check if we are sitting on any
C previously indexed locations - if so, use the same index - if not add
C a new one.

		      DO 205 n			= 1, 3
			xyz_here (n)		= qr_buf (n)
205		      CONTINUE					! End n
		      DO 220 i_Q_test		= 2, i_Q_set
			IF (.NOT. Q_set (i_Q_test)) GOTO 220
			nb_test			= igps (ig,i_Q_test-1)
			IF (nb_test .GT. 0) THEN
			  DO 215 ib_test	= 1, nb_test
			    DO 210 n		= 1, 3
			      xyz_test (n)	=
     1					xyz (ig,ib_test,n,i_Q_test-1)
210			    CONTINUE				! End n
			    dist=SQRT( (xyz_here(1)-xyz_test(1))**2 +
     1				       (xyz_here(2)-xyz_test(2))**2 +
     2				       (xyz_here(3)-xyz_test(3))**2 )
			    IF (dist .LE. 0.01) THEN
			      ind_here=ind_xyz (ig,ib_test,i_Q_test-1)
			      IF (ind_here.LT.1.OR.ind_here.GT.10)
     1							GOTO 950
			      GOTO 230
			    END IF
215			  CONTINUE				! End ib_test
			END IF
220		      CONTINUE					! End i_Q_test

		      ind_curr (ig)	= ind_curr (ig) + 1
		      ind_here		= ind_curr (ig)
		      IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 950

230		      CONTINUE

		      igps (ig,i_Q_set-1) = igps (ig,i_Q_set-1) + 1
		      gps_sum(ig,i_Q_set-1) = gps_sum(ig,i_Q_set-1) +
     1					      qr_buf (4)
		      nq_gps_here	= nq_gps_here + 1
		      ib		= igps (ig,i_Q_set-1)
		      ind_xyz (ig,ib,i_Q_set-1) = ind_here

		      xyz (ig,ib,1,i_Q_set-1)	= qr_buf (1)
		      xyz (ig,ib,2,i_Q_set-1)	= qr_buf (2)
		      xyz (ig,ib,3,i_Q_set-1)	= qr_buf (3)

		      char (ig,ib,i_Q_set-1)	= qr_buf (4)
C ?? now this pKa we pick up is labelled pKint - IS IT OK? - CHECK
C ?? - it would save us reading through qop to pKcur
		      IF (i_Q_set .EQ. 2) THEN
			pKint (ig)		= qr_buf (5)
		      END IF
		      qopind (ig,ib,i_Q_set-1)	= iq
		      chk_igps (ig)		= .TRUE.
		      GOTO 300
		    END IF
240		  CONTINUE					! End ig

C OCT.2001 - this is where we get to for an ionisable that is not in '.in'.
C OCT.2001 - we only process it for the 'full' charge file (i_Q_set=2).

		IF (i_Q_set .EQ. 2) THEN
		    nq_fix		= nq_fix + 1
		    IF (nq_fix .GT. 10000) GOTO 910
		    fix_xyz (1,nq_fix)	= qr_buf (1)
		    fix_xyz (2,nq_fix)	= qr_buf (2)
		    fix_xyz (3,nq_fix)	= qr_buf (3)
C ?? - we know it is ionisable		IF (ql_buf (1)) THEN
		    qmag		= qr_buf (4)
		    pkq			= ql_buf (1)
		    pk			= qr_buf (5)
		    CALL	q_calc (qmag, pkq, pk, pH, q_here)
		    fix_q (nq_fix)	= q_here
C !! - write to .inf the ionisable fixed value - an extra check for us
C ??		    ELSE
C ??		    fix_q (nq_fix)	= qr_buf (4)
C ??		    END IF
		    q_fix_sum		= q_fix_sum + fix_q (nq_fix)
		    fix_res (nq_fix)	= qa4_buf (1)
		    fix_atyp (nq_fix)	= qa4_buf (2)
		    fix_nres (nq_fix)	= qi_buf (1)
		    fix_chain (nq_fix)	= qc_buf
		  END IF					! i_Q_set 2 ?

C OCT.2001 - end of the insert.

		END IF						! If ionisable
	      END IF						! i_Q_set 1 ?
300	    CONTINUE						! End iq

C !! - curtly - what to do next?

	    IF (i_Q_set .EQ. 1) THEN
	      WRITE (2,2200) nq_fix, q_fix_sum
	    ELSE
	      IF (i_Q_set .EQ. 2) THEN
		WRITE (2,2205)
		WRITE (2,2210) nq_fix, q_fix_sum
	      END IF
	      DO 340 ig	= 1, n_gps
	        IF (.NOT. chk_igps (ig)) GOTO 930
	        IF ((ABS (gps_sum (ig,i_Q_set-1)+1.0).GT.0.001) .AND.
     1	          (ABS (gps_sum (ig,i_Q_set-1)).GT.0.001) .AND.
     2	          (ABS (gps_sum (ig,i_Q_set-1)-1.0).GT.0.001) ) THEN
		  GOTO 930
	        END IF
340	      CONTINUE						! End ig
	      WRITE (2,2000) i_Q_found, i_Q_set, nq_gps_here
	      nq_gps (i_Q_set-1)	= nq_gps_here
	    END IF

	    CLOSE (UNIT=3)
	  END IF

600	CONTINUE						! End i_Q_set

	WRITE (2,2400)
	DO 700 ig	= 1, n_gps
	 WRITE (2,2600) ig,rgps(ig),cgps(ig),igps_nres(ig),ind_curr(ig)
700	CONTINUE						! End ig
	WRITE (2,2400)

	IF (i_Q_found .NE. n_Q_sets) GOTO 940
C !! - curtly - o/p info on number of charge sets found

	RETURN

910	WRITE (6,9100)
	CALL	EXIT

930	WRITE (6,9300) cgps(ig), igps_nres(ig), rgps(ig)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT
	END


	SUBROUTINE	q_calc (qmag, pkq, pk, pH, q_here)
C	**********	******

C With (pk,ph) adjustment, fraction of charged/uncharged = 10**ff*(ph-pk),
C where ff=-1 for a base, ff=+1 for an acid.

	LOGICAL		pkq

9000	FORMAT ('0','*** ERROR *** problem with q_here in q_calc')

	IF (pkq) THEN
	  ff		= 1.0
	  IF (qmag .GT. 0.) ff = -1.0
	  exp		= ff * (pH-pk)
	  IF (exp .GT.  60.) exp =  60.
	  IF (exp .LT. -60.) exp = -60.
	  fracq		= 10. ** exp
	  frac		= 1. / (1. + 1./fracq)
	  q_here	= frac * qmag
	ELSE
	  q_here	= qmag
	END IF

	IF (ABS (q_here) .GT. ABS (qmag)) GOTO 900
	IF (q_here * qmag .LT. 0.)	  GOTO 900
	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	write_data (i_mger)
C	**********	**********

C Write out (i_mger=0) or overwrite (1) the complete fd_manager.out file.

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	CHARACTER*4	fix_res (10000), fix_atyp (10000),
     1			rgps (355)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*1	fix_chain (10000), cgps (355)
	CHARACTER*80	mol_label
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*8	state
	CHARACTER*4	gps_type (355)
	LOGICAL		extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

C ?? - is this all variable record lengths?
	IF	(i_mger .EQ. 0) THEN
	  OPEN (UNIT=1, NAME='fd_manager.out', TYPE='NEW',
     1	        FORM='UNFORMATTED')
	ELSE IF (i_mger .EQ. 1) THEN
	  REWIND (UNIT=1)
	ELSE
	  STOP 'i_mger'
	END IF

	WRITE (1) mol_label
	WRITE (1) i_gp_here, i_Q_here
	WRITE (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		  (Q_file (j), j=1,5)
	WRITE (1) (coords_file (j), j=1,5)
	WRITE (1) n_gps, (nq_gps (m), m=1,4), extra_runs
	WRITE (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		  (igps_nres (i), i=1,n_gps),
     2		  (cgps (i), i=1,n_gps)
	WRITE (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	WRITE (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	WRITE (1) (gps_type (i), i=1,n_gps)
	WRITE (1) ((((done (i,j,k,m), m=1,4), k=1,3), j=1,2),
     1		      i=1,n_gps)
	WRITE (1) (((((se (i,j,k,l,m), m=1,4), l=1,10), k=1,3),
     1		       j=1,2), i=1,n_gps)
	WRITE (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10),i=1,n_gps)
	WRITE (1) ((((fix (i,j,k,m), m=1,4), k=1,3), j=1,2),i=1,n_gps)
	WRITE(1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		     j=1,3), i=1,n_gps)
	WRITE (1) (pKint (i), i=1,n_gps)
	WRITE (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	WRITE (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) nq_fix
	DO 200 i	= 1, nq_fix
	  WRITE (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		     fix_atyp (i), fix_nres (i), fix_chain (i)
200	CONTINUE						! End i

C?? - close fd_manager.out when we exit
C??	CLOSE (UNIT=1)

	RETURN
	END


	SUBROUTINE	process
C	**********	*******

C Do the required interpolations and summations.

C I don't think that we need to do any extra bits in here for the mc+CBs,
C since the Vf (as opposed to the poltl) processing is done by vol_frac.

	CHARACTER*8	state, reg_file, foc_file
	LOGICAL		extra_runs

	COMMON	/various/	extra_runs, state, i_gp_here, pH

C Loop on the Protein and Isolated aa runs (i_sys), and on the a focus
C vs b,c focus grids (i_run) - only use b,c if extra_runs is set.

	DO 600 i_sys			= 1, 2
	  DO 560 i_run			= 1, 3
	    IF ((i_run.EQ.2) .OR. (i_run.EQ.3)) THEN
	      IF (.NOT. extra_runs) GOTO 560
	    END IF
	    IF (i_sys .EQ. 1) THEN
	      reg_file			= 'fd93_1_r'
	      IF (i_run.EQ.1) foc_file	= 'fd93_1_a'
	      IF (i_run.EQ.2) foc_file	= 'fd93_1_b'
	      IF (i_run.EQ.3) foc_file	= 'fd93_1_c'
	    ELSE
	      reg_file			= 'fd93_2_r'
	      IF (i_run.EQ.1) foc_file	= 'fd93_2_a'
	      IF (i_run.EQ.2) foc_file	= 'fd93_2_b'
	      IF (i_run.EQ.3) foc_file	= 'fd93_2_c'
	    END IF
	    CALL	get_maps (reg_file, foc_file)
	    i_sys_here			= i_sys
	    i_run_here			= i_run
	    CALL	energise (i_sys_here, i_run_here)
560	  CONTINUE						! End i_run
600	CONTINUE						! End i_sys

	RETURN
	END


	SUBROUTINE	get_maps (reg_file, foc_file)
C	**********	********

C Read in the potl/iter maps.

	REAL		rpotl (150,150,150), rgrid_zero (3),
     1			fpotl (150,150,150), fgrid_zero (3)
	LOGICAL*1	riter (150,150,150), fiter (150,150,150)
	INTEGER		rgrid_dims (3), fgrid_dims (3)
	CHARACTER*8	reg_file, foc_file

	COMMON	/maps/		rpotl, riter, fpotl, fiter
	COMMON	/rgrid/		rgrid_zero, rgrid_dims, rstep,
     1				imaxr, jmaxr, kmaxr
	COMMON	/fgrid/		fgrid_zero, fgrid_dims, fstep,
     1				imaxf, jmaxf, kmaxf

9000	FORMAT ('0','*** map_dims .gt. 150 in get_maps')

	OPEN (UNIT=7, NAME=reg_file//'.pot', TYPE='OLD',
     1	      FORM='UNFORMATTED')
	READ (7) rgrid_zero, rgrid_dims, rstep

	OPEN (UNIT=8, NAME=reg_file//'.itr', TYPE='OLD',
     1	      FORM='UNFORMATTED')
	READ (8)

	DO 200 n	= 1, 3
	  IF (rgrid_dims (n) .GT. 150) GOTO 900
200	CONTINUE						! End n

	imaxr		= rgrid_dims (1)
	jmaxr		= rgrid_dims (2)
	kmaxr		= rgrid_dims (3)

	DO 300	k	= 1, kmaxr
	  DO 300 j	= 1, jmaxr
	    READ (7) (rpotl (i,j,k), i = 1, imaxr)
300	CONTINUE						! End i,j,k
	CLOSE (UNIT=7)

	DO 400 k	= 1, kmaxr
	  DO 400 j	= 1, jmaxr
	    READ (8) (riter (i,j,k), i = 1, imaxr)
400	CONTINUE						! End i,j,k
	CLOSE (UNIT=8)

	OPEN (UNIT=7, NAME=foc_file//'.pot', TYPE='OLD',
     1	      FORM='UNFORMATTED')
	READ (7) fgrid_zero, fgrid_dims, fstep

	OPEN (UNIT=8, NAME=foc_file//'.itr', TYPE='OLD',
     1	      FORM='UNFORMATTED')
	READ (8)

	DO 500 n	= 1, 3
	  IF (fgrid_dims (n) .GT. 150) GOTO 900
500	CONTINUE						! End n

	imaxf		= fgrid_dims (1)
	jmaxf		= fgrid_dims (2)
	kmaxf		= fgrid_dims (3)

	DO 600	k	= 1, kmaxf
	  DO 600 j	= 1, jmaxf
	    READ (7) (fpotl (i,j,k), i = 1, imaxf)
600	CONTINUE						! End i,j,k
	CLOSE (UNIT=7)

	DO 700 k	= 1, kmaxf
	  DO 700 j	= 1, jmaxf
	    READ (8) (fiter (i,j,k), i = 1, imaxf)
700	CONTINUE						! End i,j,k
	CLOSE (UNIT=8)

	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	energise (i_sys, i_run)
C	**********	********

C Do all the processing for this (i_sys,i_run)

	REAL		rpotl (150,150,150), rgrid_zero (3),
     1			fpotl (150,150,150), fgrid_zero (3),
     2			rgrid_low (3), rgrid_top (3),
     3			fgrid_low (3), fgrid_top (3), xyz_here (3)
	LOGICAL*1	riter (150,150,150), fiter (150,150,150)
	INTEGER		rgrid_dims (3), fgrid_dims (3)
	CHARACTER*4	fix_res (10000), fix_atyp (10000),
     1			rgps (355), res_here
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	CHARACTER*1	fix_chain (10000)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*4	gps_type (355), type_gp, grid_here
	CHARACTER*1	cgps (355), chain_here
	CHARACTER*8	state, reg_file, foc_file
	CHARACTER*80	mol_label
	LOGICAL		extra_runs, oub
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file,
     1			coords_file (5), curr_coords_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60),
C ??     1		coords_file (5,60), curr_coords_file (60)

	COMMON	/coords_in/	coords_file, curr_coords_file
	COMMON	/grid_lims/	rgrid_low, rgrid_top, fgrid_low,
     1				fgrid_top
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/maps/		rpotl, riter, fpotl, fiter
	COMMON	/rgrid/		rgrid_zero, rgrid_dims, rstep,
     1				imaxr, jmaxr, kmaxr
	COMMON	/fgrid/		fgrid_zero, fgrid_dims, fstep,
     1				imaxf, jmaxf, kmaxf
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_done, i_Q_todo

1200	FORMAT (' i_sys,i_run,i_Q,    nq_fix_r/f, nq_fix = ',6I5)
1400	FORMAT ('       i_run,i_Q,j_Q,nq_on_r/f,  nq_gps = ',6X,6I5)

9000	FORMAT ('0','*** We shouldn"t be finding oub=T in energise')
9100	FORMAT ('0','*** We should be on focus grid for se values')
9200	FORMAT ('0','*** nq_fix_r/f mismatch in energise')
9300	FORMAT ('0','*** nq_on_r/f mismatch in energise')
9400	FORMAT ('0','*** unidentified type_gp')
9500	FORMAT ('0','*** the ind_here bit index is oub')
9600	FORMAT ('0','*** overwriting an unequal slot in gpij')

C Get the grid limits on xyz.

	DO 160 n	= 1, 3
	  rgrid_low (n)	= rgrid_zero (n)
	  rgrid_top (n)	= rgrid_zero (n)+rstep*FLOAT(rgrid_dims(n)-1)
	  fgrid_low (n)	= fgrid_zero (n)
	  fgrid_low (n)	= fgrid_low (n) + 3.*fstep
	  fgrid_top (n)	= fgrid_zero (n)+fstep*FLOAT(fgrid_dims(n)-1)
	  fgrid_top (n)	= fgrid_top (n) - 3.*fstep
160	CONTINUE						! End n

	nres_here		= igps_nres (i_gp_here)
	chain_here		= cgps (i_gp_here)
	res_here		= rgps (i_gp_here)
	type_gp			= gps_type (i_gp_here)

C For the self-energies we process the same for i_sys 1 and 2.

	DO 300 i_bit		= 1, igps (i_gp_here,i_Q_here)
	  DO 220 n		= 1, 3
	    xyz_here (n)	= xyz (i_gp_here,i_bit,n,i_Q_here)
220	  CONTINUE						! End n
	  CALL	which_grid (xyz_here, grid_here)
	  IF (grid_here .NE. 'focu') GOTO 910
	  CALL	potl_interp (xyz_here, value, oub, grid_here)
	  IF (oub) GOTO 900
	  se (i_gp_here,i_sys,i_run,i_bit,i_Q_here)	= value
300	CONTINUE						! End i_bit

C For the fixed charge array, we take all of them for i_sys 1, and only
C those in the same residue as i_gp_here for i_sys 2, with some
C embellishments for nter,cter and frst,last residues.
C %% Again, we are testing just on nres - we must have unique nres values.
C OCT.2001 update to test also on chain id - so do NOT need unique nres now.

	nq_fix_r		= 0
	nq_fix_f		= 0
	energy_fix		= 0.
	DO 400 iq		= 1, nq_fix

	  IF (i_sys .EQ. 2) THEN

C OCT.2001 - this *should* be ok:

	  IF (fix_chain (iq) .NE. chain_here) GOTO 400

	    IF      (type_gp .EQ. 'nter') THEN
	      IF (fix_nres (iq) .NE. nres_here) THEN
		IF (fix_nres (iq) .NE. nres_here+1) THEN
		  GOTO 400
		ELSE
		  IF ((fix_atyp (iq) .NE. 'C   ') .AND.
     1		      (fix_atyp (iq) .NE. 'O   ')) THEN
		    GOTO 400
		  END IF
		END IF
	      END IF
	    ELSE IF (type_gp .EQ. 'cter') THEN
	      IF (fix_nres (iq) .NE. nres_here) THEN
		IF (fix_nres (iq) .NE. nres_here-1) THEN
		  GOTO 400
		ELSE
		  IF ((fix_atyp (iq) .NE. 'N   ') .AND.
     1		      (fix_atyp (iq) .NE. 'H   ')) THEN
		    GOTO 400
		  END IF
		END IF
	      END IF
	    ELSE IF (type_gp .EQ. 'frst') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE IF (type_gp .EQ. 'last') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE IF (type_gp .EQ. 'side') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE
	      GOTO 940
	    END IF						! type_gp
	  END IF						! i_sys=2

	  DO 320 n		= 1, 3
	    xyz_here (n)	= fix_xyz (n,iq)
320	  CONTINUE						! End n
	  CALL	which_grid (xyz_here, grid_here)
	  IF (grid_here .EQ. 'regu') nq_fix_r = nq_fix_r + 1
	  IF (grid_here .EQ. 'focu') nq_fix_f = nq_fix_f + 1
	  CALL	potl_interp (xyz_here, value, oub, grid_here)
	  IF (oub) GOTO 900
	  energy_here		= value * fix_q (iq)
	  energy_fix		= energy_fix + energy_here
400	CONTINUE						! End iq
	IF (i_sys .EQ. 1) THEN
	  IF ((nq_fix_r+nq_fix_f) .NE. nq_fix) GOTO 920
	END IF
	fix (i_gp_here,i_sys,i_run,i_Q_here)	= energy_fix
	IF ((i_sys.EQ.1) .AND. (i_run.EQ.1)) WRITE (2,*)
	WRITE (2,1200) i_sys,i_run,i_Q_here,nq_fix_r,nq_fix_f,nq_fix

C Get the gpij interactions just for the protein system.  Note that the
C gpij diagonal will be left unfilled.
C Note that with our indexing (via ind_xyz) into a single gpij list of
C interpolated potentials, means that we'll be assigning values more than
C once - we'll go along with this, and keep a check that the values are
C repeats of themselves.

	IF (i_sys .EQ. 1) THEN
	  DO 520 j_Q			= 1, 4
	    nq_on_r			= 0
	    nq_on_f			= 0
	    IF (.NOT. Q_set (j_Q+1)) GOTO 520
	    DO 500 j			= 1, n_gps
	      IF (j .EQ. i_gp_here) GOTO 500
	      DO 460 j_bit		= 1, igps (j,j_Q)
		ind_here		= ind_xyz (j,j_bit,j_Q)
		IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 950
		DO 420 n		= 1, 3
		  xyz_here (n)		= xyz (j,j_bit,n,j_Q)
420		CONTINUE					! End n
		CALL	which_grid (xyz_here, grid_here)
		IF (grid_here .EQ. 'regu') nq_on_r = nq_on_r + 1
		IF (grid_here .EQ. 'focu') nq_on_f = nq_on_f + 1
		CALL	potl_interp (xyz_here, value, oub, grid_here)
		IF (oub) GOTO 900
		val = gpij (i_gp_here,i_run,j,ind_here,i_Q_here)
		IF (ABS (val) .GT. 0.00001) THEN
		  IF (ABS (val-value) .GT. 0.0001) GOTO 960
		END IF
		gpij (i_gp_here,i_run,j,ind_here,i_Q_here) = value
460	      CONTINUE						! End j_bit
500	    CONTINUE						! End j
	    IF ((nq_on_r + nq_on_f).NE.
     1	        (nq_gps (j_Q) - igps (i_gp_here,j_Q))) GOTO 930
	    WRITE (2,1400) i_run, i_Q_here, j_Q, nq_on_r, nq_on_f,
     1			   nq_gps (j_Q)
520	  CONTINUE						! End j_Q
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT

960	WRITE (6,9600)
	CALL	EXIT
	END


	SUBROUTINE	which_grid (xyz_here, grid_here)
C	**********	**********

	REAL		rgrid_low (3), rgrid_top (3),
     1			fgrid_low (3), fgrid_top (3), xyz_here (3)
	CHARACTER*4	grid_here

	COMMON	/grid_lims/	rgrid_low, rgrid_top, fgrid_low,
     1				fgrid_top

9000	FORMAT ('0','*** xyz out of reg grid bounds in which_grid')

	DO 200 n	= 1, 3
	  IF (xyz_here (n) .LE. rgrid_low (n)) GOTO 900
	  IF (xyz_here (n) .GE. rgrid_top (n)) GOTO 900
200	CONTINUE						! End n
	DO 300 n	= 1, 3
	  IF (xyz_here (n) .LE. fgrid_low (n)) THEN
	    grid_here	= 'regu'
	    GOTO 320
	  END IF
	  IF (xyz_here (n) .GE. fgrid_top (n)) THEN
	    grid_here	= 'regu'
	    GOTO 320
	  END IF
300	CONTINUE						! End n
	grid_here	= 'focu'

320	CONTINUE
	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	potl_interp (xyz, value, oub, grid_here)
C	**********	***********

C Linearly interpolate the current potential grid at location xyz.

	REAL		rpotl (150,150,150), fpotl (150,150,150)
	LOGICAL*1	riter (150,150,150), fiter (150,150,150)
	REAL		xyz (3), box_vals (2,2,2), del_xyz (3),
     1			rgrid_zero (3), fgrid_zero (3)
	INTEGER		ijk_low (3), rgrid_dims (3), fgrid_dims (3)
	CHARACTER*4	grid_here
	LOGICAL		oub

	COMMON	/maps/		rpotl, riter, fpotl, fiter
	COMMON	/rgrid/		rgrid_zero, rgrid_dims, rstep,
     1				imaxr, jmaxr, kmaxr
	COMMON	/fgrid/		fgrid_zero, fgrid_dims, fstep,
     1				imaxf, jmaxf, kmaxf

9000	FORMAT ('0','*** what is grid_here in potl_interp then?')

	IF (grid_here.NE.'regu' .AND. grid_here.NE.'focu') GOTO 900
	oub			= .FALSE.

	DO 200 n		= 1, 3

	  IF (grid_here .EQ. 'regu') THEN
	    ijk_low (n)		= 1 + INT((xyz (n)-rgrid_zero (n))/
     1					   rstep)
	    IF (ijk_low (n) .LT. 1 .OR.
     1	        ijk_low (n) .GT. rgrid_dims (n)-1) THEN
	      oub			= .TRUE.
	      RETURN
	    END IF
	    del_xyz (n)		= (xyz (n) - rgrid_zero (n)) -
     1				  rstep*FLOAT(ijk_low(n)-1)
	  ELSE
	    ijk_low (n)		= 1 + INT((xyz (n)-fgrid_zero (n))/
     1					   fstep)
	    IF (ijk_low (n) .LT. 1 .OR.
     1	        ijk_low (n) .GT. fgrid_dims (n)-1) THEN
	      oub			= .TRUE.
	      RETURN
	    END IF
	    del_xyz (n)		= (xyz (n) - fgrid_zero (n)) -
     1				  fstep*FLOAT(ijk_low(n)-1)
	  END IF

200	CONTINUE						! End n

	DO 300 k		= 1, 2
	  kp			= ijk_low (3) + k - 1
	  DO 300 j		= 1, 2
	    jp			= ijk_low (2) + j - 1
	    DO 300 i		= 1, 2
	      ip		= ijk_low (1) + i - 1

	      IF (grid_here .EQ. 'regu') THEN
		IF (riter (ip,jp,kp)) THEN
		  box_vals (i,j,k)	= rpotl (ip,jp,kp)
		ELSE
		  oub		= .TRUE.
		  RETURN
		END IF
	      ELSE
		IF (fiter (ip,jp,kp)) THEN
		  box_vals (i,j,k)	= fpotl (ip,jp,kp)
		ELSE
		  oub		= .TRUE.
		  RETURN
		END IF
	      END IF

300	CONTINUE						! End i,j,k

	IF (grid_here .EQ. 'regu') THEN
	  CALL	box_interp (box_vals, del_xyz, rstep, value, oub)
	ELSE
	  CALL	box_interp (box_vals, del_xyz, fstep, value, oub)
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	box_interp (bx, del_xyz, stp, value, oub)
C	**********	**********

C Interpolate from box_vals for value del_xyz away from lower faces.
C We have previously used face potentials over the dielectric cell for
C this interpolation, but this does not reproduce potentials at grid
C points.
C Now we use just 4 point interpolation, based on the potential point
C that the new point is closest too, and the 3 rods from this in the
C required directions.
C ?? - is this way of doing it right?

	REAL		del_xyz (3), bx (2,2,2), face (3,2),
     1			comp (3), del_pot (3), frac (3)
	INTEGER		oct (3)
	LOGICAL		face_interp, oub

9100	FORMAT ('0','*** ERROR *** oct index not set in box_inter')

	face_interp	= .FALSE.
	IF (face_interp) THEN
	  face (1,1)	= (bx (1,1,1) + bx (1,1,2) +
     1			   bx (1,2,1) + bx (1,2,2) ) / 4.
	  face (1,2)	= (bx (2,1,1) + bx (2,1,2) +
     1			   bx (2,2,1) + bx (2,2,2) ) / 4.
	  face (2,1)	= (bx (1,1,1) + bx (1,1,2) +
     1			   bx (2,1,1) + bx (2,1,2) ) / 4.
	  face (2,2)	= (bx (1,2,1) + bx (1,2,2) +
     1			   bx (2,2,1) + bx (2,2,2) ) / 4.
	  face (3,1)	= (bx (1,1,1) + bx (1,2,1) +
     1			   bx (2,1,1) + bx (2,2,1) ) / 4.
	  face (3,2)	= (bx (1,1,2) + bx (1,2,2) +
     1			   bx (2,1,2) + bx (2,2,2) ) / 4.
	  DO 300 n	= 1, 3
	    frac (n)	= del_xyz (n) / stp
	    IF      (frac (n) .LT. 0.) THEN
	      GOTO 900
	    ELSE IF (frac (n) .GT. 1.) THEN
	      GOTO 900
	    ELSE
	      comp (n)	= frac(n)*face(n,2) + (1.-frac(n))*face(n,1)
	    END IF
300	  CONTINUE						! End n
	  value		= (comp (1) + comp (2) + comp (3)) / 3.
	ELSE
	  DO 400 n	= 1, 3
	    oct (n)	= 0
	    frac (n)	= del_xyz (n) / stp
	    IF	    (frac (n) .LT. -0.001) GOTO 900
	    IF	    (frac (n) .LT. 0.) frac (n)	= 0.
	    IF	    (frac (n) .GT. 1.001) GOTO 900
	    IF	    (frac (n) .GT. 1.0) frac (n) = 1.0
	    IF (frac (n).GE.0.  .AND. frac (n).LE.0.5) THEN
	      oct (n)	= 1
	    ELSE IF (frac (n).GT.0.5 .AND. frac (n).LE.1.0) THEN
	      oct (n)	= 2
	    END IF
	    IF (oct (n) .EQ. 0) GOTO 910
400	  CONTINUE						! End n
	  cen_pot	= bx (oct (1), oct (2), oct (3))
	  IF	  (oct (1) .EQ. 1) THEN
	    del_pot (1)	= frac (1)  *  (bx (2,oct(2),oct(3))-cen_pot)
	  ELSE IF (oct (1) .EQ. 2) THEN
	    del_pot (1)	= (1.-frac(1))*(bx (1,oct(2),oct(3))-cen_pot)
	  ELSE
	    GOTO 910
	  END IF
	  IF	  (oct (2) .EQ. 1) THEN
	    del_pot (2)	= frac (2)  *  (bx (oct(1),2,oct(3))-cen_pot)
	  ELSE IF (oct (2) .EQ. 2) THEN
	    del_pot (2)	= (1.-frac(2))*(bx (oct(1),1,oct(3))-cen_pot)
	  ELSE
	    GOTO 910
	  END IF
	  IF	  (oct (3) .EQ. 1) THEN
	    del_pot (3)	= frac (3)  *  (bx (oct(1),oct(2),2)-cen_pot)
	  ELSE IF (oct (3) .EQ. 2) THEN
	    del_pot (3)	= (1.-frac(3))*(bx (oct(1),oct(2),1)-cen_pot)
	  ELSE
	    GOTO 910
	  END IF
	  value		= cen_pot + del_pot (1) + del_pot (2) +
     1				    del_pot (3)
	END IF

	RETURN

900	oub	= .TRUE.
	RETURN

910	WRITE (6,9100)
	CALL	EXIT
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

C Initialise the file name.

	DO 160 i	= 1, 80
	  file (i:i)	= ' '
160	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END













