
C Program reads through a standard dh_manager.in file and repeats the
C output with relevant (current) mods according to environment variables,
C and with ionisable group selection from the 'full' charge escalc file.

	CHARACTER*78	line
	CHARACTER*60	eg_path, molecule_coords, ph, mu
	CHARACTER*8	flag
	CHARACTER*1	ionisables_chain (1000)
	CHARACTER*4	ionisables_res (1000)
	INTEGER		ionisables_nres (1000)

	COMMON	/ionisables/	ionisables_res, ionisables_nres,
     1				ionisables_chain, n_ionisables

1100	FORMAT (A78)
1200	FORMAT (A8)
1300	FORMAT (A4,1X,A1,I4,1X,A4)

	CALL	GETENV ('EXAMPLES', eg_path)
	CALL	leader (eg_path, iep)

	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	CALL	GETENV ('PH', ph)
	CALL	leader (ph, iph)

	CALL	GETENV ('IONIC_STRENGTH', mu)
	CALL	leader (mu, imu)

	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/dh_manager_std.in')
 	OPEN (UNIT=2,
     1	      NAME='dh_manager_'//molecule_coords (1:imc)//'.in',
     2	      TYPE='NEW')

200	READ (1,1100,END=250) line
	READ (line,1200) flag

	IF      (flag .EQ. 'fixed   ') THEN
	  WRITE (2,1100) line
	  READ (1,1100) line
	  IF (line (2:2) .NE. 'T') STOP 'no fixed charges?'
	  WRITE (2,1100) line
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_fixed.qop'
	  READ (1,*)

	ELSE IF (flag .EQ. 'chr_unit') THEN
	  WRITE (2,1100) line
	  READ (1,1100) line
	  IF (line (2:2) .NE. 'T') STOP 'no full charges?'
	  WRITE (2,1100) line
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_full.qop'
	  READ (1,*)

	ELSE IF (flag .EQ. 'pH      ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) ph (1:iph)
	  READ (1,*)

	ELSE IF (flag .EQ. 'inclions') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) 'T, '//mu (1:imu)
	  READ (1,*)

C Here we read through the full charges file and pull all ionisables into the
C dh_manager input - ?? maybe this can be editted at a future date.
C This part if based on the read_escalc input routine.
C ?? Note that we still need unique nres, since we do not carry chain_id ??
C OCT.2001: NO - now we do carry chain id.

	ELSE IF (flag .EQ. 'groups  ') THEN
	  WRITE (2,1100) line
	  CALL	get_ionisables (molecule_coords, imc)
	  WRITE (2,*) n_ionisables
	  DO 230 i		= 1, n_ionisables
	    WRITE (2,1300) ionisables_res (i), ionisables_chain (i),
     1			   ionisables_nres (i), 'side'
230	  CONTINUE						! End i
	  GOTO 250

	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 200

250	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

	CALL	EXIT
	END


	SUBROUTINE	get_ionisables (molecule_coords, imc)
C	**********	**************

C Use bits of the read_escalc routine to get ionisable residues (and sidechain,
C Nt, Ct type) for dh_manager.in.

	LOGICAL		macinc, itrate
	INTEGER		which_VdW_es
	REAL		qr_buf (7)
	CHARACTER*4	qa4_buf (3), res_here
	INTEGER		qi_buf (3)
	LOGICAL		ql_buf (2)
	CHARACTER*1	qc_buf, chain_here, ionisables_chain (1000)

	CHARACTER*60	molecule_coords
	CHARACTER*4	ionisables_res (1000)
	INTEGER		ionisables_nres (1000)

	COMMON	/ionisables/	ionisables_res, ionisables_nres,
     1				ionisables_chain, n_ionisables

	OPEN (UNIT=3,
     1	      NAME='es_'//molecule_coords (1:imc)//'_full.qop',
     2	      TYPE='OLD', FORM='UNFORMATTED')
	READ (3) nfil
	DO 200 ifil		= 1, nfil
	  READ (3)						! pdbfil
	  READ (3)						! qfil
200	CONTINUE						! ifil
	READ (3) nq_here, macinc, itrate, i_qset, which_VdW_es, ncal
	n_ionisables		= 0
	DO 300 iq		= 1, nq_here
	  READ (3) (qr_buf (m), m=1,7), (qa4_buf (m), m=1,3),
     1		   (qi_buf (m), m=1,3), (ql_buf (m), m=1,2),
     2		    qc_buf
	  IF (ql_buf (1)) THEN
	    res_here		= qa4_buf (1)
	    nres_here		= qi_buf (1)
	    chain_here		= qc_buf
	    IF (n_ionisables .NE. 0) THEN
	      DO 250 i		= 1, n_ionisables
	        IF ( (res_here .EQ. ionisables_res (i)) .AND.
     1		     (nres_here .EQ. ionisables_nres (i)) .AND.
     2		     (chain_here .EQ. ionisables_chain (i))) GOTO 300
250	      CONTINUE						! End i
	    END IF
	    n_ionisables			= n_ionisables + 1
	    ionisables_res (n_ionisables)	= res_here
	    ionisables_nres (n_ionisables)	= nres_here
	    ionisables_chain (n_ionisables)	= chain_here
	  END IF
300	CONTINUE						! End iq
	CLOSE (UNIT=3)

	RETURN
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END


