
C Program reads through a standard pk_calc.ctr file and repeats the
C output with relevant (current) mods according to environment variables.

	CHARACTER*78	line
	CHARACTER*60	eg_path, molecule_coords, n_points,
     1			ph_low, ph_high, method, mc_steps,
     2			fd_dh_mix, vf_mod_se, vf_or_scf_decision,
     3			red_lims
	CHARACTER*8	flag
	CHARACTER*4	ionisables_res (1000)
	INTEGER		ionisables_nres (1000)

	COMMON	/ionisables/	ionisables_res, ionisables_nres,
     1				n_ionisables

1100	FORMAT (A78)
1200	FORMAT (A8)
1300	FORMAT (A4,2X,I4,1X,A4)

	CALL	GETENV ('EXAMPLES', eg_path)
	CALL	leader (eg_path, iep)

	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	CALL	GETENV ('N_POINTS', n_points)
	CALL	leader (n_points, inp)

	CALL	GETENV ('PH_LOW', ph_low)
	CALL	leader (ph_low, iphl)

	CALL	GETENV ('PH_HIGH', ph_high)
	CALL	leader (ph_high, iphh)

	CALL	GETENV ('METHOD', method)
	CALL	leader (method, imd)

	CALL	GETENV ('RED_LIMS', red_lims)
	CALL	leader (red_lims, irl)

	CALL	GETENV ('MC_STEPS', mc_steps)
	CALL	leader (mc_steps, ims)

	CALL	GETENV ('FD_DH_MIX', fd_dh_mix)
	CALL	leader (fd_dh_mix, ifd_dh)

	CALL	GETENV ('VF_MOD_SE', vf_mod_se)
	CALL	leader (vf_mod_se, ivm)

	CALL	GETENV ('VF_OR_SCF_DECISION', vf_or_scf_decision)
	CALL	leader (vf_or_scf_decision, ivs)

	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/pk_calc_std.ctr')
	OPEN (UNIT=2,
     1	      NAME='pk_calc_'//molecule_coords (1:imc)//'.ctr',
     2	      TYPE='NEW')

200	READ (1,1100,END=250) line
	READ (line,1200) flag

	IF      (flag .EQ. 'n_points') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) n_points (1:inp)
	  READ (1,*)

	ELSE IF (flag .EQ. 'pH range') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) ph_low (1:iphl)//', '//ph_high (1:iphh)
	  READ (1,*)

	ELSE IF (flag .EQ. 'method  ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) method (1:imd)
	  READ (1,*)

	ELSE IF (flag .EQ. 'red_lims') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) red_lims (1:irl)
	  READ (1,*)

	ELSE IF (flag .EQ. 'mc_pHlim') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) ph_low (1:iphl)//', 0.0'
	  READ (1,*)

	ELSE IF (flag .EQ. 'mc_steps') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) mc_steps (1:ims)
	  READ (1,*)

	ELSE IF (flag .EQ. 'fd+dh?  ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) fd_dh_mix (1:ifd_dh)
	  READ (1,*)

	ELSE IF (flag .EQ. 'fd_file ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) 'fd_manager_'//molecule_coords (1:imc)//'.out'
	  READ (1,*)

	ELSE IF (flag .EQ. 'dh_file ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) 'dh_manager_'//molecule_coords (1:imc)//'.out'
	  READ (1,*)

	ELSE IF (flag .EQ. 'dhchoice') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) vf_or_scf_decision (1:ivs)
	  WRITE (2,*) 'sc_freedom_'//molecule_coords (1:imc)//'.out'
	  READ (1,*)
	  READ (1,*)

	ELSE IF (flag .EQ. 'Vf_modSE') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) vf_mod_se (1:ivm)
	  READ (1,*)

	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 200

250	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

	CALL	EXIT
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END


