
C Program reads through a standard sc_freedom.ctr file and repeats the
C output with relevant (current) mods according to environment variables.

	CHARACTER*78	line
	CHARACTER*60	eg_path, molecule_coords, wat_layering,
     1			incl_exptrots, sc_exclusions, which_vdw,
     2			relax_to_val, target_val
	CHARACTER*8	flag

1100	FORMAT (A78)
1200	FORMAT (A8)

	CALL	GETENV ('EXAMPLES', eg_path)
	CALL	leader (eg_path, iep)

	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	CALL	GETENV ('WAT_LAYERING', wat_layering)
	CALL	leader (wat_layering, iwl)

	CALL	GETENV ('INCL_EXPTROTS', incl_exptrots)
	CALL	leader (incl_exptrots, iie)

	CALL	GETENV ('SC_EXCLUSIONS', sc_exclusions)
	CALL	leader (sc_exclusions, ise)

	CALL	GETENV ('WHICH_VDW', which_vdw)
	CALL	leader (which_vdw, iwv)

	CALL	GETENV ('RELAX_TO_VAL', relax_to_val)
	CALL	leader (relax_to_val, irv)

	CALL	GETENV ('TARGET_VAL', target_val)
	CALL	leader (target_val, itv)

	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/sc_freedom_std.ctr')
	OPEN (UNIT=2,
     1	      NAME='sc_freedom_'//molecule_coords (1:imc)//'.ctr',
     2	      TYPE='NEW')

200	READ (1,1100,END=250) line
	READ (line,1200) flag

	IF      (flag .EQ. 'coords  ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) molecule_coords (1:imc)//'_es.pdb'
	  READ (1,*)

	ELSE IF (flag .EQ. 'inclexpt') THEN
	  WRITE (2,1100) line
	  IF (incl_exptrots (1:1) .EQ. 'T') THEN
	    IF (relax_to_val (1:1) .EQ. 'T') THEN
	      WRITE (2,*) 'T, F, T, '//target_val (1:itv)
	    ELSE
	      WRITE (2,*) 'T, F, F, 1.0'
	    END IF
	  ELSE
	    IF (relax_to_val (1:1) .EQ. 'T') THEN
	      WRITE (2,*) 'F, F, T, '//target_val (1:itv)
	    ELSE
	      WRITE (2,*) 'F, F, F, 1.0'
	    END IF
	  END IF
	  READ (1,*)

	ELSE IF (flag .EQ. 'files   ') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) 'sc_freedom_'//molecule_coords (1:imc)//'.out'
	  WRITE (2,*) 'sc_freedom_'//molecule_coords (1:imc)//'.prb'
	  READ (1,*)
	  READ (1,*)

	ELSE IF (flag .EQ. 'exclude ') THEN
	  WRITE (2,1100) line
	  IF (sc_exclusions (1:1) .EQ. 'T') THEN
	    WRITE (2,*) 'T'
	  ELSE
	    WRITE (2,*) 'F'
	  END IF
	  WRITE (2,*) molecule_coords (1:imc)//'_sc.exc'
	  READ (1,*)
	  READ (1,*)

	ELSE IF (flag .EQ. 'waterlyr') THEN
	  WRITE (2,1100) line
	  IF (wat_layering (1:1) .EQ. 'T') THEN
	    WRITE (2,*) 'T, T'
	  ELSE
	    WRITE (2,*) 'F, F'
	  END IF
	  WRITE (2,*) molecule_coords (1:imc)//'_wat.gps'
	  READ (1,*)
	  READ (1,*)

	ELSE IF (flag .EQ. 'rankclsh') THEN
	  WRITE (2,1100) line
	  IF (wat_layering (1:1) .EQ. 'T') THEN
	    WRITE (2,*) 'T'
	  ELSE
	    WRITE (2,*) 'F'
	  END IF
	  READ (1,*)

	ELSE IF (flag .EQ. 'whichvdw') THEN
	  WRITE (2,1100) line
	  WRITE (2,*) which_vdw (1:iwv)
	  READ (1,*)

	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 200

250	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

	CALL	EXIT
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

