
C Make various i/p files for sc_freedom, assuming 'generic' i/p.
C Uses the pdb file (single header line + coords, N-t C-t at -/+1 nres) that
C is used for sc_freedom and es programs.
C Makes sc exclusion file, which is Cys and terminal groups (so needs editting
C with DsbA etc.)
C Makes file of ionisable groups for water layering in a 'DH allowed' calcn.

	REAL		xyz (3)
	BYTE		hed (80)
	CHARACTER*4	res, atyp
	CHARACTER*1	chain, excl_chain (1000), layr_chain (1000)
	CHARACTER*4	excl_res (1000), layr_res (1000)
	INTEGER		excl_nres (1000), layr_nres (1000)
	LOGICAL		excl_cys, excl_tyr, add_excl, add_layr
	CHARACTER*60	molecule_coords, cys_include, tyr_include,
     1			tyr_ionisable

1010	FORMAT (80A1)
1020	FORMAT (A4,9X,A4,A4,A1,I4,4X,3F8.3)
1200	FORMAT ('sc excls from rotamer analysis: num: (A4,1X,A1,I4)')
1300	FORMAT (A4,1X,A1,I4)
1400	FORMAT ('Gps/water layering/scf: num: (A4,1X,A1,I4,1X,A4)')
1500	FORMAT (A4,1X,A1,I4,1X,A4)

	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	CALL	GETENV ('CYS_INCLUDE', cys_include)
	CALL	leader (cys_include, ici)

	CALL	GETENV ('TYR_INCLUDE', tyr_include)
	CALL	leader (tyr_include, iti)

	CALL	GETENV ('TYR_IONISABLE', tyr_ionisable)
	CALL	leader (tyr_ionisable, ito)

	OPEN (UNIT=1, NAME=molecule_coords(1:imc)//'_es.pdb',
     1	      TYPE='OLD')
	OPEN (UNIT=2, NAME=molecule_coords(1:imc)//'_sc.exc',
     1	      TYPE='NEW')
	OPEN (UNIT=3, NAME=molecule_coords(1:imc)//'_wat.gps',
     1	      TYPE='NEW')

	READ (1,1010) hed
	WRITE (2,1200)
	WRITE (3,1400)

C ?? tyr is messy - currently include if tyr_include or tyr_ionisable set.

	excl_cys		= .TRUE.
	IF ((cys_include (1:ici) .EQ. 'yes') .OR.
     1	    (cys_include (1:ici) .EQ. 'YES') .OR.
     2	    (cys_include (1:ici) .EQ. 'Y')   .OR.
     3	    (cys_include (1:ici) .EQ. 'T') ) excl_cys = .FALSE.
	excl_tyr		= .TRUE.
	IF ((tyr_include (1:iti) .EQ. 'yes') .OR.
     1	    (tyr_include (1:iti) .EQ. 'YES') .OR.
     2	    (tyr_include (1:iti) .EQ. 'Y')   .OR.
     3	    (tyr_include (1:iti) .EQ. 'T') ) excl_tyr = .FALSE.
	IF ((tyr_ionisable(1:ito).EQ.'yes') .OR.
     1	    (tyr_ionisable(1:ito).EQ.'YES') .OR.
     2	    (tyr_ionisable(1:ito).EQ.'Y')   .OR.
     3	    (tyr_ionisable(1:ito).EQ.'T'))  excl_tyr = .FALSE.
	num_excl		= 0
	num_layr		= 0

200	READ (1,1020,END=500) atm, atyp, res, chain, nres, xyz

	add_excl		= .FALSE.
	IF      (atyp .EQ. 'NT  ') THEN
	  add_excl		= .TRUE.
	ELSE IF (atyp .EQ. 'CT  ') THEN
	  add_excl		= .TRUE.
	ELSE IF	(res .EQ. 'CYS ') THEN
	  IF (excl_cys .AND. atyp.EQ.'CA  ') THEN
	    add_excl		= .TRUE.
	  END IF
	END IF
	IF (add_excl) THEN
	  num_excl		= num_excl + 1
	  excl_res (num_excl)	= res
	  excl_nres (num_excl)	= nres
	  excl_chain (num_excl)	= chain
	END IF

	add_layr		= .FALSE.
	IF	((res.EQ.'LYS ') .AND. (atyp.EQ.'CA  ')) THEN
	  add_layr		= .TRUE.
	ELSE IF ((res.EQ.'ARG ') .AND. (atyp.EQ.'CA  ')) THEN
	  add_layr		= .TRUE.
	ELSE IF ((res.EQ.'HIS ') .AND. (atyp.EQ.'CA  ')) THEN
	  add_layr		= .TRUE.
	ELSE IF ((res.EQ.'ASP ') .AND. (atyp.EQ.'CA  ')) THEN
	  add_layr		= .TRUE.
	ELSE IF ((res.EQ.'GLU ') .AND. (atyp.EQ.'CA  ')) THEN
	  add_layr		= .TRUE.
	ELSE IF ((res.EQ.'CYS ') .AND. (atyp.EQ.'CA  ')) THEN
	  IF (.NOT.excl_cys) add_layr	= .TRUE.
	ELSE IF ((res.EQ.'TYR ') .AND. (atyp.EQ.'CA  ')) THEN
	  IF (.NOT.excl_tyr) add_layr	= .TRUE.
	END IF
	IF (add_layr) THEN
	  num_layr		= num_layr + 1
	  layr_res (num_layr)	= res
	  layr_nres (num_layr)	= nres
	  layr_chain (num_layr)	= chain
	END IF

	GOTO 200

500	CLOSE (UNIT=1)

	WRITE (2,*) num_excl
	DO 600 n		= 1, num_excl
	  WRITE (2,1300) excl_res (n),excl_chain (n),excl_nres (n)
600	CONTINUE						! End n
	CLOSE (UNIT=2)

	WRITE (3,*) num_layr
	DO 700 n		= 1, num_layr
	  WRITE (3,1500) layr_res (n),layr_chain (n),layr_nres (n),
     1'side'
700	CONTINUE						! End n

	CALL	EXIT
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

