
C ?? - REMEMBER - to make array dimensioning easier to change - flexibly.

C --------------------------- MAY 05 --------------------------------------

C MAY 05 - unwise - but I will be making extensive changes to the options
C available - hopefully this will make sc_freedom a central program for
C rotamer manipulation, so that sc_gen (and perhaps scf_cxxc) will not be
C needed.  THEN when we need to update rotamers etc, we only need to change
C sc_freedom.  We will try the following:

C ALT_COORDS	Option to take a list of residues within a coordinate file
C		and o/p all possible alternate sc conformers, with a given
C		VdW_tol.
C	     *  option to allow non-listed residues to move or not:
C		MOVE_BG=Y/N
C	     *  option to allow inclusion of coord file ('expt') rotamers
C		Hopefully will be a more general implementation of scf_cxxc
C		program - start with mem proteins applications
C scf_alter.in (A1,2X,A4,2X,I4)	IN
C scf_alter_rots.pdb 		OUT
C scf_alter_fixed.pdb 		OUT

C COMP_MODEL	Option to repack scs to most probable fit.  Variants:
C	     *  can have a list of fixed residues which are not repacked
C	     *  can have aas without scs, in which case scs added and will
C		be repacked, taking the most probable rotamer
C	     *  option to allow inclusion of coord file ('expt') rotamers
C		Hopefully will replace sc_gen program

C **** ACTUALLY COMP_MODEL we have as an env i/p, BUT IT DOES NOTHING
C **** currently (Aug 2005).  We have chosen to take the path of least
C **** resistance and alter sc_gen to make it optional to fix a list of
C **** scs from scf_alter.in.
C **** SO FOR NOW WE HAVE sc_freedom and sc_gen BOTH active on rot libraries

C sc_freedom will still do the normal o/p of allowed rotamer data for pick
C up by pk_calc etc.

C We'll put the new env variables straight into sc_freedom, so that we do
C not give any make_sc_freedom compatability problems.
C Any files i/p or o/p required for the new options will be given std names
C that must then be altered appropriately from the calling script.

C --------------------------- MAY 05 --------------------------------------

C ?? nb - the program will need extensive graphical (rotamer) checking

C	Program		S C _ F R E E D O M

C Assess freedom of sc's on a fixed backbone, using a rotamer library
C (e.g. Tuffery et al. 1997), and combined probabilities that looks like
C the Koehl and DelaRue (1995) mean field expression, but without a
C force-field othen allowed or disallowed (clashing).  We'll see whether
C this gives any useful i/p for our aims, which are one to work out if
C an ionisable group can gets itself solvent exposed, and two look at
C sidechain entropy estimations.

C Jim Warwicker, Glasgow, June 1999.

C Modified incrementally at UMIST:
C - notably to use getenv routine to look up the $DATA environment variable
C - for path to atoms_es.dat and rotamers data files.
C - Dec 02 - when we use relaxation to a value, now if we haven't converged
C - we just take the exptal rot (incl_expt must be on) at prob=1.  This is
C - so we can get uniform answers for any VdW over a set of proteins.

	LOGICAL		water_layer, mask_res, clash_rank
	CHARACTER*60	altern_coords, compar_model, move_background
	CHARACTER*80	file_lyr
	LOGICAL		alt_coords, comp_model, move_bg
	CHARACTER*1	alt_chn(7000)
	CHARACTER*4	alt_res(7000)
	INTEGER		alt_nres(7000)

	COMMON	/more_params/	alt_coords, comp_model, move_bg,
     1				n_alt,alt_chn,alt_res,alt_nres
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank

	DATA	wat_diam	/ 2.8 /

C We get parameters from 2 places:
C	the ctr file which is made by make_sc_freedom_ctr, which itself
C	depends on several env variables.
C	some more lately added env variables direct here into sc_freedom -
C	not setting them will just give an old sc_freedom type run.

	CALL	GETENV ('ALT_COORDS', altern_coords)
	CALL	leader (altern_coords, iac)
	alt_coords		= .FALSE.
	IF ((altern_coords(1:1).EQ.'Y') .OR.
     1	    (altern_coords(1:1).EQ.'T') .OR.
     2      (altern_coords(1:3).EQ.'YES')) alt_coords = .TRUE.

	CALL	GETENV ('COMP_MODEL', compar_model)
	CALL	leader (compar_model, icm)
	comp_model		= .FALSE.
	IF ((compar_model(1:1).EQ.'Y') .OR.
     1	    (compar_model(1:1).EQ.'T') .OR.
     2      (compar_model(1:3).EQ.'YES')) comp_model = .TRUE.

	CALL	GETENV ('MOVE_BG', move_background)
	CALL	leader (move_background, imb)
	move_bg		= .FALSE.
	IF ((move_background(1:1).EQ.'Y') .OR.
     1	    (move_background(1:1).EQ.'T') .OR.
     2      (move_background(1:3).EQ.'YES')) move_bg = .TRUE.

C??may05 - currently code the alt_coords=T bits
C??may05 - put any new disallowed flag combos into sc_ctr_read
C??may05		eg alt_coords and water_layer

C Get the various files/parameters.

	CALL	sc_ctr_read

C Link with the atoms_dat.for routines for picking-up and assigning atom/res
C types etc.

	CALL	read_atoms_es

C Read in the coordinates.

	CALL	coords_read

C Read in the rotamer library.

	CALL	rots_read

C Generate cartesian coordinates for all rotamers to be studied.

	CALL	rots_gen

C Do the mean rotamer probability analysis, based on steric overlaps.

	CALL	rots_prob

C Write out the probabilities for the non-water layer calculations.

	CALL	prob_out

C Do the additional looping over water layered groups, if required.
C We can do this one of 2 ways - either a self-consistent calcn with the
C water diameter decremeneted until we get an answer, or use the prob arrays
C from the non-layering calculation to find the key rot-rot contacts that
C are giving clashes, and record the size of the water-mediated clash.
C We use separate add_water routines, since these are quite different
C calculations conceptually.

	IF (water_layer) THEN
	  IF (clash_rank) THEN
	    CALL add_water2
	  ELSE
	    CALL add_water1
	  END IF
	END IF

C Do the best drawing of the line we can for ionisable groups, based on
C whatever information we have - append info to the .out file.

	CALL	draw_THE_line (water_layer, clash_rank)

	CLOSE (UNIT=3)

C hender ?? - off you go then

	CALL	EXIT
	END


	SUBROUTINE	sc_ctr_read
C	**********	***********

C Read in files, parameters etc.

	CHARACTER*8	check, rot_source
	INTEGER		which_vdw
	INTEGER		excl_nres (100)
	CHARACTER*4	excl_res (100)
	CHARACTER*1	excl_chain (100)
	CHARACTER*80	line, coords_in, file_out, file_prb,
     1			excl_file, file_lyr
	LOGICAL		excl_some, water_layer, mask_res
	LOGICAL*1	excl_found (100)
	LOGICAL		brick_atoms, rot_coords, collect_clash,
     1			incl_expt, rot_mask, clash_rank, till_expt,
     1			till_value
	REAL		p_new (10000,50), p_old (10000,50)

	COMMON	/ctr_stuff/	coords_in, file_out, which_vdw,
     1				rot_source, file_prb
	COMMON	/exclude/	excl_some, excl_file, n_excl,
     1				excl_res, excl_nres, excl_found,
     2				excl_chain
	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank

1020	FORMAT (A8)
Clnx1040	FORMAT (Q,60A1)
1050	FORMAT (A80)

	OPEN (UNIT=1, NAME='sc_freedom.ctr', TYPE='OLD')
	READ (1,1020) check
	IF (check .NE. 'freedom ') STOP 'freedom '

	READ (1,1020) check
	IF (check .NE. 'coords  ') STOP 'coords  '
Clnx	READ (1,1040) nc, (coords_in (ic), ic=1,nc)
	READ (1,1050) line
	CALL	get_filename (line, coords_in)

	READ (1,1020) check
	IF (check .NE. 'whichvdw') STOP 'whichvdw'
	READ (1,*) which_vdw

	READ (1,1020) check
	IF (check .NE. 'rotamers') STOP 'rotamers'
	READ (1,1020) rot_source

C Option to add in the experimental/input coord rotamers.
C Also option (if we are adding them) to keep VdW relaxing untill all exptal
C rotamers are allowed.
C Also option to simply relax until a specified vdw relaxation value - then
C if we haven't converged, we force 'effective' convergence by setting the
C relevant aa sc probs to 1 for exptal rotamer (therefore requiring that
C incl_expt is on).  NOTE we changed to this in Dec.02.
C We cannot set till_expt and till_value together/ we need not set either.

	READ (1,1020) check
	IF (check .NE. 'inclexpt') STOP 'inclexpt'
	READ (1,*) incl_expt, till_expt, till_value, rel_value

	IF (till_expt .AND. (.NOT.incl_expt)) STOP '** till/incl_expt?'
	IF (till_expt .AND. till_value) STOP '** relax until expt/val?'
	IF (till_value .AND. (.NOT.incl_expt)) STOP '** till_val/expt?'
	IF (till_expt) THEN
	  IF (ABS(MOD(rel_value,0.1)).GE.0.01) STOP 'rel_value 1 dp'
	END IF

	READ (1,1020) check
	IF (check .NE. 'files   ') STOP 'files   '
Clnx	READ (1,1040) nc, (file_out (ic), ic=1,nc)
Clnx	READ (1,1040) nc, (file_prb (ic), ic=1,nc)
	READ (1,1050) line
	CALL	get_filename (line, file_out)
	READ (1,1050) line
	CALL	get_filename (line, file_prb)

	READ (1,1020) check
	IF (check .NE. 'exclude ') STOP 'exclude '
	READ (1,*) excl_some
	IF (excl_some) THEN
Clnx	  READ (1,1040) nc, (excl_file (ic), ic=1,nc)
	  READ (1,1050) line
	  CALL	get_filename (line, excl_file)
	  CALL	set_excl
	ELSE
	  READ (1,*)
	END IF

C Option to brick atoms for quicker clash checks.

	READ (1,1020) check
	IF (check .NE. 'brickats') STOP 'brickats'
	READ (1,*) brick_atoms

C Use a sucessive decrement to allow vdw clashes until we get non-zero
C probability for all residues (i.e. at least one allowed rotamer for each
C residue).  Work with vdw_dec about 0.1 A?
C Check at 0.1, so we know we'll hit 0.x, 1.x till_value spot on.

	READ (1,1020) check
	IF (check .NE. 'vdwrelax') STOP 'vdwrelax'
	READ (1,*) vdw_dec
	IF (vdw_dec .NE. 0.1) STOP ' ** vdw_dec ne 0.1 **'

C With vdw_dec, we can still collect up all clashes at each dec, for info.
C Not with till_value set (see rots_prob subroutine).

	READ (1,1020) check
	IF (check .NE. 'clshinfo') STOP 'clshinfo'
	READ (1,*) collect_clash
	IF (collect_clash .AND. till_value) STOP 'collect/till_val'

C Option to do additional calculations of water layering for groups in the
C given file.  If mask_res is set, we will subtract out the effect of all
C atoms in a given rotamer (including fixed atoms for this residue).

	READ (1,1020) check
	IF (check .NE. 'waterlyr') STOP 'waterlyr'
	READ (1,*) water_layer, mask_res
	IF (water_layer) THEN
Clnx	  READ (1,1040) nc, (file_lyr (ic), ic=1,nc)
	READ (1,1050) line
	CALL	get_filename (line, file_lyr)
	ELSE
	  READ (1,*)
	END IF

C With the water_layer option we can EITHER do a self-consistent calcn, which
C reports d_wat at convergence OR a one-off ranking of (masked) clashes.
C The clash ranking needs the experimental rotamers.

	READ (1,1020) check
	IF (check .NE. 'rankclsh') STOP 'rankclsh'
	READ (1,*) clash_rank
	IF (clash_rank) THEN
	  IF (.NOT. mask_res) STOP 'clash_rank/mask_res'
	  IF (.NOT. incl_expt) STOP 'clash_rank/incl_expt'
	END IF

C Get the under-relaxn factor and fractional prob change for convergence.

	READ (1,1020) check
	IF (check .NE. 'convergd') STOP 'convergd'
	READ (1,*) frac_new, conv_frac

C Now we have a converegnece check and relaxation decrementer going -
C make sure we start at 1.0 (means no under-relaxation).

	IF (frac_new .NE. 1.0) STOP 'Start frac_new at 1.0'

C Option to write out rotamer coords for a chosen nres.  Also an option to
C write out a cartesian mask for one rotamer of nres_coords.

	READ (1,1020) check
	IF (check .NE. 'test_out') STOP 'test_out'
	READ (1,*) rot_coords, nres_coords, rot_mask, irot_mask
	IF ((rot_mask).AND.(.NOT.mask_res)) STOP 'rot_mask/mask_res'

C hender ?? - more in here

	CLOSE (UNIT=1)

	RETURN
	END


	SUBROUTINE	set_excl
C	**********	********

C Set up residue sidechain exclusions from rotamerisarion.

	INTEGER		excl_nres (100)
	CHARACTER*4	excl_res (100)
	CHARACTER*80	excl_file
	LOGICAL		excl_some
	LOGICAL*1	excl_found (100)
	CHARACTER*1	excl_chain (100)

	COMMON	/exclude/	excl_some, excl_file, n_excl,
     1				excl_res, excl_nres, excl_found,
     2				excl_chain

1100	FORMAT (A4,1X,A1,I4)

	OPEN (UNIT=2, NAME=excl_file, TYPE='OLD')
	READ (2,*)
	READ (2,*) n_excl
	IF (n_excl .GT. 100) STOP 'n_excl'
	DO 200 ie	= 1, n_excl
	  READ (2,1100) excl_res(ie),excl_chain(ie),excl_nres(ie)
	  excl_found (ie) = .FALSE.
200	CONTINUE						! End ie
	CLOSE (UNIT=2)

	RETURN
	END


	SUBROUTINE	coords_read
C	**********	***********

C Get the PDB coordinates, with a single header record.
C ?? Currently don't want any hydrogens in here (fixed or moving) ??

	REAL		xyz (3), at_VdW (100,10),
     1			at_chrg (2000,4), at_pK (2000)
	INTEGER		n_res_ats (200), nat_pter (200,2),
     1			at_class (2000), common_pter (100),
     2			which_vdw
	CHARACTER*80	header
	CHARACTER*34	at_info (100)
	CHARACTER*8	rot_source
	CHARACTER*4	common_atyp (100), res_type (200),
     1			at_type (2000), at_prtner (2000)
	CHARACTER*4	atom, atyp, res, atm
	CHARACTER*5	atyp_buf
	CHARACTER*1	chain
	CHARACTER*80	coords_in, file_out, file_prb
	LOGICAL		common_at
	LOGICAL*1	at_anyq (2000), at_ionise (2000)

	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000)
	LOGICAL		alt_coords, comp_model, move_bg
	CHARACTER*1	alt_chn(7000)
	CHARACTER*4	alt_res(7000)
	INTEGER		alt_nres(7000)

	COMMON	/more_params/	alt_coords, comp_model, move_bg,
     1				n_alt,alt_chn,alt_res,alt_nres
	COMMON	/ctr_stuff/	coords_in, file_out, which_vdw,
     1				rot_source, file_prb
	COMMON	/common_atoms/	common_atyp, common_pter, n_common
	COMMON	/atoms_es_type/ at_info, n_at_types, at_VdW, n_VdW
	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm

1100	FORMAT (A80)
C??atyp	1200	FORMAT (A4, 9X, A4, A4, A1, I4, 4X, 3F8.3)
1220	FORMAT (A4, 8X, A5, A4, A1, I4, 4X, 3F8.3)
2000	FORMAT ('           SC_FREEDOM OUTPUT FILE - i/p coords ->')
2100	FORMAT (/,A80)
2200	FORMAT (/,' with ',I6,' atoms read in')
2400	FORMAT (A1,2X,A4,2X,I4)
2500	FORMAT (/,'SC_FREEDOM RUNNING TO GENERATE COMBOS FOR AAS:',
     1          /,'i_alt chain   res  nres')
2600	FORMAT (I5,5X,A1,2X,A4,2X,I4)

C ?? Updated 28/Aug/01 to read atyp field from one further char to left, if
C ?? it has something there - otherwise fill up to left as do currently.

	OPEN (UNIT=2, NAME=coords_in, TYPE='OLD')
	READ (2,1100) header
	i_ats		= 0
200	i_ats		= i_ats + 1
	IF (i_ats .GT. 70000) STOP 'nat/70000'
C??atyp	READ (2,1200,END=500) atm, atyp, res, chain, nres, xyz
	READ (2,1220,END=500) atm, atyp_buf, res, chain, nres, xyz

	IF (atyp_buf (1:1) .EQ. ' ') THEN
	  atyp (1:4) = atyp_buf (2:5)
	ELSE
	  atyp (1:4) = atyp_buf (1:4)
	END IF

	IF (atm .NE. 'ATOM' .AND. atm .NE. 'HETA') STOP 'atm'
	IF (atyp (1:1) .EQ. 'H') STOP 'no hyds??'
	common_at	= .FALSE.
	ats_comm (i_ats) = .FALSE.
	DO 220 i_com	= 1, n_common
	  IF (atyp .EQ. common_atyp (i_com)) THEN
	    iat		= common_pter (i_com)
	    common_at	= .TRUE.
	    ats_comm (i_ats) = .TRUE.
	  END IF
220	CONTINUE						! End i_com
	IF (.NOT. common_at) THEN
	  CALL	res_id (res, ir, ia_1, ia_2, na)
	  CALL	atom_id (atyp, iat, ia_1, ia_2)
	END IF
	ic			= at_class (iat)
	ats_class (i_ats)	= ic
	ats_rad (i_ats)		= at_VdW (ic,which_vdw)
	IF (ats_rad (i_ats) .LT. 0.55) STOP '0.55/rad'
	DO 240 n		= 1, 3
	  ats_xyz (i_ats,n)	= xyz (n)
240	CONTINUE						! End n
	ats_res (i_ats)		= res
	ats_nres (i_ats)	= nres
	ats_atyp (i_ats)	= atyp
	ats_chain (i_ats)	= chain
	GOTO 200

500	num_ats		= i_ats - 1
	CLOSE (UNIT=2)

C Open the o/p file, and write some information.

	OPEN (UNIT=3, NAME=file_out, TYPE='NEW')
	WRITE (3,2000)
	WRITE (3,2100) header
	WRITE (3,2200) num_ats

C If we have alt_coords set, then open a file of residues to play around with,
C and record for all residues whether fixed or moving: will depend on move_bg.

	IF (alt_coords) THEN
	  WRITE (3,2500)
	  OPEN (UNIT=2, NAME='scf_alter.in', TYPE='OLD')
	  i_alt		= 1
540	  READ (2,2400,END=560) alt_chn(i_alt),alt_res(i_alt),
     1				alt_nres(i_alt)
	  WRITE (3,2600) i_alt,alt_chn(i_alt),alt_res(i_alt),
     1				alt_nres(i_alt)
	  i_alt		= i_alt + 1
	  GOTO 540

560	  n_alt		= i_alt - 1
	  IF (n_alt .LE. 0) STOP 'alt_coords but none to work with'
	  CLOSE (UNIT=2)
	END IF

	RETURN
	END


	SUBROUTINE	rots_read
C	**********	*********

C Read in rotamer chi tables from the specified dictionary.

	CHARACTER*80	rec
	CHARACTER*8	check, rot_source
	CHARACTER*4	res
	CHARACTER*1	nchi_test
	INTEGER		which_vdw
	CHARACTER*80	coords_in, file_out, file_prb
	LOGICAL		not_here
	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)

	REAL		res_chi (20,50,5)
	INTEGER		res_nchi (20), res_natm (20), res_nrot (20)
	CHARACTER*4	res_tag (20)
	CHARACTER*60	data_path

	COMMON	/ctr_stuff/	coords_in, file_out, which_vdw,
     1				rot_source, file_prb
	COMMON	/rot_dict/	res_nchi, res_natm, res_chi,
     2				res_nrot, res_tag
	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank

1100	FORMAT (A80)
1200	FORMAT (7X,A4)
1240	FORMAT (19X,A1)
1300	FORMAT (13X,I2,4X,I1,3X,I2)
1340	FORMAT (13X,I2)
1500	FORMAT (27X, (1X,F6.1))
1600	FORMAT (27X,2(1X,F6.1))
1700	FORMAT (27X,3(1X,F6.1))
1800	FORMAT (27X,4(1X,F6.1))
1900	FORMAT (27X,5(1X,F6.1))
2000	FORMAT (/,' With the rotamer library of ',A8,' we have
     1 ',I4,' total rotamers as follows:')
2100	FORMAT (/,'index  res  natm  nchi  nrot',/)
2200	FORMAT (' ',1X,I2,3X,A4,3X,I2,3X,I1,4X,I2)

C Now this little bit is an ugly set of data statements giving the
C atoms of a sidechain that are moved for each chi operation.

	CALL	rots_set

C Actually, we have modified (reduced) the tuffery file a little - where
C the final 1 or 2 chi's correspond to hydrogen positions, we have removed
C them, and we assume that Gly, Pro and Ala are all fixed at i/p coords.
C We retain the 180 chi_5 for Arg.
C ?? BUT NOTE the crossover between using a chi to place hyds and our
C ?? general polar hyd 'optimisation' problem.

	IF (rot_source .EQ. 'tuffery ') THEN
	  CALL getenv ('DATA', data_path)
	  idp			= 1
	  DO WHILE (data_path (idp:idp) .NE. ' ')
	    idp			= idp + 1
	  END DO
	  OPEN (UNIT=4, NAME=data_path(1:idp-1)//'rots_tuffery.dat',
     1		TYPE='OLD')
	  READ (4,*)
	  READ (4,*)
	  DO 180 ind_res	= 1, 20
	    res_nchi (ind_res)	= -1
	    res_nrot (ind_res)	= 0
180	  CONTINUE						! End ind_res
	  i_tot			= 0
200	  i_tot			= i_tot + 1
	  READ (4,1100,END=400) rec
	  READ (rec,1200) res
	  IF (res .EQ. '----') THEN
	    i_tot		= i_tot - 1
	    GOTO 200
	  ELSE
	    CALL res_assign (res, ind_res, not_here)
	    IF (not_here) STOP 'not_here'
	    IF (res_nchi (ind_res) .EQ. -1) THEN
	      READ (rec,1240) nchi_test
	      IF (nchi_test .EQ. ' ') THEN
		STOP 'nchi_test'
	      ELSE
		READ (rec,1300) num, nchi, natm
		IF (num .NE. 1) STOP 'num .ne. 1'
		res_natm (ind_res)	= natm
		res_nchi (ind_res)	= nchi
		IF (nchi .EQ. 0) THEN
		  i_tot		= i_tot - 1
		  GOTO 200
		END IF
	      END IF
	    END IF
	    nchi		= res_nchi (ind_res)
	    res_nrot (ind_res)	= res_nrot (ind_res) + 1
	    READ (rec,1340) num
	    IF (num .NE. res_nrot (ind_res)) STOP 'num/res_nrot'
	    IF (nchi .EQ. 0) THEN
	      STOP '?? nchi=0 - recode'
	    ELSE IF (nchi .EQ. 1) THEN
	      READ (rec,1500)  res_chi (ind_res,num,1)
	    ELSE IF (nchi .EQ. 2) THEN
	      READ (rec,1600) (res_chi (ind_res,num,m),m=1,2)
	    ELSE IF (nchi .EQ. 3) THEN
	      READ (rec,1700) (res_chi (ind_res,num,m),m=1,3)
	    ELSE IF (nchi .EQ. 4) THEN
	      READ (rec,1800) (res_chi (ind_res,num,m),m=1,4)
	    ELSE IF (nchi .EQ. 5) THEN
	      READ (rec,1900) (res_chi (ind_res,num,m),m=1,5)
	    ELSE
	      STOP 'nchi .gt. 5'
	    END IF
	    GOTO 200
	  END IF

400	  n_tot		= i_tot - 1
	  CLOSE (UNIT=4)
	  DO 430 n	= 1, 20
	    IF (sc_chi (n) .NE. res_nchi (n)) STOP 'chi mism'
430	  CONTINUE						! End n
	ELSE
	  STOP 'rot_source'
	END IF

C Write some information then.

	WRITE (3,2000) rot_source, n_tot
	WRITE (3,2100)
	DO 500 ind_res		= 1, 20
	  WRITE (3,2200) ind_res,res_tag(ind_res),res_natm(ind_res),
     1			 res_nchi(ind_res),res_nrot(ind_res)
500	CONTINUE						! End ind_res

	RETURN
	END


	SUBROUTINE	rots_set
C	**********	********

C Yes, I know that this is ugly, thankyou.
C When we come to the rotamer generation, the sc atoms are mapped to their
C corresponding array indices in sc_ats.  Each chi operation is defined by
C 4 atoms, the middle 2 defining the rotation axis, the first giving the
C chi origin, and the last being moved.  All sc atoms from this last atom
C to the end of the sc are moved in this chi operation.

C The three atoms that we need to start dihedral definitions, but which are
C not moved are stored in the chi_start array, are labelled -2,-1 and 0 in the
C chi_ats array.
C For amino acids, 0 is CB, -1 is CA, -2 is N   [Biochem (1970) 9, 3471]
C sc_rank stores which 'moving' atoms are within 2 atoms of the fixed point,
C with +1 nn to fixed pt, +2 second nn to fixed pt, 0 otherwise.
C ?? Actually not using rank derived things at present.

	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)

	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank

	DATA	n_sc_ats (1),sc_chi (1)	/ 0, 0 /		! Ala
	DATA	(sc_ats (1,m),m=1,10)	/ 10*'    ' /
	DATA	(sc_rank (1,m),m=1,10)	/ 10*0 /
	DATA	(chi_start(1,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (2),sc_chi (2) / 1, 1 /		! Cys
	DATA	(sc_ats (2,m),m=1,10)	/ 'SG  ', 9*'    ' /
	DATA	(sc_rank (2,m),m=1,10)	/ 1, 9*0 /
	DATA	(chi_ats (2,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_start(2,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (3),sc_chi (3)	/ 3, 2 /		! Asp
	DATA	(sc_ats (3,m),m=1,10)	/ 'CG  ','OD1 ','OD2 ',	
     1					7*'    ' /
	DATA	(sc_rank (3,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats (3,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (3,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(3,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (4),sc_chi (4)	/ 4, 3 /		! Glu
	DATA	(sc_ats (4,m),m=1,10)	/ 'CG  ','CD  ','OE1 ',
     1					  'OE2 ',6*'    ' /
	DATA	(sc_rank (4,m),m=1,10)	/ 1, 2, 8*0 /
	DATA	(chi_ats (4,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (4,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_ats (4,3,n),n=1,4)	/  0, 1, 2, 3 /
	DATA	(chi_start(4,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (5),sc_chi (5)	/ 6, 2 /		! Phe
	DATA	(sc_ats (5,m),m=1,10)	/ 'CG  ','CD1 ','CD2 ',
     1					  'CE1 ','CE2 ','CZ  ',
     2					4*'    ' /
	DATA	(sc_rank (5,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats (5,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (5,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(5,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (6),sc_chi (6)	/ 0, 0 /		! Gly
	DATA	(sc_ats (6,m),m=1,10)	/ 10*'    ' /
	DATA	(sc_rank (6,m),m=1,10)	/ 10*0 /
	DATA	(chi_start(6,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (7),sc_chi (7)	/ 5, 2 /		! His
	DATA	(sc_ats (7,m),m=1,10)	/ 'CG  ','ND1 ','CD2 ',
     1					  'CE1 ','NE2 ',
     2					5*'    ' /
	DATA	(sc_rank (7,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats (7,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (7,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(7,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (8),sc_chi (8)	/ 3, 2 /		! Ile
	DATA	(sc_ats (8,m),m=1,10)	/ 'CG1 ','CG2 ','CD1 ',
     1					7*'    ' /
	DATA	(sc_rank (8,m),m=1,10)	/ 1, 1, 2, 7*0 /
	DATA	(chi_ats (8,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (8,2,n),n=1,4)	/ -1, 0, 1, 3 /
	DATA	(chi_start(8,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats (9),sc_chi (9)	/ 4, 4 /		! Lys
	DATA	(sc_ats (9,m),m=1,10)	/ 'CG  ','CD  ','CE  ',
     1					  'NZ  ',6*'    ' /
	DATA	(sc_rank (9,m),m=1,10)	/ 1, 2, 8*0 /
	DATA	(chi_ats (9,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats (9,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_ats (9,3,n),n=1,4)	/  0, 1, 2, 3 /
	DATA	(chi_ats (9,4,n),n=1,4)	/  1, 2, 3, 4 /
	DATA	(chi_start(9,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(10),sc_chi(10)	/ 3, 2 /		! Leu
	DATA	(sc_ats(10,m),m=1,10)	/ 'CG  ','CD1 ','CD2 ',
     1					7*'    ' /
	DATA	(sc_rank(10,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats(10,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(10,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(10,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(11),sc_chi(11)	/ 3, 3 /		! Met
	DATA	(sc_ats(11,m),m=1,10)	/ 'CG  ','SD  ','CE  ',
     1					7*'    ' /
	DATA	(sc_rank(11,m),m=1,10)	/ 1, 2, 8*0 /
	DATA	(chi_ats(11,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(11,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_ats(11,3,n),n=1,4)	/  0, 1, 2, 3 /
	DATA	(chi_start(11,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(12),sc_chi(12)	/ 3, 2 /		! Asn
	DATA	(sc_ats(12,m),m=1,10)	/ 'CG  ','OD1 ','ND2 ',
     1					7*'    ' /
	DATA	(sc_rank(12,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats(12,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(12,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(12,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(13),sc_chi(13)	/ 2, 0 /		! Pro
C hender ?? check this out
	DATA	(sc_ats(13,m),m=1,10)	/'CG  ','CD  ',
     1					8*'    ' /
	DATA	(sc_rank(13,m),m=1,10)	/ 10*0 /
	DATA	(chi_start(13,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(14),sc_chi(14)	/ 4, 3 /		! Gln
	DATA	(sc_ats(14,m),m=1,10)	/'CG  ','CD  ','OE1 ',
     1					 'NE2 ',6*'    ' /
	DATA	(sc_rank(14,m),m=1,10)	/ 1, 2, 8*0 /
	DATA	(chi_ats(14,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(14,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_ats(14,3,n),n=1,4)	/  0, 1, 2, 3 /
	DATA	(chi_start(14,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(15),sc_chi(15)	/ 6, 5 /		! Arg
	DATA	(sc_ats(15,m),m=1,10)	/'CG  ','CD  ','NE  ',
     1					 'CZ  ','NH1 ','NH2 ',
     2					4*'    ' /
	DATA	(sc_rank(15,m),m=1,10)	/ 1, 2, 8*0 /
	DATA	(chi_ats(15,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(15,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_ats(15,3,n),n=1,4)	/  0, 1, 2, 3 /
	DATA	(chi_ats(15,4,n),n=1,4)	/  1, 2, 3, 4 /
	DATA	(chi_ats(15,5,n),n=1,4)	/  2, 3, 4, 5 /
	DATA	(chi_start(15,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(16),sc_chi(16)	/ 1, 1 /		! Ser
	DATA	(sc_ats(16,m),m=1,10)	/ 'OG  ',9*'    ' /
	DATA	(sc_rank(16,m),m=1,10)	/ 1, 9*0 /
	DATA	(chi_ats(16,1,n),n=1,4)	/ -2,-1, 0, 1/
	DATA	(chi_start(16,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(17),sc_chi(17)	/ 2, 1 /		! Thr
	DATA	(sc_ats(17,m),m=1,10)	/ 'OG1 ','CG2 ',
     1					8*'    ' /
	DATA	(sc_rank(17,m),m=1,10)	/ 1, 1, 8*0 /
	DATA	(chi_ats(17,1,n),n=1,4)	/ -2,-1, 0, 1/
	DATA	(chi_start(17,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(18),sc_chi(18)	/ 2, 1 /		! Val
	DATA	(sc_ats(18,m),m=1,10)	/ 'CG1 ','CG2 ',
     1					8*'    ' /
	DATA	(sc_rank(18,m),m=1,10)	/ 1, 1, 8*0 /
	DATA	(chi_ats(18,1,n),n=1,4)	/ -2,-1, 0, 1/
	DATA	(chi_start(18,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(19),sc_chi(19)	/ 9, 2 /		! Trp
	DATA	(sc_ats(19,m),m=1,10)	/ 'CG  ','CD1 ','CD2 ',
     1					  'NE1 ','CE2 ','CE3 ',
     2					  'CZ2 ','CZ3 ','CH2 ',
     3					  '    ' /
	DATA	(sc_rank(19,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats(19,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(19,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(19,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	DATA	n_sc_ats(20),sc_chi(20)	/ 7, 2 /		! Tyr
	DATA	(sc_ats(20,m),m=1,10)	/ 'CG  ','CD1 ','CD2 ',
     1					  'CE1 ','CE2 ','CZ  ',
     2					  'OH  ',3*'    ' /
	DATA	(sc_rank(20,m),m=1,10)	/ 1, 2, 2, 7*0 /
	DATA	(chi_ats(20,1,n),n=1,4)	/ -2,-1, 0, 1 /
	DATA	(chi_ats(20,2,n),n=1,4)	/ -1, 0, 1, 2 /
	DATA	(chi_start(20,m),m=1,3)	/ 'N   ','CA  ','CB  ' /

	RETURN
	END


	SUBROUTINE	res_assign (res, ind_res, not_here)
C	**********	**********

	REAL		res_chi (20,50,5)
	INTEGER		res_nchi (20), res_natm (20), res_nrot (20)
	CHARACTER*4	res, res_tag (20), res_tag_here
	LOGICAL		not_here

	COMMON	/rot_dict/	res_nchi, res_natm, res_chi,
     1				res_nrot, res_tag

	DATA	res_tag	/ 'ALA ','CYS ','ASP ','GLU ','PHE ',
     1			  'GLY ','HIS ','ILE ','LYS ','LEU ',
     2			  'MET ','ASN ','PRO ','GLN ','ARG ',
     3			  'SER ','THR ','VAL ','TRP ','TYR ' /

	not_here	= .FALSE.
	DO 200 i	= 1, 20
C??	  IF (res .EQ. res_tag (i)) THEN
	  res_tag_here	= res_tag (i)
	  IF (res (1:3) .EQ. res_tag_here (1:3)) THEN
	    ind_res	= i
	    RETURN
	  END IF
200	CONTINUE						! End i
	not_here	= .TRUE.

	RETURN
	END


	SUBROUTINE	rots_gen
C	**********	********

C Get xyz, in an indexed array, for all rotamers to be studied.
C ?? Currently drop out if we don't find all the relevant sc atoms ??

	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000)
	REAL		res_chi (20,50,5)
	INTEGER		res_nchi (20), res_natm (20), res_nrot (20)
	CHARACTER*4	res_tag (20)
	CHARACTER*4	res
	LOGICAL		excl_this, not_here, rot_coords, rot_mask
	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)
	LOGICAL		incl_expt, till_expt, till_value, alt_here
	CHARACTER*1	chain, chain_last

	REAL		sc_xyz (15,3), sc_rad (15)
	INTEGER		sc_num, sc_ia (15)

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	LOGICAL		alt_coords, comp_model, move_bg, excl_bg
	CHARACTER*1	alt_chn(7000)
	CHARACTER*4	alt_res(7000), fixed_atyp (70000)
	INTEGER		alt_nres(7000)

	COMMON	/more_params/	alt_coords, comp_model, move_bg,
     1				n_alt,alt_chn,alt_res,alt_nres
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/rot_dict/	res_nchi, res_natm, res_chi,
     1				res_nrot, res_tag
	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value

2100	FORMAT (/,' processing ',I6,' residues')
2400	FORMAT (' ','Rotamers for nres = ',I4,' - ',I2,' rotamers')
2420	FORMAT ('ATOM',9X,'ALA ','CA  ',1X,I4,4X,3F8.3)
2500	FORMAT (' sc atom missing for ',A4,2X,I4,2X,A4)

C Rotamer generation gives us the fixed and moved arrays:
C fixed_atyp (if) gives atom type of  fixed atom (added May 05)
C fixed, with if counter, gives xyz and rad for a fixed atom
C fixed_ind (if,1) gives the ir/jr residue index for a fixed atom
C fixed_ind (if,2) is -1,-2,-3 for the 1st,2nd,3rd nn atoms to 'moved' ats
C                  and zero otherwise (e.g. CB/-1,CA/-2,NandC/-3)
C moved, with im counter, gives xyz and rad for a rotameric atom
C moved_ind (im,1) gives the ir/jr residue index for a moved atom
C moved_ind (im,2) gives irot/jrot rotamer index for a moved atom
C moved_ind (im,3) gives the sc_rank (1,2,0) for moved at (rel to fixed ats)
C res_rots_ind (ir) points to the moved array for each residue:
C		    slot 1 gives no. of rots for res ir (none if -999)
C		    slot 2 gives no. of ats in moved for each rotamer
C		    slot 3 gives index of first at belonging to ir in moved
C		    slot 4 gives index of last at belonging to ir in moved

C Read through the ats arrays, parcelling up residues.  For each residue,
C decide if it (and which bit) is to be rotamered.  All fixed bits go into
C a fixed atom array, and all rotamers go into a linear rotamer array.
C First off, just assign residue indices in the ats arrays.

C Note that we belatedly detected a subtle error where chain swaps, but
C nres stays the same - hopefully we'll pick this up now (Mar.03).

	index_1			= 1
	num_res			= 0
	DO 200 ia		= 1, num_ats
	  IF (ia .NE. 1) THEN
Csubtle	    IF (ats_nres (ia) .NE. nres_last) THEN
	    IF ((ats_nres (ia) .NE. nres_last) .OR.
     1		(ats_chain (ia) .NE. chain_last)) THEN
	      index_2		= ia - 1
	      num_res		= num_res + 1
	      IF (num_res .GT. 10000) STOP 'num_res'
	      residue (num_res,1) = index_1
	      residue (num_res,2) = index_2
	      index_1		= ia
	    END IF
	  END IF
	  nres_last		= ats_nres (ia)
	  chain_last		= ats_chain (ia)
200	CONTINUE						! End ia
	index_2			= num_ats
	num_res			= num_res + 1
	residue (num_res,1)	= index_1
	residue (num_res,2)	= index_2
	WRITE (3,2100) num_res

C Go through by residue, checking against the set to be left fixed.
C Remember that we currently have this ugly 'common' atom notation of NT and
C CT,OT1,OT2 for peptide terminal gps, and that we should first leave these
C fixed if encountered (don't bother torsioning the C-t carboxyl at present),
C and two may need to assign as chi_1 defining atoms for their sidechains that
C may be in a different nres (ugly indeed).

	if			= 0
	im			= 0
	num_residues		= num_res
	DO 500 ir		= 1, num_res
	  res_rots_ind (ir,1)	= -999
	  i1			= residue (ir,1)
	  i2			= residue (ir,2)
	  res			= ats_res (i1)
	  nres			= ats_nres (i1)
	  chain			= ats_chain (i1)
	  CALL	res_excl (res, nres, excl_this, chain)
C??may05 - if bg to be fixed amongst combo scs, then do that here
	  excl_bg		= .FALSE.
	  IF (alt_coords .AND. (.NOT.move_bg)) THEN
	    alt_here		= .FALSE.
	    CALL alt_check (res, nres, alt_here, chain)
	    IF (.NOT.alt_here) excl_bg = .TRUE.
	  END IF
	  indr			= 1
	  CALL	res_assign (res, indr, not_here)
	  IF ((excl_this).OR.(excl_bg).OR.(not_here).OR.
     1	      (sc_chi(indr).EQ.0)) THEN
	    DO 300 ia		= i1, i2
	      if		= if + 1
	      DO 280 n		= 1, 3
		fixed (if,n)	= ats_xyz (ia,n)
280	      CONTINUE						! End n
	      fixed_atyp (if)	= ats_atyp (ia)
	      fixed (if,4)	= ats_rad (ia)
	      fixed_ind (if,1)	= ir
C ?? no 'moving' parts of this residue - no rotamer anchor atoms
	      fixed_ind (if,2)	= 0
300	    CONTINUE						! End ia
	  ELSE
	    DO 340 inda		= 1, n_sc_ats (indr)
	      DO 330 ia		= i1, i2
		IF (sc_ats(indr,inda).EQ.ats_atyp(ia)) THEN
		  DO 320 n	= 1, 3
		    sc_xyz (inda+3,n)	= ats_xyz (ia,n)
320		  CONTINUE					! End n
		  sc_rad (inda+3)	= ats_rad (ia)
		  sc_ia (inda+3)	= ia
		  GOTO 340
		END IF
330	      CONTINUE						! End ia

C ?? this loop above is the key (I think) wrt requiring all atoms in file
C ?? if we turn off incl_expt, I see no reason in principle why we should
C ?? need all atoms - this is where to come to fix (Aug 2001 - re Chris C)

	      WRITE (3,2500) res, nres, sc_ats (indr,inda)
	      WRITE (6,2500) res, nres, sc_ats (indr,inda)
	      STOP 'sc atom missing sc_freedom'
340	    CONTINUE						! End inda
	    DO 380 ia		= i1, i2
	      DO 360 inda	= 1, n_sc_ats (indr)
		IF (ats_atyp(ia).EQ.sc_ats(indr,inda)) GOTO 380
360	      CONTINUE						! End inda
	      if		= if + 1
	      DO 370 n		= 1, 3
		fixed (if,n)	= ats_xyz (ia,n)
370	      CONTINUE						! End n
	      fixed_atyp (if)	= ats_atyp (ia)
	      fixed (if,4)	= ats_rad (ia)
	      fixed_ind (if,1)	= ir
C ?? look vs chi_start(indr,?) slots - assume this is fixed link to rots
	      IF      (ats_atyp (ia) .EQ. chi_start (indr,3)) THEN
		fixed_ind (if,2) = -1
	      ELSE IF (ats_atyp (ia) .EQ. chi_start (indr,2)) THEN
		fixed_ind (if,2) = -2
	      ELSE IF (ats_atyp (ia) .EQ. chi_start (indr,1)) THEN
		fixed_ind (if,2) = -3
C ?? - fix to put the carbonyl C in - NOT O which can move under phi,psi
	      ELSE IF (ats_atyp (ia) .EQ. 'C   ') THEN
		fixed_ind (if,2) = -3
	      ELSE
		fixed_ind (if,2) = 0
	      END IF
380	    CONTINUE						! End ia
	    DO 400 is		= 1, 3
	      DO 390 ia		= i1, i2
		IF (chi_start(indr,is).EQ.ats_atyp(ia)) THEN
		  DO 386 n	= 1, 3
		    sc_xyz (is,n) = ats_xyz (ia,n)
386		  CONTINUE					! End n
		  sc_rad (is)	= ats_rad (ia)
		  sc_ia (is)	= ia
		  GOTO 400
		END IF
390	      CONTINUE						! End ia
C ?? For amino acids assume that we may be looking for is=1 in NT of res-1 ??
	      IF (is .EQ. 1) THEN
		IF (ir .EQ. 1) THEN
		  STOP 'is=1/ir=1'
		ELSE
		  DO 394 iap	= residue(ir-1,1), residue(ir-1,2)
		    IF (ats_atyp (iap) .EQ. 'NT  ') THEN
		      DO 392 n	= 1, 3
			sc_xyz (is,n) = ats_xyz (iap,n)
392		      CONTINUE					! End n
		      sc_rad (is) = ats_rad (iap)
		      sc_ia (is)  = ia
		      GOTO 400
		    END IF
394		  CONTINUE
		  STOP 'is.eq.1 not matched'
		END IF
	      ELSE
		STOP 'is.ne.1 not matched'
	      END IF
400	    CONTINUE						! End is
	    sc_num		= 3 + n_sc_ats (indr)
	    res_rots_ind (ir,1)	= res_nrot (indr)
	    res_rots_ind (ir,2)	= n_sc_ats (indr)
	    res_rots_ind (ir,3)	= im + 1
	    CALL	rotamerise (sc_xyz, sc_rad, sc_num, sc_ia,
     1				    ir, indr)
	    res_rots_ind (ir,4)	= im
	    n_test1	= res_rots_ind(ir,4) - res_rots_ind(ir,3) + 1
	    IF (n_test1 .LT. 1) STOP 'n_test'
	    IF (incl_expt) THEN
	      n_test2	= (1+res_rots_ind(ir,1))*res_rots_ind(ir,2)
	    ELSE
	      n_test2	=    res_rots_ind(ir,1)*res_rots_ind(ir,2)
	    END IF
	    IF (n_test1 .NE. n_test2) STOP 'ntest1/2'
	    imh			= res_rots_ind (ir,3) - 1
	    IF (incl_expt) THEN
	      nroth		= 1+res_rots_ind (ir,1)
	    ELSE
	      nroth		=   res_rots_ind (ir,1)
	    END IF
	    DO 440 iroth	= 1, nroth
	      DO 430 iath	= 1, res_rots_ind (ir,2)
		imh		= imh + 1
		IF (imh .GT. res_rots_ind(ir,4)) STOP 'imh'
		moved_ind (imh,1) = ir
		moved_ind (imh,2) = iroth
		moved_ind (imh,3) = sc_rank (indr,iath)
430	      CONTINUE						! End iath
440	    CONTINUE						! End iroth
	  END IF
500	CONTINUE						! End ir

	n_fixed		= if
	n_moved		= im

C ?? Just want to check the fixed_ind array?

	IF (n_fixed .EQ. 0) STOP 'n_fixed.eq.0'
	ir_last		= fixed_ind (1,1)
	itot		= fixed_ind (1,2)
	DO 540 ifh	= 2, n_fixed
	  ir		= fixed_ind (ifh,1)
	  iflag		= fixed_ind (ifh,2)
	  IF (ir .EQ. ir_last) THEN
	    itot	= itot + iflag
	  ELSE
	    IF (res_rots_ind (ir_last,1) .EQ. -999) THEN
	      IF (itot .NE. 0) STOP 'itot.ne.0'
	    ELSE
	      IF ((itot.NE.-6).AND.(itot.NE.-3).AND.
     1		  (itot.NE.-9)) THEN
	WRITE (6,*) 'scf atyp, ir ',fixed_atyp(ifh),fixed_ind(ifh,1)
		STOP 'itot.ne./-9-6/-3'
	      END IF
	    END IF
	    ir_last	= ir
	    itot	= iflag
	  END IF
540	CONTINUE						! End ifh
	IF (res_rots_ind (ir_last,1) .EQ. -999) THEN
	  IF (itot .NE. 0) STOP 'itot.ne.0'
	ELSE
	  IF ((itot.NE.-6).AND.(itot.NE.-3).AND.
     1	      (itot.NE.-9)) THEN
	WRITE (6,*) 'scf atyp, ir ',fixed_atyp(ifh),fixed_ind(ifh,1)
	    STOP 'itot.ne./-9-6/-3'
	  END IF
	END IF

C Option to write out rotamers for one residue, with nres adjusted to
C give original nres and rotamer number.

	IF (rot_coords) THEN
	  DO 640 ir		= 1, num_res
	    i1			= residue (ir,1)
	    nres		= ats_nres (i1)
	    IF (nres .EQ. nres_coords) THEN
	      im1		= res_rots_ind (ir,3)
	      im2		= res_rots_ind (ir,4)
	      IF (incl_expt) THEN
		nrotsh		= 1 + res_rots_ind (ir,1)
	      ELSE
		nrotsh		= res_rots_ind (ir,1)
	      END IF
	      natsh		= res_rots_ind (ir,2)
	      OPEN (UNIT=1, NAME='sc_test1.pdb', TYPE='NEW')
	      WRITE (1,2400) nres_coords, nrotsh
	      DO 620 ifh	= 1, n_fixed
		irh		= fixed_ind (ifh,1)
		IF (irh.EQ.ir) THEN
		  WRITE (1,2420) 1, (fixed (ifh,n),n=1,3)
		END IF
620	      CONTINUE						! End ifh
	      DO 630 iroth	= 1, nrotsh
		DO 625 iath	= 1, natsh
		  imh		= im1 + natsh*(iroth-1) + iath-1
		  IF ((imh.LT.im1).OR.(imh.GT.im2)) STOP 'imh oub'
		  WRITE (1,2420) iroth, (moved (imh,n),n=1,3)
625		CONTINUE					! End iath
630	      CONTINUE						! End iroth
	      GOTO 650
	    END IF
640	  CONTINUE						! End ir
	  STOP 'nres_coords nf'
	END IF

650	CLOSE (UNIT=1)

	RETURN
	END


	SUBROUTINE	rotamerise (sc_xyz, sc_rad, sc_num, sc_ia,
C	**********	**********
     1				    ir, indr)

C Make the rotamers, and add to the moving atom arrays.

	REAL		res_chi (20,50,5)
	INTEGER		res_nchi (20), res_natm (20), res_nrot (20)
	CHARACTER*4	res_tag (20)

	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)

	REAL		sc_xyz (15,3), sc_rad (15)
	INTEGER		sc_num, sc_ia (15)

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)

	INTEGER		m (4)
	REAL		a_ax (3), b_ax (3), new_axes (3,3),
     1			DC_1 (3,3), DC_2 (3,3), rot_mat (3,3),
     2			xyz (3), xyz_new (3), b_axu (3),
     3			sc_xyzp (15,3)
	LOGICAL		singular, incl_expt, till_expt,
     1			till_value
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/rot_dict/	res_nchi, res_natm, res_chi,
     1				res_nrot, res_tag
	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/rot_mats/	DC_1, DC_2, rot_mat
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value

C The first three atoms of sc_xyz/sc_rad have already been stored as fixed.
C Atoms 4->sc_num will be multiplied by sc_chi (=res_nchi) chi angles to give
C res_nrot rotamers, which will be stored in the moved arrays.
C sc_ia gives the index in the original atoms arrays of each sc atom.
C ir is the residue index from the original coords read.
C indr is the residue type index in the rotamer arrays.
C For each rotamer use a separate sc_xyz(p) array, so that each rotamer
C starts fresh with the original coords - avoiding cumulative errors.

C ?? The roll_point code should be checked - but prelim. look shows that
C ?? we should be getting clockwise rotn looking out along sc, for +ve
C ?? chi_move - e.g. consider if b_ax were already along x.

	IF (res_nrot (indr) .EQ. 0) STOP 'res_nrot 0'
	DO 500 irot		= 1, res_nrot (indr)
	  IF (sc_chi (indr) .EQ. 0) STOP 'sc chi 0'
	  IF (sc_chi(indr) .NE. res_nchi(indr)) STOP 'chi no mism'
	  DO 205 i		= 1, 15
	    DO 205 n		= 1, 3
	      sc_xyzp (i,n)	= sc_xyz (i,n)
205	  CONTINUE						! End n,i

	  DO 400 ichi		= 1, res_nchi (indr)
	    DO 210 i		= 1, 4
	      m (i)		= 3 + chi_ats (indr,ichi,i)
	      IF (m (i) .GT. sc_num) STOP 'm/sc_num'
210	    CONTINUE						! End i

	    CALL	start_chi (sc_xyzp, m, chi_curr)
	    chi_ang		= res_chi (indr,irot,ichi)
	    chi_move		= chi_ang - chi_curr

C ?? nb chi_move can be bigger than 180 - don't think this is a problem
	    DO 220 n		= 1, 3
	      a_ax (n)		= sc_xyzp(m(2),n)
	      b_ax (n)		= sc_xyzp(m(3),n)-sc_xyzp(m(2),n)
	      CALL	vec_normalise (b_ax, b_axm, b_axu)
220	    CONTINUE						! End n

C Apply the chi rotation about r_axis = a_ax + lambda*b_axu.
C Get the direction cosine matrices that depend upon the roll-axis.

	    CALL new_axes_gen (b_axu, new_axes)
	    CALL DC_get (new_axes)
C ?? Patriots : for DC matrix, inverse is the transpose ?
C ?? Patriots : I do not think so : use the inversion routine
C ??	    CALL mat_transpose
	    CALL INVERT3 (DC_1, DC_2, determinant, singular)
	    IF ( singular ) STOP 'singular DC inverse'
	    ang_deg		= chi_move
	    CALL rot_mat_x (ang_deg, rot_mat)

	    DO 300 iat		= m (4), sc_num
	      DO 240 n		= 1, 3
		xyz (n)		= sc_xyzp (iat,n)
240	      CONTINUE						! End n
	      CALL roll_point (xyz,xyz_new,a_ax)
	      DO 260 n		= 1, 3
		sc_xyzp (iat,n)	= xyz_new (n)
260	      CONTINUE						! End n
300	    CONTINUE						! End iat
400	  CONTINUE						! End ichi

C ?? - CHECK - WE HAD THIS WRONG - OK NOW ? - AND iat ALWAYS start at 4 ?
	  DO 460 iat		= 4, sc_num
	    im			= im + 1
	    IF (im .GT. 700000) STOP 'im/700000'
	    DO 440 n		= 1, 3
	      moved (im,n)	= sc_xyzp (iat,n)
440	    CONTINUE						! End n
	    moved (im,4)	= sc_rad (iat)
460	  CONTINUE						! End iat

500	CONTINUE						! End irot

C Add in the coord input rotamer, if required.

	IF (incl_expt) THEN
	  DO 540 iat		= 4, sc_num
	    im			= im + 1
	    IF (im .GT. 700000) STOP 'im/700000'
	    DO 520 n		= 1, 3
	      moved (im,n)	= sc_xyz (iat,n)
520	    CONTINUE						! End n
	    moved (im,4)	= sc_rad (iat)
540	  CONTINUE						! End iat
	END IF

C ?? hender - any more in here?

	RETURN
	END


	SUBROUTINE	start_chi (sc_xyzp, m, chi_curr)
C	**********	*********

C Work out the current chi value by projecting the end bonds onto a plane
C perpendicular to the central bond of the dihedral - see notes.

C Aug 2001 - we seem to have a problem here that may be from extended chain
C chi's where we get -180 and 180 - check for this.

	REAL		sc_xyzp (15,3), r_12 (3), r_23 (3),
     1			r_23u (3), r_34 (3), r_y (3), r_2y (3),
     2			r_x (3), r_3x (3), r_2yu (3), r_3xu (3),
     3			cross (3)
	REAL		mr_12 (3), mr_23 (3), norm_123 (3),
     1			norm_234 (3), norm_123u (3), norm_234u (3),
     2			norm_123m, norm_234m
	INTEGER		m (4)

	DO 200 n	= 1, 3
	  r_12 (n)	= sc_xyzp (m(2),n) - sc_xyzp (m(1),n)
	  r_23 (n)	= sc_xyzp (m(3),n) - sc_xyzp (m(2),n)
	  r_34 (n)	= sc_xyzp (m(4),n) - sc_xyzp (m(3),n)
200	CONTINUE						! End n
	CALL	dot_prod (r_12, r_23, dot_12_23)
	CALL	dot_prod (r_23, r_34, dot_23_34)
	CALL	vec_normalise (r_23, r_23m, r_23u)
	DO 300 n	= 1, 3
	  r_y (n)	= sc_xyzp(m(1),n)+(dot_12_23/r_23m)*r_23u(n)
	  r_2y (n)	= r_y (n) - sc_xyzp (m(2),n)
	  r_x (n)	= sc_xyzp(m(4),n)-(dot_23_34/r_23m)*r_23u(n)
	  r_3x (n)	= r_x (n) - sc_xyzp (m(3),n)
300	CONTINUE						! End n
	CALL	dot_prod (r_2y, r_3x, dot_2y_3x)
	CALL	vec_normalise (r_2y, r_2ym, r_2yu)
	CALL	vec_normalise (r_3x, r_3xm, r_3xu)
	cos_ang		= dot_2y_3x / (r_2ym*r_3xm)

C We want ang back between -pi and +pi, positive for 3x clockwise from 2y.
C Do this by comparing an y*x cross-product with r_23.
C ACOSD will return just 0 to 180 degrees, and arg -1 -> +1 of course.

	IF (cos_ang .LT. -1.0) THEN
	  IF (cos_ang .LT. -1.00001) THEN
	    STOP 'cos_ang/-1'
	  ELSE
	    cos_ang	= -1.0
	  END IF
	END IF
	IF (cos_ang .GT. 1.0) THEN
	  IF (cos_ang .GT. 1.00001) THEN
	    STOP 'cos_ang/+1'
	  ELSE
	    cos_ang	= 1.0
	  END IF
	END IF

Clnx	ang		= ACOSD (cos_ang)
	ang_rads	= ACOS (cos_ang)
	ang		= (ang_rads*180.)/3.14159

	CALL	cross_product (r_2y, r_3x, cross)
	CALL	dot_prod (cross, r_23, dot_test)
	IF 	(dot_test .GT. 0.) THEN
	  chi_curr	=  ang
	ELSE IF (dot_test .LT. 0.) THEN
	  chi_curr	= -ang
	ELSE
C??	  IF      (ang .EQ. 0.) THEN
	  IF	  (ABS(ang) .LT. 0.1) THEN
	    chi_curr	= 0.
C??	  ELSE IF (ang .EQ. -180.) THEN
	  ELSE IF (ABS(ang+180.) .LT. 0.1) THEN
	    chi_curr	= -180.
C??	  ELSE IF (ang .EQ. 180.) THEN
	  ELSE IF (ABS(ang-180.) .LT. 0.1) THEN
	    chi_curr	= 180.
	  ELSE
	    STOP 'dot_test start_chi 1'
	  END IF
	END IF

C ?? I'm really sorry about this - for now, check 2 ways give same result.
C Just the angle between 2 planes, with an add-on direction test.

	DO 500 n	= 1, 3
	  mr_12 (n)	= -r_12 (n)
	  mr_23 (n)	= -r_23 (n)
500	CONTINUE						! End n
	CALL	cross_product (mr_12, r_23, norm_123)
	CALL	cross_product (mr_23, r_34, norm_234)
	CALL	dot_prod (norm_123, norm_234, dot_norms)
	CALL	vec_normalise (norm_123, norm_123m, norm_123u)
	CALL	vec_normalise (norm_234, norm_234m, norm_234u)
	cos_ang		= dot_norms / (norm_123m*norm_234m)
	IF (cos_ang .LT. -1.0) THEN
	  IF (cos_ang .LT. -1.00001) THEN
	    STOP 'cos_ang/-1'
	  ELSE
	    cos_ang	= -1.0
	  END IF
	END IF
	IF (cos_ang .GT. 1.0) THEN
	  IF (cos_ang .GT. 1.00001) THEN
	    STOP 'cos_ang/+1'
	  ELSE
	    cos_ang	= 1.0
	  END IF
	END IF
Clnx	ang		= ACOSD (cos_ang)
	ang_rads	= ACOS (cos_ang)
	ang		= (ang_rads*180.)/3.14159
	CALL	cross_product (norm_123, norm_234, cross)
	CALL	dot_prod (cross, r_23, dot_test)
	IF 	(dot_test .GT. 0.) THEN
	  chi_curr1	=  ang
	ELSE IF (dot_test .LT. 0.) THEN
	  chi_curr1	= -ang
	ELSE
C??	  IF      (ang .EQ. 0.) THEN
	  IF 	  (ABS (ang) .LT. 0.1) THEN
	    chi_curr1	= 0.
C??	  ELSE IF (ang .EQ. -180.) THEN
	  ELSE IF (ABS(ang+180.) .LT. 0.1) THEN
	    chi_curr1	= -180.
C??	  ELSE IF (ang .EQ. 180.) THEN
	  ELSE IF (ABS(ang-180.) .LT. 0.1) THEN
	    chi_curr1	= 180.
	  ELSE
C??	WRITE (3,3478) ang
C??3478	FORMAT (' ang (not 0, +/- 180) = ',E14.6)
	    STOP 'dot_test start_chi 2'
	  END IF
	END IF

	IF (ABS(chi_curr-chi_curr1) .GT. 0.1) THEN
	  chi_tmp = chi_curr - 360.
	  IF (ABS(chi_tmp-chi_curr1) .GT. 0.1) THEN
	    chi_tmp = chi_curr + 360.
	    IF (ABS(chi_tmp-chi_curr1) .GT. 0.1) THEN
	      WRITE (3,1212) chi_curr, chi_curr1
1212	      FORMAT (' ',' chi_curr, chi_curr1 = ',2F6.1)
	      STOP 'chi"s out'
	    END IF
	  END IF
	END IF

	RETURN
	END


	SUBROUTINE	res_excl (res, nres, excl_this, chain)
C	**********	********

C Look through any file of sidechain exclusions.

	CHARACTER*4	res
	LOGICAL		excl_this
	INTEGER		excl_nres (100)
	CHARACTER*4	excl_res (100)
	CHARACTER*80	excl_file
	LOGICAL		excl_some
	LOGICAL*1	excl_found (100)
	CHARACTER*1	chain, excl_chain (100)
	LOGICAL		first_here

	COMMON	/exclude/	excl_some, excl_file, n_excl,
     1				excl_res, excl_nres, excl_found,
     2				excl_chain

	DATA	first_here	/ .TRUE. /

2100	FORMAT (/,' res/chain/nres for exclusion = ',A4,1X,A1,I4)
2200	FORMAT (  ' res/chain/nres for exclusion = ',A4,1X,A1,I4)

	excl_this		= .FALSE.
	IF (excl_some) THEN
	  DO 200 ie		= 1, n_excl
	    IF ((res.EQ.excl_res(ie)).AND.(nres.EQ.excl_nres(ie))
     1     .AND.(chain.EQ.excl_chain(ie))) THEN
	      excl_found (ie)	= .TRUE.
	      excl_this		= .TRUE.
	      IF (first_here) THEN
		WRITE (3,2100) res, chain, nres
		first_here	= .FALSE.
	      ELSE
		WRITE (3,2200) res, chain, nres
	      END IF
	      RETURN
	    END IF
200	  CONTINUE						! End ie
	END IF

	RETURN
	END


	SUBROUTINE	alt_check (res, nres, alt_here, chain)
C	**********	********

C We're here if alt_coords set and move_bg unset - so any bg scs to be fixed,
C whilst we combo around the residues set for alternate conformers.

	CHARACTER*4	res
	CHARACTER*1	chain
	LOGICAL		alt_coords, comp_model, move_bg, alt_here
	CHARACTER*1	alt_chn(7000)
	CHARACTER*4	alt_res(7000)
	INTEGER		alt_nres(7000)

	COMMON	/more_params/	alt_coords, comp_model, move_bg,
     1				n_alt,alt_chn,alt_res,alt_nres

2100	FORMAT (' ALT_CHECK res/chain/nres = ',
     1		A4,1X,A1,I4)

	alt_here		= .FALSE.
	DO 200 i_alt		= 1, n_alt
	  IF ((chain.EQ.alt_chn (i_alt)) .AND.
     1	      (res  .EQ.alt_res (i_alt)) .AND.
     2	      (nres .EQ.alt_nres(i_alt))) THEN
	    alt_here		= .TRUE.
	    WRITE (3,2100) res, chain, nres
	    RETURN
	  END IF
200	CONTINUE						! End i_alt

	RETURN
	END


	SUBROUTINE	new_axes_gen (R, new_axes)
C	**********	************

C This routine works out a r-h axis system s.t. the point R on regular
C (xyz) system is transformed to (mod(R),0,0) in the new system.
C new_axes (3,3) records the components of the new system in (xyz).
C ?? See JW notes.

	REAL		R (3), new_axes (3,3),
     1			mu_jw, lambda_jw, A (3), B (3), C (3)

C First the new x axis simply is the normalised R vector on old (xyz).
C b_ax/R is already a unit vector - skip vec_normalise.

C	CALL vec_normalise (R, mag_vec, unit_vec)
	DO 200 n = 1, 3
C	  new_axes (1,n)	= unit_vec (n)
	  new_axes (1,n)	= R (n)
200	CONTINUE						! End n

C Now we choose the new y to be coplanar with new x and old y, (see JW notes).

	mu_jw		= SQRT (1./(1.-new_axes(1,2)*new_axes(1,2)))
	lambda_jw	= -mu_jw * new_axes (1,2)

	new_axes (2,1)	= lambda_jw * new_axes (1,1)
	new_axes (2,2)	= lambda_jw * new_axes (1,2) + mu_jw
	new_axes (2,3)	= lambda_jw * new_axes (1,3)

C And the new z is generated so as to give a right-handed set.

	DO 400 n = 1, 3
	  A (n)			= new_axes (1,n)
	  B (n)			= new_axes (2,n)
400	CONTINUE						! End n
	CALL cross_product (A, B, C)
	DO 500 n = 1, 3
	  new_axes (3,n)	= C (n)
500	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	vec_normalise (vec, mag_vec, unit_vec)
C	**********	*************

C This routine returns magnitude and normalised vector.

	REAL		vec (3), mag_vec, unit_vec (3)

	mag_vec		= SQRT (vec (1)*vec (1) + vec (2)*vec (2) +
     1				vec (3)*vec (3) )
	DO 200 n = 1, 3
	  unit_vec (n)	= vec (n) / mag_vec
200	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	cross_product (A, B, C)
C	**********	*************

C Routine returns C = A ^ B vector cross product.

	REAL		A (3), B (3), C (3)

	C (1)	= A (2)*B (3) - A (3)*B (2)
	C (2)	= A (3)*B (1) - A (1)*B (3)
	C (3)	= A (1)*B (2) - A (2)*B (1)
	RETURN
	END


	SUBROUTINE	DC_get (new_axes)
C	**********	******

C Routine returns the direction cosine matrix (DC) that transforms coords
C between normal (xyz) system and axial system with components on normal
C (xyz) given in new_axes array.

	REAL		new_axes (3,3), DC_1 (3,3), new_ax (3),
     1			old_axes (3,3), old_ax (3), DC_2 (3,3),
     2			rot_mat (3,3)

	COMMON	/rot_mats/	DC_1, DC_2, rot_mat

	DATA	old_axes(1,1),old_axes(1,2),old_axes(1,3) /1.,0.,0./
	DATA	old_axes(2,1),old_axes(2,2),old_axes(2,3) /0.,1.,0./
	DATA	old_axes(3,1),old_axes(3,2),old_axes(3,3) /0.,0.,1./

	DO 300 l = 1, 3
	  DO 200 n = 1, 3
	    new_ax (n)		= new_axes (l,n)
200	  CONTINUE						! End n
	  DO 300 m = 1, 3
	    DO 250 n = 1, 3
	      old_ax (n)	= old_axes (m,n)
250	    CONTINUE						! End n
	    CALL dot_prod (new_ax, old_ax, dot)
	    DC_1 (l,m)		= dot
300	CONTINUE						! End m,l
	RETURN
	END


	SUBROUTINE	dot_prod (a, b, dot_product)
C	**********	********

C Routine returns the vector dot product, a.b

	REAL		a (3), b (3)

	dot_product	= a(1)*b(1) + a(2)*b(2) + a(3)*b(3)
	RETURN
	END


	SUBROUTINE	mat_transpose (A, A_T)
C	**********	*************

C Routine returns 3x3 matrix transpose of A, A_T.

	REAL		A (3,3), A_T (3,3)

	DO 300 l = 1, 3
	  DO 300 m = 1, 3
	    A_T (m,l)	= A (l,m)
300	CONTINUE						! End m,l
	RETURN
	END


	SUBROUTINE INVERT3 ( A, AINV, ADET, SING )
C	********** *******

C@@@@@@  Test this Routine  LATER !! @@@@@@

C This routine returns the matrix inverse of A in AINV, the determinant of
C A (ADET), and sets SING = .true. if A is singular.
C See J.W., p.C3, Mathematics for Chemists.

C n.b. This is programmed for a 3*3 matrix.

	REAL A (3,3), AINV (3,3), T (3,3,3), DET (3)
	LOGICAL		SING

	DO 210 I = 1, 3
	    DO 200 J = 1, 3
		T (1,I,J) = A (I,J)
200	    CONTINUE						! End J
210	CONTINUE						! End I

	DO 550 I1 = 1, 3
	    IF ( I1 .EQ. 1 ) DET (1) = 0.
	    DO 500 J1 = 1, 3
		CALL STRIKE ( T, I1, J1, 1, 3 )
		DET (2) = 0.
		DO 450 J2 = 1, 2
		    CALL STRIKE ( T, 1, J2, 2, 2 )
		    DET (3) = T (3,1,1)
		    ISN = 1
		    IF ( MOD (1+J2,2) .NE. 0 ) ISN = -1
		    SN = FLOAT (ISN)
		    DET (2) = DET (2) + SN * T (2,1,J2) * DET (3)
450		CONTINUE					! End J2
		ISN = 1
		IF ( MOD (I1+J1,2) .NE. 0 ) ISN = -1
		SN = FLOAT (ISN)
		IF ( I1 .EQ. 1 )
     1          DET (1) = DET (1) + SN * T (1,I1,J1) * DET (2)
		AINV (J1,I1) = SN * DET (2)
500	    CONTINUE						! End J1
550	CONTINUE						! End I1

	ADET = DET (1)
	SING = .FALSE.
	IF ( ADET .EQ. 0. ) SING = .TRUE.
	IF ( SING ) RETURN

	DO 610 I = 1, 3
	    DO 600 J = 1, 3
		AINV (I,J) = AINV (I,J) / ADET
600	    CONTINUE						! End J
610	CONTINUE						! End I

	RETURN
	END


	SUBROUTINE STRIKE ( T, I, J, L, N )
C	********** ******

C This routine strikes out the i row and j column of the matrix (of order N)
C in the L level of T, and inserts the result (order N-1) in the L+1 level
C of T.

	REAL T (3,3,3)

	IF ( L+1 .GT. 3 ) STOP 'T array l+1 .gt. 3'
	IVV = 0
	DO 210 IV = 1, N
	    IF ( IV .EQ. I ) GOTO 210
	    IVV = IVV + 1
	    JVV = 0
	    DO 200 JV = 1, N
		IF ( JV .EQ. J ) GOTO 200
		JVV = JVV + 1
		T (L+1,IVV,JVV) = T (L,IV,JV)
200	    CONTINUE						! End Jv
210	CONTINUE						! End Iv

	RETURN
	END


	SUBROUTINE	rot_mat_x (ang_deg, rot_mat)
C	**********	*********

C Routine returns rotation matrix for rotn of ang_deg about x axis.
C ?? Patriots : in a hurry : look this up : just definition anyway

	REAL		rot_mat (3,3)

	angle		= ang_deg
	angle_rads	= (angle*3.14159)/180.
	c_angle		= COS (angle_rads)
	s_angle		= SIN (angle_rads)
Clnx	c_angle		= COSD (angle)
Clnx	s_angle		= SIND (angle)

	rot_mat (1,1)	= 1.
	rot_mat (1,2)	= 0.
	rot_mat (1,3)	= 0.
	rot_mat (2,1)	= 0.
	rot_mat (2,2)	=  c_angle
	rot_mat (2,3)	= -s_angle
	rot_mat (3,1)	= 0.
	rot_mat (3,2)	=  s_angle
	rot_mat (3,3)	=  c_angle
	RETURN
	END


	SUBROUTINE	roll_point (xyz, xyz_new, a_ax)
C	**********	**********

C Routine performs rotation about axis that has been encoded into the
C matrices passed.
C See JW notes for the transformation, involving the dirn cosine matrices.

	REAL		xyz (3), xyz_new (3), a_ax (3), DC_1 (3,3),
     1			DC_2 (3,3), rot_mat (3,3), tmp_1 (3),
     2			tmp_2 (3), tmp_3 (3), tmp_4 (3)

	COMMON	/rot_mats/	DC_1, DC_2, rot_mat

C ?? Patriots : can we not concatenate these matrix operations?

	sign	= -1.
	CALL vec_trn		(xyz, a_ax, tmp_1, sign)
	CALL mat_vec_mult	(DC_1, tmp_1, tmp_2)
	CALL mat_vec_mult	(rot_mat, tmp_2, tmp_3)
	CALL mat_vec_mult	(DC_2, tmp_3, tmp_4)
	sign	=  1.
	CALL vec_trn		(tmp_4, a_ax, xyz_new, sign)
	RETURN
	END


	SUBROUTINE	vec_trn (A, B, C, sign)
C	**********	*******

C Vector translation, C = A + sign*B

	REAL		A (3), B (3), C (3)

	DO 200 n = 1, 3
	  C (n)		= A (n) + sign * B (n)
200	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	mat_vec_mult (A, B, C)
C	**********	************

C Routine returns C (vec) = A (mat) * B (vec)

	REAL		A (3,3), B (3), C (3)

	DO 300 l = 1, 3
	  C (l)		= 0.
	  DO 300 m = 1, 3
	    C (l)	= C (l) + A (l,m) * B (m)
300	CONTINUE						! End m,l
	RETURN
	END



	SUBROUTINE	rot_mat_z (ang_deg, rot_mat)
C	**********	*********

C Routine returns rotation matrix for rotn of ang_deg about z axis.
C ?? Patriots : in a hurry : look this up : just definition anyway

	REAL		rot_mat (3,3)

	angle		= ang_deg
Clnx	c_angle		= COSD (angle)
Clnx	s_angle		= SIND (angle)
	angle_rads	= (angle*3.14159)/180.
	c_angle		= COS (angle_rads)
	s_angle		= SIN (angle_rads)

	rot_mat (1,1)	= c_angle
	rot_mat (1,2)	= -s_angle
	rot_mat (1,3)	= 0.
	rot_mat (2,1)	= s_angle
	rot_mat (2,2)	= c_angle
	rot_mat (2,3)	= 0.
	rot_mat (3,1)	= 0.
	rot_mat (3,2)	= 0.
	rot_mat (3,3)	= 1.

	RETURN
	END


	SUBROUTINE	rot_mat_y (ang_deg, rot_mat)
C	**********	*********

C Routine returns rotation matrix for rotn of ang_deg about y axis.
C ?? Patriots : in a hurry : look this up : just definition anyway

	REAL		rot_mat (3,3)

	angle		= ang_deg
Clnx	c_angle		= COSD (angle)
Clnx	s_angle		= SIND (angle)
	angle_rads	= (angle*3.14159)/180.
	c_angle		= COS (angle_rads)
	s_angle		= SIN (angle_rads)

	rot_mat (1,1)	=  c_angle
	rot_mat (1,2)	=  0.
	rot_mat (1,3)	=  s_angle
	rot_mat (2,1)	=  0.
	rot_mat (2,2)	=  1.
	rot_mat (2,3)	=  0.
	rot_mat (3,1)	= -s_angle
	rot_mat (3,2)	=  0.
	rot_mat (3,3)	=  c_angle

	RETURN
	END


	SUBROUTINE	rots_prob
C	**********	*********

C Derive probabilities for rotamers, based on sc clashes - I think
C equivalent to a mean field approach in which a clash is strictly
C disallowed.  The cost of not using a (soft) potl fn is that we must devise
C a method to ensure that no single residue has no allowed rotamers, since
C then all probabilities go to zero in the following analysis for residue i
C and rotamer k: (where the vs results are 1-allowed or 0-clash)

C p(i,k) = {(i,k) vs fixed} * PI(over j.ne.i)[SUM[p(j,l)*{(i,k) vs (j,l)}]

C ?? Our initial way around this is to have an iterative relaxation of
C ?? vdw clashing until we get a 'solution'.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		pinc_hold (10000,50)
	REAL		xyz1 (15,3), rad1 (15)
	LOGICAL		brick_atoms, rot_coords, collect_clash
	LOGICAL		un_converged, clashed, found_clash,
     1			write_once, past_fix_here, rot_mask
	LOGICAL*1	strike_out (10000,50)
	INTEGER		clash_store (10), undone (10)
	INTEGER*2	rank (15)
	LOGICAL		incl_expt, till_expt, iam_undone,
     1			till_value, force_conv, conv_problem
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value

	DATA	write_once	/ .TRUE. /

2200	FORMAT (/,' Into vdw_dec/iter loops for ',I5,' residues')
2220	FORMAT (/,'    vdw_dec loop: i_dec,vdw_relax = ',I3,2X,F6.2,/)
2300	FORMAT (' Unconverged - num_iter, prob_rmsd, n_osc = ',
     1 I5,2X,F12.7,2X,I5)
2360	FORMAT (' ','Dummy atoms rotamer file from sc_freedom')
2380	FORMAT ('ATOM',9X,'ALA ','CA  ',1X,I4,4X,3F8.3)
2400	FORMAT ('   Converged - num_iter,rmsd,conv = ',I5,2(2X,F12.7))
2420	FORMAT (/,' The VdW relaxation at convergence = ',F6.2,' A')
2430	FORMAT (/,' VdW relaxation at ***FORCED*** convergence = ',
     1		    F6.2,' A')
2440	FORMAT (/,' *** FORCED conv, p(expt rot)=1 for',I4,' aas ***')
2510	FORMAT (' ','zero probs for ir"s = ',10(1X,I4))
2530	FORMAT (' ','zero probs for ',I4,' residues')
2600	FORMAT (/,' ** DB ROTS EXPANDED WITH EXPT ROTS - PROBS EXPANDED -
     1 WHAT A MESS **'/)
2700	FORMAT ('*** clash free at vdw_relax = ',F5.1,' but
     1 continue until all expt rots OK')
2720	FORMAT (' *** expt rots not allowed for res: ',10I5)
2740	FORMAT (' *** expt rots not allowed for more than 10 residues')
2810	FORMAT ('*** clash-free at vdw_relax = ',F5.1,' but
     1 continue to vdw target = ',F5.1)
2900	FORMAT (/,'*** Did not converge: relax = ',F3.1,' try = ',F3.1)

C Brick all the fixed and moved atoms to aid the clashing calculation -
C ?? test how much time will this save (from ctr option to brick or not).

	IF (brick_atoms) THEN
	  CALL brick_em
	END IF

	IF (incl_expt) WRITE (3,2600)

C This is where we come back to with heavier under-relaxation if required.

120	conv_problem	= .FALSE.

C For each value of the relaxation of vdw clashing parameter, cycle through
C prob array updating, until all rots at zero prob. residue is found (skip
C to relaxation) or convergence.  Initialise probs for each dec loop.
C If till_expt (and incl_expt) then we will keep VdW relaxing until all
C experimental rotamers are allowed.
C If (alternatively) till_value, we will keep VdW relaxing until all we get
C to a specific value - if we have not converged at this point, *NOW* force
C convergence by assigning p=1 for exptal rots for recalcitrant aa scs.

	IF (collect_clash) THEN
	  found_clash 	= .FALSE.
	  n_store	= 0
	END IF
	WRITE (3,2200) num_residues
	DO 600 i_dec		= 1, 100
	  vdw_relax		= vdw_dec*FLOAT(i_dec-1)
	  WRITE (3,2220) i_dec, vdw_relax

	  force_conv		= .FALSE.
	  IF (till_value) THEN
	    IF (ABS(vdw_relax-rel_value) .LE. 0.01) THEN
	      force_conv	= .TRUE.
	    END IF
	  END IF

	  un_converged		= .TRUE.
	  num_iter		= 0
	  DO 200 ir		= 1, num_residues
	    IF (res_rots_ind (ir,1) .NE. -999) THEN
	      IF (incl_expt) THEN
		nrots		= 1 + res_rots_ind (ir,1)
	      ELSE
		nrots		=     res_rots_ind (ir,1)
	      END IF
	      IF ((nrots.GE.1).AND.(nrots.LE.50)) THEN
		DO 180 irot	= 1, nrots
		  p_old (ir,irot) = 1. / FLOAT (nrots)
180		CONTINUE					! End irot
	      ELSE
		STOP 'n_here/rots'
	      END IF
	    END IF
200	  CONTINUE						! End ir

	  DO WHILE (un_converged)

	    num_iter		= num_iter + 1
	    n_osc		= 0
	    IF (force_conv) num_forced	= 0
	    DO 500 ir		= 1, num_residues
	      IF (res_rots_ind (ir,1) .NE. -999) THEN
		IF (incl_expt) THEN
		  nrots		= 1 + res_rots_ind (ir,1)
		ELSE
		  nrots		=     res_rots_ind (ir,1)
		END IF
		past_fix_here	= .FALSE.
		DO 400 irot	= 1, nrots
		  nats		= res_rots_ind (ir,2)
		  im1		= res_rots_ind (ir,3) + nats*(irot-1)
		  im2		= im1 + nats - 1
		  IF (irot .EQ. nrots) THEN
		    IF (im2 .NE. res_rots_ind (ir,4)) STOP 'im2.ne.4'
		  ELSE
		    IF (im2 .GE. res_rots_ind (ir,4)) STOP 'im2.ge.4'
		  END IF

		  DO 300 im	= im1, im2
		    ia		= im - im1 + 1
		    DO 230 n	= 1, 3
		      xyz1 (ia,n) = moved (im,n)
230		    CONTINUE					! End n
		    rad1 (ia)	= moved (im,4)
		    rank (ia)	= moved_ind (im,3)
300		  CONTINUE					! End im

		  CALL	vs_fixed (ir,xyz1,rad1,rank,nats, clashed)
		  IF (clashed) THEN
		    p_new (ir,irot)	= 0.
		  ELSE
		    past_fix_here	= .TRUE.
		    pmult		= 1.
		    CALL vs_moved (ir,xyz1,rad1,nats, strike_out)
		    DO 340 jr		= 1, num_residues
		      IF (jr .EQ. ir) GOTO 340
		      IF (incl_expt) THEN
			mrots		= 1 + res_rots_ind (jr,1)
		      ELSE
			mrots		=     res_rots_ind (jr,1)
		      END IF
		      IF (res_rots_ind (jr,1) .NE. -999) THEN
			psum		= 0.
			DO 320 jrot	= 1, mrots
			  IF (.NOT. strike_out (jr,jrot)) THEN
			    psum	= psum + p_old (jr,jrot)
			  END IF
320			CONTINUE				! End jrot
			pmult		= pmult*psum
		      END IF
340		    CONTINUE					! End jr
		    p_new (ir,irot)	= pmult
		  END IF
400		CONTINUE					! End irot

		psum_ir			= 0.
		DO 440 irot		= 1, nrots
		  psum_ir		= psum_ir+p_new (ir,irot)
440		CONTINUE					! End irot
		IF (psum_ir .EQ. 0.) THEN
C adjust with p=1 for exptal rotamer (assumed last rot in set)
		  IF (force_conv) THEN
		    p_new (ir,nrots)	= 1.0
		    psum_ir		= 1.0
		    num_forced		= num_forced + 1
		  ELSE IF (.NOT.collect_clash) THEN
		    GOTO 600
		  ELSE
		    found_clash		= .TRUE.
		    n_store		= n_store + 1
		    IF (n_store .LE. 10) THEN
C ?? store -ve for clash moving/fix and +ve for moving/moving
		      IF (past_fix_here) THEN
			clash_store (n_store) =  ir
		      ELSE
			clash_store (n_store) = -ir
		      END IF
		    END IF
		    DO 450 irot		= 1, nrots
		      p_new (ir,irot)	= 0.
450		    CONTINUE					! End irot
		  END IF
		ELSE
		  DO 460 irot		= 1, nrots
		    p_new (ir,irot)	= p_new (ir,irot) / psum_ir
460		  CONTINUE					! End irot
		END IF

	      END IF						! EndIf rots+
500	    CONTINUE						! End ir

C We may be here with a clash, if collecting info. on numbers clashing.
C Above a certain vdw_relax level (1 A say), when we get to less than
C 10 clashed ir's, write out these rotamers - we shouldn't be here.

	    IF (collect_clash) THEN
	      IF (found_clash) THEN
		IF (n_store .LE. 10) THEN
		  WRITE (3,2510) (clash_store(ist),ist=1,n_store)
		  IF (write_once) THEN
		    IF (vdw_relax .GE. 1.0) THEN
		      OPEN (UNIT=1,NAME='sc_nasties.pdb',TYPE='NEW')
		      WRITE (1,2360)
		      DO 530 i_store	= 1, n_store
			irh		= clash_store (i_store)
			imh1		= res_rots_ind (irh,3)
			imh2		= res_rots_ind (irh,4)
			DO 520 imh	= imh1, imh2
			  nresh		= irh
			  WRITE (1,2380) nresh,(moved(imh,n),n=1,3)
520			CONTINUE				! End imh
530		      CONTINUE					! End i_store
		      CLOSE (UNIT=1)
		      write_once	= .FALSE.
		    END IF
		  END IF
		ELSE
		  WRITE (3,2530) n_store
		END IF
		n_store		= 0
		found_clash	= .FALSE.
		GOTO 600
	      END IF
	    END IF

C Only update p_old after a complete pass - and check on convergence.
C And if till_expt is set, then we will not allow convergence until all exptal
C rotamers are allowed - ??check this??
C And if till_value is set, force convergence (if required) at rel_value.

	    sum_sq		= 0.
	    sum_num		= 0.
	    IF (till_expt) THEN
	      iam_undone	= .FALSE.
	      DO 550 iu		= 1, 10
		undone (iu)	= 0
550	      CONTINUE						! End num_undn
	      num_undone	= 0
	    END IF
	    DO 560 ir		= 1, num_residues
	      IF (res_rots_ind (ir,1) .NE. -999) THEN
		IF (incl_expt) THEN
		  nrots		= 1 + res_rots_ind (ir,1)
		ELSE
		  nrots		=     res_rots_ind (ir,1)
		END IF

C This is the till_expt check on this residue , with eventual rerouting (after
C all residues) to next vdw_dec if not done.

		IF (till_expt) THEN
		  IF (p_new (ir,nrots) .LT. 0.0001) THEN
		    num_undone = num_undone + 1
		    IF (num_undone .LE. 10) undone (num_undone) = ir
		    iam_undone = .TRUE.
		  END IF
		END IF

		DO 540 irot	= 1, nrots
		  p_new (ir,irot) = frac_new*p_new (ir,irot) +
     1				    (1.-frac_new)*p_old(ir,irot)
		  pinc		= p_new(ir,irot)-p_old(ir,irot)
C ??
		  IF (num_iter .EQ. 1) pinc_hold (ir,irot) = pinc
		  IF (num_iter .GT. 1) THEN
		    IF ((pinc*pinc_hold(ir,irot)).LT.0.) THEN
		      abs_now		= ABS (pinc)
		      abs_then		= ABS (pinc_hold(ir,irot))
		      frac		= abs_now/abs_then
		      IF ((frac.GT.0.8).AND.(frac.LT.1.2)) THEN
			n_osc		= n_osc + 1
C ??			IF (num_iter .GT. 20) THEN
C ?? - smooth it above 20 iterations - how?
C ??			END IF
		      END IF
		    END IF
		    pinc_hold (ir,irot) = pinc
		  END IF
C ??
		  sum_sq	= sum_sq + pinc*pinc
		  sum_num	= sum_num + 1.
		  p_old (ir,irot) = p_new (ir,irot)
540		CONTINUE					! End irot
	      END IF

C This is the final (re-routing) check on exptal rotamer inclusion, or
C reaching the required vdw value.

	      IF (ir .EQ. num_residues) THEN

		IF (till_expt) THEN
		  IF (iam_undone) THEN
		    WRITE (3,2700) vdw_relax
		    IF (num_undone .LE. 10) THEN
		      WRITE (3,2720) (undone(iu),iu=1,num_undone)
		    ELSE
		      WRITE (3,2740)
		    END IF
		    GOTO 600
		  END IF
		END IF

		IF (till_value) THEN
		  IF (.NOT. force_conv) THEN
		    WRITE (3,2810) vdw_relax, rel_value
		    GOTO 600
		  END IF
		END IF

	      END IF

560	    CONTINUE						! End ir
	    rmsd_here	= SQRT (sum_sq/sum_num)
	    WRITE (3,2300) num_iter, rmsd_here, n_osc
	    IF (rmsd_here .LT. conv_frac) GOTO 700

C Oct 02 / Jan 03 - try our best with non-converging runs (alter relaxn).

	    IF (num_iter .GT. 100) THEN
	      frac_new	= frac_new - 0.2
	      IF (frac_new .LE. 0.) THEN
		STOP 'Cannot get convergence down to 0. under-relax'
	      ELSE
		WRITE (3,2900) frac_new+0.2, frac_new
		GOTO 120
	      END IF
	    END IF

	  END DO

600	CONTINUE						! End i_dec

700	WRITE (3,2400) num_iter, rmsd_here, conv_frac
	IF (force_conv) THEN
	  WRITE (3,2430) vdw_relax
	  WRITE (3,2440) num_forced
	ELSE
	  WRITE (3,2420) vdw_relax
	END IF
	RETURN
	END


	SUBROUTINE	brick_em
C	**********	********

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyz_lims (3,2), range (3), xyz (3)

	REAL		bg (3,2)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	INTEGER		tally (50,50,50)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved

2500	FORMAT (/,' Bricking atoms, with bricks of ',F6.2,' A',/)
2520	FORMAT (' On ',A1,' low, high, top index = ',2F6.1,2X,I2)

C Get the molecule limits and the max assigned VdW radius.

	DO 160 n		= 1, 3
	  xyz_lims (n,1)	=  1.E20
	  xyz_lims (n,2)	= -1.E20
160	CONTINUE						! End n
	vdw_max_fixed		= 0.
	vdw_max_moved		= 0.

	DO 180 if		= 1, n_fixed
	  DO 170 n		= 1, 3
	    IF (fixed (if,n) .LT. xyz_lims (n,1)) THEN
	      xyz_lims (n,1)	= fixed (if,n)
	    END IF
	    IF (fixed (if,n) .GT. xyz_lims (n,2)) THEN
	      xyz_lims (n,2)	= fixed (if,n)
	    END IF
170	  CONTINUE						! End n
	  IF (fixed (if,4) .GT. vdw_max_fixed) THEN
	    vdw_max_fixed	= fixed (if,4)
	  END IF
180	CONTINUE						! End if
	DO 200 im		= 1, n_moved
	  DO 190 n		= 1, 3
	    IF (moved (im,n) .LT. xyz_lims (n,1)) THEN
	      xyz_lims (n,1)	= moved (im,n)
	    END IF
	    IF (moved (im,n) .GT. xyz_lims (n,2)) THEN
	      xyz_lims (n,2)	= moved (im,n)
	    END IF
190	  CONTINUE						! End n
	  IF (moved (im,4) .GT. vdw_max_moved) THEN
	    vdw_max_moved	= moved (im,4)
	  END IF
200	CONTINUE						! End im

C Work out a bricking array of 50 points in the longest direction.  Use
C a uniform step on x,y,z to ease distance screening with bricks.
C Store grid boundaries, grid dims, grid step: bg(3,2), bn(3), step.
C Actually each brick stores atoms 'above' lowest corner - last brk not used??

	biggest			= 0.
	DO 220 n		= 1, 3
	  range (n)		= xyz_lims (n,2) - xyz_lims (n,1)
	  IF (range (n) .GT. biggest) THEN
	    biggest		= range (n)
	    n_biggest		= n
	  END IF
220	CONTINUE						! End n
	step			= (biggest+0.2)/49.
	DO 230 n		= 1, 3
	  bg (n,1)		= xyz_lims (n,1) - 0.1
	  IF (n .EQ. n_biggest) THEN
	    bn (n)		= 50
	  ELSE
	    bn (n)		= 2 + INT ((range(n)+0.2)/step)
	    IF      (bn (n) .GT. 51) THEN
	      STOP 'bn/51'
	    ELSE IF (bn (n) .GT. 50) THEN
	      bn (n)		= 50
	    END IF
C??	    IF (bn (n) .GT. 50) STOP 'bn/50'
	  END IF
	  bg (n,2)		= bg (n,1) + step*FLOAT(bn(n)-1)
230	CONTINUE						! End n

C Brick atoms with brk_ind pointing to first and last positions in the
C linear brk array for brick (ijk).  In brk, negative indices point to
C atom location in fixed array, positive indices to atom in moved array.
C In set-up, we do 2 passes through atoms - count and then store.

	DO 250 k		= 1, bn (3)
	  DO 250 j		= 1, bn (2)
	    DO 250 i		= 1, bn (1)
	      brk_ind (i,j,k,2)	= 0
	      tally (i,j,k)	= 0
250	CONTINUE						! End i,j,k

	DO 500 i_pass		= 1, 2

	  IF (i_pass .EQ. 2) THEN
	    ib_tot		= 0
	  END IF

	  DO 300 if		= 1, n_fixed
	    DO 270 n		= 1, 3
	      xyz (n)		= fixed (if,n)
270	    CONTINUE						! End n
	    CALL	which_brk (xyz, i,j,k)
	    IF (i_pass .EQ. 1) THEN
	      brk_ind (i,j,k,2)	= brk_ind (i,j,k,2) + 1
	    ELSE
	      tally (i,j,k)	= tally (i,j,k) + 1
	      ib_tot		= ib_tot + 1
	      ib		= brk_ind(i,j,k,1)+tally(i,j,k)-1
	      brk (ib)		= -if
	    END IF
300	  CONTINUE						! End if
	  DO 400 im		= 1, n_moved
	    DO 320 n		= 1, 3
	      xyz (n)		= moved (im,n)
320	    CONTINUE						! End n
	    CALL	which_brk (xyz, i,j,k)
	    IF (i_pass .EQ. 1) THEN
	      brk_ind (i,j,k,2)	= brk_ind (i,j,k,2) + 1
	    ELSE
	      tally (i,j,k)	= tally (i,j,k) + 1
	      ib_tot		= ib_tot + 1
	      ib		= brk_ind(i,j,k,1)+tally(i,j,k)-1
	      brk (ib)		=  im
	    END IF
400	  CONTINUE						! End im
	  IF (i_pass .EQ. 1) THEN
	    n_sofar		= 0
	    DO 440 k		= 1, bn (3)
	      DO 440 j		= 1, bn (2)
		DO 440 i	= 1, bn (1)
		  IF (brk_ind (i,j,k,2) .NE. 0) THEN
		    brk_ind (i,j,k,1) = n_sofar + 1
		    n_here	= brk_ind (i,j,k,2)
		    brk_ind (i,j,k,2) = brk_ind (i,j,k,1) + n_here-1
		    n_sofar	= n_sofar + n_here
		  ELSE
		    brk_ind (i,j,k,1) = 0
		  END IF
440	    CONTINUE						! End i,j,k
	    IF (n_sofar .NE. (n_fixed+n_moved)) STOP 'n_sofar'
	  ELSE
	    IF (ib_tot .NE. (n_fixed+n_moved)) STOP 'ib'
	    DO 460 k		= 1, bn (3)
	      DO 460 j		= 1, bn (2)
		DO 460 i	= 1, bn (1)
		  indh1		= brk_ind (i,j,k,1)
		  indh2		= brk_ind (i,j,k,2)
		  IF ((indh1.EQ.0) .AND. (indh2.EQ.0)) THEN
		    n_here	= 0
		  ELSE
		    n_here	= indh2 - indh1 + 1
		  END IF
		  IF (n_here .NE. tally (i,j,k)) STOP 'tally'
460	    CONTINUE						! End i,j,k
	  END IF
500	CONTINUE						! End i_pass

C Write out some bricking info.

	WRITE (3,2500) step
	WRITE (3,2520) 'x', bg(1,1),bg(1,2), bn (1)
	WRITE (3,2520) 'y', bg(2,1),bg(2,2), bn (2)
	WRITE (3,2520) 'z', bg(3,1),bg(3,2), bn (3)

	RETURN
	END


	SUBROUTINE	which_brk (xyz, i,j,k)
C	**********	*********

C atom with coordinates xyz is stored in which brick (i,j,k) ?

	REAL		bg (3,2), xyz (3)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	INTEGER		ijk (3)

	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved

	DO 200 n	= 1, 3
	  dist		= xyz (n) - bg (n,1)
	  ijk (n)	= 1 + INT (dist/step)
	  IF ((ijk(n).LT.1).OR.(ijk(n).GT.bn(n))) STOP 'ijk oub'
200	CONTINUE						! End n
	i		= ijk (1)
	j		= ijk (2)
	k		= ijk (3)

	RETURN
	END


	SUBROUTINE	vs_fixed (ir,xyz1,rad1,rank,nats, clashed)
C	**********	********

C Test this rotamer against fixed atoms.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyz1 (15,3), rad1 (15), xyza (3), xyzb (3)
	LOGICAL		clashed
	INTEGER		brk_rad, ijk (3), brk_srch (3,2)
	REAL		bg (3,2)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	LOGICAL		brick_atoms, collect_clash
	INTEGER*2	rank (15)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved

	clashed		= .FALSE.

	DO 500 ia	= 1, nats
	  DO 200 n	= 1, 3
	    xyza (n)	= xyz1 (ia,n)
200	  CONTINUE						! End n
	  rada	= rad1 (ia)

	  IF (brick_atoms) THEN

	    CALL	which_brk (xyza, i,j,k)
	    ijk (1)	= i
	    ijk (2)	= j
	    ijk (3)	= k
	    brk_rad	= 1 + INT ((rada+vdw_max_fixed)/step)
	    DO 220 n		= 1, 3
	      brk_srch (n,1)	= ijk (n) - brk_rad
	      IF (brk_srch (n,1).LT.1) brk_srch (n,1) = 1
	      brk_srch (n,2)	= ijk (n) + brk_rad
	      IF (brk_srch(n,2) .GT. bn(n)) brk_srch (n,2) = bn (n)
220	    CONTINUE						! End n
	    DO 400 k		= brk_srch (3,1), brk_srch (3,2)
	      DO 400 j		= brk_srch (2,1), brk_srch (2,2)
	        DO 400 i	= brk_srch (1,1), brk_srch (1,2)
		  ib1		= brk_ind (i,j,k,1)
		  ib2		= brk_ind (i,j,k,2)
		  IF (ib1.NE.0 .AND. ib2.NE.0) THEN
		    DO 300 ib	= ib1, ib2
C In brk, -ve indices point to locn in fixed, +ve indices point to moved.
		      IF (brk (ib) .LT. 0) THEN

C ?? Check for fixed dist mates (same ir) in the fixed array - the tuffery
C ?? set avoids its own mc - just leave in clashes with the mc O.

			IF (fixed_ind (-brk(ib),1) .EQ. ir) THEN
			  IF      (fixed_ind(-brk(ib),2).EQ.-1) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).EQ.-2) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).EQ.-3) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).NE. 0) THEN
			    STOP 'fixed_ind.ne.0'
			  END IF
			END IF

		        DO 260 n = 1, 3
			  xyzb (n) = fixed (-brk(ib),n)
260		        CONTINUE				! End n
		        radb	= fixed (-brk(ib),4)
		        dist	= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )
		        dist_test = rada + radb - vdw_relax
		        IF (dist .LT. dist_test) THEN
			  clashed	= .TRUE.
			  RETURN
		        END IF					! EndIf clash
		      END IF					! EndIf fixed
300		    CONTINUE					! End ib
		  END IF
400	    CONTINUE						! End i,j,k

	  ELSE

	    DO 460 ifh		= 1, n_fixed

C ?? Check for fixed dist mates (same ir) in the fixed array - the tuffery
C ?? set avoids its own mc - just leave in clashes with the mc O.

	      IF (fixed_ind (ifh,1) .EQ. ir) THEN
		IF      (fixed_ind(ifh,2).EQ.-1) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).EQ.-2) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).EQ.-3) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).NE. 0) THEN
		  STOP 'fixed_ind.ne.0'
		END IF
	      END IF

	      DO 440 n		= 1, 3
		xyzb (n)	= fixed (ifh,n)
440	      CONTINUE						! End n
	      radb		= fixed (ifh,4)
	      dist		= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )
	      dist_test = rada + radb - vdw_relax
	      IF (dist .LT. dist_test) THEN
		clashed	= .TRUE.
		RETURN
	      END IF						! EndIf clash
460	    CONTINUE						! End ifh

	  END IF						! EndIf brked
500	CONTINUE						! End ia

	RETURN
	END


	SUBROUTINE	vs_moved (ir,xyz1,rad1,nats, strike_out)
C	**********	********

C Test this rotamer against moved atoms (non-ir).  Keep a record of all
C whether each non-ir rotamer has a clash with this ir rotamer - then
C multiply by p_old (jr,jrot) at the finish to give p_new (ir,irot).

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyz1 (15,3), rad1 (15), xyza (3), xyzb (3)
	INTEGER		brk_rad, ijk (3), brk_srch (3,2)
	REAL		bg (3,2)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	LOGICAL		brick_atoms, collect_clash, incl_expt,
     1			till_expt, till_value
	LOGICAL*1	strike_out (10000,50)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value

	DO 180 jr		= 1, num_residues
	  IF (res_rots_ind (jr,1) .NE. -999) THEN
	    IF (incl_expt) THEN
	      mrots		= 1 + res_rots_ind (jr,1)
	    ELSE
	      mrots		=     res_rots_ind (jr,1)
	    END IF
	    DO 170 jrot		= 1, mrots
	      strike_out (jr,jrot) = .FALSE.
170	    CONTINUE						! End jrot
	  END IF
180	CONTINUE						! End jr

	DO 500 ia	= 1, nats
	  DO 200 n	= 1, 3
	    xyza (n)	= xyz1 (ia,n)
200	  CONTINUE						! End n
	  rada		= rad1 (ia)

	  IF (brick_atoms) THEN

	    CALL	which_brk (xyza, i,j,k)
	    ijk (1)	= i
	    ijk (2)	= j
	    ijk (3)	= k
	    brk_rad	= 1 + INT ((rada+vdw_max_moved)/step)
	    DO 220 n		= 1, 3
	      brk_srch (n,1)	= ijk (n) - brk_rad
	      IF (brk_srch (n,1).LT.1) brk_srch (n,1) = 1
	      brk_srch (n,2)	= ijk (n) + brk_rad
	      IF (brk_srch(n,2) .GT. bn(n)) brk_srch (n,2) = bn (n)
220	    CONTINUE						! End n
	    DO 400 k		= brk_srch (3,1), brk_srch (3,2)
	      DO 400 j		= brk_srch (2,1), brk_srch (2,2)
	        DO 400 i	= brk_srch (1,1), brk_srch (1,2)
		  ib1		= brk_ind (i,j,k,1)
		  ib2		= brk_ind (i,j,k,2)
		  IF (ib1.NE.0 .AND. ib2.NE.0) THEN
		    DO 300 ib	= ib1, ib2
C In brk, -ve indices point to locn in fixed, +ve indices point to moved.
		      IF (brk (ib) .GT. 0) THEN
		        imh	= brk (ib)
		        jr	= moved_ind (imh,1)
		        IF (jr .EQ. ir) GOTO 300
		        jrot	= moved_ind (imh,2)
		        IF (strike_out(jr,jrot)) GOTO 300
		        DO 260 n = 1, 3
			  xyzb (n) = moved (imh,n)
260		        CONTINUE				! End n
		        radb	= moved (imh,4)
		        dist	= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )
		        dist_test = rada + radb - vdw_relax
		IF (dist.LT.dist_test) strike_out(jr,jrot) = .TRUE.
		      END IF					! EndIf moved
300		    CONTINUE					! End ib
		  END IF
400	    CONTINUE						! End i,j,k

	  ELSE

	    DO 460 imh		= 1, n_moved
	      jr		= moved_ind (imh,1)
	      IF (jr .EQ. ir) GOTO 460
	      jrot		= moved_ind (imh,2)
	      IF (strike_out(jr,jrot)) GOTO 460
	      DO 440 n		= 1, 3
		xyzb (n)	= moved (imh,n)
440	      CONTINUE						! End n
	      radb		= moved (imh,4)
	      dist		= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )
	      dist_test		= rada + radb - vdw_relax
	      IF (dist.LT.dist_test) strike_out(jr,jrot) = .TRUE.
460	    CONTINUE						! End imh

	  END IF						! EndIf brked

500	CONTINUE						! End ia

	RETURN
	END


	SUBROUTINE	add_water1
C	**********	**********

C Just when you think we'd done, we'll do it again many times over!
C Sorry - but this is in a separate routine for ease of following.
C See at what water radius each atom of each specific group can find a
C rotamer that is not occluded by any other residues.  The routine
C follows the formula of rots_prob, but with addition of a SA mask for
C each atom of interest, that is made in the context of its own residue.
C We apply vdw_relax as derived in absence of water, and further adjust
C the water diameter as required.

	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000)
	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		xyz1 (15,3), rad1 (15), mask_sa
	LOGICAL		brick_atoms, rot_coords, collect_clash
	LOGICAL		un_converged, clashed, found_clash,
     1			write_once, past_fix_here, rot_mask
	LOGICAL*1	strike_out (10000,50)
	INTEGER*2	rank (15)
	CHARACTER*4	gps_res (1000), res
	INTEGER		gps_nres (1000)
	LOGICAL		incl_expt, water_layer, mask_res,
     1			clash_rank, insider, till_expt,
     2			till_value
	CHARACTER*80	file_lyr
	INTEGER		lyr_num (1000), lyr_loc (1000,2),
     1			lyr_ind (1000)
	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)
	REAL		theta (100), phi (100,200), phi_div (100)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200)
	CHARACTER*1	chain, gps_chain (1000)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank
	COMMON	/lyr_gps/	num_gps, gps_res, gps_nres, gps_chain
	COMMON	/lyr_index/	lyr_num, lyr_loc, lyr_ind
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

	DATA	write_once	/ .TRUE. /

2100	FORMAT (A4,1X,A1,I4)
2200	FORMAT (/' Into the water layering routine with
     1 vdw_relax = ',F5.2,' and mask_res SET')
2205	FORMAT (/'*** A self-consistent water diameter decrementing
     1 calculation, until convergence ***')
2210	FORMAT (/,20X,'****************************************',/
     1		  20X,'What a complete mess/CHECK ALL MASK CODE',/
     2		  20X,'Like that ad-hoc cone biting- th_min/max',/
     3		  20X,'****************************************')
2212	FORMAT (  20X,'Not forgetting QUADRATIC ROOT PREC PROBS',/
     1		  20X,'****************************************',/
     2		  20X,'REMEMBER - COMPARE TO NON-MASK CALCULNS ',/
     3		  20X,'****************************************')
2220	FORMAT (/' Into the water layering routine with
     1 vdw_relax = ',F5.2,' and mask_res UNSET')
2300	FORMAT (/,'We have ',I4,2X,I4,' Gps/Atoms to go through',/)
2340	FORMAT('  ir    res  nres atom atyp d_wat/conv mask_sa/expt',/)
2360	FORMAT (1X,I4,3X,A4,1X,I4,3X,I1,2X,A4,3X,F5.2,5X,F5.2)
2370	FORMAT (1X,I4,3X,A4,1X,I4,3X,I1,2X,A4,3X,F5.2)
2500	FORMAT (' **** We would like inside_count at *ZERO*
     1 rather than ',I4)

C (Atoms will already be bricked, or not)/(We won't collect clash res info)
C ?? Read in the groups to be studied - use an ad-hoc expansion to atoms ??

	OPEN (UNIT=1, NAME=file_lyr, TYPE='OLD')
	READ (1,*)
	READ (1,*) num_gps
	IF (num_gps .GT. 1000) STOP 'num_gps.gt.1000'
	n_lyr_ats		= 0
	IF (rot_mask) ig_mask	= 0
	DO 160 ig		= 1, num_gps
	  READ (1,2100) gps_res (ig), gps_chain (ig), gps_nres (ig)
	  DO 140 ir		= 1, num_residues
	    i1			= residue (ir,1)
	    res			= ats_res (i1)
	    nres		= ats_nres (i1)
	    chain		= ats_chain (i1)
	    IF ((res.EQ.gps_res(ig)).AND.(nres.EQ.gps_nres(ig))
     1     .AND.(chain.EQ.gps_chain(ig))) THEN
	      IF (res_rots_ind(ir,1).EQ.-999) STOP 'ig gp has no rots'
	      lyr_ind (ig)	= ir
	      IF (rot_mask) THEN
		IF (nres.EQ.nres_coords) ig_mask = ig
	      END IF
	      IF      (res .EQ. 'ASP ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 2
		lyr_loc (ig,2)	= 3
	      ELSE IF (res .EQ. 'GLU ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 3
		lyr_loc (ig,2)	= 4
	      ELSE IF (res .EQ. 'CYS ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 1
	      ELSE IF (res .EQ. 'HIS ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 2
		lyr_loc (ig,2)	= 5
	      ELSE IF (res .EQ. 'ARG ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 5
		lyr_loc (ig,2)	= 6
	      ELSE IF (res .EQ. 'LYS ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 4
	      ELSE IF (res .EQ. 'TYR ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 7
	      ELSE
		STOP 'ig gp not recognised'
	      END IF
	      n_lyr_ats		= n_lyr_ats + lyr_num (ig)
	      GOTO 160
	    END IF
140	  CONTINUE						! End ir
	  STOP 'ig gp not found'
160	CONTINUE						! End ig
	CLOSE (UNIT=1)
	IF ((rot_mask).AND.(ig_mask.EQ.0)) STOP 'ig_mask.eq.0'
	IF (mask_res) THEN
	  WRITE (3,2200) vdw_relax
	  WRITE (3,2205)
	  WRITE (3,2210)
	  WRITE (3,2212)
	ELSE
	  WRITE (3,2220) vdw_relax
	END IF
	WRITE (3,2300) num_gps, n_lyr_ats
	WRITE (3,2340)

C Now loop over the specified groups and their atoms, with complete prob
C calculations each time, and an SA 'masked' analysis on specified atoms.
C Leave out the collect_clash option for water layering.
C vdw_relax has been fixed from non-layering - now we dec on water diameter.
C And we initialise probabilities on each new dec cycle.

	DO 700 ig		= 1, num_gps
	  ir_ig			= lyr_ind (ig)
	  DO 680 ig_loc		= 1, lyr_num (ig)
	    ia_ig		= lyr_loc (ig,ig_loc)

	  DO 600 i_dec_wat	= 1, 100
	    wat_relax		= vdw_dec*FLOAT(i_dec_wat-1)
	    IF ((wat_diam-wat_relax) .LT. 0.) THEN
	      wat_report	= -9.
	      GOTO 640
	    END IF
C Option to make masks for this atom, in the context of each rotamer, for use
C with (this atom)-others and (others)-this atom.  Reset for each wat_relax.
C Also a test option to write out a (cartesian) mask file for first wat_here.
	    IF (mask_res) THEN
	      CALL make_masks (ir_ig, ia_ig, vdw_relax, wat_relax)
	      IF ((incl_expt).AND. (i_dec_wat.EQ.1)) THEN
		irot_sa	= -999
		CALL	get_mask_sa (ir_ig,ia_ig,irot_sa, mask_sa)
	      END IF
	      IF ((rot_mask) .AND. (i_dec_wat.EQ.1)) THEN
		IF ((ig.EQ.ig_mask) .AND. (ig_loc.EQ.1)) THEN
		  rad_inc	= wat_diam/2. - vdw_relax/2.
		  CALL	write_mask (ir_ig,ia_ig,rad_inc,irot_mask)
		END IF
	      END IF
C ?? - bigger - I think this is coded now - check!
	    END IF
	    un_converged	= .TRUE.
	    num_iter		= 0
	    DO 200 ir		= 1, num_residues
	      IF (res_rots_ind (ir,1) .NE. -999) THEN
		IF (incl_expt) THEN
		  nrots		= 1 + res_rots_ind (ir,1)
		ELSE
		  nrots		=     res_rots_ind (ir,1)
		END IF
		IF ((nrots.GE.1).AND.(nrots.LE.50)) THEN
		  DO 180 irot	= 1, nrots
		    p_old (ir,irot) = 1. / FLOAT (nrots)
180		  CONTINUE					! End irot
		ELSE
		  STOP 'n_here/rots'
		END IF
	      END IF
200	    CONTINUE						! End ir

	    DO WHILE (un_converged)
	      num_iter		= num_iter + 1

	      DO 500 ir		= 1, num_residues
		IF (res_rots_ind (ir,1) .NE. -999) THEN
		  IF (incl_expt) THEN
		    nrots	= 1 + res_rots_ind (ir,1)
		  ELSE
		    nrots	=     res_rots_ind (ir,1)
		  END IF
		  past_fix_here	= .FALSE.
		  DO 400 irot	= 1, nrots
		    nats	= res_rots_ind (ir,2)
		    im1		= res_rots_ind (ir,3) + nats*(irot-1)
		    im2		= im1 + nats - 1
		    IF (irot .EQ. nrots) THEN
		      IF (im2.NE.res_rots_ind (ir,4)) STOP 'im2.ne.4'
		    ELSE
		      IF (im2.GE.res_rots_ind (ir,4)) STOP 'im2.ge.4'
		    END IF
		    DO 300 im	= im1, im2
		      ia	= im - im1 + 1
		      DO 230 n	= 1, 3
		        xyz1 (ia,n) = moved (im,n)
230		      CONTINUE					! End n
		      rad1 (ia)	= moved (im,4)
		      rank (ia)	= moved_ind (im,3)
300		    CONTINUE					! End im
		    wat_here		= wat_diam - wat_relax
		    CALL vs_fixedw (ir,xyz1,rad1,rank,nats, clashed,
     1				    wat_here,irot,ir_ig,ia_ig)
		    IF (clashed) THEN
		      p_new (ir,irot)	= 0.
		    ELSE
		      past_fix_here	= .TRUE.
		      pmult		= 1.
C ?? bigger - do we know what's going on in this routine? - check
		      CALL vs_movedw (ir,xyz1,rad1,nats, strike_out,
     1				      wat_here,irot,ir_ig,ia_ig)
		      DO 340 jr		= 1, num_residues
			IF (jr .EQ. ir) GOTO 340
			IF (incl_expt) THEN
			  mrots		= 1 + res_rots_ind (jr,1)
			ELSE
			  mrots		=     res_rots_ind (jr,1)
			END IF
			IF (res_rots_ind (jr,1) .NE. -999) THEN
			  psum		= 0.
			  DO 320 jrot	= 1, mrots
			    IF (.NOT. strike_out (jr,jrot)) THEN
			      psum	= psum + p_old (jr,jrot)
			    END IF
320			  CONTINUE				! End jrot
			  pmult		= pmult*psum
			END IF
340		      CONTINUE					! End jr
		      p_new (ir,irot)	= pmult
		    END IF
400		  CONTINUE					! End irot
		  psum_ir		= 0.
		  DO 440 irot		= 1, nrots
		    psum_ir		= psum_ir+p_new (ir,irot)
440		  CONTINUE					! End irot
		  IF (psum_ir .EQ. 0.) THEN
		    GOTO 600
		  ELSE
		    DO 460 irot		= 1, nrots
		      p_new (ir,irot)	= p_new (ir,irot) / psum_ir
460		    CONTINUE					! End irot
		  END IF
	        END IF						! EndIf rots+
500	      CONTINUE						! End ir
C Update p_old and check on convergence.
	      sum_sq		= 0.
	      sum_num		= 0.
	      DO 560 ir		= 1, num_residues
		IF (res_rots_ind (ir,1) .NE. -999) THEN
		  IF (incl_expt) THEN
		    nrots	= 1 + res_rots_ind (ir,1)
		  ELSE
		    nrots	=     res_rots_ind (ir,1)
		  END IF
		  DO 540 irot	= 1, nrots
		    p_new (ir,irot) = frac_new*p_new (ir,irot) +
     1				    (1.-frac_new)*p_old(ir,irot)
		    pinc	    = p_new(ir,irot)-p_old(ir,irot)
		    sum_sq	= sum_sq + pinc*pinc
		    sum_num	= sum_num + 1.
		    p_old (ir,irot) = p_new (ir,irot)
540		  CONTINUE					! End irot
		END IF
560	      CONTINUE						! End ir
	      rmsd_here	= SQRT (sum_sq/sum_num)
	      IF (rmsd_here .LT. conv_frac) THEN
		wat_report	= wat_diam - wat_relax
		GOTO 640
	      END IF
	    END DO
600	  CONTINUE						! End i_dec
640	  res			= ats_res (residue(ir_ig,1))
	  nres			= ats_nres (residue (ir_ig,1))
C ?? bigger - need to find indr to look up sc_ats (ia_ig) for atyp
	  IF (mask_res.AND.incl_expt) THEN
	    WRITE (3,2360) ir_ig, res, nres, ig_loc, '    ',
     1			   wat_report, mask_sa
	  ELSE
	    WRITE (3,2370) ir_ig, res, nres, ig_loc, '    ',
     1			   wat_report
	  END IF
680	 CONTINUE						! End ig_loc
700	CONTINUE						! End ig

	WRITE (3,2500) inside_count

	RETURN
	END


	SUBROUTINE	make_masks (ir_ig,ia_ig,vdw_relax,wat_relax)
C	**********	**********

C Make solvent accessible (solid angle) masks for the given atom, in each
C rotamer of the given residue.  This should make clash analysis quicker.
C Otherwise for each potential clashing atom, we would need to do an analagous
C calculation on the fly.

	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000)
	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	LOGICAL		incl_expt, water_layer, mask_res,
     1			clash_rank, till_expt, till_value
	CHARACTER*80	file_lyr
	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)
	REAL		xyz1 (3), xyz2 (3)
	LOGICAL		first_go
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank

C Store the current (decremented) water diameter.

	wat_here		= wat_diam - wat_relax
	IF (res_rots_ind (ir_ig,1) .EQ. -999) STOP '-999/make_masks'
	IF (incl_expt) THEN
	  nrots			= 1 + res_rots_ind (ir_ig,1)
	ELSE
	  nrots			=     res_rots_ind (ir_ig,1)
	END IF
	DO 500 irot		= 1, nrots
	  first_go		= .TRUE.
	  nats			= res_rots_ind (ir_ig,2)
	  im1			= res_rots_ind(ir_ig,3)+nats*(irot-1)
	  im2			= im1 + nats - 1
	  IF (irot .EQ. nrots) THEN
	    IF (im2.NE.res_rots_ind (ir_ig,4)) STOP 'im2.ne.4'
	  ELSE
	    IF (im2.GE.res_rots_ind (ir_ig,4)) STOP 'im2.ge.4'
	  END IF
C ?? - bigger - pretty sure that ia and ia_ig 'scales' match up - check
	  im_ia			= im1 + ia_ig - 1
	  DO 210 n		= 1, 3
	    xyz1 (n)		= moved (im_ia,n)
210	  CONTINUE						! End n
	  rad1			= moved (im_ia,4)
	  DO 300 im		= im1, im2
	    ia			= im - im1 + 1
C ?? - bigger - pretty sure that ia and ia_ig 'scales' match up - check
	    IF (ia .NE. ia_ig) THEN
	      DO 220 n		= 1, 3
		xyz2 (n)	= moved (im,n)
220	      CONTINUE						! End n
	      rad2		= moved (im,4)
	      CALL	mask_inc (xyz1,rad1, xyz2,rad2, irot,
     1				  vdw_relax,wat_here, first_go)
	    END IF
300	  CONTINUE						! End im
C ?? We could speed this by making an index file for ir in the fixed array.
	  DO 400 if		= 1, n_fixed
	    ir_if		= fixed_ind (if,1)
	    IF (ir_if .EQ. ir_ig) THEN
	      DO 340 n		= 1, 3
		xyz2 (n)	= fixed (if,n)
340	      CONTINUE						! End n
	      rad2		= fixed (if,4)
	      CALL	mask_inc (xyz1,rad1, xyz2,rad2, irot,
     1				  vdw_relax,wat_here, first_go)
	    END IF
400	  CONTINUE						! End if
500	CONTINUE						! End irot

	RETURN
	END


	SUBROUTINE	mask_inc (xyz1,rad1, xyz2,rad2, irot,
C	**********	********
     1				  vdw_relax,wat_here, first_go)

	REAL		xyz1 (3), xyz2 (3), theta (100),
     1			phi (100,200), phi_div (100),xyz_12 (3)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL		first_go, very_first, mask_set,
     1			wat_clash, clash_count
	LOGICAL*1	mask (50,100,200)

	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask

	DATA	very_first	/ .TRUE. /
C ?? I started at 100 for theta_slots, now reckon that 50 should be ok.
	DATA	theta_slots	/ 50 /

C Increment the mask for this rotamer, taking vdw_relax of rad1+rad2, and
C allowing for a water diameter of wat_here.
C We've done this variable phi stepping on theta before, to get a roughly
C uniform solid angle coverage.  100 th divs about 0.1 A, 50 divs about 0.2 A.

	IF (very_first) THEN
	  theta_div		= 180./(FLOAT(theta_slots)-1.)
	  DO 200 it		= 1, theta_slots
	    theta (it)		= theta_div*(FLOAT(it)-1.)
	    IF      (it .EQ. 1) THEN
	      phi_slots (it)	= 1
	      phi (it,1)	= 0.
	    ELSE IF (it .EQ. theta_slots) THEN
	      phi_slots (it)	= 1
	      phi (it,1)	= 0.
	    ELSE
	      t_rads		= (theta(it)*3.14159)/180.
	      tmp	      = 2.*FLOAT(theta_slots)*SIN (t_rads)
Clnx	      tmp	      = 2.*FLOAT(theta_slots)*SIND(theta(it))
	      phi_slots (it)	= INT (tmp)
	      IF (phi_slots (it) .GT. 200) STOP 'phi/200'
	      IF (phi_slots (it) .GT. 2*theta_slots) STOP 'phi/2*th'
	      IF (phi_slots (it) .LT. 3) phi_slots (it) = 3
	      phi_div (it)	= 360./FLOAT(phi_slots(it))
	      DO 180 ip		= 1, phi_slots (it)
		phi (it,ip)	= phi_div(it)*(FLOAT(ip)-1.)
180	      CONTINUE						! End ip
	    END IF
200	  CONTINUE						! End it
	  very_first		= .FALSE.
	END IF

	IF (first_go) THEN
	  DO 240 it		= 1, theta_slots
	    DO 220 ip		= 1, phi_slots (it)
	      mask (irot,it,ip)	= .FALSE.
220	    CONTINUE						! End ip
240	  CONTINUE						! End it
	  first_go		= .FALSE.
	END IF

C We have a general routine for assessing within range, radial coords, and
C water/probe sphere overlap, based on the subtended cone.

	mask_set		= .TRUE.
	clash_count		= .FALSE.
	CALL	mask_region (xyz1,rad1,xyz2,rad2,vdw_relax,wat_here,
     1			     irot,mask_set,wat_clash,clash_count)

C ?? - bigger - any more here?
	RETURN
	END


	SUBROUTINE	mask_region (xyz1,rad1,xyz2,rad2,vdw_relax,
C	**********	***********
     1				  wat_here,irot,mask_set,wat_clash,
     2				  clash_count)

C Work out mask regions - either set mask or look for overlap in existing mask.
C We have 2 options on looking for overlap - EITHER get out for any clash OR
C increment mask_fix/mask_mov arrays.

	REAL		xyz1 (3), xyz2 (3), theta (100),
     1			phi (100,200), phi_div (100), xyz_12 (3),
     2			r_cen (3), xyz_mid1 (3), xyz_mid2 (3),
     3			xyz_here (3)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL		mask_set, wat_clash, clash_count, insider
	LOGICAL*1	mask (50,100,200)

	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

	DATA	inside_count	/ 0 /

C First see if this atom is within masking range, then get its radial coords,
C then work out the angle subtending the excluded cone, and apply this angle.
C Get the subtended cone angle, with wat_here fitting between the 2 atoms each
C with vdw_relax/2 subtracted from their radii (triangle cosine rule).
C We'll look for one atom in another, and either drop-out this shouldn't be
C (e.g. on mask setting), get out for a clash, or signal a skip in the one-off
C calculation.

	insider			= .FALSE.
	DO 200 n		= 1, 3
	  xyz_12 (n)		= xyz2 (n) - xyz1 (n)
200	CONTINUE						! End n
	dist			= SQRT (xyz_12(1)**2 +
     1					xyz_12(2)**2 +
     2					xyz_12(3)**2 )
	dist_test		= rad1+rad2-vdw_relax + wat_here
	IF (dist .LT. dist_test) THEN
	  CALL	xyz_to_rtp (xyz_12, dist,th_12,ph_12)
	  dist_c		= dist
	  dist_a		= rad2 - vdw_relax/2. + wat_here/2.
	  dist_b		= rad1 - vdw_relax/2. + wat_here/2.

	  test_inside		= ABS (dist_a - dist_b)
	  IF (test_inside .GE. dist_c) THEN
	    IF (mask_set) THEN
	      STOP 'insider/mask_set'
	    ELSE
	      IF (clash_count) THEN
		insider		= .TRUE.
		inside_count	= inside_count + 1
		RETURN
	      ELSE
		wat_clash	= .TRUE.
		inside_count	= inside_count + 1
		RETURN
	      END IF
	    END IF
	  END IF

	  IF ((dist_a+dist_b) .LE. dist_c) STOP 'dists-abc'
	  cos_alpha		= (dist_b**2+dist_c**2-dist_a**2)/
     1				   (2.*dist_b*dist_c)
	  IF (cos_alpha.LT.-1.) THEN
	    IF (cos_alpha.LT.-1.001) THEN
	      STOP 'cos_alp_lt'
	    ELSE
	      cos_alpha		= -1.
	    END IF
	  END IF
	  IF (cos_alpha.GT. 1.) THEN
	    IF (cos_alpha.GT. 1.001) THEN
	      STOP 'cos_alp_gt'
	    ELSE
	      cos_alpha		=  1.
	    END IF
	  END IF
Clnx	  alpha			= ACOSD (cos_alpha)
	  alpha_rads		= ACOS (cos_alpha)
	  alpha			= (alpha_rads*180.)/3.14159
	  th_min		= th_12 - alpha
	  IF (th_min .LT. 0.) THEN
C ?? for all th to +ve th_min, set all phi, look for intersections otherwise.
	    it1			= 2 + INT (-th_min/theta_div)
	    DO 220 ith		= 1, it1-1
	      DO 210 ip		= 1, phi_slots (ith)
		IF (mask_set) THEN
		  mask (irot,ith,ip)	= .TRUE.
		ELSE
		  IF (.NOT. mask (irot,ith,ip)) THEN
		    IF (clash_count) THEN
		      CALL clash_adder (ith,ip)
		    ELSE
		      wat_clash		= .TRUE.
		      RETURN
		    END IF
		  END IF
		END IF
210	      CONTINUE						! End ip
220	    CONTINUE						! End ith
	  ELSE
	    it1			= 2 + INT (th_min/theta_div)
	  END IF
	  th_max		= th_12 + alpha
	  IF (th_max .GT. 180.) THEN
C ?? for all th from 360-th_max, set all phi, look for intersections otherwise.
	    it2			= 1 + INT ((360.-th_max)/theta_div)
	    DO 240 ith		= it2+1, theta_slots
	      IF (ith .GT. theta_slots) STOP 'ith/slots'
	      DO 230 ip		= 1, phi_slots (ith)
		IF (mask_set) THEN
		  mask (irot,ith,ip)	= .TRUE.
		ELSE
		  IF (.NOT. mask (irot,ith,ip)) THEN
		    IF (clash_count) THEN
		      CALL clash_adder (ith,ip)
		    ELSE
		      wat_clash		= .TRUE.
		      RETURN
		    END IF
		  END IF
		END IF
230	      CONTINUE						! End ip
240	    CONTINUE						! End ith
	  ELSE
	    it2			= 1 + INT (th_max/theta_div)
	    IF (it2 .GT. theta_slots) STOP 'it2/theta_slots'
	  END IF
	  IF (it2 .GE. it1) THEN
C For each theta slot, work out phi intersections from dot product.
C A vector describing the cone meets the const theta/z cicrle - get 2(x,y).
	    DO 400 ith		= it1, it2
	      IF ((ith.EQ.1).OR.(ith.EQ.theta_slots)) THEN
		IF (mask_set) THEN
		  mask (irot,ith,1) = .TRUE.
		ELSE
		  IF (.NOT. mask (irot,ith,1)) THEN
		    IF (clash_count) THEN
		      CALL clash_adder (ith,1)
		    ELSE
		      wat_clash	= .TRUE.
		      RETURN
		    END IF
		  END IF
		END IF
	      ELSE
		th_here		= theta (ith)
		DO 260 n	= 1, 3
		  r_cen (n)	= (dist_b/dist_c)*xyz_12 (n)
260		CONTINUE					! End n
		th_here_rads	= (th_here*3.14159)/180.
		z_here		= dist_b*COS (th_here_rads)
Clnx		z_here		= dist_b*COSD(th_here)
C ?? bigger - better check this quadratic stuff!
		Atmp	= (dist_b*dist_b*cos_alpha) -
     1			   z_here*r_cen(3)
		Btmp	= dist_b*dist_b-z_here*z_here

C ?? ad-hoc branch according to whether y_12 is zero (equal x roots if so).
	      IF (r_cen(2) .EQ. 0.) THEN			! equal roots
		x_1	= Atmp/r_cen(1)
		x_2	= x_1
		y_1	= SQRT (Btmp-x_1*x_1)
		y_2	= -y_1
	      ELSE						! solve quad
		aqd	= 1. + (r_cen(1)**2/r_cen(2)**2)
		bqd	= (-2.*Atmp*r_cen(1))/(r_cen(2)**2)
		cqd	= (Atmp**2/r_cen(2)**2) - Btmp
C ?? We'll put in a check to allow for rounding problems (equal quad roots)
C ?? at the theta limits ONLY.
		IF ((bqd**2-4.*aqd*cqd) .LE. 0.) THEN
		  IF (ith .EQ. it1) GOTO 400
		  IF (ith .EQ. it2) GOTO 400
C ?? And if we're still having problems, allow through for x roots very
C ?? close to eachother - otherwise we'll need DBLE precision here.
C ?? Note that we don't know how close x roots would be - just that we are
C ?? running into standard 6-7-8 sig figs SNGL precision problems.
		  test_tmp = SQRT (-(bqd**2-4.*aqd*cqd))/(2.*aqd)
		  IF (ABS(test_tmp) .LE. 0.003) GOTO 400
		  STOP 'complx/not lims'
		END IF
		Ctmp	= SQRT (bqd**2-4.*aqd*cqd)
		x_1	= (-bqd+Ctmp)/(2.*aqd)
		x_2	= (-bqd-Ctmp)/(2.*aqd)
		y_1	= (Atmp-x_1*r_cen(1))/r_cen(2)
		y_2	= (Atmp-x_2*r_cen(1))/r_cen(2)
	      END IF						! EndIf quad

		xyz_here (1) = x_1
		xyz_here (2) = y_1
		xyz_here (3) = z_here
		CALL xyz_to_rtp (xyz_here,dist_b,th_chk,ph_1)
		IF (ABS(th_chk-th_here) .GT. 0.001) STOP 'th mism1'
		xyz_here (1) = x_2
		xyz_here (2) = y_2
		xyz_here (3) = z_here
		CALL xyz_to_rtp (xyz_here,dist_b,th_chk,ph_2)
		IF (ABS(th_chk-th_here) .GT. 0.001) STOP 'th mism2'
C ?? bigger - get right segment of the two by dotting the 2 midpts with
C ?? bigger - with the cone centre vector - take the closer one - check this.
		IF      (ph_1 .LT. ph_2) THEN
		  ph_low	= ph_1
		  ph_top	= ph_2
		ELSE IF (ph_1 .GT. ph_2) THEN
		  ph_low	= ph_2
		  ph_top	= ph_1
		ELSE
		  STOP 'ph_1.eq.ph_2'
		END IF
		ph_mid1	= (ph_1+ph_2)/2.
		IF      ((ph_mid1.GE.  0.).AND.(ph_mid1.LE.180.)) THEN
		  ph_mid2 = ph_mid1 + 180.
		ELSE IF ((ph_mid1.GT.180.).AND.(ph_mid1.LE.360.)) THEN
		  ph_mid2 = ph_mid1 - 180.
		ELSE
		  STOP 'ph_mid1 oub'
		END IF
		CALL	rtp_to_xyz (dist_b,th_here,ph_mid1, xyz_mid1)
		CALL	rtp_to_xyz (dist_b,th_here,ph_mid2, xyz_mid2)
		CALL	dot_prod (xyz_mid1, r_cen, dot_mid1)
		CALL	dot_prod (xyz_mid2, r_cen, dot_mid2)
	  d_mid1 = SQRT(xyz_mid1(1)**2+xyz_mid1(2)**2+xyz_mid1(3)**2)
	  IF (ABS(d_mid1-dist_b).GT.0.001) STOP 'd_mid1'
	  d_mid2 = SQRT(xyz_mid2(1)**2+xyz_mid2(2)**2+xyz_mid2(3)**2)
	  IF (ABS(d_mid2-dist_b).GT.0.001) STOP 'd_mid2'
		tmp_mid1	= dot_mid1/dist_b**2
		IF (tmp_mid1 .GT. 1.001) STOP '.gt. 1.001'
		IF (tmp_mid1 .GT. 1.) tmp_mid1 =  1.
		IF (tmp_mid1 .LT.-1.001) STOP '.lt.-1.001'
		IF (tmp_mid1 .LT.-1.) tmp_mid1 = -1.
Clnx		ang_mid1	= ACOSD (tmp_mid1)
		ang_mid1_rads	= ACOS (tmp_mid1)
		ang_mid1	= (ang_mid1_rads*180.)/3.14159
		tmp_mid2	= dot_mid2/dist_b**2
		IF (tmp_mid2 .GT. 1.001) STOP '.gt. 1.001'
		IF (tmp_mid2 .GT. 1.) tmp_mid2 =  1.
		IF (tmp_mid2 .LT.-1.001) STOP '.lt.-1.001'
		IF (tmp_mid2 .LT.-1.) tmp_mid2 = -1.
Clnx		ang_mid2	= ACOSD (tmp_mid2)
		ang_mid2_rads	= ACOS (tmp_mid2)
		ang_mid2	= (ang_mid2_rads*180.)/3.14159
		IF ((ang_mid1.LT.0.).OR.(ang_mid2.LT.0.)) STOP 'ang'
		IF      (ang_mid1 .LT. ang_mid2) THEN
C ?? make sure we go through ph_mid1 - go from lower to higher phi
		  IF (ABS (ph_low) .LT. 0.001) THEN
		    ip1		= 1
		  ELSE
		    ip1		= 2 + INT (ph_low/phi_div(ith))
		  END IF
		  IF (ph_top .GE. 360.) THEN
		    IF ((ph_top-360.) .GT. 0.01) THEN
		      STOP 'ph_top too big'
		    ELSE
		      ip2	= phi_slots (ith)
		    END IF
		  ELSE
		    ip2		= 1 + INT (ph_top/phi_div(ith))
		  END IF
		  IF (ip2 .GT. phi_slots (ith)) STOP 'ip2 too big'
		  IF (ip2 .GE. ip1) THEN
		    DO 320 ip	= ip1, ip2
		      IF (mask_set) THEN
			mask (irot,ith,ip)	= .TRUE.
		      ELSE
			IF (.NOT. mask (irot,ith,ip)) THEN
			  IF (clash_count) THEN
			    CALL clash_adder (ith,ip)
			  ELSE
			    wat_clash		= .TRUE.
			    RETURN
			  END IF
			END IF
		      END IF
320		    CONTINUE					! End ip
		  END IF
		ELSE IF (ang_mid1 .GT. ang_mid2) THEN
C ?? make sure we go through ph_mid2 - go from higher to lower phi/thro zero
		  ip1		= 2 + INT (ph_top/phi_div(ith))
		  IF (ip1 .LE. phi_slots (ith)) THEN
		    DO 340 ip	= ip1, phi_slots (ith)
		      IF (mask_set) THEN
			mask (irot,ith,ip)	= .TRUE.
		      ELSE
			IF (.NOT. mask (irot,ith,ip)) THEN
			  IF (clash_count) THEN
			    CALL clash_adder (ith,ip)
			  ELSE
			    wat_clash		= .TRUE.
			    RETURN
			  END IF
			END IF
		      END IF
340		    CONTINUE					! End ip
		  END IF
		  ip2		= 1 + INT (ph_low/phi_div(ith))
		  IF (ip2 .GE. 1) THEN
		    DO 360 ip	= 1, ip2
		      IF (mask_set) THEN
			mask (irot,ith,ip)	= .TRUE.
		      ELSE
			IF (.NOT. mask (irot,ith,ip)) THEN
			  IF (clash_count) THEN
			    CALL clash_adder (ith,ip)
			  ELSE
			    wat_clash		= .TRUE.
			    RETURN
			  END IF
			END IF
		      END IF
360		    CONTINUE					! End ip
		  END IF
		ELSE
		  STOP 'ang1.eq.ang2'
		END IF
	      END IF
400	    CONTINUE						! End ith
	  END IF
	END IF

	RETURN
	END


	SUBROUTINE xyz_to_rtp (X,R,TH,PH)
C	********** **********
C
C This routine generates the spherical polar theta,phi ordinates
C corresponding to the cartesian ordinates X, (angles in degrees).
C It is assumed that the radius is already known. R is not
C checked against mag(X) *****
C
	REAL X(3)
C Theta ranges from 0 to 180 degrees, and arccos is single
C valued in this range.
Clnx	TH=ACOSD (X(3)/R)
	th_rads		= ACOS (X(3)/R)
	TH		= (th_rads*180.)/3.14159

C Phi ranges from 0 to 180 degrees, and ATAN is not single
C valued in this range. The ATAN2D routine outputs arctan(a1/a2)
C in the range -180 to +180. The result has the sign of a1.
C Adjust so that for ATAN2 -ve -> + 360 should **** give
C continuity of phi.
Clnx	PH=ATAN2D (X(2),X(1))
	PH_RADS	= ATAN2 (X(2),X(1))
	PH	= (PH_RADS*180.)/3.14159

	IF(PH.LT.0.) PH=PH + 360.
	RETURN
	END


	SUBROUTINE	rtp_to_xyz (r, t_deg, p_deg, xyz)
C	**********	**********

C Routine converts the spherical polar (rtp) set to cartesian (xyz).

	REAL		xyz (3)

Clnx	xyz (1)		= r * SIND (t_deg) * COSD (p_deg)
Clnx	xyz (2)		= r * SIND (t_deg) * SIND (p_deg)
Clnx	xyz (3)		= r * COSD (t_deg)

	t_rads		= (t_deg*3.14159)/180.
	p_rads		= (p_deg*3.14159)/180.
	xyz (1)		= r * SIN (t_rads) * COS (p_rads)
	xyz (2)		= r * SIN (t_rads) * SIN (p_rads)
	xyz (3)		= r * COS (t_rads)

	RETURN
	END


	SUBROUTINE	get_mask_sa (ir_ig,ia_ig,irot_sa, mask_sa)
C	**********	***********

C Get the effective solv access, for this atom in the experimental rotamer.
C We won't get here if incl_expt is not set.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		theta (100), phi (100,200), phi_div (100),
     1			mask_sa
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask

	pts_total		= 0.
	pts_mask		= 0.
	irot_expt		= 1 + res_rots_ind (ir_ig,1)
	DO 300 it		= 1, theta_slots
	  th			= theta (it)
	  DO 260 ip		= 1, phi_slots (it)
	    ph			= phi (it,ip)
	    pts_total		= pts_total + 1.
	    IF (irot_sa .EQ. -999) THEN
	      IF (mask (irot_expt,it,ip)) THEN
		pts_mask	= pts_mask + 1.
	      END IF
	    ELSE
	      IF (mask (irot_sa,it,ip)) THEN
		pts_mask	= pts_mask + 1.
	      END IF
	    END IF
260	  CONTINUE						! End ip
300	CONTINUE						! End it
	mask_sa			= 1. - pts_mask/pts_total

	RETURN
	END


	SUBROUTINE	write_mask (ir_ig,ia_ig,rad_inc,irot_mask)
C	**********	**********

C Convert a mask to cartesian coordinates for testing graphically.
C Coordinates will be written for mask=T for rotamer irot_mask.
C Also find and write the coordinates for all atoms in this rotamer.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		theta (100), phi (100,200), phi_div (100),
     1			xyz (3), xyz_cen (3)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask

1200	FORMAT (' mask coord file (coord=masked) for ir_ig = ',I4)
1300	FORMAT (A4, 9X, A4, A4, A1, I4, 4X, 3F8.3)

	OPEN (UNIT=1, NAME='sc_test1.msk', TYPE='NEW')
	WRITE (1,1200) ir_ig

	ires			= 0
	DO 200 if		= 1, n_fixed
	  ir_if			= fixed_ind (if,1)
	  IF (ir_if .EQ. ir_ig) THEN
	    DO 180 n		= 1, 3
	      xyz (n)		= fixed (if,n)
180	    CONTINUE						! End n
	    ires		= ires + 1
	    WRITE (1,1300) 'ATOM','ALA ','CA  ',' ',ires,xyz
	  END IF
200	CONTINUE						! End if
	DO 240 im		= 1, n_moved
	  im_ig			= moved_ind (im,1)
	  im_irot		= moved_ind (im,2)
	  IF ((im_ig.EQ.ir_ig).AND.(im_irot.EQ.irot_mask)) THEN
	    DO 220 n		= 1, 3
	      xyz (n)		= moved (im,n)
220	    CONTINUE						! End n
	    ires		= ires + 1
	    WRITE (1,1300) 'ATOM','ALA ','CA  ',' ',ires,xyz
C ?? nb we're counting for rotamer 1 only
	    iah			= 1 + im - res_rots_ind (ir_ig,3) -
     1			     (irot_mask-1)*res_rots_ind (ir_ig,2)
	    IF ((iah.LT.1) .OR. (iah.GT.res_rots_ind(ir_ig,2))) THEN
	      STOP 'iah problem'
	    ELSE
	      IF (iah.EQ.ia_ig) THEN
		radh		= moved (im,4)
		DO 230 n	= 1, 3
		  xyz_cen (n)	= xyz (n)
230		CONTINUE					! End n
	      END IF
	    END IF
	  END IF
240	CONTINUE						! End im
	IF (radh .EQ. 0.) STOP 'radh.eq.0'
	rad			= radh + rad_inc

	DO 300 it		= 1, theta_slots
	  th			= theta (it)
	  DO 260 ip		= 1, phi_slots (it)
	    ph			= phi (it,ip)
	    CALL	rtp_to_xyz (rad,th,ph, xyz)
	    DO 250 n		= 1, 3
	      xyz (n)		= xyz (n) + xyz_cen (n)
250	    CONTINUE						! End n
	    IF (mask (irot_mask,it,ip)) THEN
	      ires		= ires + 1
	      WRITE (1,1300) 'ATOM','ALA ','CA  ',' ',ires,xyz
	    END IF
260	  CONTINUE						! End ip
300	CONTINUE						! End it
	CLOSE (UNIT=1)

	RETURN
	END


	SUBROUTINE	prob_out
C	**********	********

C Write the rotamer probabilities then.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		p_fiddle (50)
	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2), which_vdw
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000), chain
	LOGICAL*1	ats_comm (70000)
	CHARACTER*4	res, atyp
	CHARACTER*8	rot_source
	LOGICAL		incl_expt, rot_coords, rot_mask, till_expt,
     1			till_value
	CHARACTER*80	coords_in, file_out, file_prb
	LOGICAL		alt_coords, comp_model, move_bg, alt_here
	CHARACTER*1	alt_chn(7000)
	CHARACTER*4	alt_res(7000)
	INTEGER		alt_nres(7000)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/more_params/	alt_coords, comp_model, move_bg,
     1				n_alt,alt_chn,alt_res,alt_nres
	COMMON	/ctr_stuff/	coords_in, file_out, which_vdw,
     1				rot_source, file_prb
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value

2100	FORMAT (/,' Rotamer probabilities written to sc_freedom.prb
     1 for ',I5,' residues')
2120	FORMAT (/,' Look at this unformatted file with "prb_look"')
2200	FORMAT ('Residue  ',A1,2X,A4,2X,I4,'  has  ',I3,' std rots',
     1 I3,' allowed rots')
2300	FORMAT ('Rotamer  ',I3)
2400	FORMAT ('ATOM', 9X, A4, A4, A1, I4, 4X, 3F8.3)
2500	FORMAT (/,'ROTS INSERT ',I3,2X,A4,A1,I4,/)

C With the incl_expt option we have these arbitrary extra rotamers to get us
C out of a fix.  We will also report plnp and p's for a set rescaled to 1.0
C in the absence of the extra rotamer - although in rescaling we will set all
C to zero if we have less than a sum of 0.0001 without the expt rotamer.

	OPEN (UNIT=1, NAME=file_prb, TYPE='NEW',
     1	      FORM='UNFORMATTED')
	WRITE (1) num_residues, incl_expt
	DO 300 ir	= 1, num_residues
	  i1		= residue (ir,1)
	  res		= ats_res (i1)
	  nres		= ats_nres (i1)
	  chain		= ats_chain (i1)
	  IF (incl_expt) THEN
	    nrots	= 1 + res_rots_ind (ir,1)
	  ELSE
	    nrots	=     res_rots_ind (ir,1)
	  END IF
	  IF (res_rots_ind (ir,1) .EQ. -999) THEN
	    WRITE (1) ir, res, nres, 0, chain
	  ELSE
	    WRITE (1) ir, res, nres, nrots, chain
	    sum_old	= 0.
	    plnp_old	= 0.
	    sum_new	= 0.
	    plnp_new	= 0.
	    DO 280 irot	= 1, nrots
	      p_old (ir,irot) = 1. / FLOAT (nrots)
	      sum_old	= sum_old + p_old (ir,irot)
	      plnp_old = plnp_old+p_old(ir,irot)*LOG(p_old(ir,irot))
	      sum_new	= sum_new + p_new (ir,irot)
	      IF (p_new (ir,irot) .NE. 0.) THEN
	      plnp_new = plnp_new+p_new(ir,irot)*LOG(p_new(ir,irot))
	      END IF
280	    CONTINUE						! End irot
	    IF (incl_expt) THEN
	      sum_here		= sum_new - p_new (ir,nrots)
	      sum_fiddle	= 0.
	      plnp_fiddle	= 0.
	      DO 290 irot	= 1, nrots-1
		IF (sum_here .GT. 0.0001) THEN
		  p_fiddle (irot) = p_new (ir,irot)/sum_here
		  sum_fiddle	= sum_fiddle + p_fiddle (irot)
		  IF (p_fiddle (irot) .NE. 0.) THEN
		    plnp_fiddle	= plnp_fiddle +
     1				p_fiddle(irot)*LOG(p_fiddle(irot))
		  END IF
		ELSE
		  p_fiddle (irot) = 0.
		END IF
290	      CONTINUE						! End irot
	    END IF
	    WRITE (1) 'before', sum_old, plnp_old,
     1		      (p_old (ir,irot), irot=1,nrots)
	    WRITE (1) 'after ', sum_new, plnp_new,
     1		      (p_new (ir,irot), irot=1,nrots)
	    IF (incl_expt) THEN
	      WRITE (1) 'fiddle', sum_fiddle, plnp_fiddle,
     1		      (p_fiddle (irot), irot=1,nrots-1)
	    END IF

C??may05 this is the some rots branch - make sure we have written rots
C??may05 coords (p>0) and the number of P>0 rots, for ease of processing

	  END IF
300	CONTINUE						! End ir
	CLOSE (UNIT=1)
	WRITE (3,2100) num_residues
	WRITE (3,2120)

C ?? hender - update with sum{p.ln(p)} - any more to write out?

C If we're seting up rotamers for some external combo calculation, then
C write them out here.  We'll also write out the coords that are not being
C combo-ed - including the mc of those that are - take this from the
C original coords so that we get everything in, except the combo scs.
C??kwikfit

	IF (alt_coords) THEN
	  OPEN (UNIT=1, NAME='scf_alter_rots.pdb', TYPE='NEW')
	  OPEN (UNIT=2, NAME='scf_alter_fixed.pdb', TYPE='NEW')
	  WRITE (2,*) 'Fixed coordinate frame (alt_coords/sc_freedom)'
	  DO 400 ir		= 1, num_residues
	   i1			= residue (ir,1)
	   i2			= residue (ir,2)
	   res			= ats_res (i1)
	   nres			= ats_nres (i1)
	   chain		= ats_chain (i1)
	   alt_here		= .FALSE.
	   DO 302 i_alt		= 1, n_alt
	    IF ((chain.EQ.alt_chn (i_alt)) .AND.
     1	        (res  .EQ.alt_res (i_alt)) .AND.
     2	        (nres .EQ.alt_nres(i_alt))) THEN
	      alt_here		= .TRUE.
	    END IF
302	   CONTINUE						! End i_alt

304	   CONTINUE
	   IF (alt_here) THEN
	    im1			= res_rots_ind (ir,3)
	    im2			= res_rots_ind (ir,4)
	    IF (incl_expt) THEN
	      nrotsh		= 1 + res_rots_ind (ir,1)
	    ELSE
	      nrotsh		= res_rots_ind (ir,1)
	    END IF
	    natsh		= res_rots_ind (ir,2)
C??	    IF (natsh.NE.(i2-i1+1)) THEN
C??	      WRITE (6,*) 'nres, natsh, i2, i1 = ', nres,natsh,i2,i1
C??	      STOP 'natsh mismatch prob_out'
C??	    END IF
C??	    IF (natsh.NE.(i2-i1+1)) STOP 'natsh mismatch prob_out'
	    nrotso		= 0
	    DO 306 iroth	= 1, nrotsh
	      IF (p_new (ir,iroth) .NE. 0.) nrotso = nrotso+1
306	    CONTINUE
	    IF (nrotso .EQ. 0) STOP 'alt_coords/res with no rots'
	    WRITE (1,2200) chain, res, nres, nrotsh, nrotso
	    DO 310 i_ats	= 1, num_ats
	      IF ((chain .EQ. ats_chain(i_ats)) .AND.
     1		  (res   .EQ. ats_res(i_ats)) .AND.
     2		  (nres  .EQ. ats_nres(i_ats))) THEN
		atyp		= ats_atyp(i_ats)
		IF ((atyp .EQ. 'N   ') .OR.
     1		    (atyp .EQ. 'CA  ') .OR.
     2		    (atyp .EQ. 'C   ') .OR.
     3		    (atyp .EQ. 'O   ') .OR.
     4		    (atyp .EQ. 'CB  ')) THEN
		  WRITE (2,2400) atyp, res, chain, nres,
     1			         (ats_xyz(i_ats,n),n=1,3)
		END IF
	      END IF
310	    CONTINUE						! End i_ats
	      WRITE (2,2500) nrotso, res, chain, nres
	      DO 330 iroth	= 1, nrotsh
	       IF (p_new (ir,iroth) .NE. 0.) THEN
		WRITE (1,2300) iroth
C??		DO 320 iath	= 1, natsh
C??		  ia		= i1 + iath - 1
		DO 320 ia	= i2-natsh+1, i2
		  iath		= ia+natsh-i2
		  atyp		= ats_atyp (ia)
C??		  imh		= im1 + natsh*(iroth-1) + iath-1
		  imh		= im1 + natsh*(iroth-1) + iath-1
		  IF ((imh.LT.im1).OR.(imh.GT.im2)) STOP 'imh oub'
		  WRITE (1,2400) atyp, res, chain, nres,
     1				 (moved (imh,n),n=1,3)
320		CONTINUE					! End iath
	       END IF
330	      CONTINUE						! End iroth
	   ELSE
	    DO 340 i_ats	= 1, num_ats
	      IF ((chain .EQ. ats_chain(i_ats)) .AND.
     1		  (res   .EQ. ats_res(i_ats)) .AND.
     2		  (nres  .EQ. ats_nres(i_ats))) THEN
		WRITE (2,2400) ats_atyp(i_ats), res, chain, nres,
     1			       (ats_xyz(i_ats,n),n=1,3)
	      END IF
340	    CONTINUE						! End i_ats
	   END IF
400	  CONTINUE						! End ir
	  CLOSE (UNIT=1)
	  CLOSE (UNIT=2)
	END IF

	RETURN
	END


	SUBROUTINE	vs_fixedw (ir,xyz1,rad1,rank,nats, clashed,
C	**********	*********
     1				   wat_here,irot,ir_ig,ia_ig)

C Test this rotamer against fixed atoms - water adding version.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyz1 (15,3), rad1 (15), xyza (3), xyzb (3)
	LOGICAL		clashed
	INTEGER		brk_rad, ijk (3), brk_srch (3,2)
	REAL		bg (3,2)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	LOGICAL		brick_atoms, collect_clash, i_mask
	INTEGER*2	rank (15)
	LOGICAL		water_layer, mask_res, wat_clash, mask_set,
     1			clash_rank, clash_count
	CHARACTER*80	file_lyr
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank

C We can do this with (complex) or without (much simpler) a mask.

	clashed		= .FALSE.

	DO 500 ia	= 1, nats
	  i_mask	= .FALSE.
	  IF ((ir.EQ.ir_ig).AND.(ia.EQ.ia_ig)) i_mask = .TRUE.
	  DO 200 n	= 1, 3
	    xyza (n)	= xyz1 (ia,n)
200	  CONTINUE						! End n
	  rada	= rad1 (ia)

	  IF (brick_atoms) THEN

	    CALL	which_brk (xyza, i,j,k)
	    ijk (1)	= i
	    ijk (2)	= j
	    ijk (3)	= k
	    IF (i_mask) THEN
	      brk_rad	= 1+INT ((rada+wat_here+vdw_max_fixed)/step)
	    ELSE
	      brk_rad	= 1 + INT ((rada+vdw_max_fixed)/step)
	    END IF
	    DO 220 n		= 1, 3
	      brk_srch (n,1)	= ijk (n) - brk_rad
	      IF (brk_srch (n,1).LT.1) brk_srch (n,1) = 1
	      brk_srch (n,2)	= ijk (n) + brk_rad
	      IF (brk_srch(n,2) .GT. bn(n)) brk_srch (n,2) = bn (n)
220	    CONTINUE						! End n
	    DO 400 k		= brk_srch (3,1), brk_srch (3,2)
	      DO 400 j		= brk_srch (2,1), brk_srch (2,2)
	        DO 400 i	= brk_srch (1,1), brk_srch (1,2)
		  ib1		= brk_ind (i,j,k,1)
		  ib2		= brk_ind (i,j,k,2)
		  IF (ib1.NE.0 .AND. ib2.NE.0) THEN
		    DO 300 ib	= ib1, ib2
C In brk, -ve indices point to locn in fixed, +ve indices point to moved.
		      IF (brk (ib) .LT. 0) THEN

C ?? Check for fixed dist mates (same ir) in the fixed array - the tuffery
C ?? set avoids its own mc - just leave in clashes with the mc O.

			IF (fixed_ind (-brk(ib),1) .EQ. ir) THEN
			  IF      (fixed_ind(-brk(ib),2).EQ.-1) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).EQ.-2) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).EQ.-3) THEN
			    GOTO 300
			  ELSE IF (fixed_ind(-brk(ib),2).NE. 0) THEN
			    STOP 'fixed_ind.ne.0'
			  END IF
			END IF

		        DO 260 n = 1, 3
			  xyzb (n) = fixed (-brk(ib),n)
260		        CONTINUE				! End n
		        radb	= fixed (-brk(ib),4)
			dist	= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )
			IF (i_mask) THEN
			  IF (mask_res) THEN
			    mask_set		= .FALSE.
			    clash_count		= .FALSE.
			    wat_clash		= .FALSE.
			    CALL mask_region (xyza,rada,xyzb,radb,
     1					       vdw_relax,wat_here,
     2					  irot,mask_set,wat_clash,
     3					  clash_count)
			    IF (wat_clash) THEN
			      clashed	= .TRUE.
			      RETURN
			    END IF
			  ELSE
			    dist_test = rada+radb-vdw_relax+wat_here
			    IF (dist .LT. dist_test) THEN
			      clashed	= .TRUE.
			      RETURN
			    END IF				! EndIf clash
			  END IF
			ELSE
		          dist_test = rada + radb - vdw_relax
		          IF (dist .LT. dist_test) THEN
			    clashed	= .TRUE.
			    RETURN
		          END IF				! EndIf clash
			END IF					! EndIf mask

		      END IF					! EndIf fixed
300		    CONTINUE					! End ib
		  END IF
400	    CONTINUE						! End i,j,k

	  ELSE

	    DO 460 ifh		= 1, n_fixed

C ?? Check for fixed dist mates (same ir) in the fixed array - the tuffery
C ?? set avoids its own mc - just leave in clashes with the mc O.

	      IF (fixed_ind (ifh,1) .EQ. ir) THEN
		IF      (fixed_ind(ifh,2).EQ.-1) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).EQ.-2) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).EQ.-3) THEN
		  GOTO 460
		ELSE IF (fixed_ind(ifh,2).NE. 0) THEN
		  STOP 'fixed_ind.ne.0'
		END IF
	      END IF

	      DO 440 n		= 1, 3
		xyzb (n)	= fixed (ifh,n)
440	      CONTINUE						! End n
	      radb		= fixed (ifh,4)
	      dist		= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )

	      IF (i_mask) THEN
		IF (mask_res) THEN
		  mask_set		= .FALSE.
		  wat_clash		= .FALSE.
		  clash_count		= .FALSE.
		  CALL	mask_region (xyza,rada,xyzb,radb,
     1				     vdw_relax,wat_here,
     2				 irot,mask_set,wat_clash,
     3				 clash_count)
		  IF (wat_clash) THEN
		    clashed	= .TRUE.
		    RETURN
		  END IF
		ELSE
		  dist_test = rada+radb-vdw_relax+wat_here
		  IF (dist .LT. dist_test) THEN
		    clashed	= .TRUE.
		    RETURN
		  END IF					! EndIf clash
		END IF
	      ELSE
		dist_test = rada + radb - vdw_relax
		IF (dist .LT. dist_test) THEN
		  clashed	= .TRUE.
		  RETURN
		END IF						! EndIf clash
	      END IF						! EndIf mask

460	    CONTINUE						! End ifh

	  END IF						! EndIf brked
500	CONTINUE						! End ia

	RETURN
	END


	SUBROUTINE	vs_movedw (ir,xyz1,rad1,nats, strike_out,
C	**********	*********
     1				   wat_here,irot,ir_ig,ia_ig)

C Test this rotamer against moved atoms (non-ir).  Keep a record of all
C whether each non-ir rotamer has a clash with this ir rotamer - then
C multiply by p_old (jr,jrot) at the finish to give p_new (ir,irot).
C - water adding version.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyz1 (15,3), rad1 (15), xyza (3), xyzb (3)
	INTEGER		brk_rad, ijk (3), brk_srch (3,2)
	REAL		bg (3,2)
	INTEGER		bn (3), brk_ind (50,50,50,2),
     1			brk (770000)
	LOGICAL		brick_atoms, collect_clash, incl_expt,
     1			till_expt, till_value
	LOGICAL*1	strike_out (10000,50)
	LOGICAL		water_layer, mask_res, wat_clash, mask_set,
     1			i_mask, j_mask, clash_rank, clash_count
	CHARACTER*80	file_lyr
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/bricks/	bg, bn, brk_ind, brk, step,
     1				vdw_max_fixed, vdw_max_moved
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank

C Do this with or without a mask.  In vs_fixedw we didn't need to look for
C a reciprocal (inner loop) layered atom, since we don't layer fixed atoms.
C In vs_movedw we need to look for either outer or inner loop (i_mask,j_mask).

C ?? bigger - is the strike_out analysis the same with a mask? - CHECK
	DO 180 jr		= 1, num_residues
	  IF (res_rots_ind (jr,1) .NE. -999) THEN
	    IF (incl_expt) THEN
	      mrots		= 1 + res_rots_ind (jr,1)
	    ELSE
	      mrots		=     res_rots_ind (jr,1)
	    END IF
	    DO 170 jrot		= 1, mrots
	      strike_out (jr,jrot) = .FALSE.
170	    CONTINUE						! End jrot
	  END IF
180	CONTINUE						! End jr

	DO 500 ia	= 1, nats
	  i_mask	= .FALSE.
	  IF ((ir.EQ.ir_ig).AND.(ia.EQ.ia_ig)) i_mask = .TRUE.
	  DO 200 n	= 1, 3
	    xyza (n)	= xyz1 (ia,n)
200	  CONTINUE						! End n
	  rada		= rad1 (ia)

	  IF (brick_atoms) THEN

	    CALL	which_brk (xyza, i,j,k)
	    ijk (1)	= i
	    ijk (2)	= j
	    ijk (3)	= k
C ?? We add wat_here whatever - we may pick up the layered atom on inner loop
	    brk_rad	= 1+INT ((rada+wat_here+vdw_max_moved)/step)
	    DO 220 n		= 1, 3
	      brk_srch (n,1)	= ijk (n) - brk_rad
	      IF (brk_srch (n,1).LT.1) brk_srch (n,1) = 1
	      brk_srch (n,2)	= ijk (n) + brk_rad
	      IF (brk_srch(n,2) .GT. bn(n)) brk_srch (n,2) = bn (n)
220	    CONTINUE						! End n
	    DO 400 k		= brk_srch (3,1), brk_srch (3,2)
	      DO 400 j		= brk_srch (2,1), brk_srch (2,2)
	        DO 400 i	= brk_srch (1,1), brk_srch (1,2)
		  ib1		= brk_ind (i,j,k,1)
		  ib2		= brk_ind (i,j,k,2)
		  IF (ib1.NE.0 .AND. ib2.NE.0) THEN
		    DO 300 ib	= ib1, ib2
C In brk, -ve indices point to locn in fixed, +ve indices point to moved.
		      IF (brk (ib) .GT. 0) THEN
		        imh	= brk (ib)
		        jr	= moved_ind (imh,1)
		        IF (jr .EQ. ir) GOTO 300
		        jrot	= moved_ind (imh,2)
		        IF (strike_out(jr,jrot)) GOTO 300
		        DO 260 n = 1, 3
			  xyzb (n) = moved (imh,n)
260		        CONTINUE				! End n
		        radb	= moved (imh,4)
C ?? Check the inner loop atom being our layered friend.
			j_mask	= .FALSE.
			IF (jr.EQ.ir_ig) THEN
			  jah	= 1 + imh - res_rots_ind(jr,3) -
     1				  (jrot-1)*res_rots_ind(jr,2)
			  IF ((jah.LT.1).OR.
     1			      (jah.GT.res_rots_ind(jr,2))) THEN
			    STOP 'jah oub'
			  END IF
			  IF (jah.EQ.ia_ig) THEN
			    j_mask = .TRUE.
			  END IF
			END IF
			dist	= SQRT ( (xyza(1)-xyzb(1))**2 +
     1					 (xyza(2)-xyzb(2))**2 +
     2					 (xyza(3)-xyzb(3))**2 )

			IF      (i_mask) THEN
			  IF (mask_res) THEN
			    mask_set		= .FALSE.
			    wat_clash		= .FALSE.
			    clash_count		= .FALSE.
			    CALL mask_region (xyza,rada,xyzb,radb,
     1					       vdw_relax,wat_here,
     2					  irot,mask_set,wat_clash,
     3					  clash_count)
		IF (wat_clash) strike_out(jr,jrot) = .TRUE.
		GOTO 290
			  ELSE
			    dist_test = rada+radb-vdw_relax+wat_here
			  END IF
			ELSE IF (j_mask) THEN
			  IF (mask_res) THEN
			    mask_set		= .FALSE.
			    wat_clash		= .FALSE.
			    clash_count		= .FALSE.
C ?? bigger - Swap around a,b order sinceb=j=the masked one - check this.
C ?? bigger - And it will be jrot in place of irot in mask array - check.
			    CALL mask_region (xyzb,radb,xyza,rada,
     1					       vdw_relax,wat_here,
     2					  jrot,mask_set,wat_clash,
     3					  clash_count)
		IF (wat_clash) strike_out(jr,jrot) = .TRUE.
		GOTO 290
			  ELSE
			    dist_test = rada+radb-vdw_relax+wat_here
			  END IF
			ELSE
		          dist_test = rada + radb - vdw_relax
			END IF
		IF (dist.LT.dist_test) strike_out(jr,jrot) = .TRUE.

290			CONTINUE				! From masks
		      END IF					! EndIf moved
300		    CONTINUE					! End ib
		  END IF
400	    CONTINUE						! End i,j,k

	  ELSE

	    DO 460 imh		= 1, n_moved
	      jr		= moved_ind (imh,1)
	      IF (jr .EQ. ir) GOTO 460
	      jrot		= moved_ind (imh,2)
	      IF (strike_out(jr,jrot)) GOTO 460
	      DO 440 n		= 1, 3
		xyzb (n)	= moved (imh,n)
440	      CONTINUE						! End n
	      radb		= moved (imh,4)
C ?? Check the inner loop atom being our layered friend.
	      j_mask	= .FALSE.
	      IF (jr.EQ.ir_ig) THEN
		jah	= 1 + imh - res_rots_ind(jr,3) -
     1			  (jrot-1)*res_rots_ind(jr,2)
		IF ((jah.LT.1).OR.
     1		    (jah.GT.res_rots_ind(jr,2))) THEN
		  STOP 'jah oub'
		END IF
		IF (jah.EQ.ia_ig) THEN
		  j_mask = .TRUE.
		END IF
	      END IF
	      dist	= SQRT ( (xyza(1)-xyzb(1))**2 +
     1				 (xyza(2)-xyzb(2))**2 +
     2				 (xyza(3)-xyzb(3))**2 )

	      IF      (i_mask) THEN
		IF (mask_res) THEN
		  mask_set		= .FALSE.
		  wat_clash		= .FALSE.
		  clash_count		= .FALSE.
		  CALL mask_region (xyza,rada,xyzb,radb,
     1				     vdw_relax,wat_here,
     2				irot,mask_set,wat_clash,
     3				clash_count)
		IF (wat_clash) strike_out(jr,jrot) = .TRUE.
		GOTO 450
		ELSE
		  dist_test = rada+radb-vdw_relax+wat_here
		END IF
	      ELSE IF (j_mask) THEN
		IF (mask_res) THEN
		  mask_set		= .FALSE.
		  wat_clash		= .FALSE.
		  clash_count		= .FALSE.
C ?? bigger - Swap around a,b order sinceb=j=the masked one - check this.
C ?? bigger - And it will be jrot in place of irot in mask array - check.
		  CALL mask_region (xyzb,radb,xyza,rada,
     1				     vdw_relax,wat_here,
     2				jrot,mask_set,wat_clash,
     3				clash_count)
		IF (wat_clash) strike_out(jr,jrot) = .TRUE.
		GOTO 450
		ELSE
		  dist_test = rada+radb-vdw_relax+wat_here
		END IF
	      ELSE
		dist_test = rada + radb - vdw_relax
	      END IF
	      IF (dist.LT.dist_test) strike_out(jr,jrot) = .TRUE.

450	      CONTINUE						! From masks
460	    CONTINUE						! End imh

	  END IF						! EndIf brked

500	CONTINUE						! End ia

	RETURN
	END


	SUBROUTINE	add_water2
C	**********	**********

C A repeat of add_water1 I'm afraid, but with a one-off clash ranking,
C rather than self-consistent water diameter decrementing to convergence.

	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000)
	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		mask_sa, xyza (3)
	LOGICAL		brick_atoms, rot_coords, collect_clash
	LOGICAL		write_once, rot_mask
	LOGICAL*1	strike_out (10000,50)
	CHARACTER*4	gps_res (1000), res
	INTEGER		gps_nres (1000)
	LOGICAL		incl_expt, water_layer, mask_res,
     1			clash_rank, insider, till_expt,
     2			till_value
	CHARACTER*80	file_lyr
	INTEGER		lyr_num (1000), lyr_loc (1000,2),
     1			lyr_ind (1000)
	INTEGER		n_sc_ats (20), chi_ats (20,5,4), sc_chi (20)
	CHARACTER*4	sc_ats (20,10), chi_start (20,3)
	INTEGER*2	sc_rank (20,10)
	REAL		theta (100), phi (100,200), phi_div (100)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200)
	CHARACTER*1	chain, gps_chain (1000)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/rot_scs/	n_sc_ats, sc_ats, chi_ats, sc_chi,
     1				chi_start, sc_rank
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/testit/	rot_coords, nres_coords, rot_mask,
     1				irot_mask
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank
	COMMON	/lyr_gps/	num_gps, gps_res, gps_nres, gps_chain
	COMMON	/lyr_index/	lyr_num, lyr_loc, lyr_ind
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

	DATA	write_once	/ .TRUE. /

2100	FORMAT (A4,1X,A1,I4)
2200	FORMAT (/' Into the water layering routine with
     1 vdw_relax = ',F5.2)
2205	FORMAT (/,'*** A one-off calculation of
     1 clashes, from prob arrays without water ***')
2300	FORMAT (/,'We have ',I4,2X,I4,' Gps/Atoms to go through',/)
2500	FORMAT (' *** We would like inside_count at *ZERO*
     1 rather than ',I4)

C Note that mask_res will be set for this routine, and we will not use bricked
C atoms - to ease (ir,irot)-(jr,jrot) analysis in the movedw calcn.
C ?? Read in the groups to be studied - use an ad-hoc expansion to atoms ??

	OPEN (UNIT=1, NAME=file_lyr, TYPE='OLD')
	READ (1,*)
	READ (1,*) num_gps
	IF (num_gps .GT. 1000) STOP 'num_gps.gt.1000'
	n_lyr_ats		= 0
	IF (rot_mask) ig_mask	= 0
	DO 160 ig		= 1, num_gps
	  READ (1,2100) gps_res (ig), gps_chain (ig), gps_nres (ig)
	  DO 140 ir		= 1, num_residues
	    i1			= residue (ir,1)
	    res			= ats_res (i1)
	    nres		= ats_nres (i1)
	    chain		= ats_chain (i1)
	    IF ((res.EQ.gps_res(ig)).AND.(nres.EQ.gps_nres(ig))
     1     .AND.(chain.EQ.gps_chain(ig))) THEN
	      IF (res_rots_ind(ir,1).EQ.-999) STOP 'ig gp has no rots'
	      lyr_ind (ig)	= ir
	      IF (rot_mask) THEN
		IF (nres.EQ.nres_coords) ig_mask = ig
	      END IF
	      IF      (res .EQ. 'ASP ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 2
		lyr_loc (ig,2)	= 3
	      ELSE IF (res .EQ. 'GLU ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 3
		lyr_loc (ig,2)	= 4
	      ELSE IF (res .EQ. 'CYS ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 1
	      ELSE IF (res .EQ. 'HIS ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 2
		lyr_loc (ig,2)	= 5
	      ELSE IF (res .EQ. 'ARG ') THEN
		lyr_num (ig)	= 2
		lyr_loc (ig,1)	= 5
		lyr_loc (ig,2)	= 6
	      ELSE IF (res .EQ. 'LYS ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 4
	      ELSE IF (res .EQ. 'TYR ') THEN
		lyr_num (ig)	= 1
		lyr_loc (ig,1)	= 7
	      ELSE
		STOP 'ig gp not recognised'
	      END IF
	      n_lyr_ats		= n_lyr_ats + lyr_num (ig)
	      GOTO 160
	    END IF
140	  CONTINUE						! End ir
	  STOP 'ig gp not found'
160	CONTINUE						! End ig
	CLOSE (UNIT=1)
	IF ((rot_mask).AND.(ig_mask.EQ.0)) STOP 'ig_mask.eq.0'
	IF (mask_res) THEN
	  WRITE (3,2200) vdw_relax
	  WRITE (3,2205)
	END IF
	WRITE (3,2300) num_gps, n_lyr_ats
C??	WRITE (3,2340)

C Now loop over the specified groups and their atoms, making masks for each
C atom in the context of each rotamer, with a mask o/p test option.
C And without a new prob calcn, we need only look at ir=ir_ig.
C Get mask_sa and expt_sa in the experimental structure.

	DO 700 ig		= 1, num_gps
	  ir_ig			= lyr_ind (ig)
	  DO 680 ig_loc		= 1, lyr_num (ig)
	    ia_ig		= lyr_loc (ig,ig_loc)

	    CALL make_masks (ir_ig, ia_ig, vdw_relax, wat_relax)
	    irot_sa		= -999
	    CALL	get_mask_sa (ir_ig,ia_ig,irot_sa, mask_sa)
	    IF (rot_mask) THEN
	      IF ((ig.EQ.ig_mask) .AND. (ig_loc.EQ.1)) THEN
		rad_inc	= wat_diam/2. - vdw_relax/2.
		CALL	write_mask (ir_ig,ia_ig,rad_inc,irot_mask)
	      END IF
	    END IF

	    ir			= ir_ig
	    IF (res_rots_ind (ir,1) .EQ. -999) STOP '-999/why?'
	    IF (incl_expt) THEN
	      nrots		= 1 + res_rots_ind (ir,1)
	    ELSE
	      nrots		=     res_rots_ind (ir,1)
	    END IF
	    smallest_clash	= 9.
	    irot_smallest	= 0
	    DO 400 irot		= 1, nrots
	      nats		= res_rots_ind (ir,2)
	      im1		= res_rots_ind (ir,3) + nats*(irot-1)
	      im2		= im1 + nats - 1
	      IF (irot .EQ. nrots) THEN
		IF (im2.NE.res_rots_ind (ir,4)) STOP 'im2.ne.4'
	      ELSE
		IF (im2.GE.res_rots_ind (ir,4)) STOP 'im2.ge.4'
	      END IF
	      im		= im1 + ia_ig - 1
	      DO 230 n		= 1, 3
		xyza (n)	= moved (im,n)
230	      CONTINUE						! End n
	      rada		= moved (im,4)

C ?? Get the expt sa decrement to subtract from mask_sa for total expt sa.
	      IF (irot.EQ.nrots) THEN
		IF (.NOT. incl_expt) STOP 'incl_expt/irot'
		CALL	get_expt_sa (ir_ig,irot,xyza,rada, expt_sa)
		expt_sa		= mask_sa - expt_sa
	      END IF

	      IF (p_new (ir,irot) .LT. 0.0001) GOTO 400

	      CALL vs_fixedw2 (irot,xyza,rada)
	      IF (insider) GOTO 400
	      CALL vs_movedw2 (ir_ig,irot,xyza,rada,strike_out,
     1			       smallest_clash, irot_smallest)
400	    CONTINUE						! End irot
	    IF (smallest_clash .EQ. 9.) STOP 'smallest_clash unset'
	    res			= ats_res (residue(ir_ig,1))
	    nres		= ats_nres (residue (ir_ig,1))
	    chain		= ats_chain (residue(ir_ig,1))
	    irot_sa		= irot_smallest
	    CALL	get_mask_sa (ir_ig,ia_ig,irot_sa, small_sa)
	    best_sa		= small_sa - smallest_clash

C Ok we've got the best clash sum, albeit needing combinatorial improvement -
C for now just store this away.

	    CALL	store_layr_gp (res,nres,mask_sa,best_sa,
     1				       ir_ig,ig_loc,expt_sa,
     2				       irot_smallest, chain)

680	  CONTINUE						! End ig_loc
700	CONTINUE						! End ig
	WRITE (3,2500) inside_count

	RETURN
	END


	SUBROUTINE	vs_fixedw2 (irot,xyza,rada)
C	**********	**********

C Test this rotamer against fixed atoms - water adding version without
C bricking, with adding of clash severity, always with mask, and just
C looking at the ia_ig atom of ir=ir_ig - no other dist testing.
C We assume that other dists got passed in the preceeding vdw_relax calcn.
C And since we are masking with this aa anyhow, we won't test for same aa ats.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyza (3), xyzb (3)
	LOGICAL		brick_atoms, collect_clash
	LOGICAL		water_layer, mask_res, wat_clash, mask_set,
     1			clash_rank, clash_count
	CHARACTER*80	file_lyr
	REAL		theta (100), phi (100,200), phi_div (100)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200), mask_fix (100,200),
     1			mask_mov (100,200), mask_jr (100,200),
     2			mask_jrot (100,200)
	LOGICAL		mask_fix_here, insider
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank
	COMMON	/strike_comp/	mask_fix, mask_mov, mask_jr,
     1				mask_jrot, mask_fix_here
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

C Initialise the shell of fixed atom clashes (F = no clash).

	DO 300 it		= 1, theta_slots
	  DO 260 ip		= 1, phi_slots (it)
	    mask_fix (it,ip)	= .FALSE.
260	  CONTINUE						! End ip
300	CONTINUE						! End it

	DO 460 ifh		= 1, n_fixed
	  DO 440 n		= 1, 3
	    xyzb (n)		= fixed (ifh,n)
440	  CONTINUE						! End n
	  radb			= fixed (ifh,4)
	  wat_here		= wat_diam
	  mask_set		= .FALSE.
	  wat_clash		= .FALSE.
	  clash_count		= .TRUE.
	  mask_fix_here		= .TRUE.
	  CALL	mask_region (xyza,rada,xyzb,radb,
     1			     vdw_relax,wat_here,
     2			     irot,mask_set,wat_clash,
     3			     clash_count)
	  IF (insider) RETURN
460	CONTINUE						! End ifh

	RETURN
	END


	SUBROUTINE	vs_movedw2 (ir_ig,irot,xyza,rada,strike_out,
C	**********	**********
     1				    smallest_clash, irot_smallest)

C Just for the water layered atom, using its own aa mask, cycle through
C each allowed (non-ir_ig) jr,jrot recording any clashing on a temp shell
C array, and add the minimum clash for each jr to the overall clash shell,
C (which is the evolving mask_fix array).

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		xyza (3), xyzb (3)
	LOGICAL		brick_atoms, collect_clash, incl_expt,
     1			till_expt, till_value
	LOGICAL*1	strike_out (10000,50)
	LOGICAL		water_layer, mask_res, wat_clash, mask_set,
     1			clash_rank, clash_count
	CHARACTER*80	file_lyr
	REAL		theta (100), phi (100,200), phi_div (100)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200), mask_fix (100,200),
     1			mask_mov (100,200), mask_jr (100,200),
     2			mask_jrot (100,200)
	LOGICAL		mask_fix_here, insider
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank
	COMMON	/strike_comp/	mask_fix, mask_mov, mask_jr,
     1				mask_jrot, mask_fix_here
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

C Skip over jr/jrot rotamers that have come out of the vdw_relax loop with
C zero probability and initialise the temp shell for each allowed rotamer
C (with the shell relating to ia_ig/irot of course).
C After each jr/jrot, store shell if this is least clashing jrot.  After all
C jrots for a jr, increment the overall mask_mov shell with the last clash.
C Positives are encroachment.
C ?? This is all a bit of a mess - maybe we should be into combinatorials here?

	    DO 300 it		= 1, theta_slots
	      DO 260 ip		= 1, phi_slots (it)
		mask_mov (it,ip) = .FALSE.
260	      CONTINUE						! End ip
300	    CONTINUE						! End it

	DO 500 jr		= 1, num_residues
	  IF (jr .EQ. ir_ig) GOTO 500
	  IF (res_rots_ind (jr,1) .EQ. -999) GOTO 500
	  IF (incl_expt) THEN
	    mrots		= 1 + res_rots_ind (jr,1)
	  ELSE
	    mrots		=     res_rots_ind (jr,1)
	  END IF

	    best_jrot		= 0.
	    DO 340 it		= 1, theta_slots
	      DO 320 ip		= 1, phi_slots (it)
		best_jrot	= best_jrot + 1.
		mask_jr (it,ip) = .FALSE.
320	      CONTINUE						! End ip
340	    CONTINUE						! End it

	  DO 480 jrot		= 1, mrots

	    IF (p_new (jr,jrot) .LT. 0.0001) GOTO 480

	    DO 400 it		= 1, theta_slots
	      DO 360 ip		= 1, phi_slots (it)
		mask_jrot (it,ip) = .FALSE.
360	      CONTINUE						! End ip
400	    CONTINUE						! End it

	    DO 460 imh		= 1, n_moved
	      jrh		= moved_ind (imh,1)
	      jroth		= moved_ind (imh,2)
	      IF ((jrh.EQ.jr).AND.(jroth.EQ.jrot)) THEN
		DO 440 n	= 1, 3
		  xyzb (n)	= moved (imh,n)
440		CONTINUE					! End n
		radb		= moved (imh,4)
		wat_here	= wat_diam
		mask_set	= .FALSE.
		wat_clash	= .FALSE.
		clash_count	= .TRUE.
		mask_fix_here	= .FALSE.
		CALL mask_region (xyza,rada,xyzb,radb,
     1				  vdw_relax,wat_here,
     2				  irot,mask_set,wat_clash,
     3				  clash_count)
		IF (insider) GOTO 480
	      END IF						! =jr/jrot
460	    CONTINUE						! End imh

	    this_jrot		= 0.
	    DO 470 it		= 1, theta_slots
	      DO 465 ip		= 1, phi_slots (it)
		IF (mask_jrot(it,ip)) this_jrot	= this_jrot + 1.
465	      CONTINUE						! End ip
470	    CONTINUE						! End it
	    IF (this_jrot .LT. best_jrot) THEN
	      best_jrot		= this_jrot
	      DO 476 it		= 1, theta_slots
		DO 474 ip	= 1, phi_slots (it)
		  mask_jr (it,ip) = mask_jrot (it,ip)
474		CONTINUE					! End ip
476	      CONTINUE						! End it
	    END IF

480	  CONTINUE						! End jrot

	  DO 490 it		= 1, theta_slots
	    DO 488 ip		= 1, phi_slots (it)
	      IF (mask_jr (it,ip)) mask_mov (it,ip) = .TRUE.
488	    CONTINUE						! End ip
490	  CONTINUE						! End it

500	CONTINUE						! End jr

	pts_total		= 0.
	pts_clash		= 0.
	DO 540 it		= 1, theta_slots
	  DO 520 ip		= 1, phi_slots (it)
	    pts_total		= pts_total + 1.
	    IF ((mask_fix(it,ip)).OR.(mask_mov(it,ip))) THEN
	      pts_clash		= pts_clash + 1.
	    END IF
520	  CONTINUE						! End ip
540	CONTINUE						! End it
	clash_here		= pts_clash/pts_total
	IF (clash_here.LT.smallest_clash) THEN
	  smallest_clash	= clash_here
	  irot_smallest		= irot
	END IF

	RETURN
	END


	SUBROUTINE	clash_adder (it,ip)
C	**********	***********

C Add clashes in for our one-off water layering ranking thinguy.

	LOGICAL*1	mask_fix (100,200), mask_mov (100,200),
     1			mask_jr (100,200), mask_jrot (100,200)
	LOGICAL		mask_fix_here

	COMMON	/strike_comp/	mask_fix, mask_mov, mask_jr,
     1				mask_jrot, mask_fix_here

	IF (mask_fix_here) THEN
	  mask_fix (it,ip)	= .TRUE.
	ELSE
	  mask_jrot (it,ip)	= .TRUE.
	END IF

	RETURN
	END


	SUBROUTINE	get_expt_sa (ir_ig,irot,xyza,rada, expt_sa)
C	**********	***********

C No rotamer looping or prob checking - just use the exptal rotamer set.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		xyza (3), xyzb (3)
	LOGICAL		brick_atoms, collect_clash
	LOGICAL		water_layer, mask_res, wat_clash, mask_set,
     1			clash_rank, clash_count
	CHARACTER*80	file_lyr
	REAL		theta (100), phi (100,200), phi_div (100)
	INTEGER		theta_slots, phi_slots (100)
	LOGICAL*1	mask (50,100,200), mask_fix (100,200),
     1			mask_mov (100,200), mask_jr (100,200),
     2			mask_jrot (100,200)
	LOGICAL		mask_fix_here, insider
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/ctr_clash/	brick_atoms, vdw_dec, vdw_relax,
     1				conv_frac, collect_clash
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/water_lyr/	water_layer, file_lyr, wat_diam,
     1				mask_res, clash_rank
	COMMON	/strike_comp/	mask_fix, mask_mov, mask_jr,
     1				mask_jrot, mask_fix_here
	COMMON	/shell/		theta_slots,theta,theta_div,
     1				phi_slots,phi,phi_div, mask
	COMMON	/inside/	insider, inside_count

C Initialise the shell of fixed atom clashes (F = no clash).

	DO 300 it		= 1, theta_slots
	  DO 260 ip		= 1, phi_slots (it)
	    mask_fix (it,ip)	= .FALSE.
260	  CONTINUE						! End ip
300	CONTINUE						! End it

	DO 460 ifh		= 1, n_fixed
	  DO 440 n		= 1, 3
	    xyzb (n)		= fixed (ifh,n)
440	  CONTINUE						! End n
	  radb			= fixed (ifh,4)
	  wat_here		= wat_diam
	  mask_set		= .FALSE.
	  wat_clash		= .FALSE.
	  clash_count		= .TRUE.
	  mask_fix_here		= .TRUE.
	  CALL	mask_region (xyza,rada,xyzb,radb,
     1			     vdw_relax,wat_here,
     2			     irot,mask_set,wat_clash,
     3			     clash_count)
	  IF (insider) STOP 'insider/expt rots'
460	CONTINUE						! End ifh

	DO 470 it		= 1, theta_slots
	  DO 468 ip		= 1, phi_slots (it)
	    mask_mov (it,ip)	= .FALSE.
468	  CONTINUE						! End ip
470	CONTINUE						! End it

	DO 600 jr		= 1, num_residues
	  IF (jr .EQ. ir_ig) GOTO 600
	  IF (res_rots_ind (jr,1) .EQ. -999) GOTO 600
	  jrot			= 1 + res_rots_ind (jr,1)
	  DO 500 it		= 1, theta_slots
	    DO 480 ip		= 1, phi_slots (it)
	      mask_jrot (it,ip)	= .FALSE.
480	    CONTINUE						! End ip
500	  CONTINUE						! End it
	  DO 560 imh		= 1, n_moved
	    jrh			= moved_ind (imh,1)
	    jroth		= moved_ind (imh,2)
	    IF ((jrh.EQ.jr).AND.(jroth.EQ.jrot)) THEN
	      DO 540 n		= 1, 3
		xyzb (n)	= moved (imh,n)
540	      CONTINUE						! End n
	      radb		= moved (imh,4)
	      wat_here		= wat_diam
	      mask_set		= .FALSE.
	      wat_clash		= .FALSE.
	      clash_count	= .TRUE.
	      mask_fix_here	= .FALSE.
	      CALL mask_region (xyza,rada,xyzb,radb,
     1				vdw_relax,wat_here,
     2				irot,mask_set,wat_clash,
     3				clash_count)
	      IF (insider) STOP 'insider/expt rots'
	    END IF						! =jr/jrot
560	  CONTINUE						! End imh
	  DO 580 it		= 1, theta_slots
	    DO 570 ip		= 1, phi_slots (it)
	      IF (mask_jrot (it,ip)) mask_mov (it,ip) = .TRUE.
570	    CONTINUE						! End ip
580	  CONTINUE						! End it
600	CONTINUE						! End jr

	pts_total		= 0.
	pts_clash		= 0.
	DO 620 it		= 1, theta_slots
	  DO 610 ip		= 1, phi_slots (it)
	    pts_total		= pts_total + 1.
	    IF ((mask_fix(it,ip)).OR.(mask_mov(it,ip))) THEN
	      pts_clash		= pts_clash + 1.
	    END IF
610	  CONTINUE						! End ip
620	CONTINUE						! End it
	expt_sa			= pts_clash/pts_total

	RETURN
	END


	SUBROUTINE	store_layr_gp (res,nres,mask_sa,best_sa,
C	**********	*************
     1				       ir_ig,ig_loc,expt_sa,
     2				       irot_smallest,chain)

C Update Aug.2002 to just store the data now, then we look through the
C basic allowed rotamer data and combine and append the .out information
C file - pk_calc can then pick up on this combination info.
C Also we now actually make the DH decision based on the combined info.

	REAL		mask_sa, mask_sa_1, mask_sa_here
	CHARACTER*4	res, res_1
	CHARACTER*1	chain
	LOGICAL		slot1_set
	CHARACTER*4		store_res (1000)
	CHARACTER*1		store_chain (1000)
	INTEGER			store_nres (1000)
	REAL			store (1000,4)

	COMMON	/hold_1/	slot1_set,mask_sa_1,nres_1,res_1,
     1				best_sa_1,ir_ig_1,irot_smallest_1,
     3				expt_sa_1
	COMMON	/store_layr/	n_store_layr, store_res,
     1				store_nres, store_chain,
     2				store

	DATA	slot1_set	/ .FALSE. /
	DATA	n_store_layr	/ 0 /

C For D,E,R with 2 equivalent atoms test the bigger best_sa vs bigger iso.
C For H, 2 non-equivalent atoms, test each??
Cmay03 - ACTUALLY, for all 2 site gps, take the average - may03 trial

	IF      (ig_loc .EQ. 1) THEN
	  IF ((res.EQ.'LYS ').OR.(res.EQ.'CYS ').OR.
     1	      (res.EQ.'TYR ')) THEN
	    test_line		= best_sa/mask_sa
	    n_store_layr	= n_store_layr + 1
	    IF (n_store_layr .GT. 1000) STOP 'n_store_layr > 1000'
	    i			= n_store_layr
	    store_res (i)	= res
	    store_nres (i)	= nres
	    store_chain (i)	= chain
	    store (i,1)		= mask_sa
	    store (i,2)		= best_sa
	    store (i,3)		= test_line
	    store (i,4)		= expt_sa
	  ELSE
	    IF (slot1_set) STOP 'slot1_set'
	    mask_sa_1		= mask_sa
	    nres_1		= nres
	    res_1		= res
	    best_sa_1		= best_sa
	    ir_ig_1		= ir_ig
	    irot_smallest_1	= irot_smallest
	    expt_sa_1		= expt_sa
	    slot1_set		= .TRUE.
	  END IF
	ELSE IF (ig_loc .EQ. 2) THEN
	  IF (.NOT.slot1_set) STOP '.not.slot1'
	  IF ((res.NE.'ASP ').AND.(res.NE.'GLU ').AND.
     1        (res.NE.'HIS ').AND.(res.NE.'ARG ')) STOP 'ig_loc/2'
	  IF (res .NE. res_1) STOP 'res/res_1'
	  IF (nres .NE. nres_1) STOP 'nres/nres_1'
	  IF (ir_ig .NE. ir_ig_1) STOP 'ir_ig/ir_ig_1'
Cmay03	  IF (res.EQ.'HIS ') THEN
	    n_store_layr	= n_store_layr + 1
	    IF (n_store_layr .GT. 1000) STOP 'n_store_layr > 1000'
	    i			= n_store_layr
	    store_res (i)	= res
	    store_nres (i)	= nres
	    store_chain (i)	= chain
	    store (i,1)		= (mask_sa + mask_sa_1)/2.
	    store (i,2)		= (best_sa + best_sa_1)/2.
	    store (i,3)		= store (i,2) / store (i,1)
	    store (i,4)		= (expt_sa + expt_sa_1)/2.
Cmay03	  ELSE
Cmay03	    best_sa_here	= best_sa_1
Cmay03	    IF (best_sa.GT.best_sa_here) best_sa_here = best_sa
Cmay03	    mask_sa_here	= mask_sa_1
Cmay03	    IF (mask_sa.GT.mask_sa_here) mask_sa_here = mask_sa
Cmay03	    expt_sa_here	= expt_sa_1
Cmay03	    IF (expt_sa.GT.expt_sa_here) expt_sa_here = expt_sa
Cmay03	    n_store_layr	= n_store_layr + 1
Cmay03	    IF (n_store_layr .GT. 1000) STOP 'n_store_layr > 1000'
Cmay03	    i			= n_store_layr
Cmay03	    store_res (i)	= res
Cmay03	    store_nres (i)	= nres
Cmay03	    store_chain (i)	= chain
Cmay03	    store (i,1)		= mask_sa_here
Cmay03	    store (i,2)		= best_sa_here
Cmay03	    store (i,3)		= best_sa_here / mask_sa_here
Cmay03	    store (i,4)		= (expt_sa + expt_sa_1)/2.
Cmay03	  END IF
	  slot1_set		= .FALSE.
	ELSE
	  STOP 'ig_loc/1or2'
	END IF

	RETURN
	END


	SUBROUTINE	draw_THE_line (water_layer, clash_rank)
C	**********	*************

C Append DH allowed information for ionisable groups to unit 3.
C Use allowed rotamer info AND water layering/max. access. if we have it.

C *** CURRENTLY NO_DH SET FOR:

C ***    allowed rots <= 2 (incl_expt) OR allowed rots = 1 (not incl_expt)
C ***		(i.e. one ~rotamer plus no other is FD only)
C ***		(where anticipate VdWtol of ~0.8 if using rots_NODH)
C *** OR best_sa/mask(iso)_sa < 0.75 (if water_layer/clash_rank) (tol=1.2?)
C ***OLD OR best_sa/mask(iso)_sa <= 0.75 (if water_layer and clash_rank) OLD

C *** NOTE that we've had different schemes - check back through notes:
C *** e.g. PREVIOUSLY for any gp with less than 0.5 of iso aa SA
C (for best atom), and also any gps from 0.5 to 0.67 in these fractional terms
C that move by < 0.5 (absolute) from exptal to best - since this greatly
C restricted freedom seems to characterise gps of potential interest.

	REAL		fixed (70000,4), moved (700000,4)
	INTEGER		res_rots_ind (10000,4)
	INTEGER*2	moved_ind (700000,3), fixed_ind (70000,2)
	REAL		p_new (10000,50), p_old (10000,50)
	REAL		ats_xyz (70000,3), ats_rad (70000)
	INTEGER		ats_nres (70000), ats_class (70000),
     1			residue (10000,2)
	CHARACTER*4	ats_atyp (70000), ats_res (70000)
	CHARACTER*1	ats_chain (70000)
	LOGICAL*1	ats_comm (70000), rots_NODH, sa_NODH
	LOGICAL		water_layer, clash_rank, incl_expt,
     1			till_expt, till_value, store_found
	CHARACTER*5	nodh
	CHARACTER*4	res, store_res (1000)
	CHARACTER*1	chain, store_chain (1000)
	INTEGER		store_nres (1000)
	REAL		store (1000,4)
	LOGICAL		excl_this
	INTEGER		excl_nres (100)
	CHARACTER*4	excl_res (100)
	CHARACTER*80	excl_file
	LOGICAL		excl_some
	LOGICAL*1	excl_found (100)
	CHARACTER*1	excl_chain (100)
	CHARACTER*4	fixed_atyp (70000)

	COMMON	/exclude/	excl_some, excl_file, n_excl,
     1				excl_res, excl_nres, excl_found,
     2				excl_chain
	COMMON	/ats/		num_ats, ats_xyz, ats_res,
     1				ats_nres, ats_chain, ats_atyp,
     2				ats_rad, ats_class, residue,
     3				num_res, ats_comm
	COMMON	/ats_loads/	fixed, fixed_ind, moved, moved_ind,
     1				if, im, res_rots_ind, n_fixed,n_moved,
     2				num_residues, fixed_atyp
	COMMON	/probs/		p_new, p_old, frac_new
	COMMON	/experiment/	incl_expt, till_expt, till_value,
     1				rel_value
	COMMON	/store_layr/	n_store_layr, store_res,
     1				store_nres, store_chain,
     2				store

2100	FORMAT (/,' For pk_calc list all available ionisable group
     1 info - it may not be used',/)
2200	FORMAT('  res chn nres    SA_iso_exp=A SA_prt_bst=B   B/A',
     1'   SA_prt_exp  DH   rots tot',/)
2300	FORMAT ('>',1X,A4,1X,A1,2X,I4,7X,F5.2,7X,F5.2,7X,F5.2,5X,
     1 F5.2,2X,A5,2X,I3,2X,I3)
2400	FORMAT ('>',1X,A4,1X,A1,2X,I4,48X,
     1 A5,2X,I3,2X,I3)

C Go through residues - only process for potential ionisable groups,
C and miss out residue exclusions from the scf calculations - hopefully
C this will catch e.g. Cys (if disulhides), NT, CT.  For NT, CT pk_calc
C will *CURRENTLY* set to DH _allowed - *COULD* add some SA calc here.

	WRITE (3,2100)
	WRITE (3,2200)
	DO 300 ir	= 1, num_residues
	  i1		= residue (ir,1)
	  res		= ats_res (i1)
	  IF ((res.EQ.'ASP ').OR.(res.EQ.'GLU ').OR.
     1	      (res.EQ.'LYS ').OR.(res.EQ.'ARG ').OR.
     2	      (res.EQ.'HIS ').OR.(res.EQ.'CYS ').OR.
     3	      (res.EQ.'TYR ')) THEN
	    nres	= ats_nres (i1)
	    chain	= ats_chain (i1)
	    DO 240 ie	= 1, n_excl
	      IF ((res.EQ.excl_res(ie)).AND.(nres.EQ.excl_nres(ie))
     1       .AND.(chain.EQ.excl_chain(ie))) GOTO 300
240	    CONTINUE						! End ie
	    IF (incl_expt) THEN
	      nrots	= 1 + res_rots_ind (ir,1)
	    ELSE
	      nrots	=     res_rots_ind (ir,1)
	    END IF
C add up allowed rotamers and combine with other info, if available.
	    IF (res_rots_ind (ir,1) .EQ. -999) THEN
	      n_allowed	= 0
	    ELSE
	      n_allowed		= 0
	      DO 260 irot	= 1, nrots
		IF (p_new (ir,irot) .GT. 0.0001) THEN
		  n_allowed = n_allowed + 1
		END IF
260	      CONTINUE						! End irot
	    END IF
	    rots_NODH		= .FALSE.
	    nodh		= '     '
	    IF (incl_expt) THEN
	      IF (n_allowed .LE. 2) rots_NODH = .TRUE.
Cdec05	      IF (n_allowed .LE. 2) rots_NODH = .TRUE.
	    ELSE
	      IF (n_allowed .LE. 1) rots_NODH = .TRUE.
Cdec05	      IF (n_allowed .LE. 1) rots_NODH = .TRUE.
	    END IF
	    store_found		= .FALSE.
	    sa_NODH		= .FALSE.
	    IF (water_layer .AND. clash_rank) THEN
	      DO 280 i		= 1, n_store_layr
		IF ((res.EQ.store_res(i)).AND.
     1		    (nres.EQ.store_nres(i)).AND.
     2		    (chain.EQ.store_chain(i))) THEN
		  IF (store_found) STOP 'store already found'
		  store_found	= .TRUE.
		  is		= i
		  IF (store (i,3) .LT. 0.75) sa_NODH = .TRUE.
C OLD		  IF (store (i,3) .LE. 0.75) sa_NODH = .TRUE.
		END IF
280	      CONTINUE						! End i
	      nodh = '     '
	      IF (res_rots_ind (ir,1) .EQ. -999) nrots = 0
	      IF (store_found) THEN
		IF (rots_NODH .OR. sa_NODH) nodh = 'NO_DH'
		WRITE (3,2300) res,chain,nres,(store(is,m),m=1,4),
     1			       nodh,n_allowed,nrots
	      ELSE
		IF (rots_NODH) nodh = 'NO_DH'
		WRITE (3,2400) res,chain,nres,
     1			       nodh,n_allowed,nrots
	      END IF
	    ELSE
	      IF (res_rots_ind (ir,1) .EQ. -999) nrots = 0
	      IF (rots_NODH) nodh = 'NO_DH'
	      WRITE (3,2400) res,chain,nres,
     1			     nodh,n_allowed,nrots
	    END IF
	  END IF						! ionis sc
300	CONTINUE						! End ir

	RETURN
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

	DO 180 i	= 1, 80
	  file (i:i)	= ' '
180	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

